#!/usr/bin/perl
#$Id: close_fiscal_year2.cgi,v 1.1 2001/09/06 10:21:19 moreejt Exp $
#This package is released under the GPL.  You should have recieved the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.

# close_fiscal_year2.cgi  -  Created by James Pattie, 12/31/1999
# This script takes the equity account(s) gathered by the first and does
# all the computations and balance table entries.
use strict;

use Pg;  # PostgreSQL Database Module
use cgi_lib;  # CGI Library routines
use custom;  # our customizable features
use reports;  # The report module

use vars '$date';

# get the values being passed in from the client
%input = ();  # make sure it is empty!
cgi_lib::ReadParse(*input);

my $ledger_name;
my $ledger_db;
my $ledger_color;
my $result2;
my $business_type;
my $business_name;
my $report_obj;
my $equity_account_str;
my $close_date;
my $leftover_equity_account_str;
my @ResultEquityAccounts;
@ResultEquityAccounts = ();

my @EquityAccounts;
@EquityAccounts = ();
my @AssetAccounts;
@AssetAccounts = ();
my @LiabilityAccounts;
@LiabilityAccounts = ();
my @RevenueAccounts;
@RevenueAccounts = ();
my @ExpenseAccounts;
@ExpenseAccounts = ();

my @EquitySubAccounts;
@EquitySubAccounts = ();
my @AssetSubAccounts;
@AssetSubAccounts = ();
my @LiabilitySubAccounts;
@LiabilitySubAccounts = ();
my @RevenueSubAccounts;
@RevenueSubAccounts = ();
my @ExpenseSubAccounts;
@ExpenseSubAccounts = ();

my @EquityBalances;
@EquityBalances = ();
my @AssetBalances;
@AssetBalances = ();
my @LiabilityBalances;
@LiabilityBalances = ();
my @RevenueBalances;
@RevenueBalances = ();
my @ExpenseBalances;
@ExpenseBalances = ();

my @EquitySubAccountBalances;
@EquitySubAccountBalances = ();
my @AssetSubAccountBalances;
@AssetSubAccountBalances = ();
my @LiabilitySubAccountBalances;
@LiabilitySubAccountBalances = ();
my @RevenueSubAccountBalances;
@RevenueSubAccountBalances = ();
my @ExpenseSubAccountBalances;
@ExpenseSubAccountBalances = ();

my @AssetTypes;
@AssetTypes = ();
my @LiabilityTypes;
@LiabilityTypes = ();
my @EquityTypes;
@EquityTypes = ();
my @RevenueTypes;
@RevenueTypes = ();
my @ExpenseTypes;
@ExpenseTypes = ();
my ($revenue_total, $expenses_total, $dividends_total, $retained_earnings);
$revenue_total = $expenses_total = $dividends_total = $retained_earnings = "0.00";
my $ledger_code;

use PortalWrapper; # The Portal Wrapper library.

my $portalObj;
$portalObj = PortalWrapper->new;
if ($portalObj->didErrorOccur)
{
  # begin the HTML Output
  print cgi_lib::PrintHeader();
  print "<html>\n";

  PrintErrorHeader();
  print $portalObj->errorMessage;
  CleanUp();
}
my $dbObj;
$dbObj = $portalObj->getDBInfo;
if (!defined $dbObj)
{
  if ($portalObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $portalObj->errorMessage;
    CleanUp();
  }
}
else
{
  if ($dbObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $dbObj->errorMessage;
    CleanUp();
  }
}
$db_host = $dbObj->dbHost;
$db_name = $dbObj->dbName;
$db_user = $dbObj->dbUser;
$db_passwd = $dbObj->dbPasswd;

my $database_connected;
$database_connected = 0;

# begin the HTML Output
print cgi_lib::PrintHeader();
print "<html>\n";

$ledger_db = $input{'ledger'};
if (length $ledger_db == 0)
{
  PrintErrorHeader();
  print "<h1>Error:  A Ledger must be specified!</h1>\n";
  print "$sys_admin";
  CleanUp();
}

$equity_account_str = $input{'equity_account'};
if (length $equity_account_str == 0)
{
  PrintErrorHeader();
  print "<h1>Error:  You must select an equity account(s) to work with!</h1>\n";
  print "$back_button";
  CleanUp();
}

$close_date = $input{'close_date'};
if (length $close_date == 0)
{
  PrintErrorHeader();
  print "<h1>Error:  You must specify the Close Out Date!</h1>\n";
  print "$back_button";
  CleanUp();
}

# check to see if we are running under mod_perl
if (exists $ENV{MOD_PERL})
{
  # check to see if the database is still connected
  if (defined $conn)
  {
    # check the status of the connection
    if ($conn->status != PGRES_CONNECTION_OK)
    {
      $database_connected = 0;
    }
    else
    {
      # connection still good!
      $database_connected = 1;
    }
  }
  else
  {
    $database_connected = 0;
  }
}

if (not $database_connected)
{
  # connect to the database.
  $conn = Pg::connectdb("host = $db_host dbname = $db_name user = $db_user password = $db_passwd");
  if ($conn->status == PGRES_CONNECTION_BAD)
  {
    PrintErrorHeader();
    print "<h1>Error:  Couldn't connect to the database!</h1><br>\n";
    print $conn->errorMessage . "<br>$sys_admin";
    CleanUp();
  }
}

# set the DateStyle for the Database.
$result = setDBDateStyle($conn);
if ($result->resultStatus != PGRES_COMMAND_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Setting Date Style failed!</h1>\n";
  print $conn->errorMessage . "<br>$sys_admin";
  CleanUp();
}

# now we check and validate the ledger is valid
$result = $conn->exec("select name from entity_tb where database_name = '$ledger_db'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Accessing database failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to validate Ledger <font color=\"blue\">$ledger_db</font>.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples == 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Ledger <font color=\"blue\">$ledger_db</font> does not exist!</h1>\n";
  print "Tried to validate Ledger <font color=\"blue\">$ledger_db</font>.<br>$sys_admin";
  CleanUp();
}
$ledger_name = $result->getvalue(0, 0);

# create the reports object
$report_obj = reports->new($conn, $ledger_db);
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}
$ledger_code = $report_obj->getLedgerCode();
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}
$ledger_color = $report_obj->getLedgerColor();
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}

# check and make sure that the given equity accounts are assigned to the ledger in question.
@ResultEquityAccounts = split /\0/, $equity_account_str;

# figure out the beginning and ending date of the current working year
my ($working_year, $from_date, $to_date);

$result = $conn->exec("select year, start_date, end_date from known_years_tb where year in (select working_year from variables_tb WHERE ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Accessing database failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get working year and fiscal year dates from ledger <font color=\"$ledger_color\">$ledger_db</font>.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples == 0)
{
  PrintErrorHeader();
  print "<h1>Error: Program not configured!</h1>\n";
  print "Working Year is not set!<br>$sys_admin";
  CleanUp();
}
$working_year = $result->getvalue(0, 0);
$from_date    = $result->getvalue(0, 1);
$to_date      = $result->getvalue(0, 2);

my $working_year_end;
$working_year_end = $to_date;  # save this as we need it later.

if ($close_date =~ /(-|\/)/)
{
  if (IsValidDateSyntax($close_date))
  {
    $close_date = MakeValidDate($close_date);  # make sure of it.
  }
  else
  {
    PrintErrorHeader();
    print "<h1>Error: Invalid Date!</h1>\n";
    print "Close Out Date = '$to_date' is invalid!<br>$back_button";
    CleanUp();
  }
  $to_date = $close_date;

  # get a list of all closeout dates that are within the current fiscal period.
  my $result2 = $conn->exec("SELECT DISTINCT(bal_date) FROM acct_bal_tb WHERE ledger_code = '$ledger_code' AND ledger_code = known_years_tb.ledger_code AND known_years_tb.ledger_code = variables_tb.ledger_code AND known_years_tb.year = variables_tb.working_year AND bal_date >= known_years_tb.start_date AND bal_date < known_years_tb.end_date ORDER BY bal_date DESC");
  if ($result2->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get list of all Close Out Periods in the current fiscal year.<br>$sys_admin";
    CleanUp();
  }
  if ($result2->ntuples > 0)  # use the last close out date as our from value.
  {
    $from_date = $result2->getvalue(0, 0);
  }
}
else
{
  $close_date = $to_date;  # We are wanting to close out the current fiscal year.
}

if (ReverseDateString($from_date) > ReverseDateString($close_date) || ReverseDateString($to_date) < ReverseDateString($close_date))
{
  PrintErrorHeader();
  print "<h1>Error: Close Out Date is invalid!</h1>\n";
  print "'$close_date' must be after '$from_date'.<br>$back_button";
  CleanUp();
}

# verify that the close_date specified has not already been used or is not before a current close_date period wise.
$result = $conn->exec("SELECT DISTINCT(bal_date) FROM acct_bal_tb WHERE ledger_code = '$ledger_code' AND bal_date >= '$close_date'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Accessing database failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to see if the ledger has already been closed out after date = '$close_date'.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples != 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Ledger has already been closed out after Date = '$close_date'!</h1><br>$back_button\n";
  CleanUp();
}

$result = $conn->exec("SELECT business_type FROM ledger_tb WHERE code = '$ledger_code'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Accessing database failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get the business type of this ledger.<br>$sys_admin";
  CleanUp();
}
$business_type = $result->getvalue(0, 0);

# get the business name
$result = $conn->exec("SELECT name FROM business_type_tb WHERE num = $business_type");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Accessing database failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get the business name for business type = '$business_type'.<br>$sys_admin";
  CleanUp();
}
$business_name = $result->getvalue(0, 0);

# get the last close out period value.
my $last_close_out;
$result = $conn->exec("SELECT DISTINCT(bal_date) FROM acct_bal_tb WHERE ledger_code = '$ledger_code' ORDER BY bal_date DESC");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Accessing database failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get the last close out date.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples == 0)
{
  $last_close_out = "Never";
}
else
{
  $last_close_out = $result->getvalue(0, 0);
}

if ($business_type == 0 || $business_type == 2 || $business_type == 4)
{
  if (scalar @ResultEquityAccounts != 1)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must select a single equity account to work with!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  my ($acct_num_str, $temp) = split /\|/, @ResultEquityAccounts[0];

  $result = $conn->exec("SELECT * FROM local_accounts_tb WHERE acct_num = $acct_num_str AND ledger_code = '$ledger_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to validate that Account ($temp) = $acct_num_str is assigned to Ledger <font color=\"$ledger_color\">$ledger_db</font>.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Account ($temp) = $acct_num_str is not assigned to Ledger <font color=\"$ledger_color\">$ledger_db</font>!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }

  # now validate that it exists in the global database.
  $result = $conn->exec("SELECT type, active FROM account_tb WHERE name = '$temp' AND number = $acct_num_str");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error:  Accessing Global Database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to validate that Account ($temp) = $acct_num_str is of Type = 7 and is Active.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Account ($temp) = $acct_num_str does not exist in the Global Database!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
  my ($type, $active);
  $type = $result->getvalue(0, 0);
  $active = $result->getvalue(0, 1);
  if ($type != 7)
  {
    PrintErrorHeader();
    print "<h1>Error:  Account ($temp) = $acct_num_str is not an Equity Account!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
  if ($active eq "f")
  {
    PrintErrorHeader();
    print "<h1>Error:  Account ($temp) = $acct_num_str is not Active!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
}
elsif ($business_type == 1)
{
  if (scalar @ResultEquityAccounts <= 1)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must select at least two equity accounts to work with!</h1>\n";
    print "$back_button";
    CleanUp();
  }

  $leftover_equity_account_str = $input{'leftover_equity_account'};
  if (length $leftover_equity_account_str == 0)
  {
    PrintErrorHeader();
    print "<h1>Error: You must select an account to assign left over cents to!</h1>\n";
    print "$back_button";
    CleanUp();
  }

  my ($i);
  for ($i=0; $i < scalar @ResultEquityAccounts; $i++)
  {
    my ($acct_num_str, $temp) = split /\|/, @ResultEquityAccounts[$i];

    $result = $conn->exec("SELECT * FROM local_accounts_tb WHERE acct_num = $acct_num_str AND ledger_code = '$ledger_code'");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error:  Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to validate that Account ($temp) = $acct_num_str is assigned to Ledger <font color=\"$ledger_color\">$ledger_db</font>.<br>$sys_admin";
      CleanUp();
    }
    if ($result->ntuples == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  Account ($temp) = $acct_num_str is not assigned to Ledger <font color=\"$ledger_color\">$ledger_db</font>!</h1>\n";
      print "$sys_admin";
      CleanUp();
    }

    # now validate that it exists in the global database.
    $result = $conn->exec("SELECT type, active FROM account_tb WHERE name = '$temp' AND number = $acct_num_str");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error:  Accessing Global Database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to validate that Account ($temp) = $acct_num_str is of Type = 7 and is Active.<br>$sys_admin";
      CleanUp();
    }
    if ($result->ntuples == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  Account ($temp) = $acct_num_str does not exist in the Global Database!</h1>\n";
      print "$sys_admin";
      CleanUp();
    }
    my ($type, $active);
    $type = $result->getvalue(0, 0);
    $active = $result->getvalue(0, 1);
    if ($type != 7)
    {
      PrintErrorHeader();
      print "<h1>Error:  Account ($temp) = $acct_num_str is not an Equity Account!</h1>\n";
      print "$sys_admin";
      CleanUp();
    }
    if ($active eq "f")
    {
      PrintErrorHeader();
      print "<h1>Error:  Account ($temp) = $acct_num_str is not Active!</h1>\n";
      print "$sys_admin";
      CleanUp();
    }
  }

  # now validate that the leftover equity account is valid and assigned to the ledger, etc.
  my ($acct_num_str, $temp) = split /\|/, $leftover_equity_account_str;

  $result = $conn->exec("SELECT * FROM local_accounts_tb WHERE acct_num = $acct_num_str AND ledger_code = '$ledger_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to validate that Account ($temp) = $acct_num_str is assigned to Ledger <font color=\"$ledger_color\">$ledger_db</font>.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Account ($temp) = $acct_num_str is not assigned to Ledger <font color=\"$ledger_color\">$ledger_db</font>!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }

  # now validate that it exists in the global database.
  $result = $conn->exec("SELECT type, active FROM account_tb WHERE name = '$temp' AND number = $acct_num_str");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error:  Accessing Global Database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to validate that Account ($temp) = $acct_num_str is of Type = 7 and is Active.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Account ($temp) = $acct_num_str does not exist in the Global Database!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
  my ($type, $active);
  $type = $result->getvalue(0, 0);
  $active = $result->getvalue(0, 1);
  if ($type != 7)
  {
    PrintErrorHeader();
    print "<h1>Error:  Account ($temp) = $acct_num_str is not an Equity Account!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
  if ($active eq "f")
  {
    PrintErrorHeader();
    print "<h1>Error:  Account ($temp) = $acct_num_str is not Active!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
}
elsif ($business_type == 3)
{
  if (scalar @ResultEquityAccounts <= 1)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must select at least two equity accounts to work with!</h1>\n";
    print "$back_button";
    CleanUp();
  }

  $leftover_equity_account_str = $input{'leftover_equity_account'};
  if (length $leftover_equity_account_str == 0)
  {
    PrintErrorHeader();
    print "<h1>Error: You must select an account to assign left over cents to!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }

  my ($i, $total_percentage);
  for ($i=0, $total_percentage=0; $i < scalar @ResultEquityAccounts; $i++)
  {
    my ($acct_num_str, $temp) = split /\|/, @ResultEquityAccounts[$i];  # $temp = account name, $percent = percentage for this account

    $result = $conn->exec("SELECT * FROM local_accounts_tb WHERE acct_num = $acct_num_str AND ledger_code = '$ledger_code'");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error:  Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to validate that Account ($temp) = $acct_num_str is assigned to Ledger <font color=\"$ledger_color\">$ledger_db</font>.<br>$sys_admin";
      CleanUp();
    }
    if ($result->ntuples == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  Account ($temp) = $acct_num_str is not assigned to Ledger <font color=\"$ledger_color\">$ledger_db</font>!</h1>\n";
      print "$sys_admin";
      CleanUp();
    }

    # now validate that it exists in the global database.
    $result = $conn->exec("SELECT type, active FROM account_tb WHERE name = '$temp' AND number = $acct_num_str");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error:  Accessing Global Database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to validate that Account ($temp) = $acct_num_str is of Type = 7 and is Active.<br>$sys_admin";
      CleanUp();
    }
    if ($result->ntuples == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  Account ($temp) = $acct_num_str does not exist in the Global Database!</h1>\n";
      print "$sys_admin";
      CleanUp();
    }
    my ($type, $active);
    $type = $result->getvalue(0, 0);
    $active = $result->getvalue(0, 1);
    if ($type != 7)
    {
      PrintErrorHeader();
      print "<h1>Error:  Account ($temp) = $acct_num_str is not an Equity Account!</h1>\n";
      print "$sys_admin";
      CleanUp();
    }
    if ($active eq "f")
    {
      PrintErrorHeader();
      print "<h1>Error:  Account ($temp) = $acct_num_str is not Active!</h1>\n";
      print "$sys_admin";
      CleanUp();
    }

    my $percent = "percent_$i";
    if (length $input{$percent} == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  Percentage for Account ($temp) = $acct_num_str does not Exist!</h1>\n";
      print "$back_button";
      CleanUp();
    }

    $percent = $input{$percent};

    # now check and make sure that the percentage given ($percent) > 0 and < 100
    if ($percent <= 0 || $percent >= 100)
    {
      PrintErrorHeader();
      print "<h1>Error:  The percentage give for Account ($temp) = $acct_num_str is Invalid!</h1>\n";
      print "Percentage = '$percent'.<br>$back_button";
      CleanUp();
    }
    $total_percentage += $percent;

    # add this percentage to the EquityAccounts array as part of the string to make future use easier.
    $EquityAccounts[$i] .= "|$percent";
  }
  if ($total_percentage != 100)
  {
    PrintErrorHeader();
    print "<h1>Error:  The sum of all Equity Account Percentages does not equal 100!</h1>\n";
    print "Total Percentages = $total_percentage.<br>$back_button";
    CleanUp();
  }

  # now validate that the leftover equity account is valid and assigned to the ledger, etc.
  my ($acct_num_str, $temp) = split /\|/, $leftover_equity_account_str;

  $result = $conn->exec("SELECT * FROM local_accounts_tb WHERE acct_num = $acct_num_str AND ledger_code = '$ledger_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to validate that Account ($temp) = $acct_num_str is assigned to Ledger <font color=\"$ledger_color\">$ledger_db</font>.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Account ($temp) = $acct_num_str is not assigned to Ledger <font color=\"$ledger_color\">$ledger_db</font>!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }

  # now validate that it exists in the global database.
  $result = $conn->exec("SELECT type, active FROM account_tb WHERE name = '$temp' AND number = $acct_num_str");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error:  Accessing Global Database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to validate that Account ($temp) = $acct_num_str is of Type = 7 and is Active.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Account ($temp) = $acct_num_str does not exist in the Global Database!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
  my ($type, $active);
  $type = $result->getvalue(0, 0);
  $active = $result->getvalue(0, 1);
  if ($type != 7)
  {
    PrintErrorHeader();
    print "<h1>Error:  Account ($temp) = $acct_num_str is not an Equity Account!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
  if ($active eq "f")
  {
    PrintErrorHeader();
    print "<h1>Error:  Account ($temp) = $acct_num_str is not Active!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
}
else
{
  print "<h1>Error:  Unknown Business Type in ledger <font color=\"$ledger_color\">$ledger_name</font>!</h1>\n";
  print "Business Type specified = '$business_type'<br>$sys_admin";
  CleanUp();
}

print "<head><title>$prog_name $prog_version Close Out Fiscal Year/Period $close_date - Almost Done!</title></head>\n";
print "<body bgcolor=$body_bgcolor>\n";
print <<"END_OF_STYLE";
<style type="text/css"><!--
  a:hover   { color: red }
  a:link    { text-decoration: none; color: blue }
  a:visited { text-decoration: none; color: blue }
  a:active  { text-decoration: none; color: blue }-->
</style>
<script language="Javascript1.2" src="../js/common.js"></script>
END_OF_STYLE
# get the date
$date = `/bin/date +%m-%d-%Y`;
chomp $date;

my ($i, $name, $code);

print "<center>\n";
print "<table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
print "<tr>\n";
print "<td width=47%><font color=red>Working in ledger <font color=\"$ledger_color\">$ledger_name</font>.  Closing out Fiscal Year/Period <font color=\"black\">$close_date</font> (<font color=\"black\">$from_date</font> to <font color=\"black\">$to_date</font>).</font></td>\n";
print "<td align=left><a href=\"$site_dir/help.html#closing_fiscal_year\" target=\"docs\"><img border=0 src=\"$site_dir/images/help.jpg\" alt=\"Help\"></a></td>\n";
print "<td align=right>$date</td></tr></table>\n<hr><br>\n";
print PrintStandardLedgerMainMenu($ledger_db);

# verify that the debits = credits before we go any further. (For all transactions in the system).
my @is_balanced;
@is_balanced = $report_obj->DoesSystemBalance($from_date, $to_date);
if ($report_obj->didErrorOccur)
{
  print "<h1>Error:  Checking for Debits = Credits failed!</h1>\n";
  print $report_obj->getErrorMessage;
  CleanUp();
}
if ($is_balanced[2] == 0)
{
  print "<h1>Error:  Debits do not Equal Credits!</h1>\n";
  print "Total Debits = $is_balanced[0]<br>Total Credits = $is_balanced[1]<br>\n";
  print "$sys_admin";
  CleanUp();
}

# start a transaction with the ledger
$result = $conn->exec("BEGIN WORK");
if ($result->resultStatus != PGRES_COMMAND_OK)
{
  print "<h1>Error:  Starting Ledger Transaction failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to BEGIN WORK.<br>$sys_admin";
  CleanUp();
}

# remove any balance table entries that exist for the last day of this fiscal year.
#$result = $conn->exec("DELETE FROM acct_bal_tb WHERE bal_date >= '$to_date' AND ledger_code = '$ledger_code'");
#if ($result->resultStatus != PGRES_COMMAND_OK)
#{
#  print "<h1>Error:  Deleting Balance Table Entries failed!</h1>\n";
#  print $conn->errorMessage . "<br>Tried to delete any existing Balance Table Entries before Closing out the Fiscal Year.<br>$sys_admin";
#  CleanUp();
#}

# gather Account Balances and SubAccount Balances for Assets, Liabilities and Equities.
# Account Balances = [Account Type][Account Array][Balance Info Array for each Account]
# SubAccount Balances = [Account Type][SubAccount Array][Balance Info Array for each Account/SubAccount pair]

# Use the balance stored procedures for the date passed in and the ledger code to gather the balances, accounts, and sub-accounts
# that are needed to close out that period.
$result = $conn->exec("select ledger_code, account_num,
sub_account_balance_plus_activity(account_num, sub_account_num, ledger_code, '$close_date', 'custom'), sub_account_num, '$close_date'
from debitcredit_tb
where ledger_code = '$ledger_code' and trans_date < '$close_date' and account_num = (select number from account_tb where number = account_num
and type = (select num from acct_type_tb where num = type and num <> 0 and num <> 10 and num <> 17 and first_digit <> '4' and first_digit <> '5'))
group by ledger_code, account_num, sub_account_num
union
select ledger_code, acct_num,
sub_account_balance_plus_activity(acct_num, sub_acct_num, ledger_code, '$close_date', 'custom'), sub_acct_num, '$close_date'
from acct_bal_tb
where ledger_code = '$ledger_code' and bal_date < '$close_date' and acct_num = (select number from account_tb where number = acct_num
and type = (select num from acct_type_tb where num = type and num <> 0 and num <> 10 and num <> 17 and first_digit <> '4' and first_digit <> '5'))
AND sub_acct_num <> -2
group by ledger_code, acct_num, sub_acct_num");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "<h1>Error:  Retrieving sub-account balances and activity failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get the sub-account balance and activity to insert into the acct_bal_tb table.<br>$sys_admin";
  CleanUp();
}
for (my $count=0; $count < $result->ntuples; $count++)
{
  my $ledger = $result->getvalue($count, 0);
  my $account_num = $result->getvalue($count, 1);
  my $balance = $result->getvalue($count, 2);
  my $sub_account_num = $result->getvalue($count, 3);
  my $bal_date = $result->getvalue($count, 4);
  my $result2 = $conn->exec("insert into acct_bal_tb (ledger_code, acct_num, balance, sub_acct_num, bal_date) values ('$ledger', $account_num, '$balance', $sub_account_num, '$bal_date')");
  if ($result2->resultStatus != PGRES_COMMAND_OK)
  {
    print "<h1>Error:  Inserting sub-account balances into the acct_bal_tb table failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to insert the sub-account balances into the account balance table.<br>$sys_admin";
    CleanUp();
  }
}

$result = $conn->exec("select ledger_code, account_num,
account_balance_plus_activity(account_num, ledger_code, '$close_date', 'custom'), -2, '$close_date'
from debitcredit_tb
where ledger_code = '$ledger_code' and trans_date < '$close_date' and account_num = (select number from account_tb where number = account_num
and type = (select num from acct_type_tb where num = type and num <> 17 and first_digit <> '4' and first_digit <> '5'))
group by ledger_code, account_num
union
select ledger_code, acct_num,
account_balance_plus_activity(acct_num, ledger_code, '$close_date', 'custom'), -2, '$close_date'
from acct_bal_tb
where ledger_code = '$ledger_code' and bal_date < '$close_date' and acct_num = (select number from account_tb where number = acct_num
and type = (select num from acct_type_tb where num = type and num <> 17 and first_digit <> '4' and first_digit <> '5'))
group by ledger_code, acct_num");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "<h1>Error:  Retrieving account balances and activity failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get the account balance and activity to insert into the acct_bal_tb table.<br>$sys_admin";
  CleanUp();
}
for (my $count=0; $count < $result->ntuples; $count++)
{
  my $ledger = $result->getvalue($count, 0);
  my $account_num = $result->getvalue($count, 1);
  my $balance = $result->getvalue($count, 2);
  my $sub_account_num = $result->getvalue($count, 3);
  my $bal_date = $result->getvalue($count, 4);
  $result2 = $conn->exec("insert into acct_bal_tb (ledger_code, acct_num, balance, sub_acct_num, bal_date) values ('$ledger', $account_num, '$balance', $sub_account_num, '$bal_date')");
  if ($result2->resultStatus != PGRES_COMMAND_OK)
  {
    print "<h1>Error:  Inserting account balances into the acct_bal_tb table failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to insert the account balances into the account balance table.<br>$sys_admin";
    CleanUp();
  }
}

$result = $conn->exec("select max(bal_date) from acct_bal_tb where ledger_code = '$ledger_code' and bal_date < '$close_date'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "<h1>Error:  Failed to lookup balance date!</h1>\n";
  print $conn->errorMessage . "<br>Tried looking up the latest closeout date before the 'close_date'.<br>$sys_admin";
}
my $balance_date;
$balance_date = $result->getvalue(0, 0);
# gather Activity for Revenues and Expenses and Dividends Paid (account type = 17).
my $sql_statement;
$sql_statement = "select activity_sum(true, (select sum(amount) from debitcredit_tb where ledger_code ='$ledger_code' and account_num = (select number from account_tb where number = account_num and type = 17) ##?## and trans_date <= '$close_date' and dorc = true), (select sum(amount) from debitcredit_tb where ledger_code ='$ledger_code' and account_num = (select number from account_tb where number = account_num and type = 17) ##?## and trans_date <= '$close_date' and dorc = false))";
if ($balance_date eq "")
{
  $sql_statement =~ s/\#\#\?\#\#//g;
}
else
{
  $sql_statement =~ s/\#\#\?\#\#/and trans_date > '$balance_date'/g;
}
$result = $conn->exec($sql_statement);
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "<h1>Error:  Retrieving Dividends Paid balance failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to retrieve the sum of the balances for Dividends Paid accounts.<br>$sys_admin";
  CleanUp();
}
$dividends_total = $result->getvalue(0, 0);
if ($dividends_total eq "")
{
  $dividends_total = "0.00";
}

$sql_statement = "select activity_sum(false, (select sum(amount) from debitcredit_tb where ledger_code = '$ledger_code' and account_num = (select number from account_tb where number = account_num and type = (select num from acct_type_tb where num = type and first_digit = '4')) ##?## and trans_date <= '$close_date' and dorc = true), (select sum(amount) from debitcredit_tb where ledger_code = '$ledger_code' and account_num = (select number from account_tb where number = account_num and type = (select num from acct_type_tb where num = type and first_digit = '4')) ##?## and trans_date <= '$close_date' and dorc = false))";
if ($balance_date eq "")
{
  $sql_statement =~ s/\#\#\?\#\#//g;
}
else
{
  $sql_statement =~ s/\#\#\?\#\#/and trans_date > '$balance_date'/g;
}
$result = $conn->exec($sql_statement);
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "<h1>Error:  Retrieving Revenue balances failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to retrieve the sum of the balances for Revenue accounts.<br>$sys_admin";
  CleanUp();
}
$revenue_total = $result->getvalue(0, 0);
if ($revenue_total eq "")
{
  $revenue_total = "0.00";
}

$sql_statement = "select activity_sum(true, (select sum(amount) from debitcredit_tb where ledger_code = '$ledger_code' and account_num = (select number from account_tb where number = account_num and type = (select num from acct_type_tb where num = type and first_digit = '5')) ##?## and trans_date <= '$close_date' and dorc = true), (select sum(amount) from debitcredit_tb where ledger_code = '$ledger_code' and account_num = (select number from account_tb where number = account_num and type = (select num from acct_type_tb where num = type and first_digit = '5')) ##?## and trans_date <= '$close_date' and dorc = false))";
if ($balance_date eq "")
{
  $sql_statement =~ s/\#\#\?\#\#//g;
}
else
{
  $sql_statement =~ s/\#\#\?\#\#/and trans_date > '$balance_date'/g;
}
$result = $conn->exec($sql_statement);
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "<h1>Error:  Retrieving Expense balances failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to retrieve the sum of the balances for Expense accounts.<br>$sys_admin";
  CleanUp();
}
$expenses_total = $result->getvalue(0, 0);
if ($revenue_total eq "")
{
  $expenses_total = "0.00";
}

# Sum all activity from the last closeout for each account
my $result_string;
$result_string = "<table border=0 cellpadding=2 cellspacing=0>\n";
$result_string .= "<tr><td align=center>revenues: '$revenue_total', expenses: '$expenses_total', dividends: '$dividends_total'<br></td></tr>\n";

$revenue_total = sprintf "%.2f", $revenue_total;
$expenses_total = sprintf "%.2f", $expenses_total;
$dividends_total = sprintf "%.2f", $dividends_total;

# Calculate the Retained Earnings balance
$retained_earnings = $revenue_total - ($expenses_total + $dividends_total);
$retained_earnings = sprintf "%.2f", $retained_earnings;
$result_string .= "<tr><td align=right><h3>Retained Earnings = \$" . commify($retained_earnings) . ".</h3></td></tr>\n";

# The user-defined equity account(s) must be adjusted by retained earnings amount.
# Divide it up based upon the business type of the ledger.
if ($business_type == 0 || $business_type == 2 || $business_type == 4)
{
  my ($acct_num_str, $temp) = split /\|/, @ResultEquityAccounts[0];
  #print "Account ($temp) = $acct_num_str\n<br>\n";
  # first get the equity account balance, as we need to add to the total it already has.
  $result2 = $conn->exec("SELECT balance FROM acct_bal_tb WHERE acct_num = $acct_num_str AND sub_acct_num = '-2' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
  if ($result2->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error:  Checking to see if the Equity Account ($temp - $acct_num_str) had a balance failed!</h1>Business Type = '$business_type'<br>\n";
    print $conn->errorMessage . "<br>$sys_admin";
    CleanUp();
  }
  if ($result2->ntuples == 0)  # create it
  {
    $result_string .= "<tr><td align=center>Equity Account ($temp - $acct_num_str) created with balance = '" . commify($retained_earnings) . "'</td></tr>\n";
    $result2 = $conn->exec("INSERT INTO acct_bal_tb (acct_num, sub_acct_num, balance, bal_date, ledger_code) VALUES ($acct_num_str, '-2', '$retained_earnings', '$to_date', '$ledger_code')");
    if ($result2->resultStatus != PGRES_COMMAND_OK)
    {
      print "<h1>Error:  Creating Initial Balance Table entry for Equity Account ($temp - $acct_num_str) failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to Create Default Retained Earnings Balance of '$retained_earnings' on '$to_date'.<br>$sys_admin";
      CleanUp();
    }
    $result2 = $conn->exec("INSERT INTO acct_bal_tb (acct_num, sub_acct_num, balance, bal_date, ledger_code) VALUES ($acct_num_str, '-1', '$retained_earnings', '$to_date', '$ledger_code')");
    if ($result2->resultStatus != PGRES_COMMAND_OK)
    {
      print "<h1>Error:  Creating Initial Balance Table entry for Equity Account ($temp - $acct_num_str) failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to Create Default Retained Earnings (-1) Balance of '$retained_earnings' on '$to_date'.<br>$sys_admin";
      CleanUp();
    }
  }
  else  # add to it
  {
    my $balance = $result2->getvalue(0, 0);
    $result_string .= "<tr><td>The Equity entry is being updated!  Initial balance = <i>\$" . commify($balance) . "</i>.<br></td></tr>\n";
    $balance += $retained_earnings;
    $balance = sprintf "%.2f", $balance;

    $result2 = $conn->exec("UPDATE acct_bal_tb SET balance = '$balance' WHERE acct_num = $acct_num_str AND sub_acct_num = '-2' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
    if ($result2->resultStatus != PGRES_COMMAND_OK)
    {
      print "<h1>Error:  Updating Balance Table entry for Equity Account ($temp - $acct_num_str) failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to update Retained Earnings Balance to be '$balance' on '$to_date'.<br>$sys_admin";
      CleanUp();
    }

    $result2 = $conn->exec("SELECT balance FROM acct_bal_tb WHERE acct_num = $acct_num_str AND sub_acct_num = '-1' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error:  Checking to see if the Equity Account ($temp - $acct_num_str) had a balance failed!</h1>Business Type = '$business_type'<br>\n";
      print $conn->errorMessage . "<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples > 0)
    {
      $balance = $result2->getvalue(0, 0);
      $balance += $retained_earnings;
      $balance = sprintf "%.2f", $balance;
      $result2 = $conn->exec("UPDATE acct_bal_tb SET balance = '$balance' WHERE acct_num = $acct_num_str AND sub_acct_num = '-1' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
      if ($result2->resultStatus != PGRES_COMMAND_OK)
      {
        print "<h1>Error:  Updating Balance Table entry for Equity Account ($temp - $acct_num_str) failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to update Retained Earnings (-1) Balance to be '$balance' on '$to_date'.<br>$sys_admin";
        CleanUp();
      }
    }
    else
    {
      # sub-account -1 does not exist; insert value
      $result2 = $conn->exec("INSERT INTO acct_bal_tb (acct_num, sub_acct_num, balance, bal_date, ledger_code) VALUES ($acct_num_str, '-1', '$retained_earnings', '$to_date', '$ledger_code')");
      if ($result2->resultStatus != PGRES_COMMAND_OK)
      {
        print "<h1>Error:  Creating Initial Balance Table entry for Equity Account ($temp - $acct_num_str) failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to Create Default Retained Earnings (-1) Balance of '$retained_earnings' on '$to_date'.<br>$sys_admin";
        CleanUp();
      }
    }
  }
}
elsif ($business_type == 1)
{
  my ($i, $total, $remainder);
  if ($retained_earnings ne "0.00")
  {
    $total = ($retained_earnings / scalar @ResultEquityAccounts);  #/ calculate how much each partner gets.
    if ($total < 0)
    {
      $total += "0.005";
    }
    else
    {
      $total -= "0.005";
    }
    $total = sprintf "%.2f", $total;

    $remainder = (scalar @ResultEquityAccounts * $total); # calculate how much total was divided up
    if ($remainder < 0)
    {
      $remainder += "0.005";
    }
    else
    {
      $remainder -= "0.005";
    }
    $remainder = sprintf "%.2f", $remainder;

    $remainder = $retained_earnings - $remainder; # calculate the remainder (if any)
    if ($remainder < 0)
    {
      $remainder += "0.005";
    }
    else
    {
      $remainder -= "0.005";
    }
    $remainder = sprintf "%.2f", $remainder;
  }
  else
  {
    $total = $remainder = "0.00";  # There can be no division of 0.00!
  }

  $result_string .= "<tr><td align=right><h3>Each partner receives <i>\$" . commify($total) . "</i> with a remainder of <i>\$" . commify($remainder) . "</i>.</h3></td></tr>\n";
  for ($i=0; $i < scalar @EquityAccounts; $i++)
  {
    my ($acct_num_str, $temp) = split /\|/, @ResultEquityAccounts[$i];
    #print "Account ($temp) = $acct_num_str\n<br>\n";
    # first get the equity account balance, as we need to add to the total it already has.
    $result2 = $conn->exec("SELECT balance FROM acct_bal_tb WHERE acct_num = $acct_num_str AND sub_acct_num = '-2' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error:  Checking to see if the Partner Equity Account ($temp - $acct_num_str) had a balance failed!</h1>Business Type = '$business_type'<br>\n";
      print $conn->errorMessage . "<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples == 0)  # create it
    {
      $result2 = $conn->exec("INSERT INTO acct_bal_tb (acct_num, sub_acct_num, balance, bal_date, ledger_code) VALUES ($acct_num_str, '-2', '$total', '$to_date', '$ledger_code')");
      if ($result2->resultStatus != PGRES_COMMAND_OK)
      {
        print "<h1>Error:  Creating Initial Balance Table entry for Partner Equity Account ($temp - $acct_num_str) failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to Create Default Retained Earnings Balance of '$total' on '$to_date'.<br>$sys_admin";
        CleanUp();
      }
      $result2 = $conn->exec("INSERT INTO acct_bal_tb (acct_num, sub_acct_num, balance, bal_date, ledger_code) VALUES ($acct_num_str, '-1', '$total', '$to_date', '$ledger_code')");
      if ($result2->resultStatus != PGRES_COMMAND_OK)
      {
        print "<h1>Error:  Creating Initial Balance Table entry for Partner Equity Account ($temp - $acct_num_str) failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to Create Default Retained Earnings (-1) Balance of '$total' on '$to_date'.<br>$sys_admin";
        CleanUp();
      }
    }
    else  # add to it
    {
      my $balance = $result2->getvalue(0, 0);
      #print "The Partner Equity entry ($temp - $acct_num_str) is being updated!  Initial balance = <i>\$" . commify($balance) . "</i>.<br>\n";
      $balance += $total;
      $balance = sprintf "%.2f", $balance;

      $result2 = $conn->exec("UPDATE acct_bal_tb SET balance = '$balance' WHERE acct_num = $acct_num_str AND sub_acct_num = '-2' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
      if ($result2->resultStatus != PGRES_COMMAND_OK)
      {
        print "<h1>Error:  Updating Balance Table entry for Equity Account ($temp - $acct_num_str) failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to update Partners Retained Earnings Balance to be '$balance' on '$to_date'.<br>$sys_admin";
        CleanUp();
      }

      $result2 = $conn->exec("SELECT balance FROM acct_bal_tb WHERE acct_num = $acct_num_str AND sub_acct_num = '-1' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
      if ($result2->resultStatus != PGRES_TUPLES_OK)
      {
        print "<h1>Error:  Checking to see if the Partner Equity Account ($temp - $acct_num_str) had a balance failed!</h1>Business Type = '$business_type'<br>\n";
        print $conn->errorMessage . "<br>$sys_admin";
        CleanUp();
      }
      $balance = $result2->getvalue(0, 0);
      $balance += $total;
      $balance = sprintf "%.2f", $balance;
      $result2 = $conn->exec("UPDATE acct_bal_tb SET balance = '$balance' WHERE acct_num = $acct_num_str AND sub_acct_num = '-1' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
      if ($result2->resultStatus != PGRES_COMMAND_OK)
      {
        print "<h1>Error:  Updating Balance Table entry for Equity Account ($temp - $acct_num_str) failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to update Partners Retained Earnings (-1) Balance to be '$balance' on '$to_date'.<br>$sys_admin";
        CleanUp();
      }
    }
  }

  if ($remainder ne "0.00")
  {
    my ($acct_num_str, $temp) = split /\|/, $leftover_equity_account_str;
    #print "Account ($temp) = $acct_num_str\n<br>\n"

    # first get the equity account balance, as we need to add to the total it already has.
    $result2 = $conn->exec("SELECT balance FROM acct_bal_tb WHERE acct_num = $acct_num_str AND sub_acct_num = '-2' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error:  Checking to see if the Partner Equity Account ($temp - $acct_num_str) had a balance failed!</h1>\n";
      print $conn->errorMessage . "<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples == 0)  # create it
    {
      $result2 = $conn->exec("INSERT INTO acct_bal_tb (acct_num, sub_acct_num, balance, bal_date, ledger_code) VALUES ($acct_num_str, '-2', '$remainder', '$to_date', '$ledger_code')");
      if ($result2->resultStatus != PGRES_COMMAND_OK)
      {
        print "<h1>Error:  Creating Initial Balance Table entry for Leftover Partner Equity Account ($temp - $acct_num_str) failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to Create Default Retained Earnings Balance of '$remainder' on '$to_date'.<br>$sys_admin";
        CleanUp();
      }
      $result2 = $conn->exec("INSERT INTO acct_bal_tb (acct_num, sub_acct_num, balance, bal_date, ledger_code) VALUES ($acct_num_str, '-1', '$remainder', '$to_date', '$ledger_code')");
      if ($result2->resultStatus != PGRES_COMMAND_OK)
      {
        print "<h1>Error:  Creating Initial Balance Table entry for Leftover Partner Equity Account ($temp - $acct_num_str) failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to Create Default Retained Earnings (-1) Balance of '$remainder' on '$to_date'.<br>$sys_admin";
        CleanUp();
      }
    }
    else  # add to it
    {
      my $balance = $result2->getvalue(0, 0);
      $result_string .= "<tr><td align=right><h3>The leftover entry ($temp - $acct_num_str) is being updated! &nbsp;Initial balance = <i>\$" . commify($balance) . "</i>.</h3></td></tr>\n";
      $balance += $remainder;
      $balance = sprintf "%.2f", $balance;

      $result2 = $conn->exec("UPDATE acct_bal_tb SET balance = '$balance' WHERE acct_num = $acct_num_str AND sub_acct_num = '-2' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
      if ($result2->resultStatus != PGRES_COMMAND_OK)
      {
        print "<h1>Error:  Updating Balance Table entry for Equity Account ($temp - $acct_num_str) failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to update Partners Retained Earnings Balance to be '$balance' on '$to_date'.<br>$sys_admin";
        CleanUp();
      }

      $result2 = $conn->exec("SELECT balance FROM acct_bal_tb WHERE acct_num = $acct_num_str AND sub_acct_num = '-1' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
      if ($result2->resultStatus != PGRES_TUPLES_OK)
      {
        print "<h1>Error:  Checking to see if the Partner Equity Account ($temp - $acct_num_str) had a balance failed!</h1>\n";
        print $conn->errorMessage . "<br>$sys_admin";
        CleanUp();
      }
      $balance = $result2->getvalue(0, 0);
      $balance += $remainder;
      $balance = sprintf "%.2f", $balance;
      $result2 = $conn->exec("UPDATE acct_bal_tb SET balance = '$balance' WHERE acct_num = $acct_num_str AND sub_acct_num = '-1' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
      if ($result2->resultStatus != PGRES_COMMAND_OK)
      {
        print "<h1>Error:  Updating Balance Table entry for Equity Account ($temp - $acct_num_str) failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to update Partners Retained Earnings (-1) Balance to be '$balance' on '$to_date'.<br>$sys_admin";
        CleanUp();
      }
    }
  }
}
elsif ($business_type == 3)
{
  my ($i, $percentage, $share, $total);
  $total = $retained_earnings;
  for ($i=0; $i < scalar @ResultEquityAccounts; $i++)
  {
    $percentage = "percent_$i";
    $percentage = $input{$percentage};
    $percentage = "0.$percentage";
    my ($acct_num_str, $temp) = split /\|/, @ResultEquityAccounts[$i];  # $temp = account name, $percentage = percentage for this account
    #print "Account ($temp) = $acct_num_str, Percentage = $percentage%\n<br>\n";

    if ($retained_earnings ne "0.00")
    {
      $share = $retained_earnings * $percentage;
      if ($share < 0)
      {
        $share += "0.005";
      }
      else
      {
        $share -= "0.005";
      }
      $share = sprintf "%.2f", $share;
    }
    else
    {
      $share = "0.00";  # can't divide 0.00 up into anything other than 0.00!
    }

    $total -= $share;
    $total = sprintf "%.2f", $total;

    $result_string .= "<tr><td align=right><h3>Shareholder ($temp - $acct_num_str) receives <i>\$" . commify($share) . "</i> = " . $input{"percent_$i"} . "\%</h3></td></tr>\n";

    # first get the equity account balance, as we need to add to the total it already has.
    $result2 = $conn->exec("SELECT balance FROM acct_bal_tb WHERE acct_num = $acct_num_str AND sub_acct_num = '-2' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error:  Checking to see if the Shareholder Equity Account ($temp - $acct_num_str) had a balance failed!</h1>Business Type = '$business_type'<br>\n";
      print $conn->errorMessage . "<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples == 0)  # create it
    {
      $result2 = $conn->exec("INSERT INTO acct_bal_tb (acct_num, sub_acct_num, balance, bal_date, ledger_code) VALUES ($acct_num_str, '-2', '$share', '$to_date', '$ledger_code')");
      if ($result2->resultStatus != PGRES_COMMAND_OK)
      {
        print "<h1>Error:  Creating Initial Balance Table entry for Shareholder Equity Account ($temp - $acct_num_str) failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to Create Default Retained Earnings Balance of '$share' on '$to_date'.<br>$sys_admin";
        CleanUp();
      }
      $result2 = $conn->exec("INSERT INTO acct_bal_tb (acct_num, sub_acct_num, balance, bal_date, ledger_code) VALUES ($acct_num_str, '-1', '$share', '$to_date', '$ledger_code')");
      if ($result2->resultStatus != PGRES_COMMAND_OK)
      {
        print "<h1>Error:  Creating Initial Balance Table entry for Shareholder Equity Account ($temp - $acct_num_str) failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to Create Default Retained Earnings (-1) Balance of '$share' on '$to_date'.<br>$sys_admin";
        CleanUp();
      }
    }
    else  # add to it
    {
      my $balance = $result2->getvalue(0, 0);
      #print "The Partner Equity entry ($temp - $acct_num_str) is being updated!  Initial balance = <i>\$" . commify($balance) . "</i>.<br>\n";
      $balance += $share;
      $balance = sprintf "%.2f", $balance;

      $result2 = $conn->exec("UPDATE acct_bal_tb SET balance = '$balance' WHERE acct_num = $acct_num_str AND sub_acct_num = '-2' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
      if ($result2->resultStatus != PGRES_COMMAND_OK)
      {
        print "<h1>Error:  Updating Balance Table entry for Shareholder Equity Account ($temp - $acct_num_str) failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to update Shareholder Retained Earnings Balance to be '$balance' on '$to_date'.<br>$sys_admin";
        CleanUp();
      }

      $result2 = $conn->exec("SELECT balance FROM acct_bal_tb WHERE acct_num = $acct_num_str AND sub_acct_num = '-1' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
      if ($result2->resultStatus != PGRES_TUPLES_OK)
      {
        print "<h1>Error:  Checking to see if the Shareholder Equity Account ($temp - $acct_num_str) had a balance failed!</h1>Business Type = '$business_type'<br>\n";
        print $conn->errorMessage . "<br>$sys_admin";
        CleanUp();
      }
      $balance = $result2->getvalue(0, 0);
      $balance += $share;
      $balance = sprintf "%.2f", $balance;
      $result2 = $conn->exec("UPDATE acct_bal_tb SET balance = '$balance' WHERE acct_num = $acct_num_str AND sub_acct_num = '-1' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
      if ($result2->resultStatus != PGRES_COMMAND_OK)
      {
        print "<h1>Error:  Updating Balance Table entry for Shareholder Equity Account ($temp - $acct_num_str) failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to update Shareholder Retained Earnings (-1) Balance to be '$balance' on '$to_date'.<br>$sys_admin";
        CleanUp();
      }
    }
  }

  if ($total ne "0.00")
  {
    my ($acct_num_str, $temp) = split /\|/, $leftover_equity_account_str;
    #print "Account ($temp) = $acct_num_str\n<br>\n"

    $result_string .= "<tr><td align=right><h3>There is a remainder of <i>\$" . commify($total) . "</i>.</h3></td></tr>\n";

    # first get the equity account balance, as we need to add to the total it already has.
    $result2 = $conn->exec("SELECT balance FROM acct_bal_tb WHERE acct_num = $acct_num_str AND sub_acct_num = '-2' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error:  Checking to see if the Shareholder Equity Account ($temp - $acct_num_str) had a balance failed!</h1>\n";
      print $conn->errorMessage . "<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples == 0)  # create it
    {
      $result2 = $conn->exec("INSERT INTO acct_bal_tb (acct_num, sub_acct_num, balance, bal_date, ledger_code) VALUES ($acct_num_str, '-2', '$total', '$to_date', '$ledger_code')");
      if ($result2->resultStatus != PGRES_COMMAND_OK)
      {
        print "<h1>Error:  Creating Initial Balance Table entry for Leftover Shareholder Equity Account ($temp - $acct_num_str) failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to Create Default Retained Earnings Balance of '$total' on '$to_date'.<br>$sys_admin";
        CleanUp();
      }
      $result2 = $conn->exec("INSERT INTO acct_bal_tb (acct_num, sub_acct_num, balance, bal_date, ledger_code) VALUES ($acct_num_str, '-1', '$total', '$to_date', '$ledger_code')");
      if ($result2->resultStatus != PGRES_COMMAND_OK)
      {
        print "<h1>Error:  Creating Initial Balance Table entry for Leftover Shareholder Equity Account ($temp - $acct_num_str) failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to Create Default Retained Earnings (-1) Balance of '$total' on '$to_date'.<br>$sys_admin";
        CleanUp();
      }
    }
    else  # add to it
    {
      my $balance = $result2->getvalue(0, 0);
      $result_string .= "<tr><td align=right><h3>The leftover entry ($temp - $acct_num_str) is being updated! &nbsp;Initial balance = <i>\$" . commify($balance) . "</i>.</h3></td></tr>\n";
      $balance += $total;
      $balance = sprintf "%.2f", $balance;

      $result2 = $conn->exec("UPDATE acct_bal_tb SET balance = '$balance' WHERE acct_num = $acct_num_str AND sub_acct_num = '-2' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
      if ($result2->resultStatus != PGRES_COMMAND_OK)
      {
        print "<h1>Error:  Updating Balance Table entry for Equity Account ($temp - $acct_num_str) failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to update Partners Retained Earnings Balance to be '$balance' on '$to_date'.<br>$sys_admin";
        CleanUp();
      }

      $result2 = $conn->exec("SELECT balance FROM acct_bal_tb WHERE acct_num = $acct_num_str AND sub_acct_num = '-1' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
      if ($result2->resultStatus != PGRES_TUPLES_OK)
      {
        print "<h1>Error:  Checking to see if the Shareholder Equity Account ($temp - $acct_num_str) had a balance failed!</h1>\n";
        print $conn->errorMessage . "<br>$sys_admin";
        CleanUp();
      }
      $balance = $result2->getvalue(0, 0);
      $balance += $total;
      $balance = sprintf "%.2f", $balance;
      $result2 = $conn->exec("UPDATE acct_bal_tb SET balance = '$balance' WHERE acct_num = $acct_num_str AND sub_acct_num = '-1' AND bal_date = '$to_date' AND ledger_code = '$ledger_code'");
      if ($result2->resultStatus != PGRES_COMMAND_OK)
      {
        print "<h1>Error:  Updating Balance Table entry for Equity Account ($temp - $acct_num_str) failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to update Partners Retained Earnings (-1) Balance to be '$balance' on '$to_date'.<br>$sys_admin";
        CleanUp();
      }
    }
  }
}

$result_string .= "</table><br><br>\n";
print "$result_string";

my ($next_fiscal_year, $next_exists);

if ($working_year_end eq $to_date)
{
  # now check and see if the next fiscal year already exists in the known_years_tb
  $next_fiscal_year = $working_year + 1;

  $result = $conn->exec("SELECT year, closed, start_date, end_date FROM known_years_tb WHERE year = $working_year AND ledger_code = '$ledger_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get current fiscal year start and end dates from the known years table.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples == 0)
  {
    print "<h1>Error:  Internal Error!</h1>\n";
    print "The current fiscal year '$working_year' did not return it's start and end dates!<br>$sys_admin";
    CleanUp();
  }
  $from_date = $result->getvalue(0, 2);  # make sure I have the actual start and end dates of the fiscal year in question.
  $to_date = $result->getvalue(0, 3);

  $result2 = $conn->exec("SELECT year, closed FROM known_years_tb WHERE year = $next_fiscal_year AND ledger_code = '$ledger_code'");
  if ($result2->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to see if fiscal year = $next_fiscal_year existed in the known years table.<br>$sys_admin";
    CleanUp();
  }
  if ($result2->ntuples == 0)
  {
    $next_exists = 0;
  }
  else
  {
    $next_exists = 1;
  }

  # create the next fiscal year (if needed) in the known_years_tb
  if (not $next_exists)
  {
    my $begin_date = $from_date;
    $begin_date =~ s/-/\//g;
    $begin_date = `/bin/date --date \"$begin_date 1 year\" +%m/%d/%Y`; # point to the day 1 year from now
    chomp $begin_date;

    my $end_date = $to_date;
    $end_date =~ s/-/\//g;
    $end_date = `/bin/date --date \"$end_date 1 year\" +%m/%d/%Y`; # point to the day 1 year from now
    chomp $end_date;

    #print "Creating Fiscal Year Info for Year = $next_fiscal_year, Begin Date = $begin_date, End Date = $end_date<br>\n";

    $result2 = $conn->exec("INSERT INTO known_years_tb (year, closed, start_date, end_date, ledger_code) VALUES ($next_fiscal_year, false, '$begin_date', '$end_date', '$ledger_code')");
    if ($result2->resultStatus != PGRES_COMMAND_OK)
    {
      print "<h1>Error:  Creating Entry for Fiscal Year = $next_fiscal_year failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to create new record with Begin Date = $begin_date, End Date = $end_date<br>$sys_admin";
      CleanUp();
    }
    
    # check and see if we are doing a calendar year or not.
    if ($begin_date =~ /01\/01\/\d{4}/ && $end_date =~ /12\/31\/\d{4}/)
    { # calendar year
      my ($k, $quarter_start, $quarter_end, $result3);
      for ($k=1; $k <= 4; $k++)
      {
        if ($k == 1)
        {
          $quarter_start = "01/01/$next_fiscal_year";
          $quarter_end = "03/31/$next_fiscal_year";
        }
        elsif ($k == 2)
        {
          $quarter_start = "04/01/$next_fiscal_year";
          $quarter_end = "06/30/$next_fiscal_year";
        }
        elsif ($k == 3)
        {
          $quarter_start = "07/01/$next_fiscal_year";
          $quarter_end = "09/30/$next_fiscal_year";
        }
        elsif ($k == 4)
        {
          $quarter_start = "10/01/$next_fiscal_year";
          $quarter_end = "12/31/$next_fiscal_year";
        }
        
        $result3 = $conn->exec("UPDATE known_years_tb SET q" . $k . "_start = '$quarter_start', q" . $k . "_end = '$quarter_end' WHERE year = $next_fiscal_year AND ledger_code = '$ledger_code'");
        if ($result3->resultStatus != PGRES_COMMAND_OK)
        {
          print "<h1>Error:  Updating Fiscal Year = $next_fiscal_year's Quarter $k failed!</h1>\n";
          print $conn->errorMessage . "<br>Tried to create the info for Quarter $k.  Start = $quarter_start, End = $quarter_end.<br>$sys_admin";
          CleanUp();
        }
      }
    }
    else
    { # non-calendar year
      my ($k, $quarter_start, $quarter_end, $result3);
      for ($k=1; $k <= 4; $k++)
      {
        $quarter_start = $begin_date;
        if ($k != 4)
        {
          #$quarter_end = `/bin/date --date \"$begin_date 90 days\" +%m/%d/%Y`;
          $quarter_end = `/bin/date --date \"$begin_date 1 day ago 3 months\" +%m/%d/%Y`;
          chomp $quarter_end;
  
          $begin_date = `/bin/date --date \"$quarter_end 1 day\" +%m/%d/%Y`;
          chomp $begin_date;
        }
        else
        {
          $quarter_end = `/bin/date --date \"$begin_date 3 months\" +%m/%d/%Y`;
          chomp $quarter_end;
  
          if (not ($quarter_end eq $end_date)) # we must have a leap year,
          {
            $quarter_end = $end_date;
          }
        }
  
        #print "Adding Quarter $k info:  Start = $quarter_start, End = $quarter_end<br>\n";
  
        $result3 = $conn->exec("UPDATE known_years_tb SET q" . $k . "_start = '$quarter_start', q" . $k . "_end = '$quarter_end' WHERE year = $next_fiscal_year AND ledger_code = '$ledger_code'");
        if ($result3->resultStatus != PGRES_COMMAND_OK)
        {
          print "<h1>Error:  Updating Fiscal Year = $next_fiscal_year's Quarter $k failed!</h1>\n";
          print $conn->errorMessage . "<br>Tried to create the info for Quarter $k.  Start = $quarter_start, End = $quarter_end.<br>$sys_admin";
          CleanUp();
        }
      }
    }
  }
  else  # else set it active
  {
    $result2 = $conn->exec("UPDATE known_years_tb SET closed = false WHERE year = $next_fiscal_year AND ledger_code = '$ledger_code'");
    if ($result2->resultStatus != PGRES_COMMAND_OK)
    {
      print "<h1>Error:  Opening the next fiscal year failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to update the next fiscal year record.<br>$sys_admin";
      CleanUp();
    }
  }

  # mark the old current fiscal year as being closed
  $result2 = $conn->exec("UPDATE known_years_tb SET closed = true WHERE year = $working_year AND ledger_code = '$ledger_code'");
  if ($result2->resultStatus != PGRES_COMMAND_OK)
  {
    print "<h1>Error:  Closing the current fiscal year failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to update the fiscal year record.<br>$sys_admin";
    CleanUp();
  }

  # update the variables_tb to reflect the next fiscal year
  $result2 = $conn->exec("UPDATE variables_tb SET working_year = $next_fiscal_year WHERE ledger_code = '$ledger_code'");
  if ($result2->resultStatus != PGRES_COMMAND_OK)
  {
    print "<h1>Error:  Changing the working year failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to update the variables table.<br>$sys_admin";
    CleanUp();
  }
} # end of check if this was closing out a fiscal year and not just a fiscal period.

# commit the transaction
$result = $conn->exec("END WORK");
if ($result->resultStatus != PGRES_COMMAND_OK)
{
  print "<h1>Error:  Ending Ledger Transaction failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to END WORK.<br>$sys_admin";
  CleanUp();
}

if ($working_year_end eq $to_date)
{
  print "<h1>Fiscal Year <font color=\"red\">$working_year</font> Successfully Closed!<br><br>Fiscal Year <font color=\"red\">$next_fiscal_year</font> Successfully Opened!</h1>\n";
}
else
{
  print "<h1>Fiscal Period ending in <font color=\"red\">$to_date</font> in Fiscal Year <font color=\"red\">$working_year</font> Successfully Closed!<br><br>Next Fiscal Period Successfully Opened!</h1>\n";
}
print "<hr width=50%>\n";
print "Business Type = <b>$business_name</b>.<br>\n";
print "Previous Close Out was <b>$last_close_out</b>.\n";
print "<hr width=50%>\n";
print "<br>You will be returned to the <b>Ledger Summary</b> in <b><i>15</i></b> seconds.<br>\n";
print "<form name=\"success_form\" method=post action=\"$site_dir/cgi-bin/ledger.cgi\">\n";
print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
print "<input type=hidden name=\"open\" value=\"\">\n";
print "</form>\n";
print "<script Language=\"JavaScript1.2\">\n";
print "function SubmitForm()\n";
print "{\n";
print "  document.success_form.submit();\n";
print "}\n";
print "setTimeout('SubmitForm();', 15000);\n";
print "</script>\n";

print "</center>\n";

print "</body>\n";
print "</html>\n";
exit 0;