#!/usr/bin/perl
#$Id: journal_activity_rows_sheet.cgi,v 1.6 2004/02/23 23:23:39 pattieja Exp $
#This package is released under the GPL.  You should have recieved the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.

# journal_activity_rows_sheet.cgi  -  Created by Jason A. Pattie, 09/23/1999
# This script allows the user to enter the rows of information for the journal entry
# they are working with.  This includes Sub Entities, Accounts, Sub Accounts, Debits, and Credits.
# It takes the current working mode by which this script was reached and, upon submittal, sends the
# entered information to the appropriate script to create a new entry or update an existing entry.

use strict;

use Pg;  # PostgreSQL Database Module
use cgi_lib;  # CGI Library routines
use custom;  # our customizable features
use reports;

use vars '$date';
use vars '$count';
use vars '$count2';
use vars '$temp_count';
use vars '$debit_count';
use vars '$credit_count';
use vars '$trans_date';
use vars '$payee_payer';
use vars '$memo';
use vars '$remember';
use vars '$current_fiscal_year';
use vars '$start_fiscal';
use vars '$stop_fiscal';
use vars '$start_month_fiscal';
use vars '$stop_month_fiscal';
use vars '$start_day_fiscal';
use vars '$stop_day_fiscal';
use vars '$start_year_fiscal';
use vars '$stop_year_fiscal';
use vars '$ref_num';
use vars '@sub_e_codes';
use vars '@account_nums';
use vars '@sub_account_nums';
use vars '@amounts';
use vars '@dorcs';
use vars '@cleareds';
use vars '@counters';
use vars '$num_rows';
use vars '$sub_entity_value';
use vars '$local_account_name';
use vars '$local_account_id';
use vars '$local_account_type';
use vars '$local_account_taxable';
use vars '$sub_account_name';
use vars '$sub_account_id';
use vars '%sub_account_bank';
use vars '$account_numbers_string';
use vars '$payee_payer_exists';
use vars '$payee_payer_id';
use vars '$temp';
use vars '$last_check';
use vars '$last_deposit';
use vars '%check_hash';
use vars '%deposit_hash';
use vars '$local_accounts_string';
use vars '$other_mode';
use vars '$interface';
# multiple interfaces: "edit_rows_double_entry", "style_sheets_double_entry"
# There may possibly be a future interface that does not use double entry ("style_sheet"?)
# make display use the new interface until the configuration options are available to dynamically change the interface used
$interface = "style_sheets_double_entry";

use vars '@sub_entity_array';
use vars '@account_array';
use vars '$journal_command';
use vars '$journal_view_command';
use vars '$journal_display_string';
use vars '$refresh_record';
use vars '$refresh_item';
use vars '$refresh_key';
use vars '$refresh_value';
use vars '%refresh_debits_values';
use vars '%refresh_credits_values';
use vars '%reset_debits_values';
use vars '%reset_credits_values';
use vars '$refresh_debit_count';
use vars '$refresh_credit_count';
use vars '$reset_debit_count';
use vars '$reset_credit_count';
my $error_string;

# get the values being passed in from the client
%input = ();  # make sure it is empty!
cgi_lib::ReadParse(*input);

# begin the HTML Output
print cgi_lib::PrintHeader();
print "<html>\n";

my $mode;  # modes are "edit" or "new"
my $ledger_name;  # name of ledger to work with
my $ledger_db;
my $ledger_color;
my $journal_name;
my $journal_code;
my $result2;
my $result3;
my $date_from;
my $date_to;
my $sort_journal;
my $sort_by;
my $journal_bgcolor;
my $ledger_code;
my $report_obj;

use PortalWrapper; # The Portal Wrapper library.

my $portalObj;$portalObj = PortalWrapper->new;
if ($portalObj->didErrorOccur)
{
  # begin the HTML Output
  print cgi_lib::PrintHeader();
  print "<html>\n";

  PrintErrorHeader();
  print $portalObj->errorMessage;
  CleanUp();
}
my $dbObj;$dbObj = $portalObj->getDBInfo;
if (!defined $dbObj)
{
  if ($portalObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $portalObj->errorMessage;
    CleanUp();
  }
}
else
{
  if ($dbObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $dbObj->errorMessage;
    CleanUp();
  }
}
$db_host = $dbObj->dbHost;
$db_name = $dbObj->dbName;
$db_user = $dbObj->dbUser;
$db_passwd = $dbObj->dbPasswd;

my $database_connected;$database_connected = 0;

$payee_payer_exists = "false";

if (not (exists $input{'edit_submit'} or exists $input{'create_submit'} or exists $input{'refresh1'}))
{
  PrintErrorHeader();
  print "<h1>Error:  Access Denied!</h1>\n";
  print "Invalid options.<br>$sys_admin";
  CleanUp();
}

$ledger_db = $input{'ledger_db'};
if (length $ledger_db == 0)
{
  PrintErrorHeader();
  print "<h1>Error: You must specify a ledger to work with!</h1>\n";
  print "$back_button";
  CleanUp();
}
$error_string = IsValidString($ledger_db);
if (length $error_string > 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Database Name!</h1>\n";
  print "<b>$error_string</b> is invalid!<br>$back_button";
  CleanUp();
}

# validate we got valid input from the user.
if (exists $input{'edit_submit'})
{
  $mode = "edit";
}
elsif (exists $input{'create_submit'})
{
  $mode = "new";
}
elsif (exists $input{'refresh1'})
{
  $mode = "refresh";
  $other_mode = $input{'mode'};
  if ($other_mode eq "edit")
  {
    # check to make sure that we have a reference number to edit
    if (not exists $input{'ref_num'})
    {
      PrintErrorHeader();
      print "<h1>Access Denied!</h1>\n";
      print "Error: Reference Number not specified for editing journal entry!<br>$sys_admin";
      CleanUp();
    }
    $ref_num = $input{'ref_num'};
    $error_string = IsValidUInteger($ref_num);
    if (length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid Reference Number!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
  }
}
else
{
  PrintErrorHeader();
  print "<h1>Access Denied!</h1>\n";
  print "Error: Invalid options given!\n<br>$sys_admin";
  CleanUp();
}

if ($mode eq "refresh")
{
  # get the first half of the transaction information
  $journal_code = $input{'journal_code'};
  $error_string = IsValidString($journal_code);
  if (length $error_string > 0)
  {
    print "<h1>Error:  Invalid Journal Code!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  $trans_date = $input{'trans_date'};
  if (not IsValidDateSyntax($trans_date))
  {
    print "<h1>Error:  Invalid Transaction Date!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $payee_payer = $input{'payee_payer'};
  $error_string = IsValidString($payee_payer);
  if (length $error_string > 0)
  {
    print "<h1>Error:  Invalid Payee-Payer</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  $memo = $input{'memo'};
  $error_string = IsValidString($memo);
  if (length $error_string > 0)
  {
    print "<h1>Error:  Invalid Memo!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  if (exists $input{'remember'})
  {
    $remember = $input{'remember'};
  }
  else
  {
    $remember = "false";
  }
}
else
{
  # get the first half of the transaction information
  $journal_code = $input{'journal_code_select'};
  $error_string = IsValidString($journal_code);
  if (length $error_string > 0)
  {
    print "<h1>Error:  Invalid Journal Code!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  $trans_date = $input{'trans_date'};
  if (not IsValidDateSyntax($trans_date))
  {
    print "<h1>Error:  Invalid Transaction Date!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $memo = $input{'memo_text'};
  $error_string = IsValidString($memo);
  if (length $error_string > 0)
  {
    print "<h1>Error:  Invalid Memo!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  if (exists $input{'remembered_check'})
  {
    $remember = "true";
  }
  else
  {
    $remember = "false";
  }
}
if (length $journal_code == 0)
{
  PrintErrorHeader();
  print "<h1>Error: You must specify a journal to work with!</h1>\n";
  print "$back_button";
  CleanUp();
}
$error_string = IsValidString($journal_code);
if (length $error_string > 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Journal Code!</h1>\n";
  print "<b>$error_string</b> is invalid!<br>$back_button";
  CleanUp();
}

$journal_bgcolor = $input{'journal_bgcolor'};
if (length $journal_bgcolor == 0)
{
  $journal_bgcolor = "deepskyblue";
}
$error_string = IsValidString($journal_bgcolor);
if (length $error_string > 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Journal Color!</h1>\n";
  print "<b>$error_string</b> is invalid!<br>$back_button";
  CleanUp();
}

if ($mode eq "edit")
{
  # check to make sure that we have a reference number to edit
  if (not exists $input{'ref_num'})
  {
    PrintErrorHeader();
    print "<h1>Access Denied!</h1>\n";
    print "Error: Reference Number not specified for editing journal entry!<br>$sys_admin";
    CleanUp();
  }
  $ref_num = $input{'ref_num'};
  $error_string = IsValidUInteger($ref_num);
  if (length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Reference Number!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
}

# check to see if we are running under mod_perl
if (exists $ENV{MOD_PERL})
{
  # check to see if the database is still connected
  if (defined $conn)
  {
    # check the status of the connection
    if ($conn->status != PGRES_CONNECTION_OK)
    {
      $database_connected = 0;
    }
    else
    {
      # connection still good!
      $database_connected = 1;
    }
  }
  else
  {
    $database_connected = 0;
  }
}

if (not $database_connected)
{
  # connect to the database.
  $conn = Pg::connectdb("host = $db_host dbname = $db_name user = $db_user password = $db_passwd");
  if ($conn->status == PGRES_CONNECTION_BAD)
  {
    PrintErrorHeader();
    print "<h1>Error:  Couldn't connect to the database!</h1><br>\n";
    print $conn->errorMessage . "<br>$sys_admin";
    CleanUp();
  }
}

# set the DateStyle for the Database.
$result = setDBDateStyle($conn);
if ($result->resultStatus != PGRES_COMMAND_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Setting Date Style failed!</h1>\n";
  print $conn->errorMessage . "<br>$sys_admin";
  CleanUp();
}

# now validate that the ledger they specified is valid
$result = $conn->exec("select name from entity_tb where database_name = '$ledger_db'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error: Accessing database failed!</h1>\n";
  print $conn->errorMessage . "<br>Trying to check entity table.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples == 0)
{
  PrintErrorHeader();
  print "<h1>Error: Ledger <font color=\"blue\">$ledger_db</font> does not exist!</h1>\n";
  print "$sys_admin";
  CleanUp();
}
else
{
  $ledger_name = $result->getvalue(0, 0);
}

# create the reports object
$report_obj = reports->new($conn, $ledger_db);
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}
$ledger_code = $report_obj->getLedgerCode();
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}
$ledger_color = $report_obj->getLedgerColor();
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}

# now make sure that the journal exists that we are supposed to work with
if ($journal_code eq "all_journals")
{ # this will be a special case
  $journal_name = "All Journals";
}
else
{
  $result = $conn->exec("select name from journal_tb where code = '$journal_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error:  Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to validate Journal with code = <font color=\"blue\">$journal_code</font>.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Journal with code = <font color=\"blue\">$journal_code</font> does not exist!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
  $journal_name = $result->getvalue(0, 0);
}

# get current fiscal year and verify that it is not closed
$result = $conn->exec("select working_year from variables_tb WHERE ledger_code = '$ledger_code'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "<h1>Error: Accessing database <font color=\"blue\"$ledger_db</font> failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get current fiscal year from database.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples != 1)
{
  print "<h1>Error: Wrong number of records returned!</h1>\n";
  print "There should only be one record in the variables_tb.  " . $result->ntuples . " were returned.<br>$sys_admin";
  CleanUp();
}
$current_fiscal_year = $result->getvalue(0, 0);
# get the date ranges for the current fiscal year if it is not closed
$result = $conn->exec("select closed, start_date, end_date from known_years_tb where year = $current_fiscal_year AND ledger_code = '$ledger_code'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "<h1>Error: Accessing database <font color=\"blue\"$ledger_db</font> failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get current fiscal year info. from database.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples != 1)
{
  print "<h1>Error: Wrong number of records returned!</h1>\n";
  print "There should only be one record for each individual fiscal year.<br>$sys_admin";
  CleanUp();
}
if ($result->getvalue(0, 0) eq "t")
{
  print "<h1>Fiscal Year ($current_fiscal_year) is Closed!</h1>\n";
  print "You cannot work with the records in a closed fiscal year.<br>$sys_admin";
  CleanUp();
}
$start_fiscal = $result->getvalue(0, 1);
$stop_fiscal = $result->getvalue(0, 2);
($start_month_fiscal, $start_day_fiscal, $start_year_fiscal) = split "-", $start_fiscal;
($stop_month_fiscal, $stop_day_fiscal, $stop_year_fiscal) = split "-", $stop_fiscal;

if ($mode eq "edit")
{
  $payee_payer_id = $input{'payee_payer_select'};
  $error_string = IsValidInteger($payee_payer_id);
  if (length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Payee-Payer ID!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  if ($payee_payer_id != -1)
  {
    $result = $conn->exec("select payee_payer from journal_entry_tb where ref_num = $payee_payer_id AND ledger_code = '$ledger_code'");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to get payee-payer name for record $payee_payer_id.<br>$sys_admin";
      CleanUp();
    }
    if ($result->ntuples != 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print "There should be only one record returned, not " . $result->ntuples . ".<br>$sys_admin";
      CleanUp();
    }
    $payee_payer = $result->getvalue(0, 0);
    # determine whether the payee-payer is remembered or recalled or does not exist yet
    if ($input{'payee_payer_text'} =~ /^R>.+/)
    {
      $payee_payer_exists = "true";
    }
    else
    {
      # see if payee-payer matches what is entered in the payee-payer text field
      if ($payee_payer eq $input{'payee_payer_text'})
      {
        $payee_payer_exists = "true";
      }
      else
      {
        $payee_payer_exists = "false";
      }
    }
  }
  else
  {
    $payee_payer_exists = "false";
  }
  if ($payee_payer_exists eq "false")
  {
    $payee_payer = $input{'payee_payer_text'};
    $error_string = IsValidString($payee_payer);
    if (length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid Payee-Payer!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
  }
  # get the row data for the journal entry pointed to by ref_num
  $result = $conn->exec("select parent_num, sub_e_code, account_num, sub_account_num, amount, dorc, cleared, counter from debitcredit_tb where parent_num = $ref_num and dorc = true AND ledger_code = '$ledger_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error: Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to retrieve Journal Entry rows data for ref_num = <font color=\"blue\">$ref_num</font>.<br>$sys_admin";
    CleanUp();
  }
  for ($count=0; $count < $result->ntuples; $count++)
  {
    # load the arrays with the row data from the transaction
    $sub_e_codes[$count] = $result->getvalue($count, 1);
    $account_nums[$count] = $result->getvalue($count, 2);
    $sub_account_nums[$count] = $result->getvalue($count, 3);
    # if account is bank account (cash), then sub-account is check/deposit number; put into sub_account_text field
    $result2 = $conn->exec("select type from account_tb where number = $account_nums[$count]");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to lookup account type for $account_nums[$count].<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples != 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print $result2->ntuples . " records were returned. There should be only one.<br>$sys_admin";
      CleanUp();
    }
    if ($result2->getvalue(0, 0) == 0)
    {
      # this is a bank (cash) account; mark it
      $sub_account_bank{$account_nums[$count]} = 1;
    }
    $amounts[$count] = $result->getvalue($count, 4);
    # remove ($)s and (,)s from amount; database doesn't like these
    $amounts[$count] =~ s/\$//g;
    $amounts[$count] =~ s/\,//g;
    $dorcs[$count] = $result->getvalue($count, 5);
    $cleareds[$count] = $result->getvalue($count, 6);
    $counters[$count] = $result->getvalue($count, 7);
  }
  $result = $conn->exec("select parent_num, sub_e_code, account_num, sub_account_num, amount, dorc, cleared, counter from debitcredit_tb where parent_num = $ref_num and dorc = false AND ledger_code = '$ledger_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error: Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to retrieve Journal Entry rows data for ref_num = <font color=\"blue\">$ref_num</font>.<br>$sys_admin";
    CleanUp();
  }
  for ($count2=0; $count2 < $result->ntuples; $count++, $count2++)
  {
    # load the arrays with the row data from the transaction
    $sub_e_codes[$count] = $result->getvalue($count2, 1);
    $account_nums[$count] = $result->getvalue($count2, 2);
    $sub_account_nums[$count] = $result->getvalue($count2, 3);
    # if account is bank account (cash), then sub-account is check number; put into sub_account_text field
    $result2 = $conn->exec("select type from account_tb where number = $account_nums[$count]");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to lookup account type for $account_nums[$count].<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples != 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print $result2->ntuples . " records were returned. There should be only one.<br>$sys_admin";
      CleanUp();
    }
    if ($result2->getvalue(0, 0) == 0)
    {
      # this is a bank (cash) account; mark it
      $sub_account_bank{$account_nums[$count]} = 1;
    }
    $amounts[$count] = $result->getvalue($count2, 4);
    # remove ($)s and (,)s from amount; database doesn't like these
    $amounts[$count] =~ s/\$//g;
    $amounts[$count] =~ s/\,//g;
    $dorcs[$count] = $result->getvalue($count2, 5);
    $cleareds[$count] = $result->getvalue($count2, 6);
    $counters[$count] = $result->getvalue($count2, 7);
  }
  $num_rows = $count;

  # run through all accounts that are cash accounts (type == 0) and get the next available check/deposit #'s
  $result = $conn->exec("select acct_num from local_accounts_tb, account_tb WHERE ledger_code = '$ledger_code' AND (account_tb.number = acct_num AND account_tb.active = '1') UNION select account_num from debitcredit_tb WHERE parent_num = $ref_num AND ledger_code = '$ledger_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>1006: Tried to get the list of local accounts assigned to this ledger.<br>$sys_admin";
    CleanUp();
  }
  # build a string with the list of local account numbers in it
  $local_accounts_string = "";
  for ($count=0; $count < $result->ntuples; $count++)
  {
    $local_accounts_string .= $result->getvalue($count, 0);
    if ($count < $result->ntuples - 1)
    {
      $local_accounts_string .= ", ";
    }
  }
  if ($local_accounts_string eq "")
  {
    PrintErrorHeader();
    print "<h1>Error: No Accounts Found!</h1>\n";
    print "It appears that there are no accounts assigned to this ledger.  You must assign some accounts to continue.<br>$sys_admin";
    CleanUp();
  }
  $result = $conn->exec("select number from account_tb where type = 0 and number in ($local_accounts_string)");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>1007: Tried to get all accounts from the main database with type = 0.<br>$sys_admin";
    CleanUp();
  }
  for ($count=0; $count < $result->ntuples; $count++)
  {
    # get last used check/deposit #'s
    $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = true and parent_num = (select max(parent_num) from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = true and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print "Error 1000<br>\n";
      print $conn->errorMessage . "<br>Tried to get the last used deposit# for account " . $result->getvalue($count, 0) . ".<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples > 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print "Error 1001<br>\n";
      print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples == 0)
    {
      $last_deposit = -1;
    }
    else
    {
      $last_deposit = $result2->getvalue(0, 0);
      if ($last_deposit eq "")
      {
        $last_deposit = -1;
      }
    }
    $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = false and parent_num = (select max(parent_num) from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = false and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print "Error 1002<br>\n";
      print $conn->errorMessage . "<br>Tried to get the last used check# for account " . $result->getvalue($count, 0) . ".<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples > 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print "Error 1003<br>\n";
      print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples == 0)
    {
      $last_check = -1;
    }
    else
    {
      $last_check = $result2->getvalue(0, 0);
      if ($last_check eq "")
      {
        $last_check = -1;
      }
    }
    # increment last_deposit and last_check and check for duplicates in database
    do {
      $last_deposit++;
      $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = true and sub_account_num = $last_deposit AND ledger_code = '$ledger_code'");
    } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>1004:  Tried to see if the incremented deposit exists in the database.<br>$sys_admin";
      CleanUp();
    }
    do {
      $last_check++;
      $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = false and sub_account_num = $last_check AND ledger_code = '$ledger_code'");
    } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>1005:  Tried to see if the incremented check exists in the database.<br>$sys_admin";
      CleanUp();
    }

    $temp = $result->getvalue($count, 0);
    $deposit_hash{$temp} = $last_deposit;

    $temp = $result->getvalue($count, 0);
    $check_hash{$temp} = $last_check;
  }
}
elsif ($mode eq "new")
{
  $payee_payer_id = $input{'payee_payer_select'};
  $error_string = IsValidInteger($payee_payer_id);
  if (length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Payee-Payer ID!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  if ($payee_payer_id eq "-1")
  {
    $payee_payer_exists = "false";
  }
  if ($payee_payer_id != -1 && $input{'payee_payer_text'} ne "")
  {
    $result = $conn->exec("select payee_payer from journal_entry_tb where ref_num = $payee_payer_id AND ledger_code = '$ledger_code'");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to get payee-payer name for record $payee_payer_id.<br>$sys_admin";
      CleanUp();
    }
    if ($result->ntuples > 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print "There should be only one record returned, not " . $result->ntuples . ".<br>$sys_admin";
      CleanUp();
    }
    if ($result->ntuples == 0)
    {
      $payee_payer = "";
    }
    else
    {
      $payee_payer = $result->getvalue(0, 0);
    }
    # determine whether the payee-payer is remembered or recalled or does not exist yet
    if ($input{'payee_payer_text'} =~ /^R>.+/)
    {
      $payee_payer_exists = "true";
    }
    else
    {
      # see if payee-payer matches what is entered in the payee-payer text field
      if ($payee_payer eq $input{'payee_payer_text'})
      {
        $payee_payer_exists = "true";
      }
      else
      {
        $payee_payer_exists = "false";
      }
    }
  }
  else
  {
    $payee_payer_exists = "false";
  }
  if ($payee_payer_exists eq "true")
  {
    # get recalled/remembered data for the payee-payer previously entered
    # get the row data for the journal entry pointed to by ref_num
    $result = $conn->exec("select parent_num, sub_e_code, account_num, sub_account_num, amount, dorc, cleared, counter from debitcredit_tb where parent_num = $payee_payer_id and dorc = true AND ledger_code = '$ledger_code'");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to retrieve Journal Entry rows data for ref_num = <font color=\"blue\">$ref_num</font>.<br>$sys_admin";
      CleanUp();
    }
    for ($count=0; $count < $result->ntuples; $count++)
    {
      # load the arrays with the row data from the transaction
      $sub_e_codes[$count] = $result->getvalue($count, 1);
      $account_nums[$count] = $result->getvalue($count, 2);
      $dorcs[$count] = $result->getvalue($count, 5);
      # if account is bank account (cash), then sub-account is check/deposit number; put into sub_account_text field
      $result2 = $conn->exec("select type from account_tb where number = $account_nums[$count]");
      if ($result2->resultStatus != PGRES_TUPLES_OK)
      {
        print "<h1>Error: Accessing database failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to lookup account type for $account_nums[$count].<br>$sys_admin";
        CleanUp();
      }
      if ($result2->ntuples != 1)
      {
        print "<h1>Error: Wrong number of records returned!</h1>\n";
        print $result2->ntuples . " records were returned. There should be only one.<br>$sys_admin";
        CleanUp();
      }
      if ($result2->getvalue(0, 0) == 0)
      {
        # this is a bank (cash) account; mark it
        $sub_account_bank{$account_nums[$count]} = 1;
        # get last used check/deposit #'s
        $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = true and parent_num = (select max(parent_num) from debitcredit_tb where account_num = $account_nums[$count] and dorc = true and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
        if ($result2->resultStatus != PGRES_TUPLES_OK)
        {
          print "<h1>Error: Accessing database failed!</h1>\n";
          print "Error 1000<br>\n";
          print $conn->errorMessage . "<br>Tried to get the last used deposit# for account " . $account_nums[$count] . ".<br>$sys_admin";
          CleanUp();
        }
        if ($result2->ntuples > 1)
        {
          print "<h1>Error: Wrong number of records returned!</h1>\n";
          print "Error 1001<br>\n";
          print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
          CleanUp();
        }
        if ($result2->ntuples == 0)
        {
          $last_deposit = -1;
        }
        else
        {
          $last_deposit = $result2->getvalue(0, 0);
          if ($last_deposit eq "")
          {
            $last_deposit = -1;
          }
        }
        $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = false and parent_num = (select max(parent_num) from debitcredit_tb where account_num = $account_nums[$count] and dorc = false and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
        if ($result2->resultStatus != PGRES_TUPLES_OK)
        {
          print "<h1>Error: Accessing database failed!</h1>\n";
          print "Error 1002<br>\n";
          print $conn->errorMessage . "<br>Tried to get the last used check# for account " . $account_nums[$count] . ".<br>$sys_admin";
          CleanUp();
        }
        if ($result2->ntuples > 1)
        {
          print "<h1>Error: Wrong number of records returned!</h1>\n";
          print "Error 1003<br>\n";
          print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
          CleanUp();
        }
        if ($result2->ntuples == 0)
        {
          $last_check = -1;
        }
        else
        {
          $last_check = $result2->getvalue(0, 0);
          if ($last_check eq "")
          {
            $last_check = -1;
          }
        }
        # increment last_deposit and last_check and check for duplicates in database
        do {
          $last_deposit++;
          $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = $account_nums[$count] and dorc = true and sub_account_num = $last_deposit AND ledger_code = '$ledger_code'");
        } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
        if ($result2->resultStatus != PGRES_TUPLES_OK)
        {
          PrintErrorHeader();
          print "<h1>Error: Accessing database failed!</h1>\n";
          print $conn->errorMessage . "<br>1004.  Tried to see if the incremented deposit exists in the database.<br>$sys_admin";
          CleanUp();
        }
        do {
          $last_check++;
          $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = $account_nums[$count] and dorc = false and sub_account_num = $last_check AND ledger_code = '$ledger_code'");
        } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
        if ($result2->resultStatus != PGRES_TUPLES_OK)
        {
          PrintErrorHeader();
          print "<h1>Error: Accessing database failed!</h1>\n";
          print $conn->errorMessage . "<br>1005.  Tried to see if the incremented check exists in the database.<br>$sys_admin";
          CleanUp();
        }
        if ($dorcs[$count] eq "t")
        {
          if ($last_deposit == 0)
          {
            $sub_account_nums[$count] = -1;
          }
          else
          {
            $sub_account_nums[$count] = $last_deposit;
          }
        }
        else
        {
          if ($last_check == 0)
          {
            $sub_account_nums[$count] = -1;
          }
          else
          {
            $sub_account_nums[$count] = $last_check;
          }
        }
      }
      else
      {
        $sub_account_nums[$count] = $result->getvalue($count, 3);
      }

      $amounts[$count] = $result->getvalue($count, 4);
      # remove ($)s and (,)s from amount; database doesn't like these
      $amounts[$count] =~ s/\$//g;
      $amounts[$count] =~ s/\,//g;
      $cleareds[$count] = $result->getvalue($count, 6);
      $counters[$count] = $result->getvalue($count, 7);
    }
    $result = $conn->exec("select parent_num, sub_e_code, account_num, sub_account_num, amount, dorc, cleared, counter from debitcredit_tb where parent_num = $payee_payer_id and dorc = false AND ledger_code = '$ledger_code'");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to retrieve Journal Entry rows data for ref_num = <font color=\"blue\">$ref_num</font>.<br>$sys_admin";
      CleanUp();
    }
    for ($count2=0; $count2 < $result->ntuples; $count++, $count2++)
    {
      # load the arrays with the row data from the transaction
      $sub_e_codes[$count] = $result->getvalue($count2, 1);
      $account_nums[$count] = $result->getvalue($count2, 2);
      $dorcs[$count] = $result->getvalue($count2, 5);
      # if account is bank account (cash), then sub-account is check/deposit number; put into sub_account_text field
      $result2 = $conn->exec("select type from account_tb where number = $account_nums[$count]");
      if ($result2->resultStatus != PGRES_TUPLES_OK)
      {
        print "<h1>Error: Accessing database failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to lookup account type for $account_nums[$count].<br>$sys_admin";
        CleanUp();
      }
      if ($result2->ntuples != 1)
      {
        print "<h1>Error: Wrong number of records returned!</h1>\n";
        print $result2->ntuples . " records were returned. There should be only one.<br>$sys_admin";
        CleanUp();
      }
      if ($result2->getvalue(0, 0) == 0)
      {
        # this is a bank (cash) account; mark it
        $sub_account_bank{$account_nums[$count]} = 1;
        # get last used check/deposit #'s
        $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = true and parent_num = (select max(parent_num) from debitcredit_tb where account_num = $account_nums[$count] and dorc = true and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
        if ($result2->resultStatus != PGRES_TUPLES_OK)
        {
          print "<h1>Error: Accessing database failed!</h1>\n";
          print "Error 1000<br>\n";
          print $conn->errorMessage . "<br>Tried to get the last used deposit# for account " . $account_nums[$count] . ".<br>$sys_admin";
          CleanUp();
        }
        if ($result2->ntuples > 1)
        {
          print "<h1>Error: Wrong number of records returned!</h1>\n";
          print "Error 1001<br>\n";
          print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
          CleanUp();
        }
        if ($result2->ntuples == 0)
        {
          $last_deposit = -1;
        }
        else
        {
          $last_deposit = $result2->getvalue(0, 0);
          if ($last_deposit eq "")
          {
            $last_deposit = -1;
          }
        }
        $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = false and parent_num = (select max(parent_num) from debitcredit_tb where account_num = $account_nums[$count] and dorc = false and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
        if ($result2->resultStatus != PGRES_TUPLES_OK)
        {
          print "<h1>Error: Accessing database failed!</h1>\n";
          print "Error 1002<br>\n";
          print $conn->errorMessage . "<br>Tried to get the last used check# for account " . $account_nums[$count] . ".<br>$sys_admin";
          CleanUp();
        }
        if ($result2->ntuples > 1)
        {
          print "<h1>Error: Wrong number of records returned!</h1>\n";
          print "Error 1003<br>\n";
          print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
          CleanUp();
        }
        if ($result2->ntuples == 0)
        {
          $last_check = -1;
        }
        else
        {
          $last_check = $result2->getvalue(0, 0);
          if ($last_check eq "")
          {
            $last_check = -1;
          }
        }
        # increment last_deposit and last_check and check for duplicates in database
        do {
          $last_deposit++;
          $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = $account_nums[$count] and dorc = true and sub_account_num = $last_deposit AND ledger_code = '$ledger_code'");
        } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
        if ($result2->resultStatus != PGRES_TUPLES_OK)
        {
          PrintErrorHeader();
          print "<h1>Error: Accessing database failed!</h1>\n";
          print $conn->errorMessage . "<br>1004.  Tried to see if the incremented deposit exists in the database.<br>$sys_admin";
          CleanUp();
        }
        do {
          $last_check++;
          $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = $account_nums[$count] and dorc = false and sub_account_num = $last_check AND ledger_code = '$ledger_code'");
        } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
        if ($result2->resultStatus != PGRES_TUPLES_OK)
        {
          PrintErrorHeader();
          print "<h1>Error: Accessing database failed!</h1>\n";
          print $conn->errorMessage . "<br>1005.  Tried to see if the incremented check exists in the database.<br>$sys_admin";
          CleanUp();
        }
        if ($dorcs[$count] eq "t")
        {
          if ($last_deposit == 0)
          {
            $sub_account_nums[$count] = -1;
          }
          else
          {
            $sub_account_nums[$count] = $last_deposit;
          }
        }
        else
        {
          if ($last_check == 0)
          {
            $sub_account_nums[$count] = -1;
          }
          else
          {
            $sub_account_nums[$count] = $last_check;
          }
        }
      }
      else
      {
        $sub_account_nums[$count] = $result->getvalue($count2, 3);
      }

      $amounts[$count] = $result->getvalue($count2, 4);
      # remove ($)s and (,)s from amount; database doesn't like these
      $amounts[$count] =~ s/\$//g;
      $amounts[$count] =~ s/\,//g;
      $cleareds[$count] = $result->getvalue($count2, 6);
      $counters[$count] = $result->getvalue($count2, 7);
    }
    $num_rows = $count;
  }
  else
  {
    $num_rows = 0;
    $payee_payer = $input{'payee_payer_text'};
    $error_string = IsValidString($payee_payer);
    if (length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid Payee-Payer!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
  }
  # run through all accounts that are cash accounts (type == 0) and get the next available check/deposit #'s
  my $tmpSQLString = ($payee_payer_exists eq "true" ? " UNION select account_num FROM debitcredit_tb WHERE ledger_code = '$ledger_code' AND parent_num = $payee_payer_id" : "");
  $result = $conn->exec("select acct_num from local_accounts_tb, account_tb WHERE ledger_code = '$ledger_code' AND (account_tb.number = acct_num AND account_tb.active = '1')$tmpSQLString");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>1006: Tried to get the list of local accounts assigned to this ledger.<br>$sys_admin";
    CleanUp();
  }
  # build a string with the list of local account numbers in it
  $local_accounts_string = "";
  for ($count=0; $count < $result->ntuples; $count++)
  {
    $local_accounts_string .= $result->getvalue($count, 0);
    if ($count < $result->ntuples - 1)
    {
      $local_accounts_string .= ", ";
    }
  }
  if ($local_accounts_string eq "")
  {
    PrintErrorHeader();
    print "<h1>Error: No Accounts Found!</h1>\n";
    print "It appears that there are no accounts assigned to this ledger.  You must assign some accounts to continue.<br>$sys_admin";
    CleanUp();
  }
  $result = $conn->exec("select number from account_tb where type = 0 and number in ($local_accounts_string)");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>1007: Tried to get all accounts from the main database with type = 0.<br>$sys_admin";
    CleanUp();
  }
  for ($count=0; $count < $result->ntuples; $count++)
  {
    # get last used check/deposit #'s
    $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = true and parent_num = (select max(parent_num) from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = true and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print "Error 1000<br>\n";
      print $conn->errorMessage . "<br>Tried to get the last used deposit# for account " . $result->getvalue($count, 0) . ".<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples > 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print "Error 1001<br>\n";
      print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples == 0)
    {
      $last_deposit = -1;
    }
    else
    {
      $last_deposit = $result2->getvalue(0, 0);
      if ($last_deposit eq "")
      {
        $last_deposit = -1;
      }
    }
    $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = false and parent_num = (select max(parent_num) from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = false and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print "Error 1002<br>\n";
      print $conn->errorMessage . "<br>Tried to get the last used check# for account " . $result->getvalue($count, 0) . ".<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples > 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print "Error 1003<br>\n";
      print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples == 0)
    {
      $last_check = -1;
    }
    else
    {
      $last_check = $result2->getvalue(0, 0);
      if ($last_check eq "")
      {
        $last_check = -1;
      }
    }
    # increment last_deposit and last_check and check for duplicates in database
    do {
      $last_deposit++;
      $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = true and sub_account_num = $last_deposit AND ledger_code = '$ledger_code'");
    } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>1004:  Tried to see if the incremented deposit exists in the database.<br>$sys_admin";
      CleanUp();
    }
    do {
      $last_check++;
      $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = false and sub_account_num = $last_check AND ledger_code = '$ledger_code'");
    } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>1005:  Tried to see if the incremented check exists in the database.<br>$sys_admin";
      CleanUp();
    }

    $temp = $result->getvalue($count, 0);
    $deposit_hash{$temp} = $last_deposit;

    $temp = $result->getvalue($count, 0);
    $check_hash{$temp} = $last_check;
  }
}
elsif ($mode eq "refresh")
{
  $payee_payer_id = $input{'payee_payer_id'};
  $error_string = IsValidInteger($payee_payer_id);
  if (length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Payee-Payer ID!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  # run through all accounts that are cash accounts (type == 0) and get the next available check/deposit #'s
  my $tmpSQLString = (($payee_payer_id != -1 && $payee_payer_id ne "") ? " UNION select account_num FROM debitcredit_tb WHERE ledger_code = '$ledger_code' AND parent_num = $payee_payer_id" : "");
  $tmpSQLString .= ($ref_num ne "" ? " UNION select account_num from debitcredit_tb WHERE parent_num = $ref_num AND ledger_code = '$ledger_code'" : "");
  $result = $conn->exec("select acct_num from local_accounts_tb, account_tb WHERE ledger_code = '$ledger_code' AND (account_tb.number = acct_num AND account_tb.active = '1')$tmpSQLString");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>1006: Tried to get the list of local accounts assigned to this ledger.<br>$sys_admin";
    CleanUp();
  }
  # build a string with the list of local account numbers in it
  $local_accounts_string = "";
  for ($count=0; $count < $result->ntuples; $count++)
  {
    $local_accounts_string .= $result->getvalue($count, 0);
    if ($count < $result->ntuples - 1)
    {
      $local_accounts_string .= ", ";
    }
  }
  if ($local_accounts_string eq "")
  {
    PrintErrorHeader();
    print "<h1>Error: No Accounts Found!</h1>\n";
    print "It appears that there are no accounts assigned to this ledger.  You must assign some accounts to continue.<br>$sys_admin";
    CleanUp();
  }
  $result = $conn->exec("select number from account_tb where type = 0 and number in ($local_accounts_string)");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>1007: Tried to get all accounts from the main database with type = 0.<br>$sys_admin";
    CleanUp();
  }
  for ($count=0; $count < $result->ntuples; $count++)
  {
    # get last used check/deposit #'s
    $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = true and parent_num = (select max(parent_num) from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = true and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print "Error 1000<br>\n";
      print $conn->errorMessage . "<br>Tried to get the last used deposit# for account " . $result->getvalue($count, 0) . ".<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples > 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print "Error 1001<br>\n";
      print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples == 0)
    {
      $last_deposit = -1;
    }
    else
    {
      $last_deposit = $result2->getvalue(0, 0);
      if ($last_deposit eq "")
      {
        $last_deposit = -1;
      }
    }
    $result2 = $conn->exec("select max(sub_account_num) from debitcredit_tb where dorc = false and parent_num = (select max(parent_num) from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = false and sub_account_num > -1 AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print "Error 1002<br>\n";
      print $conn->errorMessage . "<br>Tried to get the last used check# for account " . $result->getvalue($count, 0) . ".<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples > 1)
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print "Error 1003<br>\n";
      print $result2->ntuples . " records were returned.  There should be only one.<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples == 0)
    {
      $last_check = -1;
    }
    else
    {
      $last_check = $result2->getvalue(0, 0);
      if ($last_check eq "")
      {
        $last_check = -1;
      }
    }
    # increment last_deposit and last_check and check for duplicates in database
    do {
      $last_deposit++;
      $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = true and sub_account_num = $last_deposit AND ledger_code = '$ledger_code'");
    } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>1004:  Tried to see if the incremented deposit exists in the database.<br>$sys_admin";
      CleanUp();
    }
    do {
      $last_check++;
      $result2 = $conn->exec("select parent_num from debitcredit_tb where account_num = " . $result->getvalue($count, 0) . " and dorc = false and sub_account_num = $last_check AND ledger_code = '$ledger_code'");
    } while ($result2->resultStatus == PGRES_TUPLES_OK && $result2->ntuples > 0);
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>1005:  Tried to see if the incremented check exists in the database.<br>$sys_admin";
      CleanUp();
    }

    $temp = $result->getvalue($count, 0);
    $deposit_hash{$temp} = $last_deposit;

    $temp = $result->getvalue($count, 0);
    $check_hash{$temp} = $last_check;
  }
}

print "<head><title>$prog_name $prog_version Journals Activity</title>\n";
if ($interface eq "style_sheets_double_entry")
{
  print "<style type=\"text/css\">\n";
  print "#DebitCreditView {}\n";
  print "th, td {font-family:fantasy; font-size:small;}\n";
  print "</style>\n";
  print <<"END_OF_JAVASCRIPT";
<script language="Javascript1.2">
<!--
  var isNav4, isIE4, isDOM;
  // check for browser capabilities
  // getElementById => DOM1
  // document.all => IE4
  // document.layers => Netscape 4 Layers
  if (window.document.getElementById)
  {
    isDOM = true;
    isIE4 = false;
    isNav4 = false;
  }
  else if (window.document.all)
  {
    isIE4 = true;
    isDOM = false;
    isNav4 = false;
  }
  else if (window.document.layers)
  {
    isNav4 = true;
    isDOM = false;
    isIE4 = false;
  }
  else
  {
    window.alert("Browser support for layers or cascading style sheets not detected!\\n");
  }
//-->
</script>
END_OF_JAVASCRIPT
}
print "</head>\n";
print "<body bgcolor=$body_bgcolor onLoad=\"do_load();\">\n";
print <<"END_OF_STYLE";
<style type="text/css"><!--
  a:hover   { color: red }
  a:link    { text-decoration: none; color: blue }
  a:visited { text-decoration: none; color: blue }
  a:active  { text-decoration: none; color: blue }-->
</style>
<script language="Javascript1.2" src="../js/common.js"></script>
<script language=\"Javascript1.2\">
  <!--
  var sub_entities_array = new Array();
  var accounts_array = new Array();

  var accounts_hash = new Array();
  var sub_accounts_hash = new Array();
  var sub_accounts_bank = new Array();

  var debit_rows_array = new Array();
  var credit_rows_array = new Array();
  var reset_debit_rows_array = new Array();
  var reset_credit_rows_array = new Array();

  var edit_string = \"Edit\";
  var delete_string = \"Delete\";

  var allowEntry = true;

  document.errorString = "";
  document.focus_element;

  function create_sub_account(name, value)
  {
    this.name = name;
    this.value = value;
  }

END_OF_STYLE
# get the sub entities from the database and fill in the array
$result = $conn->exec("select code from sub_entity_tb WHERE ledger_code = '$ledger_code' order by code");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "</script></head><body>\n";
  print "<h1>Error: Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to retrieve all sub entities from $ledger_db.<br>$sys_admin";
  CleanUp();
}
for ($count=0; $count < $result->ntuples; $count++)
{
  $sub_entity_value = $result->getvalue($count, 0);
  $sub_entity_array[$count] = $sub_entity_value;
  print "  sub_entities_array[$count] = \"$sub_entity_value\";\n";
}
print "\n";
# get the accounts from the database and fill in the array
my $tmpSQLString = "select acct_num from local_accounts_tb, account_tb WHERE ledger_code = '$ledger_code' AND (account_tb.number = acct_num AND account_tb.active = '1')";
$tmpSQLString .= (($payee_payer_id != -1 && $payee_payer_id ne "") ? " UNION select account_num FROM debitcredit_tb WHERE ledger_code = '$ledger_code' AND parent_num = $payee_payer_id" : "");
$tmpSQLString .= ($ref_num ne "" ? " UNION select account_num from debitcredit_tb WHERE parent_num = $ref_num AND ledger_code = '$ledger_code'" : "");
$result2 = $conn->exec("select name, number, type, taxable from account_tb where number in ($tmpSQLString) order by name");
if ($result2->resultStatus != PGRES_TUPLES_OK)
{
  print "</script></head><body>\n";
  print "<h1>Error: Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to retrieve the local accounts from $ledger_db.<br>$sys_admin";
  CleanUp();
}
for ($count=0; $count < $result2->ntuples; $count++)
{
  $local_account_name = $result2->getvalue($count, 0);
  $local_account_id = $result2->getvalue($count, 1);
  $local_account_type = $result2->getvalue($count, 2);
  $local_account_taxable = $result2->getvalue($count, 3);
  $account_array[$count][0] = "$local_account_id";
  $account_array[$count][1] = "$local_account_name - $local_account_id";
  $account_array[$count][2] = $local_account_type;
  $account_array[$count][3] = $local_account_taxable;
  print "  accounts_array[$count] = new Array();\n";
  print "  accounts_array[$count][0] = \"$local_account_id\"\n";
  print "  accounts_array[$count][1] = \"$local_account_name - $local_account_id";
  if ($local_account_taxable eq "t")
  {
    print " ~";
  }
  print "\";\n";
  # get the sub-account type this account is assigned to
  $result3 = $conn->exec("select sub_acct_type from acct_type_tb where num = (select type from account_tb where number = $local_account_id)");
  if ($result3->resultStatus != PGRES_TUPLES_OK)
  {
    print "</script></head><body>\n";
    print "<h1>Error: Accessing the database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to retrieve the sub-account type this account is assigned to.<br>$sys_admin";
    CleanUp();
  }
  if ($result3->ntuples <= 0)
  {
    print "</script></head><body>\n";
    print "<h1>Error: No records returned!</h1>\n";
    print "Tried to retrieve the sub-account type this account is assigned to but no records were returned.<br>$sys_admin";
    CleanUp();
  }
  print "  accounts_hash[\"$local_account_id\"] = new Array();\n";
  # assign the account's type to the first element of the accounts_hash array
  print "  accounts_hash[\"$local_account_id\"][0] = $local_account_type;\n";
  print "  accounts_hash[\"$local_account_id\"][1] = new Array();\n";
  my @sub_account_types = split /\,/, $result3->getvalue(0, 0);
  for ($count2=0; $count2 < scalar @sub_account_types; $count2++)
  {
    print "  accounts_hash[\"$local_account_id\"][1][$count2] = \"$sub_account_types[$count2]\";\n";
  }
  if ($local_account_type == 0)
  {
    # use the existing deposit_hash and check_hash to fill in the sub_account array
    # put a "C" and a "D" as options in the accounts_hash array
    print "  accounts_hash[\"$local_account_id\"][2] = new create_sub_account(\"---------------\", \"-1\");\n";
    print "  accounts_hash[\"$local_account_id\"][3] = new create_sub_account(\"Check #\", \"C\");\n";
    print "  accounts_hash[\"$local_account_id\"][4] = new create_sub_account(\"Deposit #\", \"D\");\n";
    print "  sub_accounts_bank[\"$local_account_id\"] = new Array();\n";
    print "  sub_accounts_bank[\"$local_account_id\"][0] = ";
    if (not exists $deposit_hash{$local_account_id})
    {
      print "0; // hash entry did not exist; hash value = $deposit_hash{$local_account_id}";
    }
    else
    {
      print "$deposit_hash{$local_account_id}";
    }
    print ";\n";
    print "  sub_accounts_bank[\"$local_account_id\"][1] = ";
    if (not exists $check_hash{$local_account_id})
    {
      print "0; // hash entry did not exist; hash value = $check_hash{$local_account_id}";
    }
    else
    {
      print "$check_hash{$local_account_id}";
    }
    print ";\n";
  }
  #elsif ($local_account_type == <sales revenue account type>)
  #{
  #}
}
# build the sub-account hash from the sub-account type table
$result = $conn->exec("select num from sub_acct_type_tb order by num");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "</script></head><body>\n";
  print "<h1>Error: Accessing the database failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get the sub-account types from the sub_acct_type_tb table.<br>$sys_admin";
  CleanUp();
}
for ($count=0; $count < $result->ntuples; $count++)
{
  my $sub_account_type = $result->getvalue($count, 0);
  # get the sub accounts from the database for the current sub-account type
  $result3 = $conn->exec("select sub_acc_name, sub_acc_number from sub_acc_tb where type = $sub_account_type order by sub_acc_name");
  if ($result3->resultStatus != PGRES_TUPLES_OK)
  {
    print "</script></head><body>\n";
    print "<h1>Error: Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to retrieve name and id information for sub accounts associated with sub-account type = $sub_account_type.<br>$sys_admin";
    CleanUp();
  }
  print "  sub_accounts_hash[\"$sub_account_type\"] = new Array();\n";
  print "  sub_accounts_hash[\"$sub_account_type\"][0] = new create_sub_account(\"---------------\", \"-1\");\n";
  for ($count2=0; $count2 < $result3->ntuples; $count2++)
  {
    $sub_account_name = $result3->getvalue($count2, 0);
    $sub_account_id = $result3->getvalue($count2, 1);
    $temp_count = $count2+1;
    print "  sub_accounts_hash[\"$sub_account_type\"][$temp_count] = new create_sub_account(\"$sub_account_name - $sub_account_id\", $sub_account_id);\n";
  }
}
print "  sub_accounts_hash[\"-1\"] = new Array();\n";
print "  sub_accounts_hash[\"-1\"][0] = new create_sub_account(\"---------------\", \"-1\");\n";

print "  var site_dir = \"$site_dir\"\n";

print <<"END_OF_STYLE";

  function do_load()
  {
    // add the contents of the arrays to the debit/credit_rows_arrays and reset_debit/credit_rows_arrays; set the initial values to the data for the journal entry if in edit mode or payee exists
END_OF_STYLE
if ($mode eq "edit" || $payee_payer_exists eq "true")
{
  for ($count=0, $debit_count=0, $credit_count=0; $count < $num_rows; $count++)
  {
    # determine if this entry is a debit or credit
    if ($dorcs[$count] eq "t")
    {
      print "    debit_rows_array[$debit_count] = new Array();\n";
      print "    reset_debit_rows_array[$debit_count] = new Array();\n";

      print "    debit_rows_array[$debit_count]['se'] = \"$sub_e_codes[$count]\";\n";
      print "    reset_debit_rows_array[$debit_count]['se'] = \"$sub_e_codes[$count]\";\n";

      print "    debit_rows_array[$debit_count]['ac'] = new Array();\n";
      print "    reset_debit_rows_array[$debit_count]['ac'] = new Array();\n";

      print "    debit_rows_array[$debit_count]['ac'][0] = \"$account_nums[$count]\";\n";
      print "    reset_debit_rows_array[$debit_count]['ac'][0] = \"$account_nums[$count]\";\n";

      print "    for (var count=0; count < document.row_entry_form.account_select.options.length; count++)\n";
      print "    {\n";
      print "      if (document.row_entry_form.account_select.options[count].value == \"$account_nums[$count]\")\n";
      print "      {\n";
      print "        debit_rows_array[$debit_count]['ac'][1] = document.row_entry_form.account_select.options[count].text;\n";
      print "        reset_debit_rows_array[$debit_count]['ac'][1] = document.row_entry_form.account_select.options[count].text;";
      print "      }\n";
      print "    }\n";

      print "    debit_rows_array[$debit_count]['sa'] = new Array();\n";
      print "    reset_debit_rows_array[$debit_count]['sa'] = new Array();\n";

      if (exists $sub_account_bank{$account_nums[$count]})
      {
        if ($sub_account_nums[$count] ne "-1")
        {
          print "    debit_rows_array[$debit_count]['sa'][0] = \"D\";\n";
          print "    reset_debit_rows_array[$debit_count]['sa'][0] = \"D\";\n";

          print "    debit_rows_array[$debit_count]['sa'][1] = \"$sub_account_nums[$count]\";\n";
          print "    reset_debit_rows_array[$debit_count]['sa'][1] = \"$sub_account_nums[$count]\";\n";
        }
        else
        {
          print "    debit_rows_array[$debit_count]['sa'][0] = \"-1\";\n";
          print "    reset_debit_rows_array[$debit_count]['sa'][0] = \"-1\";\n";

          print "    debit_rows_array[$debit_count]['sa'][1] = \"\";\n";
          print "    reset_debit_rows_array[$debit_count]['sa'][1] = \"\";\n";
        }
      }
      else
      {
        print "    debit_rows_array[$debit_count]['sa'][0] = \"$sub_account_nums[$count]\";\n";
        print "    reset_debit_rows_array[$debit_count]['sa'][0] = \"$sub_account_nums[$count]\";\n";

        print "    if (debit_rows_array[$debit_count]['sa'][0] == \"-1\")\n";
        print "    {\n";
        print "      debit_rows_array[$debit_count]['sa'][1] = \"\";\n";
        print "      reset_debit_rows_array[$debit_count]['sa'][1] = \"\";\n";
        print "    }\n";
        print "    else\n";
        print "    {\n";
        print "      for (var count in accounts_hash[debit_rows_array[$debit_count]['ac'][0]][1])\n";
        print "      {\n";
        print "        var accounts_index = accounts_hash[debit_rows_array[$debit_count]['ac'][0]][1];\n";
        print "        for (var count1=0; count1 < sub_accounts_hash[accounts_index[count]].length; count1++)\n";
        print "        {\n";
        print "          if (sub_accounts_hash[accounts_index[count]][count1].value == $sub_account_nums[$count])\n";
        print "          {\n";
        print "            debit_rows_array[$debit_count]['sa'][1] = sub_accounts_hash[accounts_index[count]][count1].name;\n";
        print "            reset_debit_rows_array[$debit_count]['sa'][1] = sub_accounts_hash[accounts_index[count]][count1].name;\n";
        print "          }\n";
        print "        }\n";
        print "      }\n";
        print "    }\n";
      }

      print "    debit_rows_array[$debit_count]['am'] = \"$amounts[$count]\";\n";
      print "    reset_debit_rows_array[$debit_count]['am'] = \"$amounts[$count]\";\n";

      print "    debit_rows_array[$debit_count]['cl'] = \"$cleareds[$count]\";\n";
      print "    reset_debit_rows_array[$debit_count]['cl'] = \"$cleareds[$count]\";\n";
      $debit_count++;
    }
    else
    {
      print "    credit_rows_array[$credit_count] = new Array();\n";
      print "    reset_credit_rows_array[$credit_count] = new Array();\n";

      print "    credit_rows_array[$credit_count]['se'] = \"$sub_e_codes[$count]\";\n";
      print "    reset_credit_rows_array[$credit_count]['se'] = \"$sub_e_codes[$count]\";\n";

      print "    credit_rows_array[$credit_count]['ac'] = new Array();\n";
      print "    reset_credit_rows_array[$credit_count]['ac'] = new Array();\n";

      print "    credit_rows_array[$credit_count]['ac'][0] = \"$account_nums[$count]\";\n";
      print "    reset_credit_rows_array[$credit_count]['ac'][0] = \"$account_nums[$count]\";\n";

      print "    for (var count=0; count < document.row_entry_form.account_select.options.length; count++)\n";
      print "    {\n";
      print "      if (document.row_entry_form.account_select.options[count].value == \"$account_nums[$count]\")\n";
      print "      {\n";
      print "        credit_rows_array[$credit_count]['ac'][1] = document.row_entry_form.account_select.options[count].text;\n";
      print "        reset_credit_rows_array[$credit_count]['ac'][1] = document.row_entry_form.account_select.options[count].text;";
      print "      }\n";
      print "    }\n";

      print "    credit_rows_array[$credit_count]['sa'] = new Array();\n";
      print "    reset_credit_rows_array[$credit_count]['sa'] = new Array();\n";

      if (exists $sub_account_bank{$account_nums[$count]})
      {
        if ($sub_account_nums[$count] ne "-1")
        {
          print "    credit_rows_array[$credit_count]['sa'][0] = \"C\";\n";
          print "    reset_credit_rows_array[$credit_count]['sa'][0] = \"C\";\n";

          print "    credit_rows_array[$credit_count]['sa'][1] = \"$sub_account_nums[$count]\";\n";
          print "    reset_credit_rows_array[$credit_count]['sa'][1] = \"$sub_account_nums[$count]\";\n";
        }
        else
        {
          print "    credit_rows_array[$credit_count]['sa'][0] = \"-1\";\n";
          print "    reset_credit_rows_array[$credit_count]['sa'][0] = \"-1\";\n";

          print "    credit_rows_array[$credit_count]['sa'][1] = \"\";\n";
          print "    reset_credit_rows_array[$credit_count]['sa'][1] = \"\";\n";
        }
      }
      else
      {
        print "    credit_rows_array[$credit_count]['sa'][0] = \"$sub_account_nums[$count]\";\n";
        print "    reset_credit_rows_array[$credit_count]['sa'][0] = \"$sub_account_nums[$count]\";\n";

        print "    if (credit_rows_array[$credit_count]['sa'][0] == \"-1\")\n";
        print "    {\n";
        print "      credit_rows_array[$credit_count]['sa'][1] = \"\";\n";
        print "      reset_credit_rows_array[$credit_count]['sa'][1] = \"\";\n";
        print "    }\n";
        print "    else\n";
        print "    {\n";
        print "      for (var count in accounts_hash[credit_rows_array[$credit_count]['ac'][0]][1])\n";
        print "      {\n";
        print "        var accounts_index = accounts_hash[credit_rows_array[$credit_count]['ac'][0]][1];\n";
        print "        for (var count1=0; count1 < sub_accounts_hash[accounts_index[count]].length; count1++)\n";
        print "        {\n";
        print "          if (sub_accounts_hash[accounts_index[count]][count1].value == $sub_account_nums[$count])\n";
        print "          {\n";
        print "            credit_rows_array[$credit_count]['sa'][1] = sub_accounts_hash[accounts_index[count]][count1].name;\n";
        print "            reset_credit_rows_array[$credit_count]['sa'][1] = sub_accounts_hash[accounts_index[count]][count1].name;\n";
        print "          }\n";
        print "        }\n";
        print "      }\n";
        print "    }\n";
      }

      print "    credit_rows_array[$credit_count]['am'] = \"$amounts[$count]\";\n";
      print "    reset_credit_rows_array[$credit_count]['am'] = \"$amounts[$count]\";\n";

      print "    credit_rows_array[$credit_count]['cl'] = \"$cleareds[$count]\";\n";
      print "    reset_credit_rows_array[$credit_count]['cl'] = \"$cleareds[$count]\";\n";
      $credit_count++;
    }
  }
}
elsif ($mode eq "refresh")
{
  # parse the debit_values/credit_values hidden input fields to recreate the form rows
  $count = 0;
  foreach $refresh_record (split /\;/, $input{'debit_values'})
  {
    foreach $refresh_item (split /\|/, $refresh_record)
    {
      ($refresh_key, $refresh_value) = split /\=/, $refresh_item, 2;
      $refresh_debits_values{"$count - $refresh_key"} = $refresh_value;
    }
    if ($refresh_record ne "")
    {
      $count++;
    }
  }
  $refresh_debit_count = $count;
  $count = 0;
  foreach $refresh_record (split /\;/, $input{'credit_values'})
  {
    foreach $refresh_item (split /\|/, $refresh_record)
    {
      ($refresh_key, $refresh_value) = split /\=/, $refresh_item, 2;
      $refresh_credits_values{"$count - $refresh_key"} = $refresh_value;
    }
    if ($refresh_record ne "")
    {
      $count++;
    }
  }
  $refresh_credit_count = $count;

  $count = 0;
  foreach $refresh_record (split /\;/, $input{'reset_debit_values'})
  {
    foreach $refresh_item (split /\|/, $refresh_record)
    {
      ($refresh_key, $refresh_value) = split /\=/, $refresh_item, 2;
      $reset_debits_values{"$count - $refresh_key"} = $refresh_value;
    }
    if ($refresh_record ne "")
    {
      $count++;
    }
  }
  $reset_debit_count = $count;
  $count = 0;
  foreach $refresh_record (split /\;/, $input{'reset_credit_values'})
  {
    foreach $refresh_item (split /\|/, $refresh_record)
    {
      ($refresh_key, $refresh_value) = split /\=/, $refresh_item, 2;
      $reset_credits_values{"$count - $refresh_key"} = $refresh_value;
    }
    if ($refresh_record ne "")
    {
      $count++;
    }
  }
  $reset_credit_count = $count;

  for ($count=0; $count < $refresh_debit_count; $count++)
  {
    # parse each entry to find the individual row items se = sub-entity, ac = account number, sa = sub-account number, cd = check#/deposit#, am = amount, cl = cleared
    print "    debit_rows_array[$count] = new Array();\n";

    $refresh_key = "$count - se";
    $temp = $refresh_debits_values{$refresh_key};
    print "    debit_rows_array[$count]['se'] = \"$temp\";\n";

    print "    debit_rows_array[$count]['ac'] = new Array();\n";

    $refresh_key = "$count - ac";
    $temp = $refresh_debits_values{$refresh_key};
    print "    debit_rows_array[$count]['ac'][0] = $temp;\n";

    print "    for (var count=0; count < document.row_entry_form.account_select.options.length; count++)\n";
    print "    {\n";
    print "      if (document.row_entry_form.account_select.options[count].value == \"$temp\")\n";
    print "      {\n";
    print "        debit_rows_array[$count]['ac'][1] = document.row_entry_form.account_select.options[count].text;\n";
    print "      }\n";
    print "    }\n";

    print "    debit_rows_array[$count]['sa'] = new Array();\n";

    $refresh_key = "$count - sa";
    $temp = $refresh_debits_values{$refresh_key};
    print "    debit_rows_array[$count]['sa'][0] = \"$temp\";\n";

    $refresh_key = "$count - cd";
    $temp = $refresh_debits_values{$refresh_key};
    print "    debit_rows_array[$count]['sa'][1] = \"$temp\";\n";

    $refresh_key = "$count - am";
    $temp = $refresh_debits_values{$refresh_key};
    print "    debit_rows_array[$count]['am'] = \"$temp\";\n";

    $refresh_key = "$count - cl";
    $temp = $refresh_debits_values{$refresh_key};
    print "    debit_rows_array[$count]['cl'] = \"$temp\";\n";
  }
  for ($count=0; $count < $refresh_credit_count; $count++)
  {
    # parse each entry to find the individual row items se = sub-entity, ac = account number, sa = sub-account number, cd = check#/deposit#, am = amount, cl = cleared
    print "    credit_rows_array[$count] = new Array();\n";

    $refresh_key = "$count - se";
    $temp = $refresh_credits_values{$refresh_key};
    print "    credit_rows_array[$count]['se'] = \"$temp\";\n";

    print "    credit_rows_array[$count]['ac'] = new Array();\n";

    $refresh_key = "$count - ac";
    $temp = $refresh_credits_values{$refresh_key};
    print "    credit_rows_array[$count]['ac'][0] = $temp;\n";

    print "    for (var count=0; count < document.row_entry_form.account_select.options.length; count++)\n";
    print "    {\n";
    print "      if (document.row_entry_form.account_select.options[count].value == \"$temp\")\n";
    print "      {\n";
    print "        credit_rows_array[$count]['ac'][1] = document.row_entry_form.account_select.options[count].text;\n";
    print "      }\n";
    print "    }\n";

    print "    credit_rows_array[$count]['sa'] = new Array();\n";

    $refresh_key = "$count - sa";
    $temp = $refresh_credits_values{$refresh_key};
    print "    credit_rows_array[$count]['sa'][0] = \"$temp\";\n";

    $refresh_key = "$count - cd";
    $temp = $refresh_credits_values{$refresh_key};
    print "    credit_rows_array[$count]['sa'][1] = \"$temp\";\n";

    $refresh_key = "$count - am";
    $temp = $refresh_credits_values{$refresh_key};
    print "    credit_rows_array[$count]['am'] = \"$temp\";\n";

    $refresh_key = "$count - cl";
    $temp = $refresh_credits_values{$refresh_key};
    print "    credit_rows_array[$count]['cl'] = \"$temp\";\n";
  }
  for ($count=0; $count < $reset_debit_count; $count++)
  {
    # parse each entry to find the individual row items se = sub-entity, ac = account number, sa = sub-account number, cd = check#/deposit#, am = amount, cl = cleared
    print "    reset_debit_rows_array[$count] = new Array();\n";

    $refresh_key = "$count - se";
    $temp = $reset_debits_values{$refresh_key};
    print "    reset_debit_rows_array[$count]['se'] = \"$temp\";\n";

    print "    reset_debit_rows_array[$count]['ac'] = new Array();\n";

    $refresh_key = "$count - ac";
    $temp = $reset_debits_values{$refresh_key};
    print "    reset_debit_rows_array[$count]['ac'][0] = $temp;\n";

    print "    for (var count=0; count < document.row_entry_form.account_select.options.length; count++)\n";
    print "    {\n";
    print "      if (document.row_entry_form.account_select.options[count].value == \"$temp\")\n";
    print "      {\n";
    print "        reset_debit_rows_array[$count]['ac'][1] = document.row_entry_form.account_select.options[count].text;\n";
    print "      }\n";
    print "    }\n";

    print "    reset_debit_rows_array[$count]['sa'] = new Array();\n";

    $refresh_key = "$count - sa";
    $temp = $reset_debits_values{$refresh_key};
    print "    reset_debit_rows_array[$count]['sa'][0] = \"$temp\";\n";

    $refresh_key = "$count - cd";
    $temp = $reset_debits_values{$refresh_key};
    print "    reset_debit_rows_array[$count]['sa'][1] = \"$temp\";\n";

    $refresh_key = "$count - am";
    $temp = $reset_debits_values{$refresh_key};
    print "    reset_debit_rows_array[$count]['am'] = \"$temp\";\n";

    $refresh_key = "$count - cl";
    $temp = $reset_debits_values{$refresh_key};
    print "    reset_debit_rows_array[$count]['cl'] = \"$temp\";\n";
  }
  for ($count=0; $count < $reset_credit_count; $count++)
  {
    # parse each entry to find the individual row items se = sub-entity, ac = account number, sa = sub-account number, cd = check#/deposit#, am = amount, cl = cleared
    print "    reset_credit_rows_array[$count] = new Array();\n";

    $refresh_key = "$count - se";
    $temp = $reset_credits_values{$refresh_key};
    print "    reset_credit_rows_array[$count]['se'] = \"$temp\";\n";

    print "    reset_credit_rows_array[$count]['ac'] = new Array();\n";

    $refresh_key = "$count - ac";
    $temp = $reset_credits_values{$refresh_key};
    print "    reset_credit_rows_array[$count]['ac'][0] = $temp;\n";

    print "    for (var count=0; count < document.row_entry_form.account_select.options.length; count++)\n";
    print "    {\n";
    print "      if (document.row_entry_form.account_select.options[count].value == \"$temp\")\n";
    print "      {\n";
    print "        reset_credit_rows_array[$count]['ac'][1] = document.row_entry_form.account_select.options[count].text;\n";
    print "      }\n";
    print "    }\n";

    print "    reset_credit_rows_array[$count]['sa'] = new Array();\n";

    $refresh_key = "$count - sa";
    $temp = $reset_credits_values{$refresh_key};
    print "    reset_credit_rows_array[$count]['sa'][0] = \"$temp\";\n";

    $refresh_key = "$count - cd";
    $temp = $reset_credits_values{$refresh_key};
    print "    reset_credit_rows_array[$count]['sa'][1] = \"$temp\";\n";

    $refresh_key = "$count - am";
    $temp = $reset_credits_values{$refresh_key};
    print "    reset_credit_rows_array[$count]['am'] = \"$temp\";\n";

    $refresh_key = "$count - cl";
    $temp = $reset_credits_values{$refresh_key};
    print "    reset_credit_rows_array[$count]['cl'] = \"$temp\";\n";
  }

  # put the values that were in each input field on the row_entry_form back; all values should defaultly be there, so the only value that needs updating is the sub_account_select field
  print "    account_select_change();\n";
  print "    document.row_entry_form.sub_account_edit.value = \"" . $input{'sub_account_edit'} . "\";\n";
  print "    sub_account_edit_change();\n";
}

print <<"END_OF_STYLE";

    rewrite_sheet();
    // if there are only two rows entered (one debit and one credit), place focus on the debit field
    if (debit_rows_array.length == 1 && credit_rows_array.length == 1 && document.row_entry_form.sub_entity_edit.value == "" && document.row_entry_form.account_edit.value == "" && document.row_entry_form.sub_account_edit.value == "")
    {
      document.row_entry_form.debit_amount.focus();
    }
    else
    {
      // otherwise, place focus on sub-entity edit field
      document.row_entry_form.sub_entity_edit.focus();
    }
  }

  function enter_row_entry(form, row, edit)
  {
    var f;

    if (arguments.length > 0)
    {
      f = form;
    }
    else
    {
      f = document.row_entry_form;
    }

    if (!allowEntry && f.name == "row_entry_form")
    {
      // do not allow the insertion of new rows to take place while an edit is in progress
      return;
    }

    // validate the row entry before doing anything else
    if (!validate_row_entry(f, row, edit))
    {
      alert(document.errorString);
      if (document.focus_element)
      {
        document.focus_element.focus();
      }
      return;
    }
    // determine if the amount is a credit or a debit
    if (f.debit_amount.value != "")
    {
      var arrayElement;
      if (edit == "d")
      {
        arrayElement = row;
      }
      else
      {
        arrayElement = debit_rows_array.length;
      }

      if (debit_rows_array.length == 1 && credit_rows_array.length == 1 && f.sub_entity_edit.value == "" && f.account_edit.value == "" && f.sub_account_edit.value == "" && f.debit_amount.value != "" && f.credit_amount.value == "")
      {
        // change the two entries to have the same amounts from the debit_amount form value
        debit_rows_array[0]['am'] = f.debit_amount.value;
        credit_rows_array[0]['am'] = f.debit_amount.value;
      }
      else
      {
        // debit; insert record into the debit_rows_array
        debit_rows_array[arrayElement] = new Array();
        debit_rows_array[arrayElement]['se'] = f.sub_entity_edit.value;
        debit_rows_array[arrayElement]['ac'] = new Array();
        debit_rows_array[arrayElement]['ac'][0] = f.account_select.options[f.account_select.selectedIndex].value;
        debit_rows_array[arrayElement]['ac'][1] = f.account_edit.value;
        debit_rows_array[arrayElement]['sa'] = new Array();
        debit_rows_array[arrayElement]['sa'][0] = f.sub_account_select.options[f.sub_account_select.selectedIndex].value;
        debit_rows_array[arrayElement]['sa'][1] = f.sub_account_edit.value;
        debit_rows_array[arrayElement]['am'] = f.debit_amount.value;
        debit_rows_array[arrayElement]['cl'] = f.cleared.value;
      }

      if (!allowEntry && edit == "c")
      {
        // delete the credit that was just edited
        delete_credit_row(row);
      }
    }
    else if (f.credit_amount.value != "")
    {
      var arrayElement;
      if (edit == "c")
      {
        arrayElement = row;
      }
      else
      {
        arrayElement = credit_rows_array.length;
      }

      // credit; insert record into the credit_rows_array
      credit_rows_array[arrayElement] = new Array();
      credit_rows_array[arrayElement]['se'] = f.sub_entity_edit.value;
      credit_rows_array[arrayElement]['ac'] = new Array();
      credit_rows_array[arrayElement]['ac'][0] = f.account_select.options[f.account_select.selectedIndex].value;
      credit_rows_array[arrayElement]['ac'][1] = f.account_edit.value;
      credit_rows_array[arrayElement]['sa'] = new Array();
      credit_rows_array[arrayElement]['sa'][0] = f.sub_account_select.options[f.sub_account_select.selectedIndex].value;
      credit_rows_array[arrayElement]['sa'][1] = f.sub_account_edit.value;
      credit_rows_array[arrayElement]['am'] = f.credit_amount.value;
      credit_rows_array[arrayElement]['cl'] = f.cleared.value;

      if (!allowEntry && edit == "d")
      {
        // delete the debit that was just edited
        delete_debit_row(row);
      }
    }

    if (allowEntry)
    {
      // clear the row entry form
      clear_row_entry();
    }
    if (!allowEntry)
    {
      allowEntry = true;
    }
    // rewrite the sheet
    rewrite_sheet();

    // calculate the debit/credit difference
    calculate_debit_credit_diff();

    // if there are only two rows entered (one debit and one credit), place focus on the debit field
    if (debit_rows_array.length == 1 && credit_rows_array.length == 1 && document.row_entry_form.sub_entity_edit.value == "" && document.row_entry_form.account_edit.value == "" && document.row_entry_form.sub_account_edit.value == "")
    {
      document.row_entry_form.debit_amount.focus();
    }
    else
    {
      // otherwise, place focus on sub-entity edit field
      document.row_entry_form.sub_entity_edit.focus();
    }
  }

  function calculate_debit_credit_diff()
  {
    var f = document.row_entry_form;
    var sum_debits;
    var sum_credits;
    var debit_credit_diff;
    var temp_diff;

    // calculate the debit/credit difference and place in the appropriate debit/credit amount edit field in the row entry form
    sum_debits = 0.0;
    sum_credits = 0.0;
    debit_credit_diff = "";
    for (var count=0; count < debit_rows_array.length; count++)
    {
      sum_debits += parseFloat(debit_rows_array[count]['am'], 10);
    }
    for (var count=0; count < credit_rows_array.length; count++)
    {
      sum_credits += parseFloat(credit_rows_array[count]['am'], 10);
    }
    if (sum_credits > sum_debits)
    {
      temp_diff = sum_credits - sum_debits;
      temp_diff += 0.005;
      temp_diff = temp_diff.toString();
      debit_credit_diff = temp_diff.substring(0, temp_diff.indexOf('.') + 3);
      if (debit_credit_diff != "0.00")
      {
        f.debit_amount.value = debit_credit_diff;
        f.credit_amount.value = "";
      }
      else
      {
        f.debit_amount.value = "";
        f.credit_amount.value = "";
      }
    }
    else if (sum_credits < sum_debits)
    {
      temp_diff = sum_debits - sum_credits;
      temp_diff += 0.005;
      temp_diff = temp_diff.toString();
      debit_credit_diff = temp_diff.substring(0, temp_diff.indexOf('.') + 3);
      if (debit_credit_diff != "0.00")
      {
        f.credit_amount.value = debit_credit_diff;
        f.debit_amount.value = "";
      }
      else
      {
        f.credit_amount.value = "";
        f.debit_amount.value = "";
      }
    }
  }

  function clear_row_entry()
  {
    var f = document.row_entry_form;

    // remove all values from all selects and edit fields in the row entry form
    f.sub_entity_edit.value = "";
    f.account_edit.value = "";
    f.sub_account_edit.value = "";
    f.sub_entity_select.selectedIndex = 0;
    f.account_select.selectedIndex = 0;
    f.sub_account_select.selectedIndex = 0;
    f.debit_amount.value = "";
    f.credit_amount.value = "";
    // reset the cleared field
    f.cleared.value = " ";
    // reset the sub_account_select
    account_select_change();
    // if there are only two rows entered (one debit and one credit), place focus on the debit field
    if (debit_rows_array.length == 1 && credit_rows_array.length == 1 && f.sub_entity_edit.value == "" && f.account_edit.value == "" && f.sub_account_edit.value == "")
    {
      f.debit_amount.focus();
    }
    else
    {
      // otherwise, place focus on sub-entity edit field
      f.sub_entity_edit.focus();
    }
  }

  function sub_entity_edit_change(form)
  {
    var f;
    if (arguments.length > 0)
    {
      f = form;
    }
    else
    {
      f = document.row_entry_form;
    }
    var regexp;
    var count;
    var sub_entity_edit = f.sub_entity_edit;
    var sub_entity = f.sub_entity_select;
    var matchfound = false;

    // attempt to match the entered text with any item in the sub-entity select; match on the closest item
    var regString = "^" + sub_entity_edit.value + "+";
    regexp = new RegExp(regString, "i");
    for (count=sub_entity.options.length-1; count > 0; count--)
    {
      if (regexp.test(sub_entity.options[count].text))
      {
        sub_entity.selectedIndex = count;
        sub_entity_edit.value = sub_entity.options[count].text;
        matchfound = true;
      }
    }
    if (!matchfound && sub_entity_edit.value != "")
    {
      alert("Invalid sub-entity entry! (" + sub_entity_edit.value + ")");
      sub_entity_edit.value = "";
      sub_entity.selectedIndex = 0;
      sub_entity_edit.focus();
    }
  }

  function sub_entity_select_change(form)
  {
    var f;
    if (arguments.length > 0)
    {
      f = form;
    }
    else
    {
      f = document.row_entry_form;
    }
    // set the value of the sub-entity edit field to the text of the selected sub-entity item
    if (f.sub_entity_select.selectedIndex == 0)
    {
      f.sub_entity_edit.value = "";
    }
    else
    {
      f.sub_entity_edit.value = f.sub_entity_select.options[f.sub_entity_select.selectedIndex].text;
    }
  }

  function account_edit_change(form)
  {
    var f;
    if (arguments.length > 0)
    {
      f = form;
    }
    else
    {
      f = document.row_entry_form;
    }
    var regexp;
    var count;
    var account_edit = f.account_edit;
    var account = f.account_select;
    var matchfound = false;

    // attempt to match the entered text with any item in the account select; match on the closest item
    var regString = "^" + account_edit.value + "+";
    regexp = new RegExp(regString, "i");
    for (count=account.options.length-1; count > 0; count--)
    {
      if (regexp.test(account.options[count].text))
      {
        account.selectedIndex = count;
        account_edit.value = account.options[count].text;
        account_select_change(f);
        matchfound = true;
      }
    }
    if (!matchfound && account_edit.value != "")
    {
      alert("Invalid account entry! (" + account_edit.value + ")");
      account_edit.value = "";
      account.selectedIndex = 0;
      account_edit.focus();
    }
  }

  function account_select_change(form)
  {
    var f;
    if (arguments.length > 0)
    {
      f = form;
    }
    else
    {
      f = document.row_entry_form;
    }
    var account_edit = f.account_edit;
    var account = f.account_select;
    var sub_account_edit = f.sub_account_edit;
    var sub_account = f.sub_account_select;
    var sub_entity_edit = f.sub_entity_edit;
    var sub_entity = f.sub_entity_select;
    var cleared = f.cleared;

    // set the account_edit field to the text in the account select if not the first entry; clear if first entry
    if (account.selectedIndex == 0)
    {
      account_edit.value = "";
    }
    else
    {
      account_edit.value = account.options[account.selectedIndex].text;
    }

    // clear the sub entity field if the account is set to nothing
    if (account.selectedIndex == 0)
    {
      sub_entity_edit.value = "";
      sub_entity.selectedIndex = 0;
    }
    // clear the sub-account select and refill with data associated with selected account
    sub_account.options.length = 0;
    account_value = account.options[account.selectedIndex].value;
    if (typeof accounts_hash[account_value] == "undefined")
    {
      sub_account.options[0] = new Option(sub_accounts_hash["-1"][0].name, "-1");
    }
    else if (accounts_hash[account_value][0] == 0)
    {
      for (var count1=2; count1<5; count1++)
      {
        sub_account.options[sub_account.options.length] = new Option(accounts_hash[account_value][count1].name, accounts_hash[account_value][count1].value);
      }
    }
//    else if (accounts_hash[account_value][0] == 10) //<sales revenue account type>
//    {
//    }
    else
    {
      var options_count = 0;
      for (var count in accounts_hash[account_value][1])
      {
        var accounts_index = accounts_hash[account_value][1];
        for (var count1=0; count1 < sub_accounts_hash[accounts_index[count]].length; count1++)
        {
          sub_account.options[options_count++] = new Option(sub_accounts_hash[accounts_index[count]][count1].name, sub_accounts_hash[accounts_index[count]][count1].value);
        }
      }
    }
    sub_account.selectedIndex = 0;
    sub_account_edit.value = "";
    if (typeof cleared != "undefined")
    {
      // set the cleared field to " "
      cleared.value = " ";
    }
  }

  function sub_account_select_change(form, row, edit)
  {
    var f;
    if (arguments.length > 0)
    {
      f = form;
    }
    else
    {
      f = document.row_entry_form;
    }
    var account = f.account_select;
    var sub_account_text = f.sub_account_edit;
    var sub_account = f.sub_account_select;
    var debit = f.debit_amount;
    var credit = f.credit_amount;

    if (sub_account.options[sub_account.selectedIndex].value != "C" && sub_account.options[sub_account.selectedIndex].value != "D")
    {
      if (sub_account.options[sub_account.selectedIndex].value == "-1")
      {
        // an empty value was selected
        sub_account_text.value = "";
      }
      else
      {
        sub_account_text.value = sub_account.options[sub_account.selectedIndex].text;
      }
    }
    else
    {
      if (sub_account.options[sub_account.selectedIndex].value == "C")
      {
        account_value = account.options[account.selectedIndex].value;
        sub_account_text.value = sub_accounts_bank[account_value][1];
        if (debit.value != "")
        {
          // move debit to credit field
          credit.value = debit.value;
          debit.value = "";
        }
        sub_account_edit_change(f, row, edit);
      }
      else if (sub_account.options[sub_account.selectedIndex].value == "D")
      {
        account_value = account.options[account.selectedIndex].value;
        sub_account_text.value = sub_accounts_bank[account_value][0];
        if (credit.value != "")
        {
          // move credit to debit field
          debit.value = credit.value;
          credit.value = "";
        }
        sub_account_edit_change(f, row, edit);
      }
    }
  }

  function sub_account_edit_change(form, row, edit)
  {
    var f;
    if (arguments.length > 0)
    {
      f = form;
    }
    else
    {
      f = document.row_entry_form;
    }
    var count;
    var regexp;
    var matchfound;
    var errorString = "";
    var account_edit = f.account_edit;
    var account_select = f.account_select;
    var sub_account_text = f.sub_account_edit;
    var sub_account = f.sub_account_select;
    var debit_amount = f.debit_amount;
    var credit_amount = f.credit_amount;

    // if text field value is not defined, set it to ""
    if (sub_account_text.value == "undefined")
    {
      sub_account_text.value = "";
    }

    matchfound = false;

    if (!sub_accounts_bank[account_select.options[account_select.selectedIndex].value])
    {
      var regString = "^" + sub_account_text.value + "+";
      regexp = new RegExp(regString, "i");
      // search for match in sub_account select and set selectedIndex to the found item
      for (count=sub_account.options.length-1; count > 0; count--)
      {
        if (regexp.test(sub_account.options[count].text))
        {
          sub_account.selectedIndex = count;
          sub_account_text.value = sub_account.options[count].text;
          matchfound = true;
        }
      }
      if (!matchfound && sub_account_text.value != "")
      {
        errorString += "Invalid sub-account entry! (" + sub_account_text.value + ")\\n";
        // clear the text entry and set the focus to the sub-account edit field
        sub_account_text.value = "";
        sub_account_text.focus();
      }
    }
    else
    {
      // verify that the value entered is numerically valid
      if (!isNaN(parseInt(sub_account_text.value)))
      {
        // set the sub-account select to check/deposit number based on the debit/credit amount field filled in
        if (debit_amount.value != "")
        {
          sub_account.selectedIndex = 2;
          // search for duplicate deposit numbers in the debit_rows_array
          for (var count=0; count < debit_rows_array.length; count++)
          {
            if (sub_account_text.value == debit_rows_array[count]['sa'][1] && account_edit.value == debit_rows_array[count]['ac'][1])
            {
              if (allowEntry || !(count == row && edit == "d"))
              {
                errorString += "Deposit #" + sub_account_text.value + " already used!\\n";
                sub_account_text.focus();
              }
            }
          }
        }
        else if (credit_amount.value != "")
        {
          sub_account.selectedIndex = 1;
          // search for duplicate check numbers in the credit_rows_array
          for (var count=0; count < credit_rows_array.length; count++)
          {
            if (sub_account_text.value == credit_rows_array[count]['sa'][1] && account_edit.value == credit_rows_array[count]['ac'][1])
            {
              if (allowEntry || !(count == row && edit == "c"))
              {
                errorString += "Check #" + sub_account_text.value + " already used!\\n";
                sub_account_text.focus();
              }
            }
          }
        }
        // set the value of the sub-account edit field to the parseInt'ed value to remove any invalid characters
        sub_account_text.value = parseInt(sub_account_text.value).toString();
      }
      else if (sub_account_text.value != "")
      {
        // check for "C" or "D" at the beginning of the number to automatically set the appropriate deposit/check number entry
        if (sub_account_text.value.charAt(0) == 'C' || sub_account_text.value.charAt(0) == 'c')
        {
          // grab a substring from one character after the start to the end of the string
          var subString = sub_account_text.value.substring(1, sub_account_text.value.length);
          if (!isNaN(parseInt(subString)))
          {
            sub_account.selectedIndex = 1;
            sub_account_text.value = parseInt(subString);
            if (debit_amount.value != "")
            {
              // move debit to credit field
              credit_amount.value = debit_amount.value;
              debit_amount.value = "";
            }
            // search for duplicate check numbers in the credit_rows_array
            for (var count=0; count < credit_rows_array.length; count++)
            {
              if (sub_account_text.value == credit_rows_array[count]['sa'][1] && account_edit.value == credit_rows_array[count]['ac'][1])
              {
                if (allowEntry || !(count == row && edit == "c"))
                {
                  errorString += "Check #" + sub_account_text.value + " already used!\\n";
                  sub_account_text.focus();
                }
              }
            }
          }
          else if ((subString = subString.replace(/\s/, "")) == "")
          {
            sub_account.selectedIndex = 1;
            sub_account_text.value = sub_account.options[sub_account.selectedIndex].value;
            if (debit_amount.value != "")
            {
              // move debit to credit field
              credit_amount.value = debit_amount.value;
              debit_amount.value = "";
            }
            // search for duplicate check numbers in the credit_rows_array
            for (var count=0; count < credit_rows_array.length; count++)
            {
              if (sub_account_text.value == credit_rows_array[count]['sa'][1] && account_edit.value == credit_rows_array[count]['ac'][1])
              {
                if (allowEntry || !(count == row && edit == "c"))
                {
                  errorString += "Check #" + sub_account_text.value + " already used!\\n";
                  sub_account_text.focus();
                }
              }
            }
            sub_account_select_change(f);
          }
          else
          {
            errorString += "Invalid check #: " + subString + "\\n";
            sub_account_text.value = "";
            sub_account_text.focus();
          }
        }
        else if (sub_account_text.value.charAt(0) == 'D' || sub_account_text.value.charAt(0) == 'd')
        {
          // grab a substring from one character after the start to the end of the string
          var subString = sub_account_text.value.substring(1, sub_account_text.value.length);
          if (!isNaN(parseInt(subString)))
          {
            sub_account.selectedIndex = 2;
            sub_account_text.value = parseInt(subString);
            if (credit_amount.value != "")
            {
              // move credit to debit field
              debit_amount.value = credit_amount.value;
              credit_amount.value = "";
            }
            // search for duplicate deposit numbers in the debit_rows_array
            for (var count=0; count < debit_rows_array.length; count++)
            {
              if (sub_account_text.value == debit_rows_array[count]['sa'][1] && account_edit.value == debit_rows_array[count]['ac'][1])
              {
                if (allowEntry || !(count == row && edit == "d"))
                {
                  errorString += "Deposit #" + sub_account_text.value + " already used!\\n";
                  sub_account_text.focus();
                }
              }
            }
          }
          else if ((subString = subString.replace(/\s/, "")) == "")
          {
            sub_account.selectedIndex = 2;
            sub_account_text.value = sub_account.options[sub_account.selectedIndex].value;
            if (credit_amount.value != "")
            {
              // move credit to debit field
              debit_amount.value = credit_amount.value;
              credit_amount.value = "";
            }
            // search for duplicate deposit numbers in the debit_rows_array
            for (var count=0; count < debit_rows_array.length; count++)
            {
              if (sub_account_text.value == debit_rows_array[count]['sa'][1] && account_edit.value == debit_rows_array[count]['ac'][1])
              {
                if (allowEntry || !(count == row && edit == "d"))
                {
                  errorString += "Deposit #" + sub_account_text.value + " already used!\\n";
                  sub_account_text.focus();
                }
              }
            }
            sub_account_select_change(f);
          }
          else
          {
            errorString += "Invalid debit #: " + subString + "\\n";
            sub_account_text.value = "";
            sub_account_text.focus();
          }
        }
        else
        {
          errorString += "Invalid check/deposit #: " + sub_account_text.value + "\\n";
          sub_account_text.value = "";
          sub_account_text.focus();
        }
      }
    }
    if (errorString != "")
    {
      alert(errorString);
    }
  }

  function debit_amount_change(form)
  {
    var f;
    if (arguments.length > 0)
    {
      f = form;
    }
    else
    {
      f = document.row_entry_form;
    }

    if (parseFloat(f.debit_amount.value, 10) < 0)
    {
      f.credit_amount.value = Math.abs(parseFloat(f.debit_amount.value, 10));
      f.debit_amount.value = "";
      credit_amount_change();
      return;
    }

    if (f.sub_account_select.options[f.sub_account_select.selectedIndex].value == "C")
    {
      if (f.debit_amount.value != "")
      {
        alert("You selected a Check # which can only be associated with a credit.\\nYou are attempting to enter a debit.\\nSwapping values...");
      }
      f.credit_amount.value = f.debit_amount.value;
      f.debit_amount.value = "";
      credit_amount_change();
      return;
    }

    var temp_debit = parseFloat(f.debit_amount.value, 10) + 0.005;
    // truncate temp_debit to 2 decimal places
    temp_debit = temp_debit.toString();
    if (temp_debit.indexOf(".") != -1)
    {
      f.debit_amount.value = temp_debit.substring(0, temp_debit.indexOf(".")+3);
    }
    else if (f.debit_amount.value != "")
    {
      alert("Invalid numeric value for debit amount!");
      // clear the debit amount field
      f.debit_amount.value = "";
      // reset the focus to the debit field
      f.debit_amount.focus();

      return;
    }

    // empty the credit amount field
    f.credit_amount.value = "";
    // if account is bank account, make sure the check/deposit# is selected in the sub-account select field
    sub_account_edit_change(f);
  }

  function credit_amount_change(form)
  {
    var f;
    if (arguments.length > 0)
    {
      f = form;
    }
    else
    {
      f = document.row_entry_form;
    }

    if (parseFloat(f.credit_amount.value, 10) < 0)
    {
      f.debit_amount.value = Math.abs(parseFloat(f.credit_amount.value, 10));
      f.credit_amount.value = "";
      debit_amount_change();
      return;
    }

    if (f.sub_account_select.options[f.sub_account_select.selectedIndex].value == "D")
    {
      if (f.credit_amount.value != "")
      {
        alert("You selected a Deposit # which can only be associated with a debit.\\nYou are attempting to enter a credit.\\nSwapping values...");
      }
      f.debit_amount.value = f.credit_amount.value;
      f.credit_amount.value = "";
      debit_amount_change();
      return;
    }

    var temp_credit = parseFloat(f.credit_amount.value, 10) + 0.005;
    // truncate temp_credit to 2 decimal places
    temp_credit = temp_credit.toString();
    if (temp_credit.indexOf(".") != -1)
    {
      f.credit_amount.value = temp_credit.substring(0, temp_credit.indexOf(".")+3);
    }
    else if (f.credit_amount.value != "")
    {
      alert("Invalid numeric value for credit amount!");
      // clear the credit amount field
      f.credit_amount.value = "";
      // reset the focus to the credit field
      f.credit_amount.focus();

      return;
    }

    // empty the debit amount field
    f.debit_amount.value = "";
    // if account is bank account, make sure the check/deposit# is selected in the sub-account select field
    sub_account_edit_change(f);
  }

  function validate_transaction()
  {
    var f = document.row_entry_form;
    var sum_debits = 0.0;
    var sum_credits = 0.0;
    var sum_rows = 0;
    var temp_sum;

    // run through debit_rows_array and credit_rows_array; sum debits and credits
    for (var count=0; count < debit_rows_array.length; count++)
    {
      sum_debits += parseFloat(debit_rows_array[count]['am'], 10);
      sum_rows++;
    }
    for (var count=0; count < credit_rows_array.length; count++)
    {
      sum_credits += parseFloat(credit_rows_array[count]['am'], 10);
      sum_rows++;
    }
    // check to make sure that there are at least two entries of row data
    if (sum_rows < 2)
    {
      alert("You must enter at least two rows of data!");
      f.sub_entity_edit.focus();
      return false;
    }
    // truncate sum_debits and sum_credits to 2 decimal places
    temp_sum = parseFloat(sum_debits) + 0.005;
    temp_sum = temp_sum.toString();
    sum_debits = temp_sum.substring(0, temp_sum.indexOf(".") + 3);
    temp_sum = parseFloat(sum_credits) + 0.005;
    temp_sum = temp_sum.toString();
    sum_credits = temp_sum.substring(0, temp_sum.indexOf(".") + 3);
    // check that debits == credits
    if (sum_debits != sum_credits)
    {
      // error, cannot continue because debits do not equal credits
      alert("Debits do not equal credits!\\n\\n Debits: " + commify(sum_debits) + "\\nCredits: " + commify(sum_credits));
      // if there are only two rows entered (one debit and one credit), place focus on the debit field
      if (debit_rows_array.length == 1 && credit_rows_array.length == 1 && f.sub_entity_edit.value == "" && f.account_edit.value == "" && f.sub_account_edit.value == "")
      {
        f.debit_amount.focus();
      }
      else
      {
        // otherwise, place focus on sub-entity edit field
        f.sub_entity_edit.focus();
      }
      return false;
    }

    return true;
  }

  function commify(f)
  {
    var value;
    var temp;
    var count = 0;
    var start, comma_count;

    start = false;
    comma_count = 0;

    // round the value to the nearest two decimal places
    temp = parseFloat(f, 10) + 0.005;
    temp = temp.toString();
    value = temp.substring(0, temp.indexOf('.') + 3);
    temp = "";
    // reverse the array adding the commas to it as we go
    for (count=value.length-1; count >= 0; count--)
    {
      if (value.charAt(count) == '.')
      {
        start = true;
      }
      temp += value.charAt(count);
      if (start && comma_count == 3 && count > 0)
      {
        comma_count = 1;
        temp += ',';
      }
      else if (start)
      {
        comma_count++;
      }
    }
    if (temp.length == 3)
    {
      // add a zero to the "beginning" of the array
      temp += '0';
    }
    // turn the array back around
    value = "";
    for (count=temp.length-1; count >= 0; count--)
    {
      value += temp.charAt(count);
    }

    return value;
  }

  function rewrite_sheet(edit, row)
  {
    var bodyString;
    var count;
    var am, temp;

    am = 0.0;

    bodyString =  '<form name=\"row_sheet_form\" onSubmit=\"return false;\">\\n' +
    		  '<table border=0 cellspacing=0 cellpadding=0 bgcolor=\"black\" width=\"100%\">\\n' +
    		  '<tr>\\n' +
    		  '<td>\\n' +
    		  '<table border=0 cellspacing=1 cellpadding=1 bgcolor=\"black\" width=\"100%\">\\n' +
    		  '<tr bgcolor=\"#cccccc\">\\n' +
    		  '<th colspan=7 align=left>Debits</th>\\n' +
    		  '</tr>\\n' +
    		  '<tr bgcolor=\"#dddddd\">\\n' +
    		  '<th width=\"8%\" nowrap>Sub-Entity</th><th width=\"60%\" nowrap>Account</th><th width=\"8%\" nowrap>Sub-Account</th><th width=10 nowrap>Debits&nbsp;</th><th width=10 nowrap><font color=\"#dddddd\">Credits</font></th><th width=\"4%\">Edit</th><th width=\"4%\">Delete</th>\\n' +
    		  '</tr>\\n';
    for (count=0; count < debit_rows_array.length; count++)
    {
      if (edit == "d" && row == count)
      {
        bodyString += '<tr bgcolor=\"#eeeeee\" align=center>\\n';
        bodyString += '<td nowrap><font size=-1><input type=text size=5 name=\"sub_entity_edit\" value=\"' + debit_rows_array[count]['se'] + '\" onChange=\"sub_entity_edit_change(document.row_sheet_form);\"><br><select name=\"sub_entity_select\" onChange=\"sub_entity_select_change(document.row_sheet_form);\">\\n';
        bodyString += '<option value=\"-1\">-----\\n';
        for (var count2=0; count2 < sub_entities_array.length; count2++)
        {
          bodyString += '<option';
          if (debit_rows_array[count]['se'] == sub_entities_array[count2])
          {
            bodyString += ' selected';
          }
          bodyString += '>' + sub_entities_array[count2] + '\\n';
        }
        bodyString += '</select></font></td>\\n';
        bodyString += '<td nowrap><font size=-1><input type=text size=20 name=\"account_edit\" value=\"' + debit_rows_array[count]['ac'][1] + '\" onChange=\"account_edit_change(document.row_sheet_form);\"><br><select name=\"account_select\" onChange=\"account_select_change(document.row_sheet_form);\">\\n';
        bodyString += '<option value=\"-1\">-------------------------\\n';
        for (var count2=0; count2 < accounts_array.length; count2++)
        {
          bodyString += '<option value=\"' + accounts_array[count2][0] + '\"';
          if (debit_rows_array[count]['ac'][0] == accounts_array[count2][0])
          {
            bodyString += ' selected';
          }
          bodyString += '>' + accounts_array[count2][1] + '\\n';
        }
        bodyString += '</select></font></td>\\n';
        bodyString += '<td nowrap><font size=-1><input type=text size=15 name=\"sub_account_edit\" value=\"' + debit_rows_array[count]['sa'][1] + '\" onChange=\"sub_account_edit_change(document.row_sheet_form, ' + count + ', \\'d\\');\"><br><select name=\"sub_account_select\" onChange=\"sub_account_select_change(document.row_sheet_form, ' + count + ', \\'d\\');\">\\n';
        bodyString += '<option value=\"-1\">---------------\\n';
        bodyString += '</select></font></td>\\n';
        bodyString += '<td nowrap valign=top><font size=-1><input type=text size=10 name=\"debit_amount\" value=\"' + debit_rows_array[count]['am'] + '\" onChange=\"debit_amount_change(document.row_sheet_form);\"></font></td>\\n';
        bodyString += '<td nowrap valign=top><font size=-1><input type=text size=10 name=\"credit_amount\" value=\"\" onChange=\"credit_amount_change(document.row_sheet_form);\"></font></td>\\n';
        bodyString += '<input type=hidden name=\"cleared\" value=\"' + debit_rows_array[count]['cl'] + '\">\\n';
        bodyString += '<td nowrap><font size=-1><input type=button name=\"enter_edit_row_button\" value=\"Enter\" onClick=\"enter_row_entry(document.row_sheet_form, ' + count + ', \\'d\\');\"></font></td>\\n';
        bodyString += '<td nowrap><font size=-1><input type=button name=\"cancel_edit_row_button\" value=\"Cancel\" onClick=\"allowEntry = true; rewrite_sheet();\"></font></td>\\n';
        bodyString += '</tr>\\n';
        am += parseFloat(debit_rows_array[count]['am'], 10);
      }
      else
      {
        bodyString += '<tr bgcolor=\"#eeeeee\" align=center>\\n';
        bodyString += '<td nowrap>&nbsp;' + ((debit_rows_array[count]['se'] == "") ? '&nbsp;' : debit_rows_array[count]['se']) + '&nbsp;</td>\\n';
        bodyString += '<td nowrap>&nbsp;' + debit_rows_array[count]['ac'][1] + '&nbsp;</td>\\n';
        bodyString += '<td nowrap>&nbsp;' + ((debit_rows_array[count]['sa'][1] == "" || debit_rows_array[count]['sa'][0] == "-1") ? '&nbsp;' : debit_rows_array[count]['sa'][1]) + '&nbsp;</td>\\n';
        bodyString += '<td align=right nowrap>&nbsp;' + commify(debit_rows_array[count]['am']) + '&nbsp;&nbsp;</td>\\n';
        am += parseFloat(debit_rows_array[count]['am'], 10);
        bodyString += '<td>&nbsp;</td>\\n';
        if (allowEntry)
        {
          bodyString += '<td align=center><font size=-6><input type=button value=\"E\" onClick=\"edit_debit_row(document, ' + count + '); return false;\" onMouseOver=\"window.status = edit_string;\"></font></td>\\n';
          bodyString += '<td align=center><font size=-6><input type=button value=\"D\" onClick=\"delete_debit_row(' + count + '); return false;\" onMouseOver=\"window.status = delete_string;\"></font></td>\\n';
        }
        else
        {
          bodyString += '<td><br></td>\\n';
          bodyString += '<td><br></td>\\n';
        }
        bodyString += '</tr>\\n';
      }
    }
    temp = parseFloat(am, 10) + 0.005;
    temp = temp.toString();
    am = temp.substring(0, temp.indexOf('.') + 3);
    // display summary amount for debits if sum is not zero
    if (am != "0.00")
    {
      bodyString += '<tr bgcolor=\"#ffffff\">\\n' +
    		    '<th align=right colspan=3>Debit Sum</th>\\n' +
    		    '<td align=right>' + commify(am) + '&nbsp;&nbsp;</td>\\n' +
    		    '<td colspan=3>&nbsp;</td>\\n' +
    		    '</tr>\\n';
    }

    am = 0.0;
    		
    bodyString += '<tr bgcolor=\"#cccccc\">\\n' +
    		  '<th colspan=7 align=left>Credits</th>\\n' +
    		  '</tr>\\n' +
    		  '<tr bgcolor=\"#dddddd\">\\n' +
    		  '<th nowrap>Sub-Entity</th><th nowrap>Account</th><th nowrap>Sub-Account</th><th>&nbsp;</th><th nowrap>Credits</th><th>Edit</th><th>Delete</th>\\n' +
    		  '</tr>\\n';
    for (count=0; count < credit_rows_array.length; count++)
    {
      if (edit == "c" && row == count)
      {
        bodyString += '<tr bgcolor=\"#eeeeee\" align=center>\\n';
        bodyString += '<td nowrap><font size=-1><input type=text size=5 name=\"sub_entity_edit\" value=\"' + credit_rows_array[count]['se'] + '\" onChange=\"sub_entity_edit_change(document.row_sheet_form);\"><br><select name=\"sub_entity_select\" onChange=\"sub_entity_select_change(document.row_sheet_form);\">\\n';
        bodyString += '<option value=\"-1\">-----\\n';
        for (var count2=0; count2 < sub_entities_array.length; count2++)
        {
          bodyString += '<option';
          if (credit_rows_array[count]['se'] == sub_entities_array[count2])
          {
            bodyString += ' selected';
          }
          bodyString += '>' + sub_entities_array[count2] + '\\n';
        }
        bodyString += '</select></font></td>\\n';
        bodyString += '<td nowrap><font size=-1><input type=text size=20 name=\"account_edit\" value=\"' + credit_rows_array[count]['ac'][1] + '\" onChange=\"account_edit_change(document.row_sheet_form);\"><br><select name=\"account_select\" onChange=\"account_select_change(document.row_sheet_form);\">\\n';
        bodyString += '<option value=\"-1\">--------------------\\n';
        for (var count2=0; count2 < accounts_array.length; count2++)
        {
          bodyString += '<option value=\"' + accounts_array[count2][0] + '\"';
          if (credit_rows_array[count]['ac'][0] == accounts_array[count2][0])
          {
            bodyString += ' selected';
          }
          bodyString += '>' + accounts_array[count2][1] + '\\n';
        }
        bodyString += '</select></font></td>\\n';
        bodyString += '<td nowrap><font size=-1><input type=text size=15 name=\"sub_account_edit\" value=\"' + credit_rows_array[count]['sa'][1] + '\" onChange=\"sub_account_edit_change(document.row_sheet_form, ' + count + ', \\'c\\');\"><br><select name=\"sub_account_select\" onChange=\"sub_account_select_change(document.row_sheet_form, ' + count + ', \\'c\\');\">\\n';
        bodyString += '<option value=\"-1\">---------------\\n';
        bodyString += '</select></font></td>\\n';
        bodyString += '<td nowrap valign=top><font size=-1><input type=text size=10 name=\"debit_amount\" value=\"\" onChange=\"debit_amount_change(document.row_sheet_form);\"></font></td>\\n';
        bodyString += '<td nowrap valign=top><font size=-1><input type=text size=10 name=\"credit_amount\" value=\"' + credit_rows_array[count]['am'] + '\" onChange=\"credit_amount_change(document.row_sheet_form);\"></font></td>\\n';
        bodyString += '<input type=hidden name=\"cleared\" value=\"' + credit_rows_array[count]['cl'] + '\">\\n';
        bodyString += '<td nowrap><font size=-1><input type=button name=\"enter_edit_row_button\" value=\"Enter\" onClick=\"enter_row_entry(document.row_sheet_form, ' + count + ', \\'c\\');\"></font></td>\\n';
        bodyString += '<td nowrap><font size=-1><input type=button name=\"cancel_edit_row_button\" value=\"Cancel\" onClick=\"allowEntry = true; rewrite_sheet();\"></font></td>\\n';
        bodyString += '</tr>\\n';
        am += parseFloat(credit_rows_array[count]['am'], 10);
      }
      else
      {
        bodyString += '<tr bgcolor=\"#eeeeee\" align=center>\\n';
        bodyString += '<td nowrap>&nbsp;' + ((credit_rows_array[count]['se'] == "") ? '&nbsp;' : credit_rows_array[count]['se']) + '&nbsp;</td>\\n';
        bodyString += '<td nowrap>&nbsp;' + credit_rows_array[count]['ac'][1] + '</td>\\n';
        bodyString += '<td nowrap>&nbsp;' + ((credit_rows_array[count]['sa'][1] == "" || credit_rows_array[count]['sa'][0] == "-1") ? '&nbsp;' : credit_rows_array[count]['sa'][1]) + '&nbsp;</td>\\n';
        bodyString += '<td>&nbsp;</td>\\n';
        bodyString += '<td align=right nowrap>&nbsp;' + commify(credit_rows_array[count]['am']) + '&nbsp;&nbsp;</td>\\n';
        am += parseFloat(credit_rows_array[count]['am'], 10);
        if (allowEntry)
        {
          bodyString += '<td align=center><font size=-6><input type=button value=\"E\" onClick=\"edit_credit_row(document, ' + count + '); return false;\" onMouseOver=\"window.status = edit_string;\"></font></td>';
          bodyString += '<td align=center><font size=-6><input type=button value=\"D\" onClick=\"delete_credit_row(' + count + '); return false;\" onMouseOver=\"window.status = delete_string;\"></font></td>\\n';
        }
        else
        {
          bodyString += '<td><br></td>\\n';
          bodyString += '<td><br></td>\\n';
        }
        bodyString += '</tr>\\n';
      }
    }
    temp = parseFloat(am, 10) + 0.005;
    temp = temp.toString();
    am = temp.substring(0, temp.indexOf('.') + 3);
    // display summary amount for credits if sum is not zero
    if (am != "0.00")
    {
      bodyString += '<tr bgcolor=\"#ffffff\">\\n' +
    		    '<th align=right colspan=4>Credit Sum</th>\\n' +
    		    '<td align=right>' + commify(am) + '&nbsp;&nbsp;</td>\\n' +
    		    '<td colspan=2>&nbsp;</td>\\n' +
    		    '</tr>\\n';
    }

    bodyString += '</table>\\n' +
    		  '</td>\\n' +
    		  '</tr>\\n' +
    		  '</table>\\n' +
    		  '</form>\\n';
    if (isDOM)
    {
      // get the element that contains the CSS sheet
      var dbElement = window.document.getElementById('DebitCreditView');
      dbElement.innerHTML = bodyString;
    }
    else if (isNav4)
    {
      // hide the sheet
      window.document.DebitCreditView.visibility = "hide";
      window.document.DebitCreditView.document.writeln(bodyString);
      window.document.DebitCreditView.document.close();
      // reshow the sheet
      window.document.DebitCreditView.visibility = "show";
    }
    else if (isIE4)
    {
      // hide the sheet
      window.document.all.DebitCreditView.visibility = "hidden";
      window.document.all.DebitCreditView.innerHTML = bodyString;
      // reshow the sheet
      window.document.all.DebitCreditView.visibility = "visible";
    }
    window.status = "";
  }

  function validate_row_entry(form, row, edit)
  {
    var f;

    if (arguments.length > 0)
    {
      f = form;
    }
    else
    {
      f = document.row_entry_form;
    }

    document.errorString = "";
    document.focus_element = null;

    // make sure there are valid values assigned to each mandatory field
    // sub-entity fields of "" are OK
    if (f.account_edit.value == "")
    {
      document.errorString += "An account must be entered!\\n";
      document.focus_element = f.account_edit;
    }
    if (f.debit_amount.value == "" && f.credit_amount.value == "")
    {
      document.errorString += "A debit or credit amount must be entered!\\n";
      if (!document.focus_element)
      {
        document.focus_element = f.debit_amount;
      }
    }
    else
    {
      // verify that a numeric value has been entered
      if (f.debit_amount.value != "" && isNaN(parseFloat(f.debit_amount.value, 10)))
      {
        document.errorString += "Invalid numeric value for debit! (" + f.debit_amount.value + ")\\n";
        if (!document.focus_element)
        {
          document.focus_element = f.debit_amount;
        }
      }
      else if (f.credit_amount.value != "" && isNaN(parseFloat(f.credit_amount.value, 10)))
      {
        document.errorString += "Invalid numeric value for credit! (" + f.credit_amount.value + ")\\n";
        if (!document.focus_element)
        {
          document.focus_element = f.credit_amount;
        }
      }
    }

    // sub-account fields of "" are OK, but make sure that the sub-account is known (unless check/deposit #)
    // if check/deposit number used, make sure it is not used on the form more than once
    if (f.sub_account_edit.value != "" && sub_accounts_bank[f.account_select.options[f.account_select.selectedIndex].value] && f.sub_account_select.options[f.sub_account_select.selectedIndex].value == "C")
    {
      // verify that value entered is a valid numeric value
      if (!isNaN(parseFloat(f.sub_account_edit.value, 10)))
      {
        // run through the credit_rows_array
        for (var count=0; count < credit_rows_array.length; count++)
        {
          if (credit_rows_array[count]['sa'][1] == f.sub_account_edit.value && credit_rows_array[count]['ac'][1] == f.account_edit.value)
          {
            if (allowEntry || !(count == row && edit == "c"))
            {
              document.errorString += "The check number: " + f.sub_account_edit.value + " has already been used!\\n";
              if (!document.focus_element)
              {
                document.focus_element = f.sub_account_edit;
              }
            }
          }
        }
      }
      else
      {
        document.errorString += "Invalid numeric value for a check number! (" + f.sub_account_edit.value + ")\\n";
        if (!document.focus_element)
        {
          document.focus_element = f.sub_account_edit;
        }
      }
    }
    else if (f.sub_account_edit.value != "" && sub_accounts_bank[f.account_select.options[f.account_select.selectedIndex].value] && f.sub_account_select.options[f.sub_account_select.selectedIndex].value == "D")
    {
      // verify that value entered is a valid numeric value
      if (!isNaN(parseFloat(f.sub_account_edit.value, 10)))
      {
        // run through the debit_rows_array
        for (var count=0; count < debit_rows_array.length; count++)
        {
          if (debit_rows_array[count]['sa'][1] == f.sub_account_edit.value && debit_rows_array[count]['ac'][1] == f.account_edit.value)
          {
            if (allowEntry || !(count == row && edit == "d"))
            {
              document.errorString += "The deposit number: " + f.sub_account_edit.value + " has already been used!\\n";
              if (!document.focus_element)
              {
                document.focus_element = f.sub_account_edit;
              }
            }
          }
        }
      }
      else
      {
        document.errorString += "Invalid numeric value for a deposit number! (" + f.sub_account_edit.value + ")\\n";
        if (!document.focus_element)
        {
          document.focus_element = f.sub_account_edit;
        }
      }
    }
    else if (f.sub_account_edit.value != "")
    {
      var matchFound = false;

      // check to make sure the sub-account is known
      for (var count=0; count < f.sub_account_select.options.length; count++)
      {
        if (f.sub_account_edit.value == f.sub_account_select.options[count].text)
        {
          matchFound = true;
        }
      }
      if (!matchFound)
      {
        document.errorString += "The sub-account entered does not match with any assigned sub-accounts!\\n";
        if (!document.focus_element)
        {
          document.focus_element = f.sub_account_edit;
        }
      }
    }

    // check to see if user is wanting to change the values of the two row entries (just 2 entries); this is determined by
    // having a debit amount and no other values entered
    if (debit_rows_array.length == 1 && credit_rows_array.length == 1 && f.sub_entity_edit.value == "" && f.account_edit.value == "" && f.sub_account_edit.value == "" && f.debit_amount.value != "" && f.credit_amount.value == "" && document.errorString.indexOf("Invalid numeric value for debit!") == -1)
    {
      document.errorString = "";
    }

    if (document.errorString != "")
    {
      return false;
    }

    return true;
  }

  function edit_debit_row(doc, n)
  {
    // disable the ability to enter any new transaction rows until the edit has been completed or cancelled
    allowEntry = false;
    rewrite_sheet("d", n);
    // fill in the drop-down sub-account select with the correct value
    account_edit_change(doc.row_sheet_form);
    doc.row_sheet_form.sub_account_edit.value = debit_rows_array[n]['sa'][1];
    sub_account_edit_change(doc.row_sheet_form, n, "d");
    // set the focus to the debit edit field in the inline edit row
    doc.row_sheet_form.debit_amount.focus();
  }

  function delete_debit_row(n)
  {
    // remove the row of data from the JavaScript array
    // move all values down one in the array
    for (var count=parseInt(n)+1; count < debit_rows_array.length; count++)
    {
      debit_rows_array[count-1]['se'] = debit_rows_array[count]['se'];
      debit_rows_array[count-1]['ac'][0] = debit_rows_array[count]['ac'][0];
      debit_rows_array[count-1]['ac'][1] = debit_rows_array[count]['ac'][1];
      debit_rows_array[count-1]['sa'][0] = debit_rows_array[count]['sa'][0];
      debit_rows_array[count-1]['sa'][1] = debit_rows_array[count]['sa'][1];
      debit_rows_array[count-1]['am'] = debit_rows_array[count]['am'];
      debit_rows_array[count-1]['cl'] = debit_rows_array[count]['cl'];
    }
    // shrink the array size by one
    if (debit_rows_array.length > 0)
    {
      debit_rows_array.length--;
    }
    // redraw the sheet
    rewrite_sheet();
    // if there are only two rows entered (one debit and one credit), place focus on the debit field
    if (debit_rows_array.length == 1 && credit_rows_array.length == 1 && document.row_entry_form.sub_entity_edit.value == "" && document.row_entry_form.account_edit.value == "" && document.row_entry_form.sub_account_edit.value == "")
    {
      document.row_entry_form.debit_amount.focus();
    }
    else
    {
      // otherwise, place focus on sub-entity edit field
      document.row_entry_form.sub_entity_edit.focus();
    }
  }

  function edit_credit_row(doc, n)
  {
    // disable the ability to enter any new transaction rows until the edit has been completed or cancelled
    allowEntry = false;
    rewrite_sheet("c", n);
    // fill in the drop-down sub-account select with the correct value
    account_edit_change(doc.row_sheet_form);
    doc.row_sheet_form.sub_account_edit.value = credit_rows_array[n]['sa'][1];
    sub_account_edit_change(doc.row_sheet_form, n, "c");
    // set the focus to the credit edit field in the inline edit row
    doc.row_sheet_form.credit_amount.focus();
  }

  function delete_credit_row(n)
  {
    // remove the row of data from the JavaScript array
    // move all values down one in the array
    for (var count=parseInt(n)+1; count < credit_rows_array.length; count++)
    {
      credit_rows_array[count-1]['se'] = credit_rows_array[count]['se'];
      credit_rows_array[count-1]['ac'][0] = credit_rows_array[count]['ac'][0];
      credit_rows_array[count-1]['ac'][1] = credit_rows_array[count]['ac'][1];
      credit_rows_array[count-1]['sa'][0] = credit_rows_array[count]['sa'][0];
      credit_rows_array[count-1]['sa'][1] = credit_rows_array[count]['sa'][1];
      credit_rows_array[count-1]['am'] = credit_rows_array[count]['am'];
      credit_rows_array[count-1]['cl'] = credit_rows_array[count]['cl'];
    }
    // shrink the array size by one
    if (credit_rows_array.length > 0)
    {
      credit_rows_array.length--;
    }
    // redraw the sheet
    rewrite_sheet();
    // if there are only two rows entered (one debit and one credit), place focus on the debit field
    if (debit_rows_array.length == 1 && credit_rows_array.length == 1 && document.row_entry_form.sub_entity_edit.value == "" && document.row_entry_form.account_edit.value == "" && document.row_entry_form.sub_account_edit.value == "")
    {
      document.row_entry_form.debit_amount.focus();
    }
    else
    {
      // otherwise, place focus on sub-entity edit field
      document.row_entry_form.sub_entity_edit.focus();
    }
  }

  function update_values()
  {
    var f = document.row_entry_form;

    // copy the values of the debit_rows_array and the credit_rows_array into the debit_values and credit_values hidden form elements
    f.debit_values.value = "";
    for (var count=0; count < debit_rows_array.length; count++)
    {
      f.debit_values.value += 'se='  + debit_rows_array[count]['se'] +
      			      '|ac=' + debit_rows_array[count]['ac'][0] +
      			      '|sa=' + debit_rows_array[count]['sa'][0] +
      			      '|cd=' + debit_rows_array[count]['sa'][1] +
      			      '|am=' + debit_rows_array[count]['am'] +
      			      '|cl=' + debit_rows_array[count]['cl'];
      if (count < debit_rows_array.length - 1)
      {
        f.debit_values.value += ';';
      }
    }
    f.credit_values.value = "";
    for (var count=0; count < credit_rows_array.length; count++)
    {
      f.credit_values.value += 'se='  + credit_rows_array[count]['se'] +
      			       '|ac=' + credit_rows_array[count]['ac'][0] +
      			       '|sa=' + credit_rows_array[count]['sa'][0] +
      			       '|cd=' + credit_rows_array[count]['sa'][1] +
      			       '|am=' + credit_rows_array[count]['am'] +
    			       '|cl=' + credit_rows_array[count]['cl'];
      if (count < credit_rows_array.length - 1)
      {
        f.credit_values.value += ';';
      }
    }

    // copy the values of the reset_debit_rows_array and the reset_credit_rows_array into the reset_debit_values and reset_credit_values hidden form elements
    // if the hidden values are empty
    if (f.reset_debit_values.value == "" && f.reset_credit_values.value == "")
    {
      for (var count=0; count < reset_debit_rows_array.length; count++)
      {
        f.reset_debit_values.value += 'se='  + reset_debit_rows_array[count]['se'] +
        			      '|ac=' + reset_debit_rows_array[count]['ac'][0] +
        			      '|sa=' + reset_debit_rows_array[count]['sa'][0] +
        			      '|cd=' + reset_debit_rows_array[count]['sa'][1] +
        			      '|am=' + reset_debit_rows_array[count]['am'] +
        			      '|cl=' + reset_debit_rows_array[count]['cl'];
        if (count < reset_debit_rows_array.length - 1)
        {
          f.reset_debit_values.value += ';';
        }
      }
      for (var count=0; count < reset_credit_rows_array.length; count++)
      {
        f.reset_credit_values.value += 'se='  + reset_credit_rows_array[count]['se'] +
        			       '|ac=' + reset_credit_rows_array[count]['ac'][0] +
        			       '|sa=' + reset_credit_rows_array[count]['sa'][0] +
        			       '|cd=' + reset_credit_rows_array[count]['sa'][1] +
        			       '|am=' + reset_credit_rows_array[count]['am'] +
        			       '|cl=' + reset_credit_rows_array[count]['cl'];
        if (count < reset_credit_rows_array.length - 1)
        {
          f.reset_credit_values.value += ';';
        }
      }
    }
  }

  function submit_transaction()
  {
    // validate the transaction
    if (!validate_transaction())
    {
      return false;
    }
    // update hidden values that contain the transaction rows
    update_values();

    return true;
  }

  function blank_transaction()
  {
    var f = document.row_entry_form;

    // since the form is being blown away or changed back to the original, let entries happen even if in the middle of an edit
    allowEntry = true;

    // clear the row entry form
    clear_row_entry();
    // delete all entries from the debit_rows_array and credit_rows_array
    debit_rows_array.length = 0;
    credit_rows_array.length = 0;
    f.debit_values.value = "";
    f.credit_values.value = "";
    // redraw the sheet
    rewrite_sheet();
    // put focus on sub-entity edit field
    f.sub_entity_edit.focus();
  }

  function reset_transaction()
  {
    blank_transaction();

    // run through the reset_rows arrays and refill the debit_rows_array and credit_rows_array with their respective information
    for (var count=0; count < reset_debit_rows_array.length; count++)
    {
      debit_rows_array[count] = new Array();
      debit_rows_array[count]['se'] = reset_debit_rows_array[count]['se'];
      debit_rows_array[count]['ac'] = new Array();
      debit_rows_array[count]['ac'][0] = reset_debit_rows_array[count]['ac'][0];
      debit_rows_array[count]['ac'][1] = reset_debit_rows_array[count]['ac'][1];
      debit_rows_array[count]['sa'] = new Array();
      debit_rows_array[count]['sa'][0] = reset_debit_rows_array[count]['sa'][0];
      debit_rows_array[count]['sa'][1] = reset_debit_rows_array[count]['sa'][1];
      debit_rows_array[count]['am'] = reset_debit_rows_array[count]['am'];
      debit_rows_array[count]['cl'] = reset_debit_rows_array[count]['cl'];
    }
    for (var count=0; count < reset_credit_rows_array.length; count++)
    {
      credit_rows_array[count] = new Array();
      credit_rows_array[count]['se'] = reset_credit_rows_array[count]['se'];
      credit_rows_array[count]['ac'] = new Array();
      credit_rows_array[count]['ac'][0] = reset_credit_rows_array[count]['ac'][0];
      credit_rows_array[count]['ac'][1] = reset_credit_rows_array[count]['ac'][1];
      credit_rows_array[count]['sa'] = new Array();
      credit_rows_array[count]['sa'][0] = reset_credit_rows_array[count]['sa'][0];
      credit_rows_array[count]['sa'][1] = reset_credit_rows_array[count]['sa'][1];
      credit_rows_array[count]['am'] = reset_credit_rows_array[count]['am'];
      credit_rows_array[count]['cl'] = reset_credit_rows_array[count]['cl'];
    }

    // redraw the sheet
    rewrite_sheet();
    // if there are only two rows entered (one debit and one credit), place focus on the debit field
    if (debit_rows_array.length == 1 && credit_rows_array.length == 1 && document.row_entry_form.sub_entity_edit.value == "" && document.row_entry_form.account_edit.value == "" && document.row_entry_form.sub_account_edit.value == "")
    {
      document.row_entry_form.debit_amount.focus();
    }
    else
    {
      // otherwise, place focus on sub-entity edit field
      document.row_entry_form.sub_entity_edit.focus();
    }
  }

  //-->
</script>
END_OF_STYLE
#/ get current date
$date = `/bin/date +%m-%d-%Y`;
chomp $date;

print "<center>\n";
print "<table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
print "<tr>\n";
if ($mode eq "edit" or $other_mode eq "edit")
{
  print "<td align=left width=47%><font color=\"red\">";
  print "Editing Journal Entry in Journal <font color=\"blue\">$journal_name</font>";
}
elsif ($mode eq "new" or $other_mode eq "new")
{
  print "<td align=left width=47%><font color=\"red\">";
  print "Creating Journal Entry in Journal <font color=\"blue\">$journal_name</font>";
}
print " in Ledger <font color=\"$ledger_color\">$ledger_name</font></font></td>\n";
print "<td align=left><a href=\"$site_dir/help.html#journal\" target=\"docs\"><img border=0 src=\"$site_dir/images/help.jpg\" alt=\"Help\"></a></td>\n";
print "<td align=right>$date</td></tr></table>\n<hr><br>\n";
print PrintStandardLedgerMainMenu($ledger_db);

# allow the user to get back to the same journal view they came from
my $temp_str = GetJournalViewInput();
if (length $temp_str > 0)
{
  print "<form name=\"journal_view_form\" method=post action=\"$site_dir/cgi-bin/journal_mod1.cgi\">\n";
  print "$temp_str";
  print "<br><div align=right><a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"document.journal_view_form.submit(); return false;\">To return to the Journal View, click <u>here</u>.</a></div>\n";
  print "</form>\n";
}

# start form
print "<form method=post name=\"row_entry_form\" action=\"$site_dir/cgi-bin/journal_activity_update_sheet.cgi\">\n";
# hidden ledger_name value
print "<input type=hidden name=\"ledger_db\" value=\"$ledger_db\">\n";
# hidden journal_code value
print "<input type=hidden name=\"journal_code\" value=\"$journal_code\">\n";
# hidden transaction date value
print "<input type=hidden name=\"trans_date\" value=\"$trans_date\">\n";
# hidden payee_payer value
print "<input type=hidden name=\"payee_payer\" value=\"$payee_payer\">\n";
print "<input type=hidden name=\"payee_payer_id\" value=\"$payee_payer_id\">\n";
# hidden mode for row script (edit or new)
if ($mode eq "edit")
{
  print "<input type=hidden name=\"ref_num\" value=\"$ref_num\">\n";
  print "<input type=hidden name=\"mode\" value=\"edit\">\n";
}
elsif ($mode eq "new")
{
  print "<input type=hidden name=\"mode\" value=\"new\">\n";
}
elsif ($mode eq "refresh")
{
  print "<input type=hidden name=\"mode\" value=\"$other_mode\">\n";
  if ($other_mode eq "edit")
  {
    # hidden ref_num value
    print "<input type=hidden name=\"ref_num\" value=\"$ref_num\">\n";
  }
}
print "<input type=hidden name=\"debit_values\" value=\"\">\n";
print "<input type=hidden name=\"credit_values\" value=\"\">\n";
print "<input type=hidden name=\"reset_debit_values\" value=\"" . $input{'reset_debit_values'} . "\">\n";
print "<input type=hidden name=\"reset_credit_values\" value=\"" . $input{'reset_credit_values'} . "\">\n";

# build table out of the data
print "<table border=1 cellspacing=0 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
print "<tr>\n";
if ($mode eq "edit" || ($mode eq "refresh" && $other_mode eq "edit"))
{
  print "<th valign=top>Ref #</th>";
}
print "<th valign=top>Journal</th><th valign=top align=left>Date</th><th valign=top align=left>Payee-Payer</th><th align=left>Remembered</th><th colspan=2 align=left>Memo</th>\n";
print "</tr>\n";
print "<tr>\n";
# reference number
if ($mode eq "edit" || ($mode eq "refresh" && $other_mode eq "edit"))
{
  print "<td align=center>$ref_num</td>\n";
}
# journal code
print "<td align=center>$journal_code</td>\n";
# date
print "<td>$trans_date</td>\n";
# payee/payer
if ($payee_payer eq "")
{
  print "<td><br></td>\n";
}
else
{
  print "<td>$payee_payer</td>\n";
}
# remembered
print "<td align=center>";
print "<select name=\"remember\">\n";
print "<option value=\"true\"";
if ($remember eq "true")
{
  print " selected";
}
print ">Yes\n";
print "<option value=\"false\"";
if ($remember eq "false")
{
  print " selected";
}
print ">No\n";
print "</select>\n";
print "</td>\n";
# memo text field
print "<td colspan=2 align=center><input type=text name=\"memo\" value=\"$memo\" size=35></td>\n";
print "</tr>\n";
print "</table>\n";
print "<hr>\n";

print "<table border=0 width=\"100%\" cellspacing=1 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
print "<tr>\n";
print "<td align=left><input type=submit name=\"refresh1\" value=\"Refresh\" onClick=\"update_values(); submit_my_form(document.row_entry_form, '$site_dir/cgi-bin/journal_activity_rows_sheet.cgi');\"> <input type=button name=\"blank1\" value=\"Blank\" onClick=\"blank_transaction();\"> <input type=button name=\"reset1\" value=\"Default\" onClick=\"reset_transaction();\"></td>\n";
print "<td align=center><b>New Row</b></td>\n";
print "<td align=right><input type=submit name=\"";
if ($mode eq "edit")
{
  print "edit_submit";
}
elsif ($mode eq "new")
{
  print "new_submit";
}
elsif ($mode eq "refresh")
{
  if ($other_mode eq "edit")
  {
    print "edit_submit";
  }
  elsif ($other_mode eq "new")
  {
    print "new_submit";
  }
}
print "\" value=\"Submit Journal Entry\" onClick=\"return submit_transaction();\"></td>\n";
print "</tr>\n";
print "</table>\n";

print "<table border=0 width=\"100%\" cellspacing=0 cellpadding=0 bgcolor=\"black\">\n";
print "<tr>\n";
print "<td>\n";
print "<table border=0 width=\"100%\" cellspacing=1 cellpadding=2 bgcolor=\"black\">\n";
print "<tr bgcolor=\"$body_bgcolor\">\n";
print "<th width=\"19%\">Sub-Entity</th><th width=\"19%\">Account</th><th width=\"19%\">Sub-Account</th><th width=\"19%\">Debit</th><th width=\"19%\">Credit</th>";
print "</tr>\n";
print "<tr bgcolor=\"$body_bgcolor\">\n";
print "<td align=center><input type=text name=\"sub_entity_edit\" value=\"";
if ($mode eq "refresh")
{
  print $input{'sub_entity_edit'};
}
print "\" size=5 onChange=\"sub_entity_edit_change();\"><br>\n";
print "<select name=\"sub_entity_select\" onChange=\"sub_entity_select_change();\">\n";
print "<option value=\"\">-----\n";
for ($count=0; $count < @sub_entity_array; $count++)
{
  print "<option";
  if ($mode eq "refresh" && $input{'sub_entity_select'} eq $sub_entity_array[$count])
  {
    print " selected";
  }
  print ">$sub_entity_array[$count]\n";
}
print "</select></td>\n";
print "<td align=center><input type=text name=\"account_edit\" value=\"";
if ($mode eq "refresh")
{
  print $input{'account_edit'};
}
print "\" size=20 onChange=\"account_edit_change();\"><br>\n";
print "<select name=\"account_select\" onChange=\"account_select_change();\">\n";
print "<option value=\"-1\">--------------------\n";
for ($count=0; $count < @account_array; $count++)
{
  print "<option value=\"$account_array[$count][0]\"";
  if ($mode eq "refresh" && $input{'account_select'} eq $account_array[$count][0])
  {
    print " selected";
  }
  print ">$account_array[$count][1]";
  if ($account_array[$count][3] eq "t")
  {
    print " ~";
  }
  print "\n";
}
print "</select></td>\n";
print "<td align=center><input type=text name=\"sub_account_edit\" value=\"\" size=15 onChange=\"sub_account_edit_change();\"><br>\n";
print "<select name=\"sub_account_select\" onChange=\"sub_account_select_change();\">\n";
print "<option value=\"-1\">---------------\n";
print "</select></td>\n";
print "<td align=center valign=top><input type=text name=\"debit_amount\" value=\"";
if ($mode eq "refresh")
{
  print $input{'debit_amount'};
}
print "\" size=10 onChange=\"debit_amount_change();\"></td>\n";
print "<td align=center valign=top><input type=text name=\"credit_amount\" value=\"";
if ($mode eq "refresh")
{
  print $input{'credit_amount'};
}
print "\" size=10 onChange=\"credit_amount_change();\"></td>\n";
print "</tr>\n";
print "<tr bgcolor=\"$body_bgcolor\">\n";
print "<td colspan=5 align=right>\n";
print "<input type=button name=\"enter_row_entry_button\" value=\"Enter\" onClick=\"enter_row_entry();\">";
print "<input type=button name=\"clear_row_entry_button\" value=\"Clear\" onClick=\"clear_row_entry();\">&nbsp;";
print "<input type=button name=\"calculate_diff\" value=\"Re-calculate\" onClick=\"document.row_entry_form.debit_amount.value = \'\'; document.row_entry_form.credit_amount.value = \'\'; calculate_debit_credit_diff(); if (debit_rows_array.length == 1 && credit_rows_array.length == 1 && document.row_entry_form.sub_entity_edit.value == \'\' && document.row_entry_form.account_edit.value == \'\' && document.row_entry_form.sub_account_edit.value == \'\') { document.row_entry_form.debit_amount.focus(); } else { document.row_entry_form.sub_entity_edit.focus(); };\">\n";
print "<input type=hidden name=\"cleared\" value=\" \">\n";
print "</td>\n";
print "</tr>\n";
print "</table>\n";
print "</td>\n";
print "</tr>\n";
print "</table>\n";

my $temp_str = GetJournalViewInput();
if (length $temp_str > 0)
{
  print "$temp_str";
}
print "</form>\n";

print "</center>\n";

# output the <DIV> tag for our cascading style sheet
print "<div id=\"DebitCreditView\"></div>\n";

print "</body>\n";
print "</html>\n";
exit 0;

sub GetJournalViewInput
{
  my ($mode, $date_type, $date_from, $date_to, $redisplay_string, $journal_name, $journal_code, $ref_num, $error_string, $payee_payer, $memo, $account_name, $account_num, $sub_acct_name, $sub_acct_num, $sub_acct_parent);
  my ($money_type, $money_search, $money1, $money2, $sort_by, $sort_journal, $num_entries_to_display, $start_index, $ledger_db, $check_num, $deposit_num, $sort_operator);
  my %valid_entries_to_display = ( 0 => "all", 5 => "5", 10 => "10", 15 => "15", 20 => "20", 25 => "25", 30 => "30", 35 => "35", 40 => "40", 45 => "45", 50 => "50" );
  my %valid_options = ( "open" => "open", "delete" => "delete", "add" => "add", "search" => "search", "search2" => "search2" );

  if (not exists $input{'journal_view_command'})
  {
    return "";  # nothing to do.
  }
  if (not exists $valid_options{$input{'journal_view_command'}})
  {
    PrintErrorHeader();
    print "<h1>(Journal View Re-display Code) Error:  Access Denied!</h1>\n";
    print "Invalid option given.  Option = '$input{'journal_view_command'}'.<br>$sys_admin";
    CleanUp();
  }

  $ledger_db = $input{'ledger'};
  if (length $ledger_db == 0)
  {
    PrintErrorHeader();
    print "<h1>(Journal View Re-display Code) Error: You must specify a ledger to work with!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $error_string = IsValidString($ledger_db);
  if (length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>(Journal View Re-display Code) Error:  Invalid Database Name!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  $redisplay_string .= "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";

  # validate we got valid input from the user.
  if ($input{'journal_view_command'} eq "open")
  {
    $mode = 1;
    $redisplay_string .= "<input type=hidden name=\"journal_view_command\" value=\"open\">\n";
    if (not exists $input{'journal'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: You must specify a Journal to work with!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"journal\" value=\"" . $input{'journal'} . "\">\n";
    $date_from = $input{'date_from'};
    if (length $date_from == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a From date!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $date_to = $input{'date_to'};
    if (length $date_to == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a To date!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $sort_by = $input{'sort_by'};
    if (length $sort_by == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a SortBy Option!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (not ($sort_by eq "date" || $sort_by eq "ref_num" || $sort_by eq "payee_payer"))
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid SortBy Option!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if ($sort_by eq "date")
    {
      $sort_by = "trans_date";
    }
    if (exists $input{'sort_journal'})
    {
      $sort_journal = 1;
      $redisplay_string .= "<input type=hidden name=\"sort_journal\" value=\"1\">\n";
    }
    else
    {
      $sort_journal = 0;
    }
    $redisplay_string .= "<input type=hidden name=\"date_from\" value=\"$date_from\">\n<input type=hidden name=\"date_to\" value=\"$date_to\">\n<input type=hidden name=\"sort_by\" value=\"" . $input{'sort_by'} . "\">\n";
  }
  elsif ($input{'journal_view_command'} eq "search")
  {
    $mode = 4;
    # first make sure all the correct variables are being passed in.
    if (not exists $input{'date_type'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Date Qualifier must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $date_type = $input{'date_type'};
    if (not exists $input{'date_from_search'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Date to search from must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (not ($date_type eq "equal" || $date_type eq "betweeni" || $date_type eq "betweene" || $date_type eq "afteri" || $date_type eq "aftere" || $date_type eq "beforei" || $date_type eq "beforee"))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Date Qualifier Option!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $date_from = $input{'date_from_search'};
    if (not exists $input{'date_to_search'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Date to search to must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (length $date_from > 0 && (not IsValidDateSyntax($date_from)))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Date given!</h1>\n";
      print "The From date is invalid.<br>$back_button";
      CleanUp();
    }
    $date_to = $input{'date_to_search'};
    if (length $date_to > 0 && (not IsValidDateSyntax($date_to)))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Date given!</h1>\n";
      print "The To date is invalid.<br>$back_button";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"journal_view_command\" value=\"search\">\n";
    $redisplay_string .= "<input type=hidden name=\"date_type\" value=\"$date_type\">\n<input type=hidden name=\"date_from_search\" value=\"$date_from\">\n<input type=hidden name=\"date_to_search\" value=\"$date_to\">\n";
    if (not exists $input{'journal2'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Journal selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    ($journal_name, $journal_code) = split /\|/, $input{'journal2'};
    if (not exists $input{'ref_num2'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Reference Number field must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $ref_num = $input{'ref_num2'};
    $error_string = IsValidUInteger($ref_num);
    if (length $ref_num > 0 && length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Ref Number!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    if (not exists $input{'check_num'})
    {
      PrintErrorHeader();
      print "<h1>Error: Check Number field must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $check_num = $input{'check_num'};
    $error_string = IsValidUInteger($check_num);
    if (length $check_num > 0 && length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid Check Number!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    if (not exists $input{'deposit_num'})
    {
      PrintErrorHeader();
      print "<h1>Error: Deposit Number field must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $deposit_num = $input{'deposit_num'};
    $error_string = IsValidUInteger($deposit_num);
    if (length $deposit_num > 0 && length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid Deposit Number!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    if (not exists $input{'payee_payer2'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Payee-Payer selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $payee_payer = $input{'payee_payer2'};
    $error_string = IsValidString($payee_payer);
    if (length $payee_payer > 0 && length $error_string > 0 && (not $error_string eq "_"))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Payee-Payer!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"journal2\" value=\"" . $input{'journal2'} . "\">\n<input type=hidden name=\"ref_num2\" value=\"$ref_num\">\n<input type=hidden name=\"check_num\" value=\"$check_num\">\n<input type=hidden name=\"deposit_num\" value=\"$deposit_num\">\n<input type=hidden name=\"payee_payer2\" value=\"$payee_payer\">\n";
    if (not exists $input{'memo2'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Memo field must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $memo = $input{'memo2'};
    $error_string = IsValidString($memo);
    if (length $memo > 0 && length $error_string > 0 && (not ($error_string eq "*" || $error_string eq "?")))
    {
      PrintErrorHeader();
      print "<h1(Journal View Re-display Code) >Error:  Invalid Memo!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    if (not exists $input{'sub_entity'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code)Error: Sub Entity selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (not exists $input{'account'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Account selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    ($account_name, $account_num) = split /\|/, $input{'account'};
    if (not exists $input{'sub_account'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Sub Account selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    ($sub_acct_name, $sub_acct_num, $sub_acct_parent) = split /\|/, $input{'sub_account'};
    if (not exists $input{'dorc'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Debit or Credit Selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $money_type = $input{'dorc'};
    if (not ($money_type eq "select_dorc" || $money_type eq "debit" || $money_type eq "credit" || $money_type eq "both"))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Debit or Credit Selection type!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"memo2\" value=\"$memo\">\n<input type=hidden name=\"account\" value=\"" . $input{'account'} . "\">\n<input type=hidden name=\"sub_account\" value=\"" . $input{'sub_account'} . "\">\n";
    $redisplay_string .= "<input type=hidden name=\"dorc\" value=\"$money_type\">\n<input type=hidden name=\"sub_entity\" value=\"$input{sub_entity}\">\n";
    if (not exists $input{'dorc_search'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Debit or Credit Search Type Selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $money_search = $input{'dorc_search'};
    if (not ($money_search eq "all" || $money_search eq "equal" || $money_search eq "less_than" || $money_search eq "less_than_equal" || $money_search eq "greater_than" || $money_search eq "greater_than_equal" || $money_search eq "betweene" || $money_search eq "betweeni"))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Debit or Credit Search type!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $money1 = $input{'money1'};
    $error_string = IsValidInteger($money1);
    my $error_string2 = IsValidFloat($money1);
    if (length $money1 > 0)
    {
      if (length $error_string > 0 && (not $error_string eq "."))
      {
        PrintErrorHeader();
        print "<h1>(Journal View Re-display Code) Error:  Invalid First Money Field!</h1>\n";
        print "<b>$error_string</b> is invalid!<br>$back_button";
        CleanUp();
      }
      elsif (length $error_string > 0 && $error_string eq "." && length $error_string2 > 0)
      {
        PrintErrorHeader();
        print "<h1>(Journal View Re-display Code) Error:  Invalid First Money Field!</h1>\n";
        print "<b>$error_string</b> is invalid!<br>$back_button";
        CleanUp();
      }
    }
    $redisplay_string .= "<input type=hidden name=\"dorc_search\" value=\"$money_search\">\n<input type=hidden name=\"money1\" value=\"$money1\">\n<input type=hidden name=\"money2\" value=\"" . $input{'money2'} . "\">\n";
    $money2 = $input{'money2'};
    $error_string = IsValidInteger($money2);
    $error_string2 = IsValidFloat($money2);
    if (length $money2 > 0)
    {
      if (length $error_string > 0 && (not $error_string eq "."))
      {
        PrintErrorHeader();
        print "<h1>(Journal View Re-display Code) Error:  Invalid Second Money Field!</h1>\n";
        print "<b>$error_string</b> is invalid!<br>$back_button";
        CleanUp();
      }
      elsif (length $error_string > 0 && $error_string eq "." && length $error_string2 > 0)
      {
        PrintErrorHeader();
        print "<h1>(Journal View Re-display Code) Error:  Invalid Second Money Field!</h1>\n";
        print "<b>$error_string</b> is invalid!<br>$back_button";
        CleanUp();
      }
    }
    $sort_by = $input{'sort_by2'};
    if (length $sort_by == 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  You must specify a SortBy Option!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    #print "\"$sort_by\"<br>";
    if (not ($sort_by eq "date" || $sort_by eq "ref_num" || $sort_by eq "payee_payer"))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid SortBy Option!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if ($sort_by eq "date")
    {
      $sort_by = "trans_date";
    }
    if (exists $input{'sort_journal'})
    {
      $sort_journal = 1;
      $redisplay_string .= "<input type=hidden name=\"sort_journal\" value=\"1\">\n";
    }
    else
    {
      $sort_journal = 0;
    }
    $sort_operator = $input{'sort_operator'};
    if (length $sort_operator == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a Search Operator!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (not ($sort_operator eq "AND" || $sort_operator eq "OR"))
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid Search Operator!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"sort_by2\" value=\"" . $input{'sort_by2'} . "\">\n<input type=hidden name=\"sort_operator\" value=\"$sort_operator\">\n";

    # make sure they entered something in at least one field, but not something in both the debit and credit fields.
    if ((length $input{'date_from_search'} == 0) && (length $input{'date_to_search'} == 0) && ($input{'journal2'} eq "select_journal") && (length $input{'ref_num2'} == 0) && (length $input{'check_num'} == 0) && (length $input{'deposit_num'} == 0) && ($input{'payee_payer2'} eq "select_payee_payer") && (length $input{'memo2'} == 0) && ($input{'account'} eq "select_account") && ($input{'sub_account'} eq "select_sub_acct") && ($input{'dorc'} eq "select_dorc") && ($input{'dorc_search'} eq "all") && (length $input{'money1'} == 0) && (length $input{'money2'} == 0))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: You must specify something for your search!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    # make sure that the date_to_search field is given only if the date_type is "Between".
    if ((length $input{'date_from_search'} > 0) && (length $input{'date_to_search'} > 0) && ((not $input{'date_type'} eq "betweeni") && (not $input{'date_type'} eq "betweene")))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  You must specify <b>Between</b> to use the second Date field!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    # make sure that both money fields are not both filled in if they are not doing a between search or no Dorc value selected.
    if ((length $input{'money1'} > 0) && (length $input{'money2'} > 0) && ((not $input{'dorc'} eq "select_dorc") && (not $input{'dorc_search'} eq "betweene") && (not $input{'dorc_search'} eq "betweeni")))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  You can not specify both money fields when not searching with between!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (($input{'dorc_search'} eq "betweene" || $input{'dorc_search'} eq "betweeni") && (length $input{'money1'} == 0 || length $input{'money2'} == 0))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  You must specify both money fields when searching with between!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (((not $input{'dorc'} eq "select_dorc") && (not $input{'dorc_search'} eq "all")) && ((length $input{'money1'} == 0) && (length $input{'money2'} == 0)))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  You must specify an amount to search for!</h1>\n";
      print "Error: 1007<br>$back_button";
      CleanUp();
    }
    # make sure that if they enter a Ref-Num that they don't select anything else.
    if ((length $input{'ref_num2'} > 0) && ((length $input{'date_from_search'} > 0) || (length $input{'date_to_search'} > 0) || (length $input{'check_num'} > 0) || (length $input{'deposit_num'} > 0) || (not $input{'payee_payer2'} eq "select_payee_payer") || (not $input{'journal2'} eq "select_journal") || (not $input{'account'} eq "select_account") || (not $input{'sub_account'} eq "select_sub_acct") || (not $input{'dorc'} eq "select_dorc") || (not $input{'dorc_search'} eq "all") || (length $input{'money1'} > 0) || (length $input{'money2'} > 0) || (length $input{'memo2'} > 0)))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  You can not specify anything else when specifying the Reference Number!</h1>\n";
      print "$back_button";
      CleanUp();
    }
  }
  elsif ($input{'journal_view_command'} eq "search2")
  {
    $mode = 5;
    # first make sure all the correct variables are being passed in.
    if (not exists $input{'ref_num2'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Reference Number field must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $ref_num = $input{'ref_num2'};
    $error_string = IsValidUInteger($ref_num);
    if (length $ref_num > 0 && length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Ref Number!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"journal_view_command\" value=\"search2\">\n<input type=hidden name=\"ref_num2\" value=\"$ref_num\">\n";
  }

  if ($mode == 1 || $mode == 4 || $mode == 5)
  {
    $num_entries_to_display = $input{'num_entries_to_display'};
    if (length $num_entries_to_display == 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: You must specify the number of Journal entries to display!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $error_string = IsValidInteger($num_entries_to_display);
    if (length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Value for Number of Entries to Display!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }

    # verify it is a valid value
    if (not exists $valid_entries_to_display{$num_entries_to_display})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Value for Number of Entries to Display!</h1>\n";
      print "<b>$num_entries_to_display</b> is not valid!<br>$back_button";
      CleanUp();
    }

    $start_index = $input{'start_index'};
    if (length $start_index == 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: You must specify the Starting Index to work from!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $error_string = IsValidInteger($start_index);
    if (length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Value for Start Index to display from!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    if ($start_index < 1)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  The Start Index can not be less than 1!</h1>\n";
      print "$sys_admin";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"num_entries_to_display\" value=\"$num_entries_to_display\">\n<input type=hidden name=\"start_index\" value=\"$start_index\">\n";
  }

  return $redisplay_string;  # return the string that will contain everything necessary to re-display the journal like how the person just left it.
}
