#!/usr/bin/perl
#$Id: register_update.cgi,v 1.1 2001/09/06 10:21:19 moreejt Exp $
#This package is released under the GPL.  You should have recieved the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.
# register_update.cgi  -  Created by Jason A. Pattie, 10/18/1999
# This script updates the journal entry(ies) that are affected by modifying the
# cleared/reconciled status flag.

use strict;

use Pg;  # PostgreSQL Database Module
use cgi_lib;  # CGI Library routines
use custom;  # our customizable features
use reports;

use vars '$date';
use vars '$count';
use vars '$count2';
use vars '$ref_num';
use vars '$num_rows';
use vars '$temp_ref_num';
use vars '$temp_trans_date';
use vars '$temp_counter';
use vars '$temp_cleared';
use vars '$temp';
use vars '$temp_dorc';
use vars '$temp_amount';
use vars '$temp_payee_payer';
use vars '$temp_check_deposit_number';
use vars '$debit_increases';
use vars '$cleared_beginning_balance';
use vars '$cleared_ending_balance';
use vars '$book_balance';
use vars '$sum_uncleared_debits';
use vars '$sum_uncleared_credits';
use vars '$sum_cleared_debits';
use vars '$sum_cleared_credits';
use vars '$beginning_date';
use vars '$ending_date';
use vars '$from_search_date';
use vars '$to_search_date';
use vars '@reconciled_array';
my $account_name;
my $account_num;
my $bank_account;
$bank_account = 0;

# get the values being passed in from the client
%input = ();  # make sure it is empty!
cgi_lib::ReadParse(*input);

# begin the HTML Output
print cgi_lib::PrintHeader();
print "<html>\n";

my $ledger_name;  # name of ledger to work with
my $ledger_db;
my $ledger_color;
my $result2;
my $error_string;
my $ledger_code;
my $report_obj;

use PortalWrapper; # The Portal Wrapper library.

my $portalObj;
$portalObj = PortalWrapper->new;
if ($portalObj->didErrorOccur)
{
  # begin the HTML Output
  print cgi_lib::PrintHeader();
  print "<html>\n";

  PrintErrorHeader();
  print $portalObj->errorMessage;
  CleanUp();
}
my $dbObj;
$dbObj = $portalObj->getDBInfo;
if (!defined $dbObj)
{
  if ($portalObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $portalObj->errorMessage;
    CleanUp();
  }
}
else
{
  if ($dbObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $dbObj->errorMessage;
    CleanUp();
  }
}
$db_host = $dbObj->dbHost;
$db_name = $dbObj->dbName;
$db_user = $dbObj->dbUser;
$db_passwd = $dbObj->dbPasswd;

my $database_connected;
$database_connected = 0;

$ledger_db = $input{'ledger_db'};
if (length $ledger_db == 0)
{
  PrintErrorHeader();
  print "<h1>Error: You must specify a ledger to work with!</h1>\n";
  print "$back_button";
  CleanUp();
}
$error_string = IsValidString($ledger_db);
if (length $error_string > 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Database Name!</h1>\n";
  print "<b>$error_string</b> is invalid!<br>$back_button";
  CleanUp();
}

if (not exists $input{'update_register_submit'})
{
  PrintErrorHeader();
  print "<h1>Error:  Access Denied!</h1>\n";
  print "Invalid options.<br>$sys_admin";
  CleanUp();
}

if (not exists $input{'num_rows'})
{
  PrintErrorHeader();
  print "<h1>Error: Access Denied!</h1>\n";
  print "Invalid options.  Form value (num rows) missing.<br>$sys_admin";
  CleanUp();
}
$error_string = IsValidUInteger($input{'num_rows'});
if (length $error_string > 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Num Rows Value!</h1>\n";
  print "<b>$error_string</b> is invalid!<br>$back_button";
  CleanUp();
}

if (not exists $input{'beginning_balance'})
{
  PrintErrorHeader();
  print "<h1>Error: Access Denied!</h1>\n";
  print "Invalid options.  Form value (beginning balance) missing.<br>$sys_admin";
  CleanUp();
}
$cleared_beginning_balance = $input{'beginning_balance'};
$error_string = IsValidFloat($cleared_beginning_balance);
if (length $error_string > 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Beginning Balance Value!</h1>\n";
  print "<b>$error_string</b> is invalid!<br>$back_button";
  CleanUp();
}

if (not exists $input{'debit_increases'})
{
  PrintErrorHeader();
  print "<h1>Error: Access Denied!</h1>\n";
  print "Invalid options.  Form value (debit increases) missing.<br>$sys_admin";
  CleanUp();
}
$debit_increases = $input{'debit_increases'};

if (not exists $input{'beginning_date'})
{
  PrintErrorHeader();
  print "<h1>Error: Access Denied!</h1>\n";
  print "Invalid options.  Form value (beginning date) missing.<br>$sys_admin";
  CleanUp();
}
$beginning_date = $input{'beginning_date'};

if (not IsValidDateSyntax($beginning_date))
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Beginning Date!</h1>\n";
  print "$back_button";
  CleanUp();
}

if (not exists $input{'ending_date'})
{
  PrintErrorHeader();
  print "<h1>Error: Access Denied!</h1>\n";
  print "Invalid options.  Form value (ending date) missing.<br>$sys_admin";
  CleanUp();
}
$ending_date = $input{'ending_date'};
if (not IsValidDateSyntax($ending_date))
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Ending Date!</h1>\n";
  print "$back_button";
  CleanUp();
}

if (not exists $input{'from_search_date'})
{
  PrintErrorHeader();
  print "<h1>Error: Access Denied!</h1>\n";
  print "Invalid options.  Form value (from search date) missing.<br>$sys_admin";
  CleanUp();
}
$from_search_date = $input{'from_search_date'};
if (not IsValidDateSyntax($from_search_date))
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid From Search Date!</h1>\n";
  print "$back_button";
  CleanUp();
}

if (not exists $input{'to_search_date'})
{
  PrintErrorHeader();
  print "<h1>Error: Access Denied!</h1>\n";
  print "Invalid options.  Form value (to search date) missing.<br>$sys_admin";
  CleanUp();
}
$to_search_date = $input{'to_search_date'};
if (not IsValidDateSyntax($to_search_date))
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid To Search Date!</h1>\n";
  print "$back_button";
  CleanUp();
}

$account_name = $input{'account_name'};
if (length $account_name == 0)
{
  PrintErrorHeader();
  print "<h1>Error:  You must specify the Account Name!</h1>\n";
  print "$back_button";
  CleanUp();
}
$error_string = IsValidString($account_name);
if (length $error_string > 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Account Name!</h1>\n";
  print "<b>$error_string</b> is invalid!<br>$back_button";
  CleanUp();
}

$account_num = $input{'account_num'};
if (length $account_num == 0)
{
  PrintErrorHeader();
  print "<h1>Error:  You must specify the Account Number!</h1>\n";
  print "$back_button";
  CleanUp();
}
$error_string = IsValidUInteger($account_num);
if (length $error_string > 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Invalid Account Number!</h1>\n";
  print "<b>$error_string</b> is invalid!<br>$back_button";
  CleanUp();
}

if (exists $input{'bank_account'})
{
  $bank_account = 1;
}

# check to see if we are running under mod_perl
if (exists $ENV{MOD_PERL})
{
  # check to see if the database is still connected
  if (defined $conn)
  {
    # check the status of the connection
    if ($conn->status != PGRES_CONNECTION_OK)
    {
      $database_connected = 0;
    }
    else
    {
      # connection still good!
      $database_connected = 1;
    }
  }
  else
  {
    $database_connected = 0;
  }
}

if (not $database_connected)
{
  # connect to the database.
  $conn = Pg::connectdb("host = $db_host dbname = $db_name user = $db_user password = $db_passwd");
  if ($conn->status == PGRES_CONNECTION_BAD)
  {
    PrintErrorHeader();
    print "<h1>Error:  Couldn't connect to the database!</h1><br>\n";
    print $conn->errorMessage . "<br>$sys_admin";
    CleanUp();
  }
}

# set the DateStyle for the Database.
$result = setDBDateStyle($conn);
if ($result->resultStatus != PGRES_COMMAND_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Setting Date Style failed!</h1>\n";
  print $conn->errorMessage . "<br>$sys_admin";
  CleanUp();
}

# now validate that the ledger they specified is valid
$result = $conn->exec("select name from entity_tb where database_name = '$ledger_db'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error: Accessing database failed!</h1>\n";
  print $conn->errorMessage . "<br>Trying to check entity table.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples == 0)
{
  PrintErrorHeader();
  print "<h1>Error: Ledger <font color=\"blue\">$ledger_db</font> does not exist!</h1>\n";
  print "$sys_admin";
  CleanUp();
}
else
{
  $ledger_name = $result->getvalue(0, 0);
}

# create the reports object
$report_obj = reports->new($conn, $ledger_db);
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}
$ledger_code = $report_obj->getLedgerCode();
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}
$ledger_color = $report_obj->getLedgerColor();
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}

# figure out the beginning and ending date of the current working year
my ($working_year, $from_date, $to_date);

$result = $conn->exec("select year, start_date, end_date from known_years_tb where year in (select working_year from variables_tb WHERE ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Accessing database failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get working year and fiscal year dates from ledger <font color=\"blue\">$ledger_db</font>.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples == 0)
{
  PrintErrorHeader();
  print "<h1>Error: Program not configured!</h1>\n";
  print "Working Year is not set!<br>$sys_admin";
  CleanUp();
}
$working_year = $result->getvalue(0, 0);
$from_date    = $result->getvalue(0, 1);
$to_date      = $result->getvalue(0, 2);

print "<head><title>$prog_name $prog_version Account Registers</title></head>\n";
print "<body bgcolor=$body_bgcolor>\n";
print <<"END_OF_STYLE";
<style type="text/css"><!--
  a:hover   { color: red }
  a:link    { text-decoration: none; color: blue }
  a:visited { text-decoration: none; color: blue }
  a:active  { text-decoration: none; color: blue }-->
</style>
<script language="Javascript1.2" src="../js/common.js"></script>
END_OF_STYLE
# get the date
$date = `/bin/date +%m-%d-%Y`;
chomp $date;

print "<center>\n";
print "<table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
print "<tr>\n";
print "<td align=left width=47%><font color=\"red\">Updating Register <font color=blue>" . $input{'account_name'} . "</font> in Ledger <font color=\"$ledger_color\">$ledger_name</font>. &nbsp;FY is <font color=\"black\">$working_year</font>.</font></td>\n";
print "<td align=left><a href=\"$site_dir/help.html#register\" target=\"docs\"><img border=0 src=\"$site_dir/images/help.jpg\" alt=\"Help\"></a></td>\n";
print "<td align=right>$date</td></tr></table>\n<hr><br>\n";
print PrintStandardLedgerMainMenu($ledger_db);

# update the row data entries with the changes made to the cleared fields on the previous form
$count2 = 0;
for ($count=0; $count < $input{'num_rows'}; $count++)
{
  $temp = "row_ref_num_" . $count;
  if (exists $input{$temp})
  {
    $temp_ref_num = $input{$temp};
    $temp = "counter_" . $count;
    if (exists $input{$temp})
    {
      $temp_counter = $input{$temp};
      $temp = "cleared_" . $count;
      if (exists $input{$temp})
      {
        $temp_cleared = $input{$temp};
        if ($temp_cleared ne " " && $temp_cleared ne "x" && $temp_cleared ne "r")
        {
          $temp_cleared = " ";
          print "<font color=green>Cleared value not valid! Changing to \" \" for ref_num=" . $temp_ref_num . ".</font><br>";
        }
        # if cleared (x), keep track of ref_num and counter to update to reconciled (r)
        if ($temp_cleared eq "x")
        {
          $reconciled_array[$count2] = [ ($temp_ref_num, $temp_counter) ];
          $count2++;
        }
        $result = $conn->exec("update debitcredit_tb set cleared = '$temp_cleared' where parent_num = $temp_ref_num and counter = $temp_counter AND ledger_code = '$ledger_code'");
        if ($result->resultStatus != PGRES_COMMAND_OK)
        {
          print "<font color=red>Error: Failed to update record (<font color=blue>ref_num=$temp_ref_num, counter=$temp_counter</font>)!</font><br>\n";
          print $conn->errorMessage . "<br>\n";
        }
      }
    }
  }
}

$sum_cleared_debits = 0;
$sum_cleared_credits = 0;
print "<b>Cleared Entries Summary</b>\n";
print "<table border=1 cellspacing=0 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
print "<tr>\n";
print "<td align=right>Beginning Date:</td><td align=center>$beginning_date</td>\n";
# display the beginning balance, the sum of debits, the sum of credits, and the ending balance based on the cleared entries
for ($count=0; $count < $input{'num_rows'}; $count++)
{
  $temp = "row_ref_num_" . $count;
  if (exists $input{$temp})
  {
    $temp_ref_num = $input{$temp};
    $temp = "cleared_" . $count;
    if (exists $input{$temp})
    {
      $temp_cleared = $input{$temp};
      if ($temp_cleared eq "x" || $temp_cleared eq "r")
      {
        # keep running sum of values
        $temp = "amount_" . $count;
        if (exists $input{$temp})
        {
          $temp_amount = $input{$temp};
          $temp = "dorc_" . $count;
          if (exists $input{$temp})
          {
            $temp_dorc = $input{$temp};
            if ($temp_dorc eq "t")
            {
              $sum_cleared_debits += $temp_amount;
            }
            elsif ($temp_dorc ne "t")
            {
              $sum_cleared_credits += $temp_amount;
            }
          }
        }
        else
        {
          print "<tr><td colspan=2><font color=red>No value was found for a specified entry!</font> Ref_num = $temp_ref_num.</td></tr>\n";
        }
      }
    }
  }
}
print "<td align=right>Beginning Balance:</td>";
print "<td align=right>";
if ($cleared_beginning_balance < 0)
{
  print "<font color=red>(";
}
print commify(sprintf("%.2f", abs($cleared_beginning_balance)));
if ($cleared_beginning_balance < 0)
{
  print ")</font>";
}
print "</td>\n";
print "</tr>\n";
print "<tr>\n";
print "<td rowspan=2 colspan=2><br></td>\n";
print "<td align=right>Sum Debits:</td>";
print "<td align=right>";
if ($sum_cleared_debits < 0)
{
  print "<font color=red>(";
}
print commify(sprintf("%.2f", abs($sum_cleared_debits)));
if ($sum_cleared_debits < 0)
{
  print ")</font>";
}
print "</td>\n";
print "</tr>\n";
print "<tr>\n";
print "<td align=right>Sum Credits:</td>";
print "<td align=right>";
if ($sum_cleared_credits < 0)
{
  print "<font color=red>(";
}
print commify(sprintf("%.2f", abs($sum_cleared_credits)));
if ($sum_cleared_credits < 0)
{
  print ")</font>";
}
print "</td>\n";
print "</tr>\n";
if ($debit_increases eq "t")
{
  $cleared_ending_balance = $cleared_beginning_balance + ($sum_cleared_debits - $sum_cleared_credits);
}
else
{
  $cleared_ending_balance = $cleared_beginning_balance + ($sum_cleared_credits - $sum_cleared_debits);
}
print "<tr>\n";
print "<td align=right>Ending Date:</td><td align=center>$ending_date</td>\n";
print "<td align=right>Ending Statement Balance:</td>";
print "<td align=right>";
if ($cleared_ending_balance < 0)
{
  print "<font color=red>(";
}
print commify(sprintf("%.2f", abs($cleared_ending_balance)));
if ($cleared_ending_balance < 0)
{
  print ")</font>";
}
print "</td>\n";
print "</tr>\n";
print "</table>\n";

# add finished button to change all x's into r's
print "<form method=post name=\"finish_reconciliation_form\" action=\"$site_dir/cgi-bin/register_reconcile.cgi\">\n";
print "<input type=hidden name=\"ledger_db\" value=\"$ledger_db\">\n";
print "<input type=hidden name=\"from_search_date\" value=\"$from_search_date\">\n";
print "<input type=hidden name=\"to_search_date\" value=\"$to_search_date\">\n";
print "<input type=hidden name=\"account_name\" value=\"$account_name\">\n";
print "<input type=hidden name=\"account_num\" value=\"$account_num\">\n";
if (exists $input{'display_outstanding'})
{
  print "<input type=hidden name=\"display_outstanding\" value=\"\">\n";
}
print "<input type=hidden name=\"reconciled_count\" value=\"" . (scalar @reconciled_array) . "\">\n";
for ($count=0; $count < scalar @reconciled_array; $count++)
{
  print "<input type=hidden name=\"reconcile_ref_num_$count\" value=\"" . $reconciled_array[$count][0] . "\">\n";
  print "<input type=hidden name=\"reconcile_count_$count\" value=\"" . $reconciled_array[$count][1] . "\">\n";
}
print "<center><input type=submit name=\"finish_reconcile_submit\" value=\"Finish Reconciliation\"></center>\n";
print "</form>\n";

# print view checkbox

print "<br><br>\n";

$sum_uncleared_debits = 0;
$sum_uncleared_credits = 0;
print "<b>Reconciliation Summary</b><br>\n";
print "<table border=1 cellspacing=0 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
print "<tr>\n";
print "<td colspan=";
if ($bank_account == 1)
{
  print "4";
}
else
{
  print "3";
}
print " align=right>Statement Balance</td>\n";
if ($debit_increases eq "t")
{
  if ($cleared_ending_balance < 0)
  {
    print "<td>&nbsp;</td>\n";
    print "<td align=right>" . commify(sprintf("%.2f", abs($cleared_ending_balance))) . "</td>\n";
  }
  else
  {
    print "<td align=right>" . commify(sprintf("%.2f", abs($cleared_ending_balance))) . "</td>\n";
    print "<td>&nbsp;</td>\n";
  }
}
else
{
  if ($cleared_ending_balance < 0)
  {
    print "<td align=right>" . commify(sprintf("%.2f", abs($cleared_ending_balance))) . "</td>\n";
    print "<td>&nbsp;</td>\n";
  }
  else
  {
    print "<td>&nbsp;</td>\n";
    print "<td align=right>" . commify(sprintf("%.2f", abs($cleared_ending_balance))) . "</td>\n";
  }
}
print "</tr>\n";
print "<tr>\n";
print "<th>Ref #</th><th>Date</th><th>Payee-Payer</th>";
if ($bank_account == 1)
{
  print "<th><br></th>";
}
print "<th>Debit</th><th>Credit</th>\n";
print "</tr>\n";
# display all uncleared entries
for ($count=0; $count < $input{'num_rows'}; $count++)
{
  $temp = "row_ref_num_" . $count;
  if (exists $input{$temp})
  {
    $temp_ref_num = $input{$temp};
    $temp = "cleared_" . $count;
    if (exists $input{$temp})
    {
      $temp_cleared = $input{$temp};
      if ($temp_cleared ne " " && $temp_cleared ne "x" && $temp_cleared ne "r")
      {
        $temp_cleared = " ";
      }
      if ($temp_cleared eq " ")
      {
        # display data and keep running sum of values
        $temp = "amount_" . $count;
        if (exists $input{$temp})
        {
          $temp_amount = $input{$temp};
          $temp = "dorc_" . $count;
          if (exists $input{$temp})
          {
            $temp_dorc = $input{$temp};
            if ($temp_dorc eq "t")
            {
              $sum_uncleared_debits += $temp_amount;
            }
            elsif ($temp_dorc ne "t")
            {
              $sum_uncleared_credits += $temp_amount;
            }
            print "<tr align=center>\n";
            print "<td>$temp_ref_num</td>\n";
            $temp = "trans_date_" . $count;
            $temp_trans_date = $input{$temp};
            print "<td>$temp_trans_date</td>\n";
            $temp = "payee_payer_" . $count;
            $temp_payee_payer = $input{$temp};
            if ($temp_payee_payer eq "")
            {
              $temp_payee_payer = "<br>";
            }
            print "<td>$temp_payee_payer</td>\n";
            if ($bank_account == 1)
            {
              $temp = "check_deposit_" . $count;
              $temp_check_deposit_number = $input{$temp};
              if ($temp_check_deposit_number eq "")
              {
                $temp_check_deposit_number = "<br>";
              }
              print "<td>$temp_check_deposit_number</td>\n";
            }
            if ($temp_dorc eq "t")
            {
              print "<td align=right>";
              if ($temp_amount < 0)
              {
                print "<font color=red>(";
              }
              print commify(sprintf("%.2f", abs($temp_amount)));
              if ($temp_amount < 0)
              {
                print ")</font>";
              }
              print "</td>\n";
              print "<td><br></td>\n";
            }
            else
            {
              print "<td><br></td>\n";
              print "<td align=right>";
              if ($temp_amount < 0)
              {
                print "<font color=red>(";
              }
              print commify(sprintf("%.2f", abs($temp_amount)));
              if ($temp_amount < 0)
              {
                print ")</font>";
              }
              print "</td>\n";
            }
            print "</tr>\n";
          }
        }
        else
        {
          print "<tr><td colspan=6><font color=red>No value was found for a specified entry!</font> Ref_num = $temp_ref_num.</td></tr>\n";
        }
      }
    }
  }
}
print "<tr>\n";
print "<td colspan=";
if ($bank_account == 1)
{
  print "4";
}
else
{
  print "3";
}
print " align=right><b>Uncleared Debits</b></td>";
print "<td align=right>";
if ($sum_uncleared_debits < 0)
{
  print "<font color=red>(";
}
print commify(sprintf("%.2f", abs($sum_uncleared_debits)));
if ($sum_uncleared_debits < 0)
{
  print ")</font>";
}
print "</td><td><br></td>\n";
print "</tr>\n";
print "<tr>\n";
print "<td colspan=";
if ($bank_account == 1)
{
  print "5";
}
else
{
  print "4";
}
print " align=right><b>Uncleared Credits</b></td>";
print "<td align=right>";
if ($sum_uncleared_credits < 0)
{
  print "<font color=red>(";
}
print commify(sprintf("%.2f", abs($sum_uncleared_credits)));
if ($sum_uncleared_credits < 0)
{
  print ")</font>";
}
print "</td>\n";
print "</tr>\n";
print "<tr>\n";
print "<td align=right colspan=";
if ($bank_account == 1)
{
  print "4";
}
else
{
  print "3";
}
print "><b>Book Balance</b></td>";
print "<td align=right colspan=2 bgcolor=lightblue>";
if ($debit_increases eq "t")
{
  if ($cleared_ending_balance < 0)
  {
    $book_balance = $sum_uncleared_debits - $sum_uncleared_credits - $cleared_ending_balance;
  }
  else
  {
    $book_balance = $sum_uncleared_debits - $sum_uncleared_credits + $cleared_ending_balance;
  }
}
else
{
  if ($cleared_ending_balance < 0)
  {
    $book_balance = $sum_uncleared_debits - $sum_uncleared_credits + $cleared_ending_balance;
  }
  else
  {
    $book_balance = $sum_uncleared_debits - $sum_uncleared_credits - $cleared_ending_balance;
  }
}
if ($book_balance < 0)
{
  print "<font color=red>(";
}
print commify(sprintf("%.2f", abs($book_balance)));
if ($book_balance < 0)
{
  print ")</font>";
}
print "</td>\n";
print "</tr>\n";
print "</table>\n";

# print a horizontal rule to break the menu from the behind the scenes links
print "<br><hr>\n";
print "</center>\n";

print "<form method=post action=\"\" name=\"register_redo_form\">\n";
print "<input type=hidden name=\"ledger_db\" value=\"$ledger_db\">\n";
print "<input type=hidden name=\"account_select\" value=\"$account_name|$account_num\">\n";
print "<input type=hidden name=\"account_value\" value=\"$account_name|$account_num\">\n";
print "<input type=hidden name=\"from_search_date\" value=\"$from_search_date\">\n";
print "<input type=hidden name=\"to_search_date\" value=\"$to_search_date\">\n";
if (exists $input{'display_outstanding'})
{
  print "<input type=hidden name=\"display_outstanding\" value=\"\">\n";
}
print "<input type=submit name=\"register_select_submit\" value=\"Re-Edit this Register\" onClick=\"submit_my_form(document.register_redo_form, '$site_dir/cgi-bin/register_display.cgi')\">\n";
print "</form>\n";

print "</body>\n";
print "</html>\n";
exit 0;