#$Id: reports_balance_sheet.pm,v 1.1 2001/09/06 10:21:20 moreejt Exp $
#This package is released under the GNU General Public License.
#You should have recieved a copy of the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.
sub reports3BalanceSheetJavaScriptValidation
{
  print <<"END_OF_SCRIPT";
  function reports3BalanceSheetJavaScriptValidation(doc)
  {
    var msg = "";
    var tmp = "";

    // verify that they have specified at least one complete date range
    var date1_start, date1_end, date2_start, date2_end, date3_start, date3_end, date4_start, date4_end;
    date1_start = doc.date1.value;
    date2_start = doc.date2.value;
    date3_start = doc.date3.value;
    date4_start = doc.date4.value;

    if (date1_start.length == 0 && date2_start.length == 0 && date3_start.length == 0 && date4_start.length == 0)
    {
      msg += "You must specify some dates to work with!\\n";
    }
    else  // something is filled in, now verify that it is valid
    {
      if (date1_start.length > 0)
      {
        tmp = IsValidDateSyntax(date1_start);
        if (tmp.length > 0)
        {
          msg += "Date 1: " + tmp + "\\n";
        }
      }
      if (date2_start.length > 0) // check and make sure the dates are valid.
      {
        tmp = IsValidDateSyntax(date2_start);
        if (tmp.length > 0)
        {
          msg += "Date 2: " + tmp + "\\n";
        }
      }
      if (date3_start.length > 0) // check and make sure the dates are valid.
      {
        tmp = IsValidDateSyntax(date3_start);
        if (tmp.length > 0)
        {
          msg += "Date 3: " + tmp + "\\n";
        }
      }
      if (date4_start.length > 0) // check and make sure the dates are valid.
      {
        tmp = IsValidDateSyntax(date4_start);
        if (tmp.length > 0)
        {
          msg += "Date 4: " + tmp + "\\n";
        }
      }
    }

    return msg;
  }
END_OF_SCRIPT
}

sub reports3BalanceSheetCustomizedFormItems
{
  print <<"END_OF_FORM";
  <tr><td align=center><font color=\"$menu_fgcolor\">Date 1:&nbsp;</font><input type=text name=\"date1\" value=\"$date\" size=10 maxlength=10>&nbsp;<input type=button name=\"clear_1\" value=\"Clear\" onClick=\"document.customize_form.date1.value='';\"></td></tr>
  <tr><td align=center><font color=\"$menu_fgcolor\">Date 2:&nbsp;</font><input type=text name=\"date2\" size=10 maxlength=10>&nbsp;<input type=button name=\"clear_2\" value=\"Clear\" onClick=\"document.customize_form.date2.value='';\"></td></tr>
  <tr><td align=center><font color=\"$menu_fgcolor\">Date 3:&nbsp;</font><input type=text name=\"date3\" size=10 maxlength=10>&nbsp;<input type=button name=\"clear_3\" value=\"Clear\" onClick=\"document.customize_form.date3.value='';\"></td></tr>
  <tr><td align=center><font color=\"$menu_fgcolor\">Date 4:&nbsp;</font><input type=text name=\"date4\" size=10 maxlength=10>&nbsp;<input type=button name=\"clear_4\" value=\"Clear\" onClick=\"document.customize_form.date4.value='';\"></td></tr>
  <tr><td align=center><font color=\"$menu_fgcolor\">Where to start Activity Detail at: </font><select name=\"activity_start_point\">
END_OF_FORM
  # now we display all the possible month values based upon the number of years in the known years table that are < than the current fiscal year.
  $known_years = $conn->exec("SELECT working_year FROM variables_tb WHERE ledger_code = '$ledger_code'");
  if ($known_years->resultStatus != PGRES_TUPLES_OK)
  {
    print "</select></td></tr></table></form>\n";
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get the Current Working year from the database.<br>$sys_admin";
    CleanUp();
  }
  if ($known_years->ntuples == 0)
  {
    print "</select></td></tr></table></form>\n";
    print "<h1>Error:  Program not configured!</h1>\n";
    print "There is no current Fiscal Year set in the Ledger!<br>$sys_admin";
    CleanUp();
  }
  my $current_year = $known_years->getvalue(0, 0);

  $known_years = $conn->exec("SELECT year FROM known_years_tb WHERE year < $current_year AND ledger_code = '$ledger_code'");
  if ($known_years->resultStatus != PGRES_TUPLES_OK)
  {
    print "</select></td></tr></table></form>\n";
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get list of years from Known Years Table that are < than the Current Fiscal Year of '$current_year'.<br>$sys_admin";
    CleanUp();
  }

  my ($i, $j, $counter);
  $counter = $known_years->ntuples;
  if ($counter == 0)
  {
    $counter = 1;  # at least do 1 year's dates away even though they won't probably exist.
  }

  for ($i=0; $i < $counter; $i++)
  {
    for ($j=1; $j <= 12;)
    {
      if ($i > 0) # we are past 12 months out
      {
        print "    <option value=\"" . (($i * 12) + $j) . "\">";
        if ($j < 12)
        {
          print "$i year";
          if ($i > 1)
          {
            print "s";
          }
          print " $j month";
          if ($j > 1)
          {
            print "s";
          }
        }
        else
        {
          print int ($i + 1) . " years";
        }
        print " back\n";

      }
      else
      {
        print "    <option value=\"$j\">";
        if ($j < 12)
        {
          print "$j month";
          if ($j > 1)
          {
            print "s";
          }
        }
        else
        {
          print "1 year";
        }
        print " back\n";
      }
      $j += 5;
      $j = 12 if ($j == 11);
    } # end of months loop
  } # end of known_years loop
  print "    </select></td></tr>\n";
}

sub reports4BalanceSheetWork
{
  my ($counter, $curr_year, @fiscal_years);
  $curr_year = $report_obj->GetCurrentWorkingYear();
  if ($report_obj->didErrorOccur)
  {
    PrintErrorHeader();
    print "<h1>Error:  Getting Current Fiscal Year failed!</h1>\n";
    print $report_obj->getErrorMessage;
    CleanUp();
  }
  @fiscal_years = $report_obj->GetFiscalYearsBefore($curr_year);
  if ($report_obj->didErrorOccur)
  {
    PrintErrorHeader();
    print "<h1>Error:  Getting the Fiscal Years before Fiscal Year '$curr_year' failed!</h1>\n";
    print $report_obj->getErrorMessage;
    CleanUp();
  }

  $counter = int (scalar @fiscal_years);
  $counter = 1 if ($counter == 0);
  if ($activity_start_point > ($counter * 12))
  {
    PrintErrorHeader();
    print "<h1>Error:  The Activity Start Point is out of range!</h1>\n";
    print "<b>$activity_start_point</b> is too big.<br>$sys_admin";
    CleanUp();
  }

  # for each date in the Dates array, create the corresponding Start_Dates entry that is $activity_start_point months back in time.
  for ($counter=0; $counter < scalar @Dates; $counter++)
  {
    my $temp = $Dates[$counter];
    $temp =~ s/-/\//g;  # globally replace all -'s with /'s.
    $temp = `/bin/date --date \"$temp $activity_start_point months ago\" +%m/%d/%Y`;
    chomp $temp;

    $temp =~ s/\//-/g;  # globally replace all /'s with -'s.

    $Start_Dates[$counter] = $temp;
  }
}

sub reports4BalanceSheetDisplayForm
{
  # create the header string to be displayed in the printable version of the report.
  my $header_string = "<center><table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor='$body_bgcolor'><tr><td width=35%>Ledger <font color='$ledger_color'>$ledger_name</font>";
  $header_string .= "</td><td align=center width=30%><h3>$custom_title</h3></td><td align=right>$date</td></tr>";
  if (length $date_range_string > 0)
  {
    $header_string .= "<tr><td width=35%><br></td><td align=center width=30%>$date_range_string</td><td><br></td></tr>";
  }
  $header_string .= "</table><br>";
  if (not $print_report)
  {
    print "<script language=Javascript1.2>\n";
    print "  var body_bgcolor=\"$body_bgcolor\";\n";
    print "</script>\n";

    # display the Print Button
    my $time = `/bin/date +%s`;
    chomp $time;

    print "<form name=\"Dummy_form\" method=post action=\"\" target=\"balance_sheet_other_view\">\n";  # removed _$time and added balance_sheet_ to the beginning.
    print "<div align=right><input type=button name=\"Print\" value=\"Print View\" onClick=\"printReport();\"></div>\n";
    print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
    print "<input type=hidden name=\"report_group\" value=\"$report_group\">\n";
    print "<input type=hidden name=\"run\" value=\"\">\n";
    print "<input type=hidden name=\"report\" value=\"$report\">\n";
    print "<input type=hidden name=\"custom_report_name\" value=\"$custom_title\">\n";
    print "<input type=hidden name=\"show_zero_balances\" value=\"" . ($show_zero_balances ? "YES" : "NO") . "\">\n";
    print "<input type=hidden name=\"show_accounts_as\" value=\"" . ($show_accounts_as ? "name-number" : "number-name") . "\">\n";
    print "<input type=hidden name=\"data_precision\" value=\"$data_precision\">\n";
    print "<input type=hidden name=\"font_size_text\" value=\"$font_size_text\">\n";
    print "<input type=hidden name=\"font_size_data\" value=\"$font_size_data\">\n";
    my $z;
    for ($z=1; $z <= $max_columns; $z++)
    {
      my $temp = "date$z";
      print "<input type=hidden name=\"$temp\" value=\"" . ($Dates[$z-1]) . "\">\n";
    }
    print "<input type=hidden name=\"activity_start_point\" value=\"$activity_start_point\">\n";
    print "<input type=hidden name=\"show_by_sub_entities\" value=\"" . ($show_by_sub_entities ? "YES" : "NO") . "\">\n";
    print "<input type=hidden name=\"show_non_tax_section\" value=\"" . ($show_non_tax_section ? "YES" : "NO") . "\">\n";
    print "<input type=hidden name=\"report_name\" value=\"$report_name\">\n";
    print "<input type=hidden name=\"print_report\" value=\"\">\n";
    print "<input type=hidden name=\"acct_type_num\" value=\"\">\n";
    print "<input type=hidden name=\"acct_num\" value=\"\">\n";
    print "<input type=hidden name=\"acct_name\" value=\"\">\n";
    print "<input type=hidden name=\"debit_increases\" value=\"\">\n";
    print "<input type=hidden name=\"sub_acct_name\" value=\"\">\n";
    print "<input type=hidden name=\"sub_entity_code\" value=\"\">\n";
    print "<input type=hidden name=\"sub_entity_name\" value=\"\">\n";
    print "<input type=hidden name=\"start_date\" value=\"\">\n";
    print "<input type=hidden name=\"end_date\" value=\"\">\n";
    print "<input type=hidden name=\"sub_acct_num\" value=\"-2\">\n";
    print "<input type=hidden name=\"header_string\" value=\"$header_string\">\n";
    print "<input type=hidden name=\"lists_opened\" value=\"\">\n";
    print "</form>\n";

    #print "There are '$num_list_entries' entries to be displayed at a list height of '$list_height'.<br>\n";

    #print "<table border=0 height=" . (($num_list_entries + 1) * $list_height) . "><tr><td></td></tr></table>\n";
  }
  else
  {
    my $lists_opened = $input{'lists_opened'};
    # setup the initial table to display in.
    print "<table border=0 cellpadding=2 cellspacing=0 width=100% bgcolor=#ffffff>\n";
    $text_width = 30; # resize the proportions of the text to the data.
    $data_width = 70;

    # see if we need to display the In X's line
    if ($data_precision != 1)
    {
      my $temp_str = "<tr><td colspan=" . ($max_columns + 1) . "><table border=0 width=100% cellpadding=2 cellspacing=0><tr><td width=100% align=right><font face='$font_str' size=$font_size_text>(<i>In " . $$precision_table{$data_precision} . "</i>)</font></td></tr></table></td></tr>";
      print "$temp_str\n";
    }

    my (@MyDates, $z, @SubEntity);
    for ($z=0; $z < $num_columns; $z++)
    {
      my @Entry = ();
      $Entry[0] = $Start_Dates[$z];
      $Entry[1] = $Dates[$z];
      $MyDates[$z] = [ @Entry ];
    }
    $SubEntity[0] = -2;
    $SubEntity[1] = '';
    print "<tr><td><table border=0 width=100% cellpadding=2 cellspacing=0><tr><td width=$text_width% align=left><br></td>";
    for ($z=0; $z < $max_columns; $z++) # removed the = from <= as the loop would do 1 too many.
    {
      my $width = ($data_width / $max_columns);
      print "<td width=$width% align=right><font face='$font_str' size=$font_size_text>";
      if ($z < $num_columns && $num_columns > 1)
      {
        my $temp = $MyDates[$z][0];
        $temp =~ s/-/\//g;
        print "<code>$temp&nbsp;<br>-&nbsp;";
        $temp = $MyDates[$z][1];
        $temp =~ s/-/\//g;
        print "$temp&nbsp;</code>";
      }
      elsif ($num_columns == 1 && $z == $max_columns-2)
      {
        my $temp = $MyDates[0][0];
        $temp =~ s/-/\//g;
        print "<code>$temp&nbsp;<br>-&nbsp;";
        $temp = $MyDates[0][1];
        $temp =~ s/-/\//g;
        print "$temp&nbsp;</code>";
      }
      else
      {
        print "&nbsp;";
      }
      print "</font></td>";
    }
    print "</tr></table></td></tr>\n";
    # see if we need to do a SubEntity display or just display everything.
    if ($show_by_sub_entities)
    {
      my @NetIncomes = ("0.00", "0.00", "0.00", "0.00");  # Assuming only 4 columns max.
      my @SubEntities = $report_obj->GetSubEntities();
      if ($report_obj->didErrorOccur)
      {
        print $report_obj->getErrorMessage;
        CleanUp();
      }
      for ($z=0; $z < scalar @SubEntities; $z++)
      {
        @SubEntity = @{$SubEntities[$z]};
        my @netIncomes = doIncomeStatement(\@SubEntity, \@Dates, $num_columns, 1, 1, 0); # show tax, printable view, no Income Tax Expense
        my $zz;
        for ($zz=0; $zz < $max_columns; $zz++)
        {
          $NetIncomes[$zz] += $netIncomes[$zz];
        }

        if ($show_non_tax_section)
        {
          @netIncomes = doIncomeStatement(\@SubEntity, \@Dates, $num_columns, 0, 1, 0); # don't show tax, printable view, no Income Tax Expense
          for ($zz=0; $zz < $max_columns; $zz++)
          {
            $NetIncomes[$zz] += $netIncomes[$zz];
          }
        }

        print "<tr><td><table border=0 width=100% cellpadding=2 cellspacing=0><tr><td><font face='$font_str' size=$font_size_text><hr></font></td></tr></table></td></tr>\n";  # print the horizontal dividing line
      }
      # Display the total Net Income calculated
      my $temp_str = "<tr><td><table border=0 width=100% cellpadding=2 cellspacing=0><tr><td width=$text_width% align=left><font face='$font_str' size=$font_size_text><b>Total Net Income</b></font></td>";
      for ($z=0; $z < $max_columns; $z++)
      {
        my $width = ($data_width / $max_columns);
        $temp_str .= "<td width=$width% align=right><font face='$font_str' size=$font_size_data>";
        if ($z < $num_columns)
        {
          my $temp_value = $NetIncomes[$z];
          if ($data_precision == 1)
          {
            $temp_value = sprintf "%.2f", $temp_value;
          }
          else
          {
            $temp_value = sprintf "%.0f", $temp_value;
          }
          if ($temp_value < 0)
          {
            $temp_value *= -1;
            if ($data_precision == 1)
            {
              $temp_value = sprintf "%.2f", $temp_value;
            }
            else
            {
              $temp_value = sprintf "%.0f", $temp_value;
            }
          }
          if ($NetIncomes[$z] < 0)
          {
            $temp_str .= "<font color=red>(";
          }
          $temp_str .= "<b>" . (commify($temp_value)) . "</b>";
          if ($NetIncomes[$z] < 0)
          {
            $temp_str .= ")</font>&nbsp;&nbsp;";
          }
          else
          {
            $temp_str .= "&nbsp;&nbsp;&nbsp;&nbsp;";
          }
        }
        else
        {
          $temp_str .= "<br>";
        }
        $temp_str .= "</font></td>";
      }
      $temp_str .= "</tr></table></td></tr>\n";
      print "$temp_str";
    }
    else
    {
      doBalanceSheetStatement(\@SubEntity, \@MyDates, $num_columns, $lists_opened, 1);  # printable view
    }

    print "</table>\n";
  }
}

sub reports4BalanceSheetJavaScript
{
  if (not $print_report)  # we are displaying a detailed view
  {
    # generate the Javascript code to display the detailed view lists, etc.
    print "<script language=\"JavaScript1.2\" SRC=\"../js/resize.js\"></script>\n";
    print "<script language=\"JavaScript1.2\" SRC=\"../js/list.js\"></script>\n";
    print "<script language=JavaScript1.2>\n";
    print "// Other Global Variables\n";
    print "var Ledger = \"$ledger_db\";\n";
    print "var Site_Dir = \"$site_dir\";\n";
    print "var NumColumns = $num_columns;\n\n";
    print "  function InitializeArray()\n";
    print "  {\n";
    print "    // Call init() to start the Dynamic Lists\n";
    print "    init();\n";
    print "  }\n\n";

    print << "JAVA_CODE";
  function display_entries(Acct_Type_num, Acct_Num, Acct_Name, Debit_Increases, Start_Date, End_Date, Sub_Acct_Num, Sub_Acct_Name, SubEntity_Code, SubEntity_Name)
  {
    // set the action of Dummy_form to point to report_detailed_view.cgi and submit the form
    document.Dummy_form.action = Site_Dir + "/cgi-bin/report_detailed_view.cgi";
    document.Dummy_form.acct_type_num.value = Acct_Type_num;
    document.Dummy_form.acct_num.value = Acct_Num;
    document.Dummy_form.acct_name.value = Acct_Name;
    document.Dummy_form.debit_increases.value = Debit_Increases;
    document.Dummy_form.sub_acct_name.value = Sub_Acct_Name;
    document.Dummy_form.sub_entity_code.value = SubEntity_Code;
    document.Dummy_form.sub_entity_name.value = SubEntity_Name;
    document.Dummy_form.start_date.value = Start_Date;
    document.Dummy_form.end_date.value = End_Date;
    document.Dummy_form.sub_acct_num.value = Sub_Acct_Num;
    document.Dummy_form.submit();

    return false;
  }

  function OpenedLists(list)
  {
    var value = "";  // The return value that indicates all opened lists encountered.

    for (var i=0; i < list.types.length; i++)
    {
      if (list.types[i] == "list" && list.lists[i].visible)
      {
        if (value.length > 0)
        {
          value += ",";
        }
        value += list.indexes[i];
        var temp = OpenedLists(list.lists[i]);
        if (temp.length > 0)
        {
          value += "," + temp;
        }
      }
    }

    return value;
  }

  function printReport()
  {
    // First we need to walk through the list and determine which sub-lists are open and mark them as being needed to be displayed on the print view.
    var lists_opened = document.Dummy_form.lists_opened; // point to the hidden variable we will use.
    lists_opened.value = ""; // clear it as it may have already been set and then re-run without the page being re-loaded.

    lists_opened.value = OpenedLists(mylist);
    //alert("The Lists currently open are: "+lists_opened.value);
    // set the action of Dummy_form to point to reports4.cgi and submit the form
    document.Dummy_form.action = Site_Dir + "/cgi-bin/reports4.cgi";
    document.Dummy_form.submit();

    return false;
  }

  function init()
  {
    if (parseInt(navigator.appVersion) < 4)
    {
      alert("Sorry, a 4.0+ browser is required to view this report.");
      return;
    }

    var width, height = 30;
    //if (isNav4) width = 3 * window.innerWidth / 4;
    //else width = 3 * document.body.clientWidth / 4;
    width = 800;

    //alert ("Window.innerWidth = " + window.innerWidth + ", width = " + width);

    var bgColor = "$body_bgcolor";
    mylist = new List(true, width, height, bgColor);

JAVA_CODE
    # See if we need to create the entry that says what the data precision is if not == 1
    if ($data_precision > 1)
    {
      my $temp_str = "<table border=0 width=100% cellpadding=2 cellspacing=0><tr><td width=100% align=right><font face='$font_str'>(<i>In " . $$precision_table{$data_precision} . "</i>)</font></td></tr></table>";
      print "    mylist.addItem(\"$temp_str\", -1);\n";
    }

    # at this point call the doBalanceSheet function with the correct parameters to display the report.
    my (@MyDates, $z, @SubEntity);
    for ($z=0; $z < $num_columns; $z++)
    {
      my @Entry = ();
      $Entry[0] = $Start_Dates[$z];
      $Entry[1] = $Dates[$z];
      $MyDates[$z] = [ @Entry ];
    }
    $SubEntity[0] = -2;
    $SubEntity[1] = '';
    my $temp_str = "<table border=0 width=100% cellpadding=2 cellspacing=0><tr><td width=$text_width% align=left><br></td>";
    for ($z=0; $z < $max_columns; $z++)  # removed = from <= as it would be doing 1 more loop than needed.
    {
      my $width = ($data_width / $max_columns);
      $temp_str .= "<td width=$width% align=right><font face='$font_str'>";
      if ($z < $num_columns && $num_columns > 1)
      {
        my $temp = $MyDates[$z][0];
        $temp =~ s/-/\//g;
        $temp_str .= "<code>$temp&nbsp;&nbsp;&nbsp;<br>-&nbsp;";
        $temp = $MyDates[$z][1];
        $temp =~ s/-/\//g;
        $temp_str .= "$temp&nbsp;&nbsp;&nbsp;</code>";
      }
      elsif ($num_columns == 1 && $z == $max_columns-2)
      {
        my $temp = $MyDates[0][0];
        $temp =~ s/-/\//g;
        $temp_str .= "<code>$temp&nbsp;&nbsp;&nbsp;<br>-&nbsp;";
        $temp = $MyDates[0][1];
        $temp =~ s/-/\//g;
        $temp_str .= "$temp&nbsp;&nbsp;&nbsp;</code>";
      }
      else
      {
        $temp_str .= "&nbsp;";
      }
      $temp_str .= "</font></td>";
    }
    $temp_str .= "</tr></table>";
    # add the Date header string to the list to display
    print "    mylist.addItem(\"$temp_str\", -1);\n";
    $num_list_entries++;

    # see if we need to do a SubEntity display or just display everything.
    if ($show_by_sub_entities)
    {
      my @NetIncomes = ("0.00", "0.00", "0.00", "0.00");  # Assuming only 4 columns max.
      my @SubEntities = $report_obj->GetSubEntities();
      if ($report_obj->didErrorOccur)
      {
        print "</script></head><body bgcolor=#ffffff>\n";
        print $report_obj->getErrorMessage;
        CleanUp();
      }
      for ($z=0; $z < scalar @SubEntities; $z++)
      {
        @SubEntity = @{$SubEntities[$z]};
        my @netIncomes = doIncomeStatement(\@SubEntity, \@Dates, $num_columns, 1, 0, 0); # show tax, detailed view, no Income Tax Expense
        my $zz;
        for ($zz=0; $zz < $max_columns; $zz++)
        {
          $NetIncomes[$zz] += $netIncomes[$zz];
        }

        if ($show_non_tax_section)
        {
          @netIncomes = doIncomeStatement(\@SubEntity, \@Dates, $num_columns, 0, 0, 0); # don't show tax, detailed view, no Income Tax Expense
          for ($zz=0; $zz < $max_columns; $zz++)
          {
            $NetIncomes[$zz] += $netIncomes[$zz];
          }
        }

        print "    mylist.addItem(\"<hr>\", -1);\n";  # print the horizontal dividing line
        $num_list_entries++;
      }
      # Display the total Net Income calculated
      my $temp_str = "<table border=0 width=100% cellpadding=2 cellspacing=0><tr><td width=$text_width% align=left><font face='$font_str'><b>Total Net Income</b></font></td>";
      for ($z=0; $z < $max_columns; $z++)
      {
        my $width = ($data_width / $max_columns);
        $temp_str .= "<td width=$width% align=right><font face='$font_str'>";
        if ($z < $num_columns)
        {
          my $temp_value = $NetIncomes[$z];
          if ($data_precision == 1)
          {
            $temp_value = sprintf "%.2f", $temp_value;
          }
          else
          {
            $temp_value = sprintf "%.0f", $temp_value;
          }
          if ($temp_value < 0)
          {
            $temp_value *= -1;
            if ($data_precision == 1)
            {
              $temp_value = sprintf "%.2f", $temp_value;
            }
            else
            {
              $temp_value = sprintf "%.0f", $temp_value;
            }
          }
          if ($NetIncomes[$z] < 0)
          {
            $temp_str .= "<font color=red>(";
          }
          $temp_str .= "<b>" . (commify($temp_value)) . "</b>";
          if ($NetIncomes[$z] < 0)
          {
            $temp_str .= ")</font>&nbsp;&nbsp;";
          }
          else
          {
            $temp_str .= "&nbsp;&nbsp;&nbsp;&nbsp;";
          }
        }
        else
        {
          $temp_str .= "<br>";
        }
        $temp_str .= "</font></td>";
      }
      $temp_str .= "</tr></table>";
      # add the Total Net Income string to the list to display
      print "      mylist.addItem(\"$temp_str\", -1);\n";
      $num_list_entries++;
    }
    else
    {
      doBalanceSheetStatement(\@SubEntity, \@MyDates, $num_columns, "", 0);  # detailed view
    }

    print "    mylist.build(width/8, 100);\n";
    print "  }\n";  # end of the init() function.
    print "</script>\n";
  }
}

sub reports4BalanceSheetValidate
{
  $report_name = "Balance Sheet";
  $num_columns = $max_columns;
  $show_by_sub_entities = 0;  # make sure it is turned off now until we decide we need it later.

  my ($i, @date_indexes);
  for ($i=1; $i <= $num_columns; $i++)
  {
    my $temp = "date" . $i;
    $$temp = $input{$temp};
    if (length $$temp != 0)
    {
      push @date_indexes, $i;
    }
  }
  if (scalar @date_indexes == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must specify at least one date to work with!</h1>\n";
    print $back_button;
    CleanUp();
  }
  else
  {
    foreach my $index (@date_indexes)
    {
      my $temp = "date" . $index;
      $$temp = $input{$temp};
      if (!IsValidDateSyntax($$temp))
      {
        PrintErrorHeader();
        print "<h1>Error:  Date '$$temp' is invalid!</h1>\nClose this window to fix the problem.\n";
        CleanUp();
      }
      push @Dates, $$temp;  # store the date to work with in the Dates array for future use.
    }

    $num_columns = scalar @Dates;  # remember how many entries we got from the user.
  }
  $date_range_string = ""; # each balance sheet report includes the date.

  # get and verify that the months to display back value is valid
  $activity_start_point = $input{'activity_start_point'};
  if (length $activity_start_point == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must select an Activity Start Point value!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  if ($activity_start_point <= 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Activity Start Point given!</h1>\n";
    print "The Activity Start Point must be >= 1 month back!<br>$sys_admin";
    CleanUp();
  }

  if (exists $input{'print_report'})
  {
    $print_report = 1;
  }
  else
  {
    $print_report = 0;
  }
}

return 1;
