#$Id: reports_cash_flow.pm,v 1.1 2001/09/06 10:21:20 moreejt Exp $
#This package is released under the GNU General Public License.
#You should have recieved a copy of the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.
sub reports3CashFlowJavaScriptValidation
{
  print <<"END_OF_SCRIPT";
  function reports3CashFlowJavaScriptValidation(doc)
  {
    var msg = "";
    var tmp = "";

    // verify that they have specified at least one complete date range
    var date1_start, date1_end, date2_start, date2_end, date3_start, date3_end, date4_start, date4_end;
    date1_start = doc.date1_start.value;
    date1_end   = doc.date1_stop.value;
    date2_start = doc.date2_start.value;
    date2_end   = doc.date2_stop.value;
    date3_start = doc.date3_start.value;
    date3_end   = doc.date3_stop.value;
    date4_start = doc.date4_start.value;
    date4_end   = doc.date4_stop.value;

    if (date1_start.length == 0 && date1_end.length == 0 && date2_start.length == 0 && date2_end.length == 0 && date3_start.length == 0 && date3_end.length == 0 && date4_start.length == 0 && date4_end.length == 0)
    {
      msg += "You must specify some dates to work with!\\n";
    }
    else  // something is filled in, now verify that it is a complete range
    {
      if ((date1_start.length > 0 && date1_end.length == 0) || (date1_start.length == 0 && date1_end.length > 0))
      {
        msg += "You must specify a complete range of dates for Row 1!\\n";
      }
      else
      {
        if (date1_start.length > 0 && date1_end.length > 0) // check and make sure the dates are valid.
        {
          tmp = IsValidDateSyntax(date1_start);
          if (tmp.length > 0)
          {
            msg += "Date 1 From: " + tmp + "\\n";
          }
          tmp = IsValidDateSyntax(date1_end);
          if (tmp.length > 0)
          {
            msg += "Date 1 To: " + tmp + "\\n";
          }
        }
      }
      if ((date2_start.length > 0 && date2_end.length == 0) || (date2_start.length == 0 && date2_end.length > 0))
      {
        msg += "You must specify a complete range of dates for Row 2!\\n";
      }
      else
      {
        if (date2_start.length > 0 && date2_end.length > 0) // check and make sure the dates are valid.
        {
          tmp = IsValidDateSyntax(date2_start);
          if (tmp.length > 0)
          {
            msg += "Date 2 From: " + tmp + "\\n";
          }
          tmp = IsValidDateSyntax(date2_end);
          if (tmp.length > 0)
          {
            msg += "Date 2 To: " + tmp + "\\n";
          }
        }
      }
      if ((date3_start.length > 0 && date3_end.length == 0) || (date3_start.length == 0 && date3_end.length > 0))
      {
        msg += "You must specify a complete range of dates for Row 3!\\n";
      }
      else
      {
        if (date3_start.length > 0 && date3_end.length > 0) // check and make sure the dates are valid.
        {
          tmp = IsValidDateSyntax(date3_start);
          if (tmp.length > 0)
          {
            msg += "Date 3 From: " + tmp + "\\n";
          }
          tmp = IsValidDateSyntax(date3_end);
          if (tmp.length > 0)
          {
            msg += "Date 3 To: " + tmp + "\\n";
          }
        }
      }
      if ((date4_start.length > 0 && date4_end.length == 0) || (date4_start.length == 0 && date4_end.length > 0))
      {
        msg += "You must specify a complete range of dates for Row 4!\\n";
      }
      else
      {
        if (date4_start.length > 0 && date4_end.length > 0) // check and make sure the dates are valid.
        {
          tmp = IsValidDateSyntax(date4_start);
          if (tmp.length > 0)
          {
            msg += "Date 4 From: " + tmp + "\\n";
          }
          tmp = IsValidDateSyntax(date4_end);
          if (tmp.length > 0)
          {
            msg += "Date 4 To: " + tmp + "\\n";
          }
        }
      }
    }

    return msg;
  }
END_OF_SCRIPT
}

sub reports3CashFlowCustomizedFormItems
{
  print <<"END_OF_FORM";
  <tr><td align=center><font color=\"$menu_fgcolor\">Number of Columns:&nbsp;</font><select name=\"columns\">
  <option value=\"1\">1
  <option value=\"2\">2
  <option value=\"3\">3
  <option value=\"4\">4
  </select></td></tr>
  <tr><td align=center><font color=\"$menu_fgcolor\">Date Range 1:</font>&nbsp;&nbsp;From&nbsp;<input type=text name=\"date1_start\" value=\"$date\" size=10 maxlength=10>&nbsp;To&nbsp;<input type=text name=\"date1_stop\" value=\"$date\" size=10 maxlength=10>&nbsp;<input type=button name=\"clear_1\" value=\"Clear\" onClick=\"document.customize_form.date1_start.value='';document.customize_form.date1_stop.value='';\"></td></tr>
  <tr><td align=center><font color=\"$menu_fgcolor\">Date Range 2:</font>&nbsp;&nbsp;From&nbsp;<input type=text name=\"date2_start\" size=10 maxlength=10>&nbsp;To&nbsp;<input type=text name=\"date2_stop\" size=10 maxlength=10>&nbsp;<input type=button name=\"clear_2\" value=\"Clear\" onClick=\"document.customize_form.date2_start.value='';document.customize_form.date2_stop.value='';\"></td></tr>
  <tr><td align=center><font color=\"$menu_fgcolor\">Date Range 3:</font>&nbsp;&nbsp;From&nbsp;<input type=text name=\"date3_start\" size=10 maxlength=10>&nbsp;To&nbsp;<input type=text name=\"date3_stop\" size=10 maxlength=10>&nbsp;<input type=button name=\"clear_3\" value=\"Clear\" onClick=\"document.customize_form.date3_start.value='';document.customize_form.date3_stop.value='';\"></td></tr>
  <tr><td align=center><font color=\"$menu_fgcolor\">Date Range 4:</font>&nbsp;&nbsp;From&nbsp;<input type=text name=\"date4_start\" size=10 maxlength=10>&nbsp;To&nbsp;<input type=text name=\"date4_stop\" size=10 maxlength=10>&nbsp;<input type=button name=\"clear_4\" value=\"Clear\" onClick=\"document.customize_form.date4_start.value='';document.customize_form.date4_stop.value='';\"></td></tr>
END_OF_FORM
}

sub reports4CashFlowWork
{
  # @Data will have the following structure:
  # Account Type info:  name, num, debit_increases, first_digit, [balance], num_accounts, [accounts]
  # [balance] will have: balance1, balance2, balance3, balance4
  # [accounts] will have: name, num, sub_accts, [range1], [range2], [range3], [range4]
  # sub_accts is a string of | seperated names of the sub-accts that exist for each account.
  # [rangeX] will have: start_date, end_date, balance, num_entries, [entries]
  # [entries] will have: ref_num, journal_code, payer_payee, memo, sub_entity_code, date, amount, dorc, sub-acct_name ("----" for none)

  my @Years = split /,/, $years;
  my ($z, $array_counter);
  my @Acct_Order = (9,10,1,11,12,14,13,5,16,4,15,2,3,8,18,6,7,17,0);  # The order of the data needed to be retrieved from the database
  my @Reverse_Value = (0, 0, 1, 0, 0, 1, 1, 0, 1, 0, 1, 1, 1, 0, 1, 0, 0, 1, 0);  # Does this Account type need to have it's values reversed for display relative to cash?

  # Initialize the outer loop data.
  $array_counter = 0;

  for ($z=0; $z < scalar @Acct_Order; $z++, $array_counter++)
  {
    $result2 = $conn->exec("select name, num, debit_increases, first_digit from acct_type_tb where num = $Acct_Order[$z]");
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error:  Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to get Account Type data for Account Type = <b>$Acct_Order[$z]</b>.<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples == 0)
    {
      print "<h1>Error:  Program is not configured!</h1>\n";
      print "Account Types table is not filled in!<br>$sys_admin";
      CleanUp();
    }

    my ($acct_type_name, $acct_type_num, $debit_increases, $first_digit);
    $i = 0;  # only 1 item returned per Account Type.
    $acct_type_name  = $result2->getvalue($i, 0);
    $acct_type_num   = $result2->getvalue($i, 1);
    $debit_increases = $result2->getvalue($i, 2);
    $first_digit     = $result2->getvalue($i, 3);

    # store this Account Type's info in the Data structure
    my ($j, $result3, $result4, @running_balance, @Acct_data);
    for ($j=0; $j <= 3; $j++)
    {
      $Data[$array_counter][$j] = $result2->getvalue($i, $j);
    }

    # Find all accounts for this account type in the Global Database
    $result3 = $conn->exec("select name, number from account_tb where type = $acct_type_num order by number");
    if ($result3->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error:  Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to get list of Accounts for Account Type <font color=\"blue\">$acct_type_name</font>.<br>$sys_admin";
      CleanUp();
    }

    if ($result3->ntuples == 0)
    {
      $Data[$array_counter][4][0] = "0.00";
      $Data[$array_counter][4][1] = "0.00";
      $Data[$array_counter][4][2] = "0.00";
      $Data[$array_counter][4][3] = "0.00";
      $Data[$array_counter][5] = 0;
    }
    else
    {
      my ($acct_num_list, $acct_name_list, @acct_type_balance, $acct_name, $acct_number);
      for ($j=0; $j < $result3->ntuples; $j++)
      {
        $acct_name = $result3->getvalue($j, 0);
        $acct_number = $result3->getvalue($j, 1);

        $acct_num_list .= ", " if ($j > 0);
        $acct_name_list .= ", " if ($j > 0);
        $acct_num_list .= $acct_number;
        $acct_name_list .= $acct_name;
      }

      $acct_type_balance[0] = "0.00";
      $acct_type_balance[1] = "0.00";
      $acct_type_balance[2] = "0.00";
      $acct_type_balance[3] = "0.00";

      # now ask for any accounts that exist in the local_accounts_tb of the ledger that match.
      $result3 = $conn->exec("select acct_num from local_accounts_tb where acct_num in ($acct_num_list) and sub_entity_code is null AND ledger_code = '$ledger_code' order by acct_num");
      if ($result3->resultStatus != PGRES_TUPLES_OK)
      {
        print "<h1>Error:  Accessing database failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to get list of Accounts to work with based on the Local Accounts Table.<br>List = $acct_num_list<br>$acct_name_list<br>$sys_admin";
        CleanUp();
      }

      $Data[$array_counter][5] = $result3->ntuples;
      if ($result3->ntuples == 0)
      {
        $Data[$array_counter][4] = [ @acct_type_balance ];
      }
      else
      {
        # now we have a list of accounts to work with for this Account Type that exist in the Ledger
        for ($j=0; $j < $result3->ntuples; $j++)
        {
          $acct_number = $result3->getvalue($j, 0);

          # now we find the name of the account
          $result4 = $conn->exec("select name from account_tb where number = $acct_number");
          if ($result4->resultStatus != PGRES_TUPLES_OK)
          {
            print "<h1>Error:  Accessing database failed!</h1>\n";
            print $conn->errorMessage . "<br>Tried to get the name of the account with number = '$acct_number'.<br>$sys_admin";
            CleanUp();
          }
          if ($result4->ntuples == 0)
          {
            print "<h1>Error:  Program is not configured properly!</h1>\n";
            print "The Account with Number = '$acct_number' does not have a name!<br>$sys_admin";
            CleanUp();
          }
          $acct_name = $result4->getvalue(0, 0);

          # assign this accounts info to the Acct_data array.
          $Acct_data[$j][0] = $acct_name;
          $Acct_data[$j][1] = $acct_number;

          my %sub_accounts;  # the hash to hold the sub-accounts encountered for this account.

          # now we lookup all activity that this account had for each date range specified.
          my ($k, $start_date, $end_date);
          for ($k=1; $k <= $num_columns; $k++)
          {
            $start_date = "date" . $k . "_start";
            $$start_date = $input{$start_date};

            $end_date = "date" . $k . "_stop";
            $$end_date = $input{$end_date};

            my ($balance, @Entries, @YearX);
            $balance = "0.00";

            # record what year this YearX is working with
            $YearX[0] = $$start_date;
            $YearX[1] = $$end_date;

            $result4 = $conn->exec("select amount, dorc, parent_num, sub_e_code, sub_account_num from debitcredit_tb where account_num = $acct_number and parent_num in (select ref_num from journal_entry_tb where (trans_date >= '" . $YearX[0] . "' and trans_date <= '" . $YearX[1] . "') AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code' order by parent_num");
            if ($result4->resultStatus != PGRES_TUPLES_OK)
            {
              print "<h1>Error:  Accessing database failed!</h1>\n";
              print $conn->errorMessage . "<br>Tried to get transactions for Account = '$acct_number', Date Range from <b>$YearX[0]</b> to <b>$YearX[1]</b>.<br>$sys_admin";
              CleanUp();
            }
            $YearX[3] = $result4->ntuples;  # number of entries to work with.
            if ($result4->ntuples > 0)
            {
              my ($l, $amount, $dorc, $ref_num, $sub_e_code, $sub_account_num, $sub_account_name, $journal_code, $payer_payee, $memo, $entry_date, $result5);
              for ($l=0; $l < $result4->ntuples; $l++)
              {
                $amount = $result4->getvalue($l, 0);
                # cut the $ off the front.
                $amount =~ s/^\$//;
                $amount =~ s/,//g; # remove any commas.
                $dorc = $result4->getvalue($l, 1);
                $ref_num = $result4->getvalue($l, 2);
                $sub_e_code = $result4->getvalue($l, 3);
                $sub_account_num = $result4->getvalue($l, 4);

                # get the info for this transaction from the journal_entry_tb
                $result5 = $conn->exec("select journal_code, trans_date, payee_payer, memo from journal_entry_tb where ref_num = $ref_num AND ledger_code = '$ledger_code'");
                if ($result5->resultStatus != PGRES_TUPLES_OK)
                {
                  print "<h1>Error:  Accessing database failed!</h1>\n";
                  print $conn->errorMessage . "<br>Tried to get Transaction info for Transaction with Ref_num = '$ref_num'.<br>$sys_admin";
                  CleanUp();
                }
                if ($result5->ntuples == 0)
                {
                  print "<h1>Error:  Program is not configured!</h1>\n";
                  print "Journal Entry is not created for Transaction with Ref_num = '$ref_num'!<br>$sys_admin";
                  CleanUp();
                }
                $journal_code = $result5->getvalue(0, 0);
                $entry_date = $result5->getvalue(0, 1);
                $payer_payee = $result5->getvalue(0, 2);
                $payer_payee =~ s/'/\\'/g;  # replace all ' with \'
                $memo = $result5->getvalue(0, 3);
                $memo =~ s/'/\\'/g;  # replace all ' with \'

                $sub_account_name = "----";

                # get the account type of the account
                $result5 = $conn->exec("select type from account_tb where number = $acct_number");
                if ($result5->resultStatus != PGRES_TUPLES_OK)
                {
                  print "<h1>Error:  Accessing database failed!</h1>\n";
                  print "Error Number: 1000<br>" . $conn->errorMessage . "<br>Tried to get Account Type for Account = '$acct_number'<br>$sys_admin";
                  CleanUp();
                }
                if ($result5->ntuples == 0)
                {
                  print "<h1>Error:  Account data not configured!</h1>\n";
                  print "Error Number: 1001<br>Account '$acct_number' does not have an Account Type assigned!<br>$sys_admin";
                  CleanUp();
                }
                my $account_type = $result5->getvalue(0, 0);

                # get the name of the sub-account if it isn't equal to -1
                if ($sub_account_num != -1 && $account_type != 0)
                {
                  $result5 = $conn->exec("select sub_acc_name from sub_acc_tb where sub_acc_number = $sub_account_num and parent = $acct_number");
                  if ($result5->resultStatus != PGRES_TUPLES_OK)
                  {
                    print "<h1>Error:  Accessing database failed!</h1>\n";
                    print "Error Number: 1002<br>" . $conn->errorMessage . "<br>Tried to get Sub Account Name for Sub Account = '$sub_account_num'.<br>$sys_admin";
                    CleanUp();
                  }
                  if ($result5->ntuples == 0)
                  {
                    print "<h1>Error:  Program is not configured!</h1>\n";
                    print "Error Number: 1003<br>Sub Account is not properly configured for Sub Account with Number = '$sub_account_num', Parent = '$acct_number'!<br>$sys_admin";
                    CleanUp();
                  }
                  $sub_account_name = $result5->getvalue(0, 0);
                }

                # add this transactions info to the array of Entries
                $Entries[$l][0] = $ref_num;
                $Entries[$l][1] = $journal_code;
                $Entries[$l][2] = $payer_payee;
                $Entries[$l][3] = $memo;
                $Entries[$l][4] = $sub_e_code;
                $Entries[$l][5] = $entry_date;
                $Entries[$l][6] = $amount;
                $Entries[$l][7] = $dorc;
                $Entries[$l][8] = $sub_account_name;

                # update the hash of sub-accounts encountered
                $sub_accounts{$sub_account_name} = $sub_account_name;

                # update the account balance and the Account Type balance.

                if ($debit_increases eq "t" && $dorc eq "t") # debit increases and amount is a debit
                {
                  $balance += $amount;
                }
                elsif ($debit_increases eq "t" && $dorc eq "f") # debit increases and amount is a credit
                {
                  $balance -= $amount;
                }
                elsif ($debit_increases eq "f" && $dorc eq "t") # debit decreases and amount is a debit
                {
                  $balance -= $amount;
                }
                elsif ($debit_increases eq "f" && $dorc eq "f") # debit decreases and amount is a credit
                {
                  $balance += $amount;
                }
              }
            }

            # see if we need to reverse this balance
            if ($Reverse_Value[$z] && $balance != 0)
            {
              $balance *= -1;
            }
            $balance = sprintf "%.2f", $balance;
            $acct_type_balance[$k-1] += $balance;
            $acct_type_balance[$k-1] = sprintf "%.2f", $acct_type_balance[$k-1];

            # update the YearX array
            $YearX[2] = $balance;
            $YearX[4] = [ @Entries ];

            # now add this YearX array to the Acct_data array
            $Acct_data[$j][3+$k-1] = [ @YearX ];
          }
          # now we extract the list of all sub_accounts encountered and create the | seperated string
          my $tmp_string;
          $tmp_string = join '|', (sort keys %sub_accounts);

          $Acct_data[$j][2] = $tmp_string;
        }
        $Data[$array_counter][6] = [ @Acct_data ];
        $Data[$array_counter][4] = [ @acct_type_balance ];
      }
    }
  } # end of z loop
}

sub reports4CashFlowDisplayForm
{
  # @Data will have the following structure:
  # Account Type info:  name, num, debit_increases, first_digit, [balance], num_accounts, [accounts]
  # [balance] will have: balance1, balance2, balance3, balance4
  # [accounts] will have: name, num, sub_accts, [range1], [range2], [range3], [range4]
  # sub_accts is a string of | seperated names of the sub-accts that exist for each account.
  # [rangeX] will have: start_date, end_date, balance, num_entries, [entries]
  # [entries] will have: ref_num, journal_code, payer_payee, memo, sub_entity_code, date, amount, dorc, sub-acct_name ("----" for none)

  # create the header string to be displayed in the printable version of the report.
  my $header_string = "<center><table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor=\"$body_bgcolor\"><tr><td width=35%>Ledger <font color=\"$ledger_color\">$ledger_name</font>";
  $header_string .= "</td><td align=center width=30%><h3>$custom_title</h3></td><td align=right>$date</td></tr>";
  if (length $date_range_string > 0)
  {
    $header_string .= "<tr><td width=35%><br></td><td align=center width=30%>$date_range_string</td><td><br></td></tr>";
  }
  $header_string .= "</table><br>";

  my $year_header_string = "<table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor=$body_bgcolor>";
  $year_header_string .= "<tr><td width=40% align=left><br></td>";
  for ($i=1; $i <= $num_columns; $i++)
  {
    my $width = int (60 / $num_columns);
    my $start_date = "date" . $i . "_start";
    $$start_date = $input{$start_date};
    $$start_date =~ s/-/\//g;  # replace all -'s with /'s
    my $end_date = "date" . $i . "_stop";
    $$end_date = $input{$end_date};
    $$end_date =~ s/-/\//g;

    $year_header_string .= "<td width=$width% align=right><b>$$start_date</b><br>- <b>$$end_date</b></td>";
  }
  $year_header_string .= "</tr></table>";

  $result = $conn->exec("select working_year from variables_tb WHERE ledger_code = '$ledger_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get current fiscal year from database.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples == 0)
  {
    print "<h1>Error:  Current Fiscal Year not configured!</h1>\n";
    print "The Current Fiscal Year is not set!<br>$sys_admin";
    CleanUp();
  }
  my $curr_fiscal_year = $result->getvalue(0, 0);
  # now get the start and end dates of the current fiscal year.

  $result = $conn->exec("select start_date, end_date from known_years_tb where year = $curr_fiscal_year AND ledger_code = '$ledger_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print "Error Number: 1004<br>" . $conn->errorMessage . "<br>Tried to get dates of the current fiscal year!<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples == 0)
  {
    print "<h1>Error:  Fiscal Year not configured!</h1>\n";
    print "Error Number: 1005<br>Tried to get dates for Fiscal Year = $curr_fiscal_year.<br>$sys_admin";
    CleanUp();
  }
  my $fiscal_start = $result->getvalue(0, 0);
  my $fiscal_end = $result->getvalue(0, 1);

  print "<script language=Javascript1.2>\n";
  print "  var header_string='$header_string';\n";
  print "  var year_header_string=\"$year_header_string\";\n";
  print "  var body_bgcolor=\"$body_bgcolor\";\n";
  print "  var Fiscal_Start=\"$fiscal_start\";\n";
  print "  var Fiscal_End=\"$fiscal_end\";\n";
  print "</script>\n";

  # display the Print Button
  print "<form name=\"Dummy_form\">\n";
  print "<div align=right><input type=button name=\"Print\" value=\"Print View\" onClick=\"printReport('Cash Flow Statement Report', year_header_string);\"></div>\n";
  print "</form>\n";

  #print "<table border=0 height=" . (($num_list_entries + 1) * $list_height) . "><tr><td></td></tr></table>\n";
}

sub reports4CashFlowJavaScript
{
  my $time = `/bin/date +%s`;
  chomp $time;

  my @Reverse_Value = (0, 0, 1, 0, 0, 1, 1, 0, 1, 0, 1, 1, 1, 0, 1, 0, 0, 1, 0);  # Does this Account type need to have it's values reversed for display relative to cash?
#  my @Reverse_Value = (0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 0, 1, 0);  # Does this Account type need to have it's values reversed for display relative to cash?
  print "<script language=\"JavaScript1.2\" SRC=\"../js/resize.js\"></script>\n";
  print "<script language=\"JavaScript1.2\" SRC=\"../js/list.js\"></script>\n";
  print "<script language=JavaScript1.2>\n";
  print "var Data = new Array();\n";
  print "var Data_Strings = new Array();\n";
  print "// Other Global Variables\n";
  print "var Ledger = \"$ledger_db\";\n";
  print "var Site_Dir = \"$site_dir\";\n";
  print "var NumColumns = $num_columns;\n\n";
  print "// Data will have the following structure:\n";
  print "// Account Type info:  name, num, debit_increases, first_digit, [balance], num_accounts, [accounts]\n";
  print "// [balance] will have: balance1, balance2, balance3, balance4\n";
  print "// [accounts] will have: name, num, sub_accts, [year1], [year2], [year3], [year4]\n";
  print "// sub_accts is a string of | seperated names of the sub-accts that exist for each account.\n";
  print "// [yearX] will have: start_date, end_date, balance, num_entries, [entries]\n";
  print "// [entries] will have: ref_num, journal_code, payer_payee, memo, sub_entity_code, date, amount, dorc, sub-acct_name (\"----\" for none)\n\n";
  print "  function InitializeArray()\n";
  print "  {\n";

  # create the JavaScript Array of data from the Perl array.
  my ($i, $j, $k, $l);
  LOOP: for ($i=0; $i < scalar @Data; $i++)
  {
    my ($temp_str);

    $temp_str = "'" . $Data[$i][0] . "'," . $Data[$i][1] . ",'" . $Data[$i][2] . "'," . $Data[$i][3] . ",['" . $Data[$i][4][0] . "','" . $Data[$i][4][1] . "','" . $Data[$i][4][2] . "','" . $Data[$i][4][3] . "']," . $Data[$i][5] . ",[";
    # Generate the Account Array structure.
    my @Accounts = @{$Data[$i][6]};
    for ($j=0; $j < $Data[$i][5]; $j++)
    {
      $temp_str .= "['" . $Accounts[$j][0] . "'," . $Accounts[$j][1] . ",'" . $Accounts[$j][2] . "'";
      # Generate the Years.
      for ($k=3; $k <= 6; $k++)
      {
        my @YearX = @{$Accounts[$j][$k]};
        $temp_str .= ",['" . $YearX[0] . "','" . $YearX[1] . "','" . $YearX[2] . "'," .$YearX[3] . ",[";
        my @Entries = @{$YearX[4]};
        for ($l=0; $l < $YearX[3]; $l++)
        {
          $temp_str .= "[" . $Entries[$l][0] . ",'" . $Entries[$l][1] . "','" . $Entries[$l][2] . "','" . $Entries[$l][3] . "','" . $Entries[$l][4] . "','" . $Entries[$l][5] . "','" . $Entries[$l][6] . "','" . $Entries[$l][7] . "','" . $Entries[$l][8] . "']";
          if ($l < $YearX[3] - 1)
          {
            $temp_str .= ",";
          }
        }
        $temp_str .= "]]";
      }
      $temp_str .= "]";
      if ($j < $Data[$i][5] - 1)
      {
        $temp_str .= ",";
      }
    }

    my $location = $i;

    $temp_str .= "]";  # Close the Account Array structure.
    print "    Data[$location] = [$temp_str];\n";
    print "    Data_Strings[$location] = \"[$temp_str]\";\n";
  }

  print "    // Call init() to start the Dynamic Lists\n";
  print "    init();\n";
  print "  }\n\n";
  print << "JAVA_CODE";
  function SubmitEditForm(w, ref_num)
  {
    win = window.open("", w);
    win.document.Detailed_View.action = Site_Dir + "/cgi-bin/journal_activity.cgi";
    win.document.Detailed_View.journal_entry_0.value = ref_num;
    //alert("Ref_Num = " + win.document.Detailed_View.journal_entry_0.value);
    win.document.Detailed_View.submit();
    return false;
  }
  function SubmitViewForm(w, ref_num)
  {
    win = window.open("", w);
    win.document.Detailed_View.action = Site_Dir + "/cgi-bin/journal_mod1.cgi";
    win.document.Detailed_View.ref_num2.value = ref_num;
    //alert("Ref_Num = " + win.document.Detailed_View.ref_num.value);
    win.document.Detailed_View.submit();
    return false;
  }

  function display_entries(Acct_Type_num, Acct_Num, Start_Date, End_Date, Sub_Acct_Name)
  {
    var w = window.open("", "display_entries_$time", "status=yes,menubar=yes,resizeable=yes,toolbar=yes,location=yes,scrollbars=yes");
    var d = w.document;
    var i, j, k, found;

    d.open();

    d.writeln("<html>");
    d.writeln("<head><title>Cash Flow Statement Detailed View</title></head>");
    d.writeln("<body bgcolor=#ffffff>");
    d.writeln("  <style type=\\\"text/css\\\"><!--");
    d.writeln("    a:hover   { color: blue }");
    d.writeln("    a:link    { text-decoration: none; color: blue }");
    d.writeln("    a:visited { text-decoration: none; color: blue }");
    d.writeln("    a:active  { text-decoration: none; color: blue }-->");
    d.writeln("  </style>");
    // Display the Main Header
    d.writeln(header_string);

    // Now we need to lookup in the Data Array and find the Account Type entry that has num = Acct_Type_num.
    for (i=0, found=0; i < Data.length && !found; i++)
    {
      if (Data[i][1] == Acct_Type_num)
      {
        found = 1;  // Signal we found the item.
      }
    }
    i--;  // correct for the increment.

    if (!found)
    {
      alert("Error:  The Account Type could not be found with Number = " + Acct_Type_num + "! Notify Systems Administrator.");
      d.close();
      return;
    }

    // i now holds the index into Data of the Account Type specified.

    // Now we need to find the Account in Data[i][6] that has num = Acct_Num.
    for (j=0, found=0; j < Data[i][5] && !found; j++)
    {
      if (Data[i][6][j][1] == Acct_Num)
      {
        found = 1;  // Signal we found the Account.
      }
    }
    j--;  // correct for the increment.

    if (!found)
    {
      alert("Error:  The Account could not be found with Number = " + Acct_Num + "! Notify Systems Administrator.");
      d.close();
      return;
    }

    // j now holds the index into Data[i][6] of the Account specified.

    // Now we need to find the Start and End Date's in Data[i][6][3-6] that match
    for (k=0, found=0; k < NumColumns && !found; k++)
    {
      if (Data[i][6][j][3+k][0] == Start_Date && Data[i][6][j][3+k][1] == End_Date)
      {
        found = 1;  // Signal we found the Date Range.
      }
    }
    k--;  // correct for the increment.

    if (!found)
    {
      alert("Error:  The Date Range could not be found with Start Date = " + Start_Date + " and End Date = " + End_Date + "! Notify Systems Administrator.");
      d.close();
      return;
    }

    // k now holds the index into Data[i][6][j][3+k] of the Date Range specified.

    // now we open a table and walk through the Date Range entry and display all lines that have sub-acct_name = Sub_Acct_Name.
    d.writeln("<table border=0 cellspacing=0 cellpadding=0 width=90%>");
    if (Sub_Acct_Name != "____")
    {
      d.writeln("<tr><td align=left><h3>Sub Account=<font color=red>", Sub_Acct_Name, "</font></h3></td></tr>");
    }
    else
    {
      Sub_Acct_Name = "----";
    }

    d.writeln("<tr><td align=left><h4>Account=", Data[i][6][j][0], "</h4></td></tr>");
    d.writeln("<tr><td align=left>Date Range = ", Start_Date, " to ", End_Date, "<br></td></tr>");
    d.writeln("</table>");
    //d.writeln("<h4>Account Type=",Data[i][0],", Account=",Data[i][6][j][0],", Sub Account=<font color=red>",Sub_Acct_Name,"</font>, Year=",Year,"</h4>");

    // Convert the Dates to YearMonthDay form for better comparison.
    end_date = ConvertDateString(End_Date);
    start_date = ConvertDateString(Start_Date);
    fiscal_start = ConvertDateString(Fiscal_Start);
    fiscal_end = ConvertDateString(Fiscal_End);

    //alert("Start_Date = " + start_date + " End_Date = " + end_date + " Fiscal_Start = " + fiscal_start + " Fiscal_End = " + fiscal_end);
    Editable = false;

//    if ((start_date >= fiscal_start && start_date <= fiscal_end) || (end_date >= fiscal_start && end_date <= fiscal_end) || (start_date < fiscal_start && end_date > fiscal_end))  // Editable (in the Current Fiscal Year)
//    {  // If the third condition is met, then the range of dates selected, covers the current fiscal year and so not all entries will really be editable.
//      d.writeln("<form method=post action=\\\"\", Site_Dir, \"/cgi-bin/journal_activity.cgi\\\" name=\\\"Detailed_View\\\">");
//      d.writeln("<input type=hidden name=\\\"ledger\\\" value=\\\"", Ledger, "\\\">");
//      d.writeln("<input type=hidden name=\\\"journal_code\\\" value=\\\"all_journals\\\">");
//      d.writeln("<input type=hidden name=\\\"edit\\\" value=\\\"edit\\\">");
//      d.writeln("<input type=hidden name=\\\"num_entries\\\" value=\\\"1\\\">");
//      d.writeln("<input type=hidden name=\\\"edit_entries\\\" value=\\\"journal_edit_0\\\">");
//      d.writeln("<input type=hidden name=\\\"journal_entry_0\\\" value=\\\"refnum\\\">");
//      d.writeln("<table border=1 cellspacing=1 cellpadding=2 width=90%>");
//      Editable = true;
//    }
//    else  // Viewable only
//    {
      d.writeln("<form method=post action=\\\"\", Site_Dir, \"/cgi-bin/journal_mod1.cgi\\\" name=\\\"Detailed_View\\\">");
      d.writeln("<input type=hidden name=\\\"ledger\\\" value=\\\"", Ledger, "\\\">");
      d.writeln("<input type=hidden name=\\\"journal_view_command\\\" value=\\\"search2\\\">");
      d.writeln("<input type=hidden name=\\\"ref_num2\\\" value=\\\"refnum\\\">");
      d.writeln("<input type=hidden name=\\\"num_entries_to_display\\\" value=\\\"10\\\">");
      d.writeln("<input type=hidden name=\\\"start_index\\\" value=\\\"1\\\">");
      d.writeln("<table border=1 cellspacing=1 cellpadding=2 width=90%>");
//    }
    d.writeln("<tr><th>Action</th><th>Jnl</th><th>Ref Num</th><th>Date</th><th>Payee-Payer</th><th>Memo</th><th>SE</th><th>Debit</th><th>Credit</th></tr>");

    var Num_Entries=0;
    for (var z=0; z < Data[i][6][j][3+k][3]; z++)
    {
      if (Data[i][6][j][3+k][4][z][8] == Sub_Acct_Name)
      {
        var Entry = Data[i][6][j][3+k][4][z];
        ref_num = Entry[0];
        if (Editable)
        {
          temp_date = ConvertDateString(Entry[5]);
          if ((temp_date >= fiscal_start && temp_date <= fiscal_end))  // In the current fiscal year
          {
            d.write("<tr><td align=center><a href=\\\"\\\" onClick=\\\"opener.SubmitEditForm('" + w.name + "'," + ref_num + "); return false;\\\">Edit</a></td>");
          }
          else
          {
            d.write("<tr><td align=center><a href=\\\"\\\" onClick=\\\"opener.SubmitViewForm('" + w.name + "'," + ref_num + "); return false;\\\">View</a></td>");
          }
        }
        else
        {
          d.write("<tr><td align=center><a href=\\\"\\\" onClick=\\\"opener.SubmitViewForm('" + w.name + "'," + ref_num + "); return false;\\\">View</a></td>");
        }
        d.write("<td align=center>", Entry[1], "</td><td align=right>", Entry[0], "</td><td align=center>", Entry[5], "</td><td>");
        if (Entry[2] == "")
        {
          d.write("<br>");
        }
        else
        {
          d.write(Entry[2]);
        }
        d.write("</td><td>");
        if (Entry[3] == "")
        {
          d.write("<br>");
        }
        else
        {
          d.write(Entry[3]);
        }
        d.write("</td><td>")
        if (Entry[4] == "")
        {
          d.write("<br>");
        }
        else
        {
          d.write(Entry[4]);
        }
        d.write("</td>");
        if (Entry[7] == "t")  // Debit
        {
          d.write("<td align=right>", Entry[6], "</td><td><br></td>");
        }
        else  // Credit
        {
          d.write("<td><br></td><td align=right>", Entry[6], "</td>");
        }
        d.writeln("</tr>");
        Num_Entries++;
      }
    }

    d.writeln("</table>");
    d.writeln("</form>");
    d.writeln("</body>");
    d.writeln("</html>");

    d.close();	// Don't forget this!
  }

  function init()
  {
    if (parseInt(navigator.appVersion) < 4)
    {
      alert("Sorry, a 4.0+ browser is required to view this report.");
      return;
    }

    var width, height = 30;
    //if (isNav4) width = 3 * window.innerWidth / 4;
    //else width = 3 * document.body.clientWidth / 4;
    width = 800;

    //alert ("Window.innerWidth = " + window.innerWidth + ", width = " + width);

    var bgColor = "$body_bgcolor";
    mylist = new List(true, width, 40, bgColor);
    // the height is hard-coded for the main list but not for the sub-lists.

JAVA_CODE

    # define the table header string that each list item will need.
    my $table_str = "<table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor='$body_bgcolor'>";

    my (@operating_total, @investing_total, @financing_total, $temp_str);
    my (@beginning_cash_balance, @ending_cash_balance, @increase_in_cash, @beginning_cash_balances);
    my (@total_revenue, @total_expenses, $num_years);

    for ($i=0; $i < $num_columns; $i++)
    {
      $operating_total[$i] = "0.00";
      $investing_total[$i] = "0.00";
      $financing_total[$i] = "0.00";
      $beginning_cash_balance[$i] = "0.00";
      $beginning_cash_balances[$i] = ();
      $ending_cash_balance[$i] = "0.00";
      $increase_in_cash[$i] = "0.00";
      $total_revenue[$i] = "0.00";
      $total_expenses[$i] = "0.00";
    }

    $num_list_entries = 0;
    $num_sub_lists = 0;
    $list_height = 40;  # make sure to syncronize with the JavaScript version also.

    # see if we need to print a (In X's) header
    if ($data_precision != 1)
    {
      my $temp_str = $table_str . "<tr><td width=70%><br></td><td width=30% align=right>(<i>In " . $$precision_table{$data_precision} . "</i>)</td></tr></table>";
      print "    mylist.addItem(\"$temp_str\", -1);\n";
    }

    print "    mylist.addItem(year_header_string, -1);\n";
    $num_list_entries++;

    my $js_array_index = 0;
    my $line_length = 12; # length of the line that should be generated under any text that needs it.
    my $font_str = "Helvetica";

    for ($i=0; $i < scalar @Data; $i++)
    {
      my $name = $Data[$i][0];
      my $number = $Data[$i][1];

      if ($i == 0) # operating header
      {
        print "    mylist.addItem(\"<b>&nbsp;&nbsp;&nbsp;&nbsp;Operating Activities:</b>\");\n";
        $num_list_entries++;
      }
      elsif ($i == 11) # investing header - changed from 10 to 11
      {
        # print the operating total
        $temp_str = $table_str . "<tr><td width=40% align=left><b>&nbsp;&nbsp;&nbsp;Total Operating Activitites</b></td>";
        my $z;
        for ($z=0; $z < $num_columns; $z++)
        {
          my $width = int (60 / $num_columns);
          #update the operating total with revenues and expenses.

          my $balance = $operating_total[$z];
          $temp_str .= "<td width=$width% align=right><b>";
          if ($balance < 0)
          {
            $balance *= -1;
            if ($data_precision == 1)
            {
              $balance = sprintf "%.2f", $balance;
            }
            else
            {
              $balance = sprintf "%.0f", $balance;
            }
            $temp_str .= "<code><font face='$font_str' color=red>(" . commify($balance) . ")</font></code>&nbsp;&nbsp;";
            $balance *= -1;
          }
          else
          {
            if ($data_precision == 1)
            {
              $balance = sprintf "%.2f", $balance;
            }
            else
            {
              $balance = sprintf "%.0f", $balance;
            }
            $temp_str .= "<code><font face='$font_str'>" . commify($balance) . "</font></code>&nbsp;&nbsp;&nbsp;&nbsp;";
          }
          $temp_str .= "</b></td>";
        }
        $temp_str .= "</tr></table>";
        print "    mylist.addItem(\"$temp_str\");\n";
        $num_list_entries++;
        print "    mylist.addItem(\"<hr width=90% align=center>\");\n";
        $num_list_entries++;
        print "    mylist.addItem(\"<b>&nbsp;&nbsp;&nbsp;&nbsp;Investing Activities:</b>\");\n";
        $num_list_entries++;
      }
      elsif ($i == 15) # financing header Changed from 14 to 15
      {
        # print the investing total
        $temp_str = $table_str . "<tr><td width=40% align=left><b>&nbsp;&nbsp;&nbsp;Total Investing Activitites</b></td>";
        my $z;
        for ($z=0; $z < $num_columns; $z++)
        {
          my $width = int (60 / $num_columns);
          my $balance = $investing_total[$z];
          $temp_str .= "<td width=$width% align=right><b>";
          if ($balance < 0)
          {
            $balance *= -1;
            if ($data_precision == 1)
            {
              $balance = sprintf "%.2f", $balance;
            }
            else
            {
              $balance = sprintf "%.0f", $balance;
            }
            $temp_str .= "<code><font face='$font_str' color=red>(" . commify($balance) . ")</font></code>&nbsp;&nbsp;";
            $balance *= -1;
          }
          else
          {
            if ($data_precision == 1)
            {
              $balance = sprintf "%.2f", $balance;
            }
            else
            {
              $balance = sprintf "%.0f", $balance;
            }
            $temp_str .= "<code><font face='$font_str'>" . commify($balance) . "</font></code>&nbsp;&nbsp;&nbsp;&nbsp;";
          }
          $temp_str .= "</b></td>";
        }
        $temp_str .= "</tr></table>";
        print "    mylist.addItem(\"$temp_str\");\n";
        $num_list_entries++;
        print "    mylist.addItem(\"<hr width=90% align=center>\");\n";
        $num_list_entries++;
        print "    mylist.addItem(\"<b>&nbsp;&nbsp;&nbsp;&nbsp;Financing Activities:</b>\");\n";
        $num_list_entries++;
      }
      elsif ($i == 18) # we are at the Cash Account Type info.  Changed 17 to 18.
      {
        # print the financing total
        $temp_str = $table_str . "<tr><td width=40% align=left><b>&nbsp;&nbsp;&nbsp;Total Financing Activitites</b></td>";
        my $z;
        for ($z=0; $z < $num_columns; $z++)
        {
          my $width = int (60 / $num_columns);
          my $balance = $financing_total[$z];
          my ($intro_str, $end_str);
          my ($space_str, $y, $length);
          $length = length commify($balance);
          if ($balance < 0)
          {
            $length++;  # take into account the () and no - sign.
          }
          for ($y=0; $y < $line_length - $length; $y++)
          {
            $space_str .= "&nbsp;";
          }
          $intro_str = "<u>$space_str";
          $end_str = "</u>";
          $temp_str .= "<td width=$width% align=right><b>";
          if ($balance < 0)
          {
            $balance *= -1;
            if ($data_precision == 1)
            {
              $balance = sprintf "%.2f", $balance;
            }
            else
            {
              $balance = sprintf "%.0f", $balance;
            }
            $temp_str .= "<code><font face='$font_str' color=red>$intro_str(" . commify($balance) . ")$end_str</font></code>&nbsp;&nbsp;";
            $balance *= -1;
          }
          else
          {
            if ($data_precision == 1)
            {
              $balance = sprintf "%.2f", $balance;
            }
            else
            {
              $balance = sprintf "%.0f", $balance;
            }
            $temp_str .= "<code><font face='$font_str'>$intro_str" . commify($balance) . "$end_str</font></code>&nbsp;&nbsp;&nbsp;&nbsp;";
          }
          $temp_str .= "</b></td>";
        }
        $temp_str .= "</tr></table>";
        print "    mylist.addItem(\"$temp_str\");\n";
        $num_list_entries++;
        print "    mylist.addItem(\"<hr width=90% align=center>\");\n";
        $num_list_entries++;
        # display the Increase (Decrease) in cash line
        $temp_str = $table_str . "<tr><td width=40% align=left><b>&nbsp;&nbsp;&nbsp;Increase (Decrease) in Cash</b></td>";
        my $z;
        for ($z=0; $z < $num_columns; $z++)
        {
          my $width = int (60 / $num_columns);
          my $balance = $financing_total[$z] + $investing_total[$z] + $operating_total[$z];
          $increase_in_cash[$z] = $balance;
          $temp_str .= "<td width=$width% align=right><b>";
          if ($balance < 0)
          {
            $balance *= -1;
            if ($data_precision == 1)
            {
              $balance = sprintf "%.2f", $balance;
            }
            else
            {
              $balance = sprintf "%.0f", $balance;
            }
            $temp_str .= "<code><font face='$font_str' color=red>(" . commify($balance) . ")</font></code>&nbsp;&nbsp;";
            $balance *= -1;
          }
          else
          {
            if ($data_precision == 1)
            {
              $balance = sprintf "%.2f", $balance;
            }
            else
            {
              $balance = sprintf "%.0f", $balance;
            }
            $temp_str .= "<code><font face='$font_str'>" . commify($balance) . "</font></code>&nbsp;&nbsp;&nbsp;&nbsp;";
          }
          $temp_str .= "</b></td>";
        }
        $temp_str .= "</tr></table>";
        print "    mylist.addItem(\"$temp_str\");\n";
        $num_list_entries++;
      	# display the Cash balance, beginning of date range
 	# get all accounts of type Cash (0) and get their beginning balances
        my $result7 = $conn->exec("select debit_increases from acct_type_tb where num = 0");
        if ($result7->resultStatus != PGRES_TUPLES_OK)
        {
          print "<h1>Error:  Accessing database failed!</h1>\n";
          print $conn->errorMessage . "<br>Tried to get Account Type information for Account Type = 0<br>$sys_admin";
          CleanUp();	
        }
        if ($result7->ntuples == 0)
        {
          print "<h1>Error:  Program is not configured!</h1>\n";
          print "Account Types table is not filled in!<br>$sys_admin";
          CleanUp();
        }
        my ($debit_increases);
        $debit_increases = $result7->getvalue(0, 0);
       	
        $result7 = $conn->exec("select name, number from account_tb where type = 0 order by number");
        if ($result7->resultStatus != PGRES_TUPLES_OK)
        {
          print "<h1>Error:  Accessing database failed!</h1>\n";
          print $conn->errorMessage . "<br>Tried to get list of Accounts for Account Type = 0.<br>$sys_admin";
          CleanUp();
        }
        if ($result7->ntuples == 0)
        {
          print "<h1>Error:  There are no Cash Type Accounts!</h1>\n";
          print "There needs to be at least 1 Cash Type Account for the Cash Flow Statement to work!<br>$sys_admin";
          CleanUp();
        }
        else
        {
          my ($acct_num_list, $acct_name_list, $n, $acct_name, $acct_number);
          for ($n=0; $n < $result7->ntuples; $n++)
          {
            $acct_name = $result7->getvalue($n, 0);
            $acct_number = $result7->getvalue($n, 1);

            $acct_num_list .= ", " if ($n > 0);
            $acct_name_list .= ", " if ($n > 0);
            $acct_num_list .= $acct_number;
            $acct_name_list .= $acct_name;
          }

          $result7 = $conn->exec("select acct_num from local_accounts_tb where acct_num in ($acct_num_list) and sub_entity_code is null AND ledger_code = '$ledger_code' order by acct_num");
          if ($result7->resultStatus != PGRES_TUPLES_OK)
          {
            print "<h1>Error:  Accessing database failed1</h1>\n";
            print $conn->errorMessage . "<br>Tried to get list of Accounts to work with based on the Local Accounts Table.<br>List = $acct_num_list<br>$acct_name_list<br>$sys_admin";
            CleanUp();
          }
        }

      	for ($z=0; $z< $num_columns; $z++)
      	{  # find the beginning balance for each date range specified
      	  $beginning_cash_balance[$z] = "0.00";  # zero each column out to begin with.
      	
      	  my $m;
      	  for ($m=0; $m < $result7->ntuples; $m++)
      	  {
      	    my $account_num = $result7->getvalue($m, 0);
      	    my $trans_date = "date" . ($z+1) . "_start";
      	    $$trans_date = $input{$trans_date};
      	    $trans_date = $$trans_date;
      	    my ($temp_date, $acct_balance);
      	    $acct_balance = "0.00";
            # find the last acct_bal_tb entry that is before the specified date and use that as the beginning balance.
            # if none is found, then the beginning balance is 0.00
            my $result8 = $conn->exec("select balance, bal_date from acct_bal_tb where acct_num = $account_num and bal_date <= '$trans_date' AND ledger_code = '$ledger_code' order by bal_date desc");
            if ($result8->resultStatus != PGRES_TUPLES_OK)
            {
              print "<h1>Error:  Accessing database failed!</h1>\n";
              print $conn->errorMessage . "<br>Tried to get starting balance for Account = '$account_num', Date = '$trans_date'.<br>$sys_admin";
              CleanUp();
            }
            if ($result8->ntuples > 0)
            {
              $acct_balance = $result8->getvalue(0, 0);
              $acct_balance =~ s/^\$//;
              $acct_balance =~ s/,//g;
              $temp_date = $result8->getvalue(0, 1);

              print "//Beginning balance for Account Number = '$account_num' is '$acct_balance' on $temp_date<br>\n";

              if (not $temp_date eq $trans_date)
              {
                print "//Getting rest of initial transactions from '$temp_date' to '$trans_date'.\n";
                $result8 = $conn->exec("select amount, dorc from debitcredit_tb where account_num = $account_num and parent_num in (select ref_num from journal_entry_tb where trans_date between '$temp_date' and '$trans_date' AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
                if ($result8->resultStatus != PGRES_TUPLES_OK)
                {
                  print "<h1>Error:  Accessing database failed!</h1>\n";
                  print $conn->errorMessage . "<br>Tried to get transactions for Account = '$account_num', Start Date = '$temp_date', Stop Date = '$trans_date'.<br>$sys_admin";
                  CleanUp();
                }
                if ($result8->ntuples > 0)
                {
                  my ($j, $amount, $dorc);
                  for ($j=0; $j < $result8->ntuples; $j++)
                  {
                    $amount = $result8->getvalue($j, 0);
                    $amount =~ s/^\$//;  # remove the $
                    $amount =~ s/,//g;
                    $dorc = $result8->getvalue($j, 1);

                    if ($debit_increases eq "t" && $dorc eq "t") # debit increases and amount is a debit
                    {
                      $acct_balance += $amount;
                    }
                    elsif ($debit_increases eq "t" && $dorc eq "f") # debit increases and amount is a credit
                    {
                      $acct_balance -= $amount;
                    }
                    elsif ($debit_increases eq "f" && $dorc eq "t") # debit decreases and amount is a debit
                    {
                      $acct_balance -= $amount;
                    }
                    elsif ($debit_increases eq "f" && $dorc eq "f") # debit decreases and amount is a credit
                    {
                      $acct_balance += $amount;
                    }
                  }

                  $beginning_cash_balance[$z] += $acct_balance;
                  print "//Increased by '$acct_balance'\n";
                }
                else # no transactions between the remaining dates.
                {
                  $beginning_cash_balance[$z] += $acct_balance;
                  print "//Increased by '$acct_balance'\n";
                }
              }
              else
              {
                $beginning_cash_balance[$z] += $acct_balance;
                print "//Increased by '$acct_balance'\n";
              }
            }
            else
            {
              print "//No initial balance found for account = $account_num!\n";
            }
            my @Entry = ();
            $Entry[0] = $account_num;
            $Entry[1] = $acct_balance;
            $beginning_cash_balances[$z][$m] = [ @Entry ];
          }
      	}
        $temp_str = $table_str . "<tr><td width=40% align=left><b>&nbsp;&nbsp;&nbsp;Beginning Cash balance</b></td>";
        my $z;
        for ($z=0; $z < $num_columns; $z++)
        {
          my $width = int (60 / $num_columns);
          my $balance = $beginning_cash_balance[$z]/$data_precision;
          print "//Beginning Cash Balance for column $z = '$balance'.\n";
          my ($intro_str, $end_str);
          my ($space_str, $y, $length);
          $length = length commify($balance);
          if ($balance < 0)
          {
            $length++;  # take into account the () and no - sign.
          }
          for ($y=0; $y < $line_length - $length; $y++)
          {
            $space_str .= "&nbsp;";
          }
          $intro_str = "<u>$space_str";
          $end_str = "</u>";
          $temp_str .= "<td width=$width% align=right><b>";
          if ($balance < 0)
          {
            $balance *= -1;
            if ($data_precision == 1)
            {
              $balance = sprintf "%.2f", $balance;
            }
            else
            {
              $balance = sprintf "%.0f", $balance;
            }
            $temp_str .= "<code><font face='$font_str' color=red>$intro_str(" . commify($balance) . ")$end_str</font></code>&nbsp;&nbsp;";
            $balance *= -1;
          }
          else
          {
            if ($data_precision == 1)
            {
              $balance = sprintf "%.2f", $balance;
            }
            else
            {
              $balance = sprintf "%.0f", $balance;
            }
            $temp_str .= "<code><font face='$font_str'>$intro_str" . commify($balance) . "$end_str</font></code>&nbsp;&nbsp;&nbsp;&nbsp;";
          }
          $temp_str .= "</b></td>";
        }
        $temp_str .= "</tr></table>";
        print "    mylist.addItem(\"$temp_str\");\n";
        $num_list_entries++;
      	# display the Cash balance, end of date range
      	#print "    mylist.addItem(\"<b><font size=+2>Don't forget to do this!</font></b>\");\n";
        #$num_list_entries++;
      }

      # This will either be a main List item or have a Sub List based upon if it has any items.

      $temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;&nbsp;&nbsp;";
      if ($i != 18)  # changed the 17 to 18
      {
        $temp_str .= "$name</td>";
      }
      else
      {
        $temp_str .= "<b>Ending Cash balance</b></td>";
      }
      my $total_str = $table_str . "<tr><td width=40% align=left>&nbsp;&nbsp;&nbsp;";
      if ($i != 18) # changed the 16 to 17
      {
        $total_str .= "$name Total</td>";
      }
      else
      {
        $total_str .= "<b>Ending Cash balance Total</b></td>";
      }
      my $z;
      for ($z=1; $z <= $num_columns; $z++)
      { # display data for all date ranges working with
        my $width = int (60 / $num_columns);
        my $balance = $Data[$i][4][$z-1];
        if ($i == 18)
        { # add the beginning cash balance to this balance to get the actual grand total
          $balance += $beginning_cash_balance[$z-1];
        }
        $total_str .= "<td width=$width% align=right>";
        if ($data_precision > 1)
        {
          $balance /= $data_precision;
          $balance = sprintf "%.0f", $balance;
        }
        else
        {
          $balance = sprintf "%.2f", $balance;
        }
        my ($intro_str, $end_str);
        if ($i == 10 || $i == 14 || $i == 17) # changed the 8 to 9, 15 to 16, 12 to 13
        {
          my ($space_str, $y, $length);
          $length = length commify($balance);
          if ($balance < 0)
          {
            $length++;  # take into account the () and no - sign.
          }
          for ($y=0; $y < $line_length - $length; $y++)
          {
            $space_str .= "&nbsp;";
          }
          $intro_str = "<u>$space_str";
          $end_str = "</u>";
        }
        if ($balance < 0)
        {
          $balance *= -1;
          if ($data_precision == 1)
          {
            $balance = sprintf "%.2f", $balance;
          }
          else
          {
            $balance = sprintf "%.0f", $balance;
          }
          if ($i == 18) # changed the 16 to 17
          {
            $intro_str = "<b>";
          }
          if ($i == 18)	# changed the 16 to 17
          {
            $end_str .= "</b>";
          }
          $total_str .= "<code><font face='$font_str' color=red>$intro_str(" . commify($balance) . ")$end_str</font></code>&nbsp;&nbsp;";
          $balance *= -1;
        }
        else
        {
          if ($i == 18) # changed the 16 to 17
          {
            $intro_str = "<b>";
          }
          if ($i == 18) # changed the 16 to 17
          {
            $end_str .= "</b>";
          }
          $total_str .= "<code><font face='$font_str'>$intro_str" . commify($balance) . "$end_str</font></code>&nbsp;&nbsp;&nbsp;&nbsp;";
        }
        $total_str .= "</td>";
        if ($i < 11) # operating total - changed the 9 to 10
        {
          $operating_total[$z-1] += $balance;
        }
        elsif ($i < 15) # investing total  Changed the 13 to 14
        {
          $investing_total[$z-1] += $balance;
        }
        elsif ($i < 18) # financing total. Changed the 16 to 17
        {
          $financing_total[$z-1] += $balance;
        }
      }
      $temp_str .= "</tr></table>";
      $total_str .= "</tr></table>";

      # See if there are any items for this Account Type
      if ($Data[$i][5] > 0)
      {  # we have accounts to work with
        my $count = $num_sub_lists++;
        print "    sublist$count = new List(false, width, height, bgColor);\n"; # parent list for the Accounts

        # now we need to loop through all Accounts listed of this Account Type and create the sub-lists or sub-entries to represent them.
        my ($sub_count, @Acct_Data);
        @Acct_Data = @{$Data[$i][6]};  # get the list of Accounts to work with
        for ($sub_count=0; $sub_count < $Data[$i][5]; $sub_count++)
        {
          my $count2 = $num_sub_lists++;
          my $acct_name = $Acct_Data[$sub_count][0];
          my $acct_num  = $Acct_Data[$sub_count][1];
          my $sub_accts_str = $Acct_Data[$sub_count][2];
          print "      sublist$count2 = new List(false, width, height, bgColor);\n"; # parent list of the current Account
          # determine if this Account has any entries to list.  If so we will do a double line entry or a single line entry.
          my ($year_count, $acct_temp_str, $acct_total_str, $has_accts);
          $acct_temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;$acct_name</td>";

          $acct_total_str = $table_str . "<tr><td width=40% align=left>&nbsp;$acct_name Total</td>";
          $has_accts = 0;
          for ($year_count=1; $year_count <= $num_columns; $year_count++)
          {
            my @sub_acct_data = @{$Acct_Data[$sub_count][3+$year_count-1]};
            my $width = int (60 / $num_columns);
            my ($intro_str, $end_str);
            $acct_total_str .= "<td width=$width% align=right>";
            my $acct_total = $sub_acct_data[2];

            if ($i == 18) # add the beginning cash balances to this account for the real total.
            {
              for (my $zz=0; $zz < scalar @{$beginning_cash_balances[$year_count-1]}; $zz++)
              {
                if ($beginning_cash_balances[$year_count-1][$zz][0] == $Acct_Data[$sub_count][1])
                {
                  $acct_total += $beginning_cash_balances[$year_count-1][$zz][1];
                }
              }
            }

            if ($data_precision > 1)
            {
              $acct_total /= $data_precision;
              $acct_total = sprintf "%.0f", $acct_total;
            }
            else
            {
              $acct_total = sprintf "%.2f", $acct_total;
            }

            if ($sub_count == $Data[$i][5] - 1) # see if we need to underline this total figure.
            {
              my ($space_str, $y, $length);
              $length = length commify($acct_total);
              if ($acct_total < 0)
              {
                $length++;  # take into account the () and no - sign.
              }
              for ($y=0; $y < $line_length - $length; $y++)
              {
                $space_str .= "&nbsp;";
              }
              $intro_str = "<u>$space_str";
              $end_str = "</u>";
            }

            if ($acct_total < 0)
            {
              $acct_total *= -1;
              if ($data_precision == 1)
              {
                $acct_total = sprintf "%.2f", $acct_total;
              }
              else
              {
                $acct_total = sprintf "%.0f", $acct_total;
              }
              $acct_total_str .= "<code><font face='$font_str' color=red>$intro_str(" . commify($acct_total) . ")$end_str</font></code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
              $acct_total *= -1;
            }
            else
            {
              if ($data_precision == 1)
              {
                $acct_total = sprintf "%.2f", $acct_total;
              }
              else
              {
                $acct_total = sprintf "%.0f", $acct_total;
              }
              $acct_total_str .= "<code><font face='$font_str'>$intro_str" . commify($acct_total) . "$end_str</font></code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
            }
            $acct_total_str .= "</b></td>";
            $has_accts = 1 if ($sub_acct_data[3] > 0);
            if ($i == 18 && !$has_accts)
            {
              # if the account has no sub-accounts but it has a beginning balance, then we still need to display it.
              for (my $zz=0; $zz < scalar @{$beginning_cash_balances[$year_count-1]}; $zz++)
              {
                if ($beginning_cash_balances[$year_count-1][$zz][0] == $Acct_Data[$sub_count][1])
                {
                  if ($beginning_cash_balances[$year_count-1][$zz][1] != 0)
                  {
                    $has_accts = 1;
                  }
                }
              }
            }
          }
          $acct_total_str .= "</tr></table>";
          $acct_temp_str .= "</tr></table>";

          if ($has_accts)
          { # we have to display the list of sub accounts now and the Total line
            # we need to loop through each of the Sub Accounts that this account has and determine what sub-accounts are listed for each year being displayed.
            # we have to do this before we add sublist$count2 to it's parent list.
            my (@sub_acct_names, $num_sub_accts);
            $num_sub_accts = 0;
            for ($year_count=0; $year_count < $num_columns; $year_count++)
            {
              my (%local_sub_acct_names);
              my @sub_acct_data = @{$Acct_Data[$sub_count][3+$year_count]};
              my ($xx);
              for ($xx=0; $xx < $sub_acct_data[3]; $xx++)
              {
                my @entry = @{$sub_acct_data[4][$xx]};
                my $sub_acct_name = $entry[8];
                $local_sub_acct_names{$sub_acct_name} = $sub_acct_name if (not exists $local_sub_acct_names{$sub_acct_name});
              }
              my @SubAccts;
              foreach (sort keys %local_sub_acct_names)
              {
                push @SubAccts, $_;
              }
              $sub_acct_names[$year_count] = [ @SubAccts ];
              $num_sub_accts = keys %local_sub_acct_names if (keys %local_sub_acct_names > $num_sub_accts);
            }

            if ($num_sub_accts == 0 && $i == 18)
            {
              $num_sub_accts = 1;
            }

            my ($sub_count2, $sub_acct_temp_str);
            for ($sub_count2=0; $sub_count2 < $num_sub_accts; $sub_count2++)
            {
              if ($i == 18) # displaying Ending Cash Balances
              {
                $sub_acct_temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Beginning Balance</td>";
                for ($year_count=1; $year_count <= $num_columns; $year_count++)
                {
                  my $string = "";
                  my $width = int (60 / $num_columns);
                  for (my $zz=0; $zz < @{$beginning_cash_balances[$year_count-1]}; $zz++)
                  {
                    if ($beginning_cash_balances[$year_count-1][$zz][0] == $Acct_Data[$sub_count][1])
                    {
                      $sub_total = $beginning_cash_balances[$year_count-1][$zz][1];
                    }
                  }
                  if ($data_precision > 1)
                  {
                    $sub_total /= $data_precision;
                    $sub_total = sprintf "%.0f", $sub_total;
                  }
                  else
                  {
                    $sub_total = sprintf "%.2f", $sub_total;
                  }
                  if ($sub_total < 0)
                  {
                    $sub_total *= -1;
                    if ($data_precision == 1)
                    {
                      $sub_total = sprintf "%.2f", $sub_total;
                    }
                    else
                    {
                      $sub_total = sprintf "%.0f", $sub_total;
                    }
                    $sub_total = commify($sub_total);
                    $string .= "<font color=red>$intro_str(" . $sub_total . ")$end_str";
                    $sub_total *= -1;
                  }
                  else
                  {
                    $sub_total = commify($sub_total);
                    $string .= "$intro_str" . $sub_total . "&nbsp;&nbsp;$end_str";
                  }
                  $string .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" if ($sub_count2 < scalar $sub_acct_names[$year_count-1]);
                  $sub_acct_temp_str .= "<td width=$width% align=right>&nbsp;$string</td>";
                }
                $sub_acct_temp_str .= "</tr></table>";
                print "        sublist$count2.addItem(\"$sub_acct_temp_str\", -1);\n";
                $num_list_entries++;
              }
              if (length $sub_acct_names[0][$sub_count2] > 0)
              {
                $sub_acct_temp_str = $table_str . "<tr><td width=40% align=left>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$sub_acct_names[0][$sub_count2]</td>";
                for ($year_count=1; $year_count <= $num_columns; $year_count++)
                {
                  my $string = "<br>";
                  my $width = int (60 / $num_columns);
                  my $start_date = "date" . $year_count . "_start";
                  $$start_date = $input{$start_date};
                  my $end_date = "date" . $year_count . "_stop";
                  $$end_date = $input{$end_date};

                  my $sub_total = "0.00";

                  # find the total of all entries that this sub account had for the year in question.
                  my ($yy);
                  for ($yy=0; $yy < $Acct_Data[$sub_count][3+$year_count-1][3]; $yy++)
                  {
                    if ($Acct_Data[$sub_count][3+$year_count-1][4][$yy][8] eq $sub_acct_names[$year_count-1][$sub_count2])
                    {
                      my $debit_increases = $Data[$i][2];
                      my $dorc = $Acct_Data[$sub_count][3+$year_count-1][4][$yy][7];
                      #print "//Debit Increases = $debit_increases and DORC = $dorc for Entry #$yy, Sub Acct = '$sub_acct_names[$year_count-1][$sub_count2]'\n";
                      if ($debit_increases eq "t" && $dorc eq "t") # debit increases and amount is a debit
                      {
                        $sub_total += $Acct_Data[$sub_count][3+$year_count-1][4][$yy][6];
                      }
                      elsif ($debit_increases eq "t" && $dorc eq "f") # debit increases and amount is a credit
                      {
                        $sub_total -= $Acct_Data[$sub_count][3+$year_count-1][4][$yy][6];
                      }
                      elsif ($debit_increases eq "f" && $dorc eq "t") # debit decreases and amount is a debit
                      {
                        $sub_total -= $Acct_Data[$sub_count][3+$year_count-1][4][$yy][6];
                      }
                      elsif ($debit_increases eq "f" && $dorc eq "f") # debit decreases and amount is a credit
                      {
                        $sub_total += $Acct_Data[$sub_count][3+$year_count-1][4][$yy][6];
                      }
                    }
                  }
                  if ($Reverse_Value[$i] && $sub_total != 0)
                  {
                    $sub_total *= -1;
                  }
                  if ($data_precision > 1)
                  {
                    $sub_total /= $data_precision;
                    $sub_total = sprintf "%.0f", $sub_total;
                  }
                  else
                  {
                    $sub_total = sprintf "%.2f", $sub_total;
                  }
                  my ($intro_str, $end_str);
                  if ($sub_count2 == $num_sub_accts - 1)  # see if we need to underline this entry.
                  {
                    my ($space_str, $y, $length);
                    $length = length commify($sub_total);
                    if ($sub_total < 0)
                    {
                      $length++;  # take into account the () and no - sign.
                    }
                    for ($y=0; $y < $line_length - $length; $y++)
                    {
                      $space_str .= "&nbsp;";
                    }
                    $intro_str = "<u>$space_str";
                    $end_str = "</u>";
                  }
                  else
                  {
                    $intro_str = "";
                    $end_str = "";
                  }
                  $sub_acct_names[$year_count-1][$sub_count2] = "____" if ($sub_acct_names[$year_count-1][$sub_count2] eq "----");
                  $string = "<a href='javascript:display_entries($number,$acct_num,\\\"$$start_date\\\",\\\"$$end_date\\\",\\\"$sub_acct_names[$year_count-1][$sub_count2]\\\");'>";
                  if ($sub_total < 0)
                  {
                    $sub_total *= -1;
                    if ($data_precision == 1)
                    {
                      $sub_total = sprintf "%.2f", $sub_total;
                    }
                    else
                    {
                      $sub_total = sprintf "%.0f", $sub_total;
                    }
                    $sub_total = commify($sub_total);
                    $string .= "<font color=red>$intro_str(" . $sub_total . ")$end_str";
                    $sub_total *= -1;
                  }
                  else
                  {
                    $sub_total = commify($sub_total);
                    $string .= "$intro_str" . $sub_total . "&nbsp;&nbsp;$end_str";
                  }
                  $string .= "</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" if ($sub_count2 < scalar $sub_acct_names[$year_count-1]);
                  $sub_acct_temp_str .= "<td width=$width% align=right>&nbsp;$string</td>";
                }
                $sub_acct_temp_str .= "</tr></table>";
                print "        sublist$count2.addItem(\"$sub_acct_temp_str\", -1);\n";
                $num_list_entries++;
       	      }
            }
            print "      sublist$count.addList(sublist$count2, \"$acct_temp_str\", $sub_count);\n";
            $num_list_entries++;
            print "      sublist$count.addItem(\"$acct_total_str\", -1);\n";
            $num_list_entries++;
          }
          else
          { # we just display the total line without the word Total
            $acct_total_str =~ s/Total//;
            print "      sublist$count.addItem(\"$acct_total_str\", $sub_count);\n";
            $num_list_entries++;
          }
        }
        print "    mylist.addList(sublist$count, \"$temp_str\", $js_array_index);\n";
        $js_array_index++;
        $num_list_entries++;
        print "    mylist.addItem(\"$total_str\", -1);\n";
        $num_list_entries++;
      }
      else
      {  # no accounts to work with
        $total_str =~ s/Total//;
        print "    mylist.addItem(\"$total_str\", $js_array_index);\n";
        $js_array_index++;
        $num_list_entries++;
      }
      if ($i == 18) # changed the 16 to 17
      {
        my $error_found = 0;
        # make sure that the Ending Cash Balance - Beginning Cash Balance = Increase (Decrease) in Cash
        for ($z=0; $z < $num_columns; $z++)
        {
          $temp_str = $table_str . "<tr><td width=40% align=left><br></td>";
          #print "// Ending Cash Balance = $Data[$i][4][$z]\n";
          #print "// Beginning Cash Balance = $beginning_cash_balance[$z]\n";
          #print "// Increase in Cash = $increase_in_cash[$z]\n";
          #my $test_var = $beginning_cash_balance[$z] + $increase_in_cash[$z];
          my $test_var = $increase_in_cash[$z];
          $test_var = sprintf "%.2f", $test_var;
          $Data[$i][4][$z] = sprintf "%.2f", $Data[$i][4][$z];
          if ($Data[$i][4][$z] != $test_var)
          {
            my $width = int (60 / $num_columns);
            $temp_str .= "<td width=$width% align=right><b>Cash Does Not Balance!</b></td>";
            $error_found = 1;
          }
          else
          {
            my $width = int (60 / $num_columns);
            $temp_str .= "<td width=$width% align=right><br></td>";
          }
        }
        $temp_str .= "</tr></table>";
        if ($error_found)
        {
          print "    mylist.addItem(\"$temp_str\", -1);\n";
          $num_list_entries++;
        }
      }
   }

    print << "JAVA_CODE";
    mylist.build(width/8,100);
  }

JAVA_CODE
  print "</script>\n";
}

sub reports4CashFlowValidate
{
  $report_name = "Cash Flow";
  # check and make sure we have the settings needed.
  # see how many reports we are doing in parallel
  $num_columns = $input{'columns'};
  if ($num_columns < 1 || $num_columns > 4)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid number of columns specified!</h1>\n";
    print "Currently it is only valid to select between 1 and 4.<br>$sys_admin";
    CleanUp();
  }
  my ($i);
  for ($i=1; $i <= $num_columns; $i++)
  {
    my $temp = "date" . $i . "_start";
    $$temp = $input{$temp};
    if (length $$temp == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a date for $temp!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (not ($$temp =~ /^\d{1,2}\/\d{1,2}\/(\d\d|\d\d\d\d)$/ || $$temp =~ /^\d{1,2}-\d{1,2}-(\d\d|\d\d\d\d)$/))
    {
      PrintErrorHeader();
      print "<h1>Error:  The Date specified in $temp is not a valid date!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $temp = "date" . $i . "_stop";
    $$temp = $input{$temp};
    if (length $$temp == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a date for $temp!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (not ($$temp =~ /^\d{1,2}\/\d{1,2}\/(\d\d|\d\d\d\d)$/ || $$temp =~ /^\d{1,2}-\d{1,2}-(\d\d|\d\d\d\d)$/))
    {
      PrintErrorHeader();
      print "<h1>Error:  The Date specified in $temp is not a valid date!</h1>\n";
      print "$back_button";
      CleanUp();
    }
  }
  # see if we are displaying all accounts.
  #$all_accounts = $input{'all_accounts'};
  #if (length $all_accounts == 0)
  #{
  #  PrintErrorHeader();
  #  print "<h1>Error:  You must specify that you do or do not want to Display All Accounts!</h1>\n";
  #  print "$back_button";
  #  CleanUp();
  #}
  #if (not ($all_accounts eq "YES" || $all_accounts eq "NO"))
  #{
  #  PrintErrorHeader();
  #  print "<h1>Error:  Invalid value for All Accounts!</h1>\n";
  #  print "Value given is '$all_accounts'.<br>$sys_admin";
  #  CleanUp();
  #}
  $date_range_string = ""; # each balance sheet report includes the date.

  # check and see if they want to display by Sub-Entities or not.
  if (not exists $input{'show_by_sub_entities'})
  {
    PrintErrorHeader();
    print "<h1>Error:  Show by Sub-Entities must be set!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
  $show_by_sub_entities = $input{'show_by_sub_entities'};
  if (not ($show_by_sub_entities eq "YES" || $show_by_sub_entities eq "NO"))
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid value set for Show by Sub-Entities!</h1>\n";
    print "Value set was '$show_by_sub_entities'.<br>$sys_admin";
    CleanUp();
  }
  $show_by_sub_entities = ($show_by_sub_entities eq "YES" ? 1:0);
}

return 1;
