#$Id: reports_helpers.pm,v 1.1 2001/09/06 10:21:20 moreejt Exp $
#This package is released under the GNU General Public License.
#You should have recieved a copy of the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.
# BalanceSheetReport
# Input:  Date, Account Number, DebitIncreases
# Output: The resulting balance from the last balance to the date specified for the account is returned.
sub BalanceSheetReport
{
  my $trans_date = @_[0];
  my $account_num = @_[1];
  my $debit_increases = @_[2];
  my $acct_balance = "0.00";
  my ($temp_bal, $temp_date);
  $temp_date = "Never";

  # find the last acct_bal_tb entry that is before the specified date and use that as the beginning balance.
  # if none is found, then the beginning balance is 0.00
  my $result = $conn->exec("select balance, bal_date from acct_bal_tb where acct_num = $account_num and bal_date <= '$trans_date' AND ledger_code = '$ledger_code' order by bal_date desc");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<br></td></tr></table></td></tr></table>\n"; # close the inner and outer tables.
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get starting balance for Account = '$account_num', Date = '$trans_date'.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples > 0)
  {
    $acct_balance = $result->getvalue(0, 0);
    $acct_balance =~ s/^\$//;
    $acct_balance =~ s/,//g;
    $temp_date = $result->getvalue(0, 1);

    #print "Beginning balance for Account Number = '$account_num' is '$acct_balance' on $temp_date<br>\n";

    if (not $temp_date eq $trans_date)
    {
      $result = $conn->exec("select amount, dorc from debitcredit_tb where account_num = $account_num and parent_num in (select ref_num from journal_entry_tb where trans_date between '$temp_date' and '$trans_date' AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        print "<br></td></tr></table></td></tr></table>\n"; # close the inner and outer tables.
        print "<h1>Error:  Accessing database failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to get transactions for Account = '$account_num', Start Date = '$temp_date', Stop Date = '$trans_date'.<br>$sys_admin";
        CleanUp();
      }
      if ($result->ntuples > 0)
      {
        my ($j, $amount, $dorc);
        for ($j=0; $j < $result->ntuples; $j++)
        {
          $amount = $result->getvalue($j, 0);
          $amount =~ s/^\$//;  # remove the $
          $amount =~ s/,//g;
          $dorc = $result->getvalue($j, 1);

          if ($debit_increases eq "t" && $dorc eq "t") # debit increases and amount is a debit
          {
            $acct_balance += $amount;
          }
          elsif ($debit_increases eq "t" && $dorc eq "f") # debit increases and amount is a credit
          {
            $acct_balance -= $amount;
          }
          elsif ($debit_increases eq "f" && $dorc eq "t") # debit decreases and amount is a debit
          {
            $acct_balance -= $amount;
          }
          elsif ($debit_increases eq "f" && $dorc eq "f") # debit decreases and amount is a credit
          {
            $acct_balance += $amount;
          }
        }
      }
    }
  }
  else # lookup entries
  {
    $result = $conn->exec("select amount, dorc from debitcredit_tb where account_num = $account_num and parent_num in (select ref_num from journal_entry_tb where trans_date <= '$trans_date' AND ledger_code = '$ledger_code') AND ledger_code = '$ledger_code'");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      print "<br></td></tr></table></td></tr></table>\n"; # close the inner and outer tables.
      print "<h1>Error:  Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to get transactions for Account = '$account_num', Date = '$trans_date'.<br>$sys_admin";
      CleanUp();
    }
    if ($result->ntuples > 0)
    {
      my ($j, $amount, $dorc);
      for ($j=0; $j < $result->ntuples; $j++)
      {
        $amount = $result->getvalue($j, 0);
        # cut the $ off the front.
        $amount =~ s/^\$//;
        $amount =~ s/,//g;
        $dorc = $result->getvalue($j, 1);

        if ($debit_increases eq "t" && $dorc eq "t") # debit increases and amount is a debit
        {
          $acct_balance += $amount;
        }
        elsif ($debit_increases eq "t" && $dorc eq "f") # debit increases and amount is a credit
        {
          $acct_balance -= $amount;
        }
        elsif ($debit_increases eq "f" && $dorc eq "t") # debit decreases and amount is a debit
        {
          $acct_balance -= $amount;
        }
        elsif ($debit_increases eq "f" && $dorc eq "f") # debit decreases and amount is a credit
        {
          $acct_balance += $amount;
        }
      }
    }
  }

  $acct_balance = sprintf "%.2f", $acct_balance;
  $acct_balance =~ s/ +$//;  # remove any spaces from the end of the string.

  return $acct_balance;
}

# doIncomeStatement
#    Takes  : SubEntity array [Code, Name], Date Range Array [the start and end dates for the 4 columns], String with Indexes of the Opened Lists to display, # of dates to display, taxable flag, printable flag, show Income Tax Expense flag, Type of Income Statement to display
#    Returns: Array of Net Incomes calculated or 0.00 if non-taxable.
sub doIncomeStatement
{
  my @SubEntity;
  my @Dates;
  my $num_dates;
  my $taxable;
  my $printable;
  my $lists_opened;
  my %lists_opened = ();
  my $show_income_tax_expense;
  my @AccountTypes = (); #( 9, 10, 14, 11, 12, 13, 16, 15 );  # This is in the order to display so that Sales Revenue and COGS go together and Income Tax comes after Depreciation/Depletion.
  my @AccountTypeNames = ();  # This will hold the Names of all Account Types we are working with.
  my @NetIncome = ( "0.00", "0.00", "0.00", "0.00" );
  my @PrintStack = ();  # The Array to hold the list of items to be displayed.
  my $report_type = "";

  if (defined $_[0])
  {
    @SubEntity = @{$_[0]};
    shift;
  }
  else
  {
    print "You must specify the Sub Entity to work with!<br>$sys_admin";
    CleanUp();
  }

  if (defined $_[0])
  {
    @Dates = @{$_[0]};
    shift;
  }
  else
  {
    print "You must specify the Dates to work with!<br>$sys_admin";
    CleanUp();
  }

  if (defined $_[0])
  {
    $num_dates = shift;
  }
  else
  {
    print "You must specify how many Dates to work with!<br>$sys_admin";
    CleanUp();
  }

  if (defined $_[0])
  {
    $lists_opened = shift;
    foreach my $temp (split /,/, $lists_opened)
    {
      $lists_opened{$temp} = $temp; # insert each index into the hash for future lookup.
    }
  }
  else
  {
    print "You must specify the opened lists to re-display!<br>$sys_admin";
    CleanUp();
  }

  if (defined $_[0])
  {
    $taxable = shift;
  }
  else
  {
    print "You must specify the Taxable Flag!<br>$sys_admin";
    CleanUp();
  }

  if (defined $_[0])
  {
    $printable = shift;
  }
  else
  {
    print "You must specify the Printable Flag!<br>$sys_admin";
    CleanUp();
  }

  if (defined $_[0])
  {
    $show_income_tax_expense = shift;
  }
  else
  {
    print "You must specify the Show Income Tax Expense Flag!<br>$sys_admin";
    CleanUp();
  }

  if (defined $_[0])
  {
    $report_type = shift;
    if ($report_type ne "services" && $report_type ne "investment")
    {
      print "Invalid Report Type specified!<br>Report Type = '$report_type'.<br>$sys_admin";
      CleanUp();
    }
  }
  else
  {
    print "You must specify the Income Statement Report type to display!<br>$sys_admin";
    CleanUp();
  }

  # define the table header string that each list item will need.
  my $table_str = "<table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor='$body_bgcolor'>";
  my $temp_str;  # this string is used to store most of what gets displayed.
  my $total_str;  # this string is used to store the Account Type entry that displays the Total value for the Account Type.
  my @localAccounts;  # array of all accounts to work with.
  my (@total_revenue, @admin_expenses, @ebitda, @depreciation, @net_income_before_depreciation, @net_income_before_taxes, @income_tax, @net_income, @gross_profit, @total_operating_income, @other_rev_exp, @investment_income_total, @investment_expense_total);

  # setup the Goods&Services and Investments Account Type ordering scheme for this report.
  if ($report_type eq "services")
  {
    @AccountTypes = ( 10, 14, 13, 9, 11, 12, 8, 18, 16, 15 );
  }
  elsif ($report_type eq "investment")
  {
    @AccountTypes = ( 11, 12, 8, 13, 18, 9, 10, 14, 16, 15 );
  }

  # See if we need to print a Sub Entity Header (only if a taxable report)
  if ($SubEntity[0] != -2 && $taxable)
  { # we need to print a SubEntity header.
    if ($printable)
    {
      print "<tr><td>$table_str<tr><td width=100% align=left><font face='$font_str' size=$font_size_text><h2>Sub Entity = ";
      if ($SubEntity[0] eq "" && $SubEntity[1] eq "")
      {
        print "<i>None</i>";
      }
      else
      {
        print "$SubEntity[1]";
      }
      print "</h2></font></td></tr></table></td></tr>\n";
    }
    else
    {
      $temp_str = $table_str . "<tr><td width=100% align=left><font face='$font_str'><h2>Sub Entity = ";
      if ($SubEntity[0] eq "" && $SubEntity[1] eq "")
      {
        $temp_str .= "<i>None</i>";
      }
      else
      {
        $temp_str .= "$SubEntity[1]";
      }
      $temp_str .= "</h2></font></td></tr></table>";
      print "    mylist.addItem(\"$temp_str\", -1);\n";
      $num_list_entries++;
    }
  }

  # See if we need to print the Non-Taxable block header
  if (not $taxable)
  {
    if ($printable)
    {
      print "<tr><td>$table_str<tr><td width=100% align=left><font face='$font_str' size=$font_size_text><h3>Non-Taxable</h3></font></td></tr></table></td></tr>\n";
    }
    else
    {
      $temp_str = $table_str . "<tr><td width=100% align=left><font face='$font_str'><h3>Non-Taxable</h3></font></td></tr></table>";
      print "    mylist.addItem(\"$temp_str\", -1);\n";
      $num_list_entries++;
    }

    #@AccountTypes = ( 9, 11, 12, 13, 16, 15 ); # redefine the Account Types so that only Revenues and Expenses are displayed
    if ($report_type eq "services")
    {
      @AccountTypes = ( 13, 9, 11, 12, 8, 18, 16, 15 );
    }
    elsif ($report_type eq "investment")
    {
      @AccountTypes = ( 11, 12, 8, 13, 18, 9, 16, 15 );
    }
  } # end of the Non-Taxable Header block

  # Get the Names of the Account Types we are working with.
  @AccountTypeNames = $report_obj->GetAccountTypeNames(\@AccountTypes);
  if ($report_obj->didErrorOccur)
  {
    if (not $printable)
    {
      print "</script></head><body bgcolor=#ffffff>\n";
    }
    print $report_obj->getErrorMessage;
    CleanUp();
  }

  # Get the local Accounts for the Account Types specified.
  if ($taxable)
  {
    @localAccounts = $report_obj->GetLocalAccounts(\@AccountTypes, 1);
  }
  else
  {
    @localAccounts = $report_obj->GetLocalAccounts(\@AccountTypes, 2);
  }
  if ($report_obj->didErrorOccur)
  {
    if (not $printable)
    {
      print "</script></head><body bgcolor=#ffffff>\n";
    }
    print $report_obj->getErrorMessage;
    CleanUp();
  }
  # sort the Accounts for each Account Type based upon the users criteria: name-number or number-name
  my @SortedAccounts = ();
  for (my $i=0; $i < scalar @localAccounts; $i++)
  {
    if ($show_accounts_as) # name-number
    {
      @SortedAccounts = map { [ $_->[0], $_->[1], $_->[2] ] } sort { $a->[2] cmp $b->[2] || $a->[0] <=> $b->[0] } map { [ $_->[0], $_->[1], $_->[2] ] } @{$localAccounts[$i]};
    }
    else  # number-name
    {
      @SortedAccounts = map { [ $_->[0], $_->[1], $_->[2] ] } sort { $a->[0] <=> $b->[0] || $a->[2] cmp $b->[2] } map { [ $_->[0], $_->[1], $_->[2] ] } @{$localAccounts[$i]};
    }
    $localAccounts[$i] = [ @SortedAccounts ];
  }

  my ($i, @subEntity, @AccountActivity, @AccountTypeTotal, @AccountTypeEntries, $start_date, $end_date, $k, $j);

  # initialize all the arrays needed to store the different calculations throughout the report.
  for ($k=0; $k < $num_dates; $k++)
  {
    $total_revenue[$k] = "0.00";
    $admin_expenses[$k] = "0.00";
    $ebitda[$k] = "0.00";
    $depreciation[$k] = "0.00";
    $net_income_before_taxes[$k] = "0.00";
    @net_income_before_depreciation[$k] = "0.00";
    $income_tax[$k] = "0.00";
    $net_income[$k] = "0.00";
    $total_operating_income[$k] = "0.00";
    $other_rev_exp[$k] = "0.00";
    $investment_income_total[$k] = "0.00";
    $investment_expense_total[$k] = "0.00";
    $gross_profit[$k] = "0.00";
  }

  for ($k=0; $k < $max_columns; $k++)
  {
    $AccountTypeTotal[$k] = "0.00";
    $AccountTypeEntries[$k] = 0;
  }

  # now we get the Account activity for each Account Type and display the results.
  $subEntity[0] = [ @SubEntity ];  # massage the Sub Entity array to fit the needs for GetSubEntityAccountActivity function.
  LOOP: for ($i=0; $i < scalar @localAccounts; $i++)
  {
    @PrintStack = ();
    # Make sure that we aren't trying to Display the Income Tax entry if the user doesn't want us to.
    if ($AccountTypes[$i] == 15)  # this will work for both types of Income Statements.
    {
      # if we don't calculate NetIncomeBeforeTaxes, then the NetIncome calculation is messed up!
      for ($k=0; $k < $num_dates; $k++)
      {
        my $net_income_before_taxes = $net_income_before_depreciation[$k] + $depreciation[$k];
        #$net_income_before_taxes /= $data_precision;  # massage the data into the correct precision
        if ($data_precision == 1)
        {
          $net_income_before_taxes = sprintf "%.2f", $net_income_before_taxes;
        }
        else
        {
          $net_income_before_taxes = sprintf "%.0f", $net_income_before_taxes;
        }
        $net_income_before_taxes[$k] = $net_income_before_taxes;
      }
      if ((not $show_income_tax_expense) && $taxable)
      {
        #print "<br>Breaking out early!<br>\n";
        next LOOP;
      }
      if (not $taxable)
      {
        #print "<br>Printing Net Income B4 Depreciation/Depletion!<br>\n";
        #goto DISPLAY_NET_INCOME_B4_DEPRECIATION;
        next LOOP;
      }
    }

    for ($k=0; $k < $num_dates; $k++)
    {
      # get the dates to work with.
      $start_date = $Dates[$k][0];
      $end_date   = $Dates[$k][1];

      #print "<br>Start Date = '$start_date', End Date = '$end_date'<br>\n";

      # See if we need to do a SubEntity Account Activity search or a normal search
      if ($SubEntity[0] == -2)
      { # Normal search
        my @temp = $report_obj->AccountActivity(\@{$localAccounts[$i]}, $start_date, $end_date);
        @AccountActivity[$k] = [ @temp ];
      }
      else
      { # Sub Entity search
        my @temp = $report_obj->SubEntityAccountActivity(\@subEntity, \@{$localAccounts[$i]}, $start_date, $end_date);
        @AccountActivity[$k] = [ @temp ];
      }
      if ($report_obj->didErrorOccur)
      {
        if (not $printable)
        {
          print "</script></head><body bgcolor=#ffffff>\n";
        }
        print $report_obj->getErrorMessage;
        CleanUp();
      }
      $AccountTypeTotal[$k] = 0;
      $AccountTypeEntries[$k] = 0;
      if ($SubEntity[0] == -2)  # normal search results
      {
        for ($j=0; $j < scalar @{$AccountActivity[$k]}; $j++)
        {
          my $amount = $AccountActivity[$k][$j][0];
          if ($AccountTypes[$i] == 13 || $AccountTypes[$i] == 14 || $AccountTypes[$i] == 15 || $AccountTypes[$i] == 16 || $AccountTypes[$i] == 18)
          {  # these expenses need to be negated so that I can just add them to the totals and have everything work out correctly.
            if ($amount != 0)
            {
              $amount *= -1;
            }
          }
          $AccountTypeTotal[$k] += $amount;

          # these account types are consitent between the different types of reports.
          if ($AccountTypes[$i] == 10 || $AccountTypes[$i] == 14) # Gross Profit = Sales Revenue - COGS
          {
            $gross_profit[$k] += $amount;
          }
          if ($AccountTypes[$i] == 15)  # Income Tax
          {
            $income_tax[$k] += $amount;
          }
          if ($AccountTypes[$i] == 16) # Depreciation/Depletion
          {
            $depreciation[$k] += $amount;
          }

          # report specific groupings.
          if ($report_type eq "services")
          {
            if ($AccountTypes[$i] == 13) # Admin Expenses
            {
              $admin_expenses[$k] += $amount;
            }
            if ($AccountTypes[$i] == 8 || $AccountTypes[$i] == 9 || $AccountTypes[$i] == 11 || $AccountTypes[$i] == 12 || $AccountTypes[$i] == 18)
            { # other revenues and expenses
              $other_rev_exp[$k] += $amount;
            }
          }
          elsif ($report_type eq "investment")
          {
            if ($AccountTypes[$i] == 8 || $AccountTypes[$i] == 11 || $AccountTypes[$i] == 12)
            { # investment total income
              $investment_income_total[$k] += $amount;
            }
            if ($AccountTypes[$i] == 13 || $AccountTypes[$i] == 18)
            { # investment total expenses
              $investment_expense_total[$k] += $amount;
            }
            if ($AccountTypes[$i] == 9)
            { # total revenue
              $total_revenue[$k] += $amount;
            }
          }

          $AccountTypeEntries[$k] += $AccountActivity[$k][$j][1];
        }
      }
      else # Sub Entity
      {
        #for ($j=0; $j < scalar @{$AccountActivity[$k][0][1]}; $j++)
        #{
          my $amount = $AccountActivity[$k][0][0];
          if ($AccountTypes[$i] == 13 || $AccountTypes[$i] == 14 || $AccountTypes[$i] == 15 || $AccountTypes[$i] == 16 || $AccountTypes[$i] == 18)
          {  # these expenses need to be negated so that I can just add them to the totals and have everything work out correctly.
            if ($amount != 0)
            {
              $amount *= -1;
            }
          }
          $AccountTypeTotal[$k] += $amount;

          # these account types are consitent between the different types of reports.
          if ($AccountTypes[$i] == 10 || $AccountTypes[$i] == 14) # Gross Profit = Sales Revenue - COGS
          {
            $gross_profit[$k] += $amount;
          }
          if ($AccountTypes[$i] == 15)  # Income Tax
          {
            $income_tax[$k] += $amount;
          }
          if ($AccountTypes[$i] == 16) # Depreciation/Depletion
          {
            $depreciation[$k] += $amount;
          }

          # report specific groupings.
          if ($report_type eq "services")
          {
            if ($AccountTypes[$i] == 13) # Admin Expenses
            {
              $admin_expenses[$k] += $amount;
            }
            if ($AccountTypes[$i] == 8 || $AccountTypes[$i] == 9 || $AccountTypes[$i] == 11 || $AccountTypes[$i] == 12 || $AccountTypes[$i] == 18)
            { # other revenues and expenses
              $other_rev_exp[$k] += $amount;
            }
          }
          elsif ($report_type eq "investment")
          {
            if ($AccountTypes[$i] == 8 || $AccountTypes[$i] == 11 || $AccountTypes[$i] == 12)
            { # investment total income
              $investment_income_total[$k] += $amount;
            }
            if ($AccountTypes[$i] == 13 || $AccountTypes[$i] == 18)
            { # investment total expenses
              $investment_expense_total[$k] += $amount;
            }
            if ($AccountTypes[$i] == 9)
            { # total revenue
              $total_revenue[$k] += $amount;
            }
          }

          $AccountTypeEntries[$k] += $AccountActivity[$k][0][2];
        #}
      }
      $AccountTypeTotal[$k] /= $data_precision;  # massage the data into the correct precision
      $AccountTypeTotal[$k] = sprintf "%.2f", $AccountTypeTotal[$k];
      $gross_profit[$k] = sprintf "%.2f", $gross_profit[$k];
      if ($report_type eq "investment")
      {
        $total_revenue[$k] = sprintf "%.2f", $total_revenue[$k];
        $investment_expense_total[$k] = sprintf "%.2f", $investment_expense_total[$k];
        $investment_income_total[$k] = sprintf "%.2f", $investment_income_total[$k];
      }
      elsif ($report_type eq "services")
      {
        $admin_expenses[$k] = sprintf "%.2f", $admin_expenses[$k];
        $other_rev_exp[$k] = sprintf "%.2f", $other_rev_exp[$k];
      }
      $income_tax[$k] = sprintf "%.2f", $income_tax[$k];
      $depreciation[$k] = sprintf "%.2f", $depreciation[$k];
    } # end of dates for loop.

    # Now we check to see if we need to display this item's header.
    # If Activity for all date ranges = "0.00" and number of entries == 0 and show_zero_balances then display entry
    # Else if Activity = "0.00" and number of entries == 0 and not show_zero_balances then don't display entry
    # Else display entry.
    my ($display) = 0;
    if ($AccountTypeTotal[0] eq "0.00" && $AccountTypeTotal[1] eq "0.00" && $AccountTypeTotal[2] eq "0.00" && $AccountTypeTotal[3] eq "0.00")
    {
      if ($AccountTypeEntries[0] == 0 && $AccountTypeEntries[1] == 0 && $AccountTypeEntries[2] == 0 && $AccountTypeEntries[3] == 0)
      {
        if ($show_zero_balances)
        {
          $display = 1;
        }
      }
      else
      {
        $display = 1;
      }
    }
    else
    {
      $display = 1;  # it is okay to display this Account Type's info.
    }

    # see if we need to display the Gross Profit entry
    if ($AccountTypes[$i-1] == 14) # The last entry was COGS
    {
      if ($printable)
      {
        $total_str = "<tr><td>$table_str<tr><td width=$text_width% align=left><font face='$font_str' size=$font_size_text><b>Gross Profit</b></font></td>";
      }
      else
      {
        $total_str = $table_str . "<tr><td width=$text_width% align=left><b>Gross Profit</b></td>";
      }
      for ($k=0; $k < $max_columns; $k++)
      {
        my $width = ($data_width / $max_columns);
        $total_str .= "<td width=$width% align=right><b>";
        if ($k < $num_dates)
        {
          my $gross_profit = $gross_profit[$k];
          $gross_profit /= $data_precision;  # massage the data into the correct precision
          if ($data_precision == 1)
          {
            $gross_profit = sprintf "%.2f", $gross_profit;
          }
          else
          {
            $gross_profit = sprintf "%.0f", $gross_profit;
          }
          my $balance = $gross_profit;
          if ($balance < 0)
          {
            $balance *= -1;
            if ($data_precision > 1)
            {
              $balance = sprintf "%.0f", $balance;
            }
            else
            {
              $balance = sprintf "%.2f", $balance;
            }
          }
          my ($intro_str, $end_str);
          if ($report_type eq "investment" && !$printable)
          {
            $intro_str = "<u>" . getSpaceString($AccountTypeTotal[$k], $line_length);
            $end_str = "</u>";
          }
          $total_str .= "<font face='$font_str'";
          if ($printable)
          {
            $total_str .= " size=$font_size_data";
          }
          $total_str .= "><code><font face='$font_str'";
          if ($gross_profit < 0)
          {
            $total_str .= " color=red";
          }
          $total_str .= ">$intro_str";
          if ($gross_profit < 0)
          {
            $total_str .= "(";
          }
          $total_str .= commify($balance);
          if ($gross_profit < 0)
          {
            $total_str .= ")";
          }
          $total_str .= "$end_str</font></code>";
          if ($gross_profit >= 0)
          {
            $total_str .= "&nbsp;";
          }
          $total_str .= "</font>";
        }
        else
        {  # we just display a <br> to fill in this columns entry.
          $total_str .= "<br>";
        }
        $total_str .= "</b></td>";
      }
      $total_str .= "</tr></table>";
      if ($printable)
      {
        $total_str .= "</td></tr>\n";
        print $total_str;
      }
      else
      {
        print "    mylist.addItem(\"$total_str\", -1);\n";
        $num_list_entries++;
      }

      # display an underline if this is an Investment Report
      if ($report_type eq "investment" && $printable)
      {
        my $acct_temp_str = "";
        $acct_temp_str = "<tr><td>" . $table_str . "<tr><td width=$text_width% align=left><br></td>";
        for ($k=0; $k < $max_columns; $k++)
        {
          my $width = ($data_width / $max_columns);
          $acct_temp_str .= "<td width=$width% align=right>";
          if ($k < $num_dates)
          {
            $acct_temp_str .= "<hr noshade align=right width=$uline_length>"; # underline the 10 spaces, 6 pixels per space
          }
          else
          {
            $acct_temp_str .= "<br>";
          }
          $acct_temp_str .= "</td>";
        }
        $acct_temp_str .= "</tr></table>";
        $acct_temp_str .= "</td></tr>\n";

        print $acct_temp_str;
      }
    }

    # see if we need to display the Total Revenue entry
    if ($AccountTypes[$i-1] == 13 && $report_type eq "services") # The Admin Expenses are displayed, now display Total Operating Income header
    {
      if ($printable)
      {
        $total_str = "<tr><td>$table_str<tr><td width=$text_width% align=left><font face='$font_str' size=$font_size_text><b>Total Operating Income</b></font></td>";
      }
      else
      {
        $total_str = $table_str . "<tr><td width=$text_width% align=left><b>Total Operating Income</b></td>";
      }
      for ($k=0; $k < $max_columns; $k++)
      {
        my $width = ($data_width / $max_columns);
        $total_str .= "<td width=$width% align=right><b>";
        if ($k < $num_dates)
        {
          $admin_expenses[$k] /= $data_precision;
          if ($data_precision == 1)
          {
            $admin_expenses[$k] = sprintf "%.2f", $admin_expenses[$k];
          }
          else
          {
            $admin_expenses[$k] = sprintf "%.0f", $admin_expenses[$k];
          }

          $total_operating_income[$k] = $gross_profit[$k] + $admin_expenses[$k];
          if ($data_precision == 1)
          {
            $total_operating_income[$k] = sprintf "%.2f", $total_operating_income[$k];
          }
          else
          {
            $total_operating_income[$k] = sprintf "%.0f", $total_operating_income[$k];
          }
          my $balance = $total_operating_income[$k];
          if ($balance < 0)
          {
            $balance *= -1;
            if ($data_precision > 1)
            {
              $balance = sprintf "%.0f", $balance;
            }
            else
            {
              $balance = sprintf "%.2f", $balance;
            }
          }
          my ($intro_str, $end_str);
          $total_str .= "<font face='$font_str'";
          if ($printable)
          {
            $total_str .= " size=$font_size_data";
          }
          $total_str .= "><code><font face='$font_str'";
          if ($total_operating_income[$k] < 0)
          {
            $total_str .= " color=red";
          }
          $total_str .= ">$intro_str";
          if ($total_operating_income[$k] < 0)
          {
            $total_str .= "(";
          }
          $total_str .= commify($balance);
          if ($total_operating_income[$k] < 0)
          {
            $total_str .= ")";
          }
          $total_str .= "$end_str</font></code>";
          if ($total_operating_income[$k] >= 0)
          {
            $total_str .= "&nbsp;";
          }
          $total_str .= "</font>";
        }
        else
        {  # we just display a <br> to fill in this columns entry.
          $total_str .= "<br>";
        }
        $total_str .= "</b></td>";
      }
      $total_str .= "</tr></table>";
      if ($printable)
      {
        $total_str .= "</td></tr>\n";
        print $total_str;
      }
      else
      {
        print "    mylist.addItem(\"$total_str\", -1);\n";
        $num_list_entries++;
      }
    }

    # see if we need to display the Net Income Before Depreciation/Depletion entry
    if ($AccountTypes[$i] == 16)
    {
DISPLAY_NET_INCOME_B4_DEPRECIATION: if ($printable)
      {
        $total_str = "<tr><td>$table_str<tr><td width=$text_width% align=left><font face='$font_str' size=$font_size_text><b>Net Income Before Depr/Depl</b></font></td>";
      }
      else
      {
        $total_str = $table_str . "<tr><td width=$text_width% align=left><b>Net Income Before Depr/Depl</b></td>";
      }
      for ($k=0; $k < $max_columns; $k++)
      {
        my $width = ($data_width / $max_columns);
        $total_str .= "<td width=$width% align=right><b>";
        if ($k < $num_dates)
        {
          if ($report_type eq "services")
          {
            my $other_rev_exp = $other_rev_exp[$k] / $data_precision;
            if ($data_precision == 1)
            {
              $other_rev_exp = sprintf "%.2f", $other_rev_exp;
            }
            else
            {
              $other_rev_exp = sprintf "%.0f", $other_rev_exp;
            }
            $net_income_before_depreciation[$k] = $total_operating_income[$k] + $other_rev_exp;
          }
          elsif ($report_type eq "investment")
          {
            $net_income_before_depreciation[$k] = $investment_income_total[$k] + $investment_expense_total[$k] + $total_revenue[$k] + $gross_profit[$k];
            $net_income_before_depreciation[$k] /= $data_precision;  # massage the data into the correct precision
          }
          if ($data_precision == 1)
          {
            $net_income_before_depreciation[$k] = sprintf "%.2f", $net_income_before_depreciation[$k];
          }
          else
          {
            $net_income_before_depreciation[$k] = sprintf "%.0f", $net_income_before_depreciation[$k];
          }
          my $balance = $net_income_before_depreciation[$k];
          if ($balance < 0)
          {
            $balance *= -1;
            if ($data_precision > 1)
            {
              $balance = sprintf "%.0f", $balance;
            }
            else
            {
              $balance = sprintf "%.2f", $balance;
            }
          }
          $total_str .= "<font face='$font_str'";
          if ($printable)
          {
            $total_str .= " size=$font_size_data";
          }
          $total_str .= "><code><font face='$font_str'";
          if ($net_income_before_depreciation[$k] < 0)
          {
            $total_str .= " color=red";
          }
          $total_str .= ">";
          if ($net_income_before_depreciation[$k] < 0)
          {
            $total_str .= "(";
          }
          $total_str .= commify($balance);
          if ($net_income_before_depreciation[$k] < 0)
          {
            $total_str .= ")";
          }
          $total_str .= "</font></code>";
          if ($net_income_before_depreciation[$k] >= 0)
          {
            $total_str .= "&nbsp;";
          }
          $total_str .= "</font>";
        }
        else
        {  # we just display a <br> to fill in this columns entry.
          $total_str .= "<br>";
        }
        $total_str .= "</b></td>";
      }
      $total_str .= "</tr></table>";
      if ($printable)
      {
        $total_str .= "</td></tr>\n";
        print $total_str;
      }
      else
      {
        print "    mylist.addItem(\"$total_str\", -1);\n";
        $num_list_entries++;
      }
    }

    # see if we need to display the EBIT value
    if ($AccountTypes[$i] == 15 && $taxable)
    {  # EBIT = Net Income B4 Taxes
      if ($printable)
      {
        $total_str = "<tr><td>$table_str<tr><td width=$text_width% align=left><font face='$font_str' size=$font_size_text><b>Net Income Before Taxes</b></font></td>";
      }
      else
      {
        $total_str = $table_str . "<tr><td width=$text_width% align=left><b>Net Income Before Taxes</b></td>";
      }
      for ($k=0; $k < $max_columns; $k++)
      {
        my $width = ($data_width / $max_columns);
        $total_str .= "<td width=$width% align=right><b>";
        if ($k < $num_dates)
        {
          $depreciation[$k] /= $data_precision;
          if ($data_precision == 1)
          {
            $depreciation[$k] = sprintf "%.2f", $depreciation[$k];
          }
          else
          {
            $depreciation[$k] = sprintf "%.0f", $depreciation[$k];
          }
          $net_income_before_taxes[$k] = $net_income_before_depreciation[$k] + $depreciation[$k];
          my $balance = $net_income_before_taxes[$k];
          if ($balance < 0)
          {
            $balance *= -1;
          }

          if ($data_precision > 1)
          {
            $balance = sprintf "%.0f", $balance;
          }
          else
          {
            $balance = sprintf "%.2f", $balance;
          }

          $total_str .= "<font face='$font_str'";
          if ($printable)
          {
            $total_str .= " size=$font_size_data";
          }
          $total_str .= "><code><font face='$font_str'";
          if ($net_income_before_taxes[$k] < 0)
          {
            $total_str .= " color=red";
          }
          $total_str .= ">";
          if ($net_income_before_taxes[$k] < 0)
          {
            $total_str .= "(";
          }
          $total_str .= commify($balance);
          if ($net_income_before_taxes[$k] < 0)
          {
            $total_str .= ")";
          }
          $total_str .= "</font></code>";
          if ($net_income_before_taxes[$k] >= 0)
          {
            $total_str .= "&nbsp;";
          }
          $total_str .= "</font>";
        }
        else
        {  # we just display a <br> to fill in this columns entry.
          $total_str .= "<br>";
        }
        $total_str .= "</b></td>";
      }
      $total_str .= "</tr></table>";
      if ($printable)
      {
        $total_str .= "</td></tr>\n";
        print $total_str;
      }
      else
      {
        print "    mylist.addItem(\"$total_str\", -1);\n";
        $num_list_entries++;
      }
    }

    my $AccountPrinted = 0;
    if ($display)
    { # Display the Account Type Entry and related info.
      # start the header for the Account Type name
      if ($printable)
      {
        $temp_str = "<tr><td>$table_str<tr><td width=$text_width% align=left>";
      }
      else
      {
        $temp_str = $table_str . "<tr><td width=$text_width% align=left>";
      }

      # see if we are a Sales Revenue value or a COGS value
      if ($AccountTypes[$i] == 10 || $AccountTypes[$i] == 14)
      {
        $temp_str .= "&nbsp;&nbsp;&nbsp;";
      }

      # finish the header for the Account Type name
      $temp_str .= "<font face='$font_str'";
      if ($printable)
      {
        $temp_str .= " size=$font_size_text";
      }
      $temp_str .= ">";
      $temp_str .= $AccountTypeNames[$i];
      $total_str = $temp_str . "&nbsp;Total</font></td>";
      $temp_str .= "</td>";

      # just handle normally now.

      # create the Total string with the totals for this Account Type.
      for ($k=0; $k < $max_columns; $k++)
      {
        my $width = ($data_width / $max_columns);
        $total_str .= "<td width=$width% align=right>";
        if ($k < $num_dates)
        {
          my $balance = $AccountTypeTotal[$k];
          if ($data_precision == 1)
          {
            $balance = sprintf "%.2f", $balance;
          }
          else
          {
            $balance = sprintf "%.0f", $balance;
          }
          if ($balance < 0)
          {
            $balance *= -1;
            if ($data_precision > 1)
            {
              $balance = sprintf "%.0f", $balance;
            }
            else
            {
              $balance = sprintf "%.2f", $balance;
            }
          }
          my ($intro_str, $end_str);
          # see if we need to underline this total as it is a Revenue, Expense, Depreciation/Depletion, Income Tax Total, or COGS Expense and not printable.
          if ($AccountTypes[$i] == 14 || $AccountTypes[$i] == 15 || $AccountTypes[$i] == 16)
          {
            $intro_str = "<u>" . getSpaceString($AccountTypeTotal[$k], $line_length);
            $end_str = "</u>";
          }
          if ($report_type eq "services")
          {
            if ($AccountTypes[$i] == 13 || $AccountTypes[$i] == 18)
            {
              $intro_str = "<u>" . getSpaceString($AccountTypeTotal[$k], $line_length);
              $end_str = "</u>";
            }
          }
          elsif ($report_type eq "investment")
          {
            if (!$taxable && $AccountTypes[$i] == 9)
            {
              $intro_str = "<u>" . getSpaceString($AccountTypeTotal[$k], $line_length);
              $end_str = "</u>";
            }
          }
          $total_str .= "<font face='$font_str'";
          if ($printable)
          {
            $total_str .= " size=$font_size_data";
          }
          if ($AccountTypeTotal[$k] < 0)
          {
            $total_str .= " color=red";
          }
          $total_str .= "><code>";
          if (not $printable)
          {
            $total_str .= "$intro_str";
          }
          if ($AccountTypeTotal[$k] < 0)
          {
            $total_str .= "(";
          }
          $total_str .= commify($balance);
          if ($AccountTypeTotal[$k] < 0)
          {
            $total_str .= ")";
          }
          if (not $printable)
          {
            $total_str .= "$end_str";
          }
          $total_str .= "</code>";
          if ($AccountTypeTotal[$k] >= 0)
          {
            $total_str .= "&nbsp;";
          }
          $total_str .= "</font>";
        }
        else
        {  # we just display a <br> to fill in this columns entry.
          $total_str .= "<br>";
        }
        $total_str .= "</td>";
        $temp_str .= "<td width=$width% align=right><br></td>";  # make the Header string equal the Total string minus the totals.
      }
      $total_str .= "</tr></table>";
      $temp_str .= "</tr></table>";
      if ($printable)
      {
        $total_str .= "</td></tr>";
        $temp_str .= "</td></tr>";
      }

      # now we display any Accounts that exist for this Account Type
      #print "<tr><td>Before display Accounts</td></tr>\n";
      if (scalar @{$localAccounts[$i]}> 0)
      {
        my $count = $num_sub_lists++;
        my $print_AccountList = 0;
        #print "<tr><td>We are in the Display Accounts loop.</td></tr>\n";

        # now we go through all accounts for this Account Type and create their lists or entries
        my ($sub_count, $acct_name, $acct_num, $acct_temp_str, $acct_total_str, $debit_increases);
        for ($sub_count=0; $sub_count < scalar @{$localAccounts[$i]}; $sub_count++)
        {
          $acct_name = $localAccounts[$i][$sub_count][2];
          $acct_num  = $localAccounts[$i][$sub_count][0];
          $debit_increases = $localAccounts[$i][$sub_count][1];
          #print "<tr><td>Working with Account ($acct_name) = $acct_num</td></tr>\n";
          # make sure this Account's activity != 0 and if so, see what the user wants to do.
          my ($display_account) = 0;
          for ($k=0; $k < $num_dates; $k++)
          {
            if ($SubEntity[0] == -2)
            {
              if (not $AccountActivity[$k][$sub_count][0] eq "0.00")
              {
                $display_account = 1;
              }
            }
            else
            {
              if (not $AccountActivity[$k][0][1][$sub_count][0] eq "0.00")  # have to index into the SubEntity Account array first.
              {
                $display_account = 1;
              }
            }
          }
          if (not $display_account)
          {
            #print "//Checking to see if there is activity since we have all \"0.00\"'s.\n";
            my ($account_num) = 0;
            for ($k=0; $k < $num_dates; $k++)
            {
              if ($SubEntity[0] == -2)
              {
                #print "// Normal - $acct_name has '".$AccountActivity[$k][$sub_count][1]."' entries.\n";
                if ($AccountActivity[$k][$sub_count][1] > 0)
                {
                  $account_num = 1;
                }
              }
              else
              {
                #print "//$acct_name has '$AccountActivity[$k][$sub_count][2]' entries.\n";
                if ($AccountActivity[$k][0][1][$sub_count][1] > 0)
                {
                  $account_num = 1;
                }
              }
            }
            if (not $account_num && $show_zero_balances)
            {
              $display_account = 1;
            }
          }
          if ($display_account)
          {
            my @SubAcctPrintStack = ();
            #print "<tr><td>We are displaying Account ($acct_name).</td></tr>\n";
            # Generate the acct_temp_str and acct_total_str values
            $acct_temp_str = $acct_total_str = "";
            if ($printable)
            {
              $acct_temp_str = "<tr><td>";
              $acct_total_str = "<tr><td>";
            }
            my $acct_string = "";
            if ($show_accounts_as)
            { # name - number
              $acct_string = $acct_name . " - " . $acct_num;
            }
            else
            { # number - name
              $acct_string = $acct_num . " - " . $acct_name;
            }
            # see if we are a Sales Revenue value or a COGS value
            my $my_temp_str = "<font face='$font_str'";
            if ($printable)
            {
              $my_temp_str .= " size=$font_size_text";
            }
            $my_temp_str .= ">";
            if ($AccountTypes[$i] == 10 || $AccountTypes[$i] == 14)
            {
              $my_temp_str .= "&nbsp;&nbsp;&nbsp;";
            }
            $acct_temp_str .= "$table_str<tr><td width=$text_width% align=left>&nbsp;&nbsp;$my_temp_str$acct_string</font>";
            $acct_total_str .= "$table_str<tr><td width=$text_width% align=left>&nbsp;&nbsp;$my_temp_str$acct_string" . " Total</font>";
            $acct_temp_str .= "</td>";
            $acct_total_str .= "</td>";

            # see if this Account has any entries to display, and if so, how many sub-accounts to work with
            my ($has_accts) = 0;
            for ($k=0; $k < $num_dates; $k++)
            {
              if ($SubEntity[0] == -2)
              {
                #print "//$acct_name has '$AccountActivity[$k][$sub_count][1]' entries.\n";
                if ($AccountActivity[$k][$sub_count][1] > 0)
                { # This account has some activity
                  $has_accts = 1;
                }
              }
              else
              {
                #print "//$acct_name has '$AccountActivity[$k][$sub_count][2]' entries.\n";
                if ($AccountActivity[$k][0][1][$sub_count][1] > 0)
                { # This account has some activity
                  $has_accts = 1;
                }
              }
            }
            for ($k=0; $k < $max_columns; $k++)
            {
              my $width = ($data_width / $max_columns);
              $acct_total_str .= "<td width=$width% align=right>";
              if ($k < $num_dates)
              {
                my $acct_total = "0.00";
                if ($SubEntity[0] == -2)
                {
                  $acct_total = $AccountActivity[$k][$sub_count][0];
                }
                else
                {
                  $acct_total = $AccountActivity[$k][0][1][$sub_count][0];
                }
                if ($AccountTypes[$i] == 13 || $AccountTypes[$i] == 14 || $AccountTypes[$i] == 15 || $AccountTypes[$i] == 16 || $AccountTypes[$i] == 18)
                {  # these expenses need to be negated so that I can just add them to the totals and have everything work out correctly.
                  if ($acct_total != 0)
                  {
                    $acct_total *= -1;
                    if ($SubEntity[0] == -2)
                    {
                      $AccountActivity[$k][$sub_count][0] = $acct_total;
                    }
                    else
                    {
                      $AccountActivity[$k][0][1][$sub_count][0] = $acct_total;
                    }
                  }
                }
                $acct_total /= $data_precision;
                if ($data_precision == 1)
                {
                  $acct_total = sprintf "%.2f", $acct_total;
                }
                else
                {
                  $acct_total = sprintf "%.0f", $acct_total;
                }
                if ($acct_total < 0)
                {
                  $acct_total *= -1;
                  if ($data_precision == 1)
                  {
                    $acct_total = sprintf "%.2f", $acct_total;
                  }
                  else
                  {
                    $acct_total = sprintf "%.0f", $acct_total;
                  }
                }
                $acct_total_str .= "<font face='$font_str'";
                if ($printable)
                {
                  $acct_total_str .= " size=$font_size_data";
                }
                if ($SubEntity[0] == -2)
                {
                  if ($AccountActivity[$k][$sub_count][0] < 0)
                  {
                    $acct_total_str .= " color=red";
                  }
                }
                else
                {
                  if ($AccountActivity[$k][0][1][$sub_count][0] < 0)
                  {
                    $acct_total_str .= " color=red";
                  }
                }
                $acct_total_str .= "><code>";
                if ($SubEntity[0] == -2)
                {
                  if ($AccountActivity[$k][$sub_count][0] < 0)
                  {
                    $acct_total_str .= "(";
                  }
                }
                else
                {
                  if ($AccountActivity[$k][0][1][$sub_count][0] < 0)
                  {
                    $acct_total_str .= "(";
                  }
                }
                $acct_total_str .= commify($acct_total);
                if ($SubEntity[0] == -2)
                {
                  if ($AccountActivity[$k][$sub_count][0] < 0)
                  {
                    $acct_total_str .= ")";
                  }
                }
                else
                {
                  if ($AccountActivity[$k][0][1][$sub_count][0] < 0)
                  {
                    $acct_total_str .= ")";
                  }
                }
                $acct_total_str .= "</code>";
                if ($SubEntity[0] == -2)
                {
                  if ($AccountActivity[$k][$sub_count][0] >= 0)
                  {
                    $acct_total_str .= "&nbsp;";
                  }
                }
                else
                {
                  if ($AccountActivity[$k][0][1][$sub_count][0] >= 0)
                  {
                    $acct_total_str .= "&nbsp;";
                  }
                }
                $acct_total_str .= getSpaceString('', 4);
                $acct_total_str .= "</font>";
              }
              else
              {
                $acct_total_str .= "<br>";
              }
              $acct_total_str .= "</td>";
            }

            # finish the Account Name and Total strings
            $acct_total_str .= "</tr></table>";
            $acct_temp_str .= "</tr></table>";
            if ($printable)
            {
              $acct_total_str .= "</td></tr>\n";
              $acct_temp_str .= "</td></tr>\n";
            }

            if ($has_accts)
            {
              #print "//This account has activity!\n";
              # Check for any Sub Accounts to work with and make sure we have something to display before we display the Account Header
              my @temp = [ @{$localAccounts[$i][$sub_count]} ];
              my @sub_accts = $report_obj->GetSubAccounts(\@temp);
              if ($report_obj->didErrorOccur)
              {
                if (not $printable)
                {
                  print "</script></head><body bgcolor=#ffffff>\n";
                }
                print $report_obj->getErrorMessage;
                CleanUp();
              }

              my @Entry = ( -1, "<i>Other</i>" );
              $sub_accts[0][ scalar @{$sub_accts[0]} ] = [ @Entry ];

              # sort the sub-accounts by name-number or number-name.
              my @temp_array2 = ();
              if ($show_accounts_as) # name-number
              {
                @temp_array2 = map { [ $_->[0], $_->[1] ] } sort { $a->[1] cmp $b->[1] || $a->[0] <=> $b->[0] } map { [ $_->[0], $_->[1] ] } @{$sub_accts[0]};
              }
              else # number-name
              {
                @temp_array2 = map { [ $_->[0], $_->[1] ] } sort { $a->[0] <=> $b->[0] || $a->[1] cmp $b->[1] } map { [ $_->[0], $_->[1] ] } @{$sub_accts[0]};
              }
              $sub_accts[0] = [ @temp_array2 ];

              my $count2 = $num_sub_lists++;

              # Get all Sub Account Activity and decide if we have at least 1 non-zero value to show, so that we can create the
              # account list and display the sub-accounts.
              my $display_sub_acct = 0;
              my $sub_acct_created = 0; # signal to indicate if the sub_acct list has been created yet.
              my @sub_acct_activity;
              for ($k=0; $k < $num_dates; $k++)
              {
                # get the dates to work with.
                $start_date = $Dates[$k][0];
                $end_date   = $Dates[$k][1];

                my @temp = [ @{$localAccounts[$i][$sub_count]} ];
                #print "SubAccountActivity:  # of Accounts = " . int (scalar @temp) . ", Name ($temp[0][2]) = $temp[0][0]\n";
                if ($SubEntity[0] == -2)
                {
                  @temp = $report_obj->SubAccountActivity(\@temp, \@sub_accts, $start_date, $end_date);
                }
                else
                {
                  @temp = $report_obj->SubEntitySubAccountActivity(\@subEntity, \@temp, \@sub_accts, $start_date, $end_date);
                }
                @sub_acct_activity[$k] = [ @temp ];
                if ($report_obj->didErrorOccur)
                {
                  if (not $printable)
                  {
                    print "</script></head><body bgcolor=#ffffff>\n";
                  }
                  print $report_obj->getErrorMessage;
                  CleanUp();
                } # Report Module Error!
                my ($z);
                #print "Loop $k had " . int (scalar @{$sub_acct_activity[$k]}) . " account entries returned for sub-accounts";
                if ($SubEntity[0] == -2) # normal
                {
                  for ($z=0; $z < scalar @{$sub_acct_activity[$k][0][1]}; $z++)
                  {
                    # see if we are to display this entry.
                    if ($sub_acct_activity[$k][0][1][$z][0] eq "0.00")
                    {
                      if ($sub_acct_activity[$k][0][1][$z][1] > 0)
                      {
                        $display_sub_acct = 1;
                      }
                      elsif ($show_zero_balances)
                      {
                        $display_sub_acct = 1;
                      }
                    }
                    else
                    {
                      $display_sub_acct = 1;
                    }
                  } # end of loop to check and see if there are any sub-accts that have data to display
                }
                else # SubEntity
                {
                  #print "// There are " . int (scalar @{$sub_acct_activity[$k][0][1][0][1]}) . " sub accounts.\n";
                  for ($z=0; $z < scalar @{$sub_acct_activity[$k][0][1][0][1]}; $z++)
                  {
                    # see if we are to display this entry.
                    #print "// The value of column $k's $z sub-account is $sub_acct_activity[$k][0][1][0][1][$z][0].  The number of entries is $sub_acct_activity[$k][0][1][0][1][$z][1].\n";
                    if ($sub_acct_activity[$k][0][1][0][1][$z][0] eq "0.00")
                    {
                      if ($sub_acct_activity[$k][0][1][0][1][$z][1] > 0)
                      {
                        $display_sub_acct = 1;
                      }
                      elsif ($show_zero_balances)
                      {
                        $display_sub_acct = 1;
                      }
                    }
                    else
                    {
                      $display_sub_acct = 1;
                    }
                  } # end of loop to check and see if there are any sub-accts that have data to display
                }
              } # end of loop to get all Sub Account Activity for the date ranges specified.

              if ($display_sub_acct)  # we have some sub-accounts to display
              {
                #print "We are in Display_Sub_Acct loop.";
                # loop through all the subaccounts and for each one that has data or if show_zero_balances is on,
                # display the sub-account name and the activity for each date range
                my ($sub_count2, $sub_acct_temp_str, $intro_str, $end_str, $z);
                for ($sub_count2=0; $sub_count2 < scalar @{$sub_accts[0]}; $sub_count2++)
                {
                  # see if we should display this value
                  my ($y, $show_this_sub_acct);
                  for ($y=0, $show_this_sub_acct=0; $y < $num_dates; $y++)
                  {
                    if ($SubEntity[0] == -2)
                    {
                      if (not $sub_acct_activity[$y][0][1][$sub_count2][0] eq "0.00")
                      {
                        $show_this_sub_acct = 1;
                      }
                    }
                    else # SubEntity
                    {
                      if (not $sub_acct_activity[$y][0][1][0][1][$sub_count2][0] eq "0.00")
                      {
                        $show_this_sub_acct = 1;
                      }
                    }
                  } # end of the check to display this sub-acct or not.
                  if (not $show_this_sub_acct)
                  {
                    if ($SubEntity[0] == -2)
                    {
                      my ($yy);
                      for ($yy=0; $yy <= $y; $yy++)
                      {
                        if ($sub_acct_activity[$yy][0][1][$sub_count2][1] > 0)
                        {
                          $show_this_sub_acct = 1;
                        }
                      }
                    }
                    else # SubEntity
                    {
                      my ($yy);
                      for ($yy=0; $yy <= $y; $yy++)
                      {
                        if ($sub_acct_activity[$yy][0][1][0][1][$sub_count2][1] > 0)
                        {
                          $show_this_sub_acct = 1;
                        }
                      }
                    }
                    if ((not $show_this_sub_acct) && $show_zero_balances)
                    {
                      $show_this_sub_acct = 1;
                    }
                  }
                  if ($show_this_sub_acct)
                  {
                    #print "We are displaying sub-acct $sub_accts[0][$sub_count2][1]";
                    if ($printable)
                    {
                      $sub_acct_temp_str = "<tr><td>";
                    }
                    else
                    {
                      $sub_acct_temp_str = "";
                    }
                    my $space_str = getSpaceString('', 6);
                    if ($AccountTypes[$i] == 10 || $AccountTypes[$i] == 14)
                    {
                      $space_str .= "&nbsp;&nbsp;&nbsp;";
                    }
                    $sub_acct_temp_str .= $table_str . "<tr><td width=$text_width% align=left><font face='$font_str'";
                    if ($printable)
                    {
                      $sub_acct_temp_str .= " size=$font_size_text";
                    }
                    $sub_acct_temp_str .= ">$space_str" . $sub_accts[0][$sub_count2][1] . "</font></td>";
                    for ($z=0; $z < $max_columns; $z++)
                    {
                      my $width = ($data_width / $max_columns);
                      if ($z < $num_dates)
                      {
                        my $sub_acct_total;
                        my $really_display = 1;
                        if ($SubEntity[0] == -2)
                        {
                          $sub_acct_total = $sub_acct_activity[$z][0][1][$sub_count2][0];
                          if ($sub_acct_total eq "0.00" && $sub_acct_activity[$z][0][1][$sub_count2][1] == 0)
                          {
                            $really_display = 0;
                          }
                        }
                        else
                        {
                          $sub_acct_total = $sub_acct_activity[$z][0][1][0][1][$sub_count2][0];
                          if ($sub_acct_total eq "0.00" && $sub_acct_activity[$z][0][1][0][1][$sub_count2][1] == 0)
                          {
                            $really_display = 0;
                          }
                        }
                        if ($AccountTypes[$i] == 13 || $AccountTypes[$i] == 14 || $AccountTypes[$i] == 15 || $AccountTypes[$i] == 16 || $AccountTypes[$i] == 18)
                        {  # these expenses need to be negated so that I can just add them to the totals and have everything work out correctly.
                          if ($sub_acct_total != 0)
                          {
                            $sub_acct_total *= -1;
                            if ($SubEntity[0] == -2)
                            {
                              $sub_acct_activity[$z][0][1][$sub_count2][0] = $sub_acct_total;
                            }
                            else
                            {
                              $AccountActivity[$z][0][1][0][1][$sub_count2][0] = $sub_acct_total;
                            }
                          }
                        }
                        my $string = "<font face='$font_str'";
                        if ($printable)
                        {
                          $string .= " size=$font_size_data";
                        }
                        $string .= "><code>";
                        if ((not $printable) && $really_display)
                        {
                          if ($SubEntity[0] != -2 && length $SubEntity[1] == 0)
                          {
                            $SubEntity[1] = "<i>None</i>";
                            $SubEntity[0] = " ";
                          }
                          $string .= "<a href='javascript:display_entries' onClick='javascript:display_entries($AccountTypes[$i], $acct_num, \\\"$acct_name\\\", \\\"$debit_increases\\\", \\\"$Dates[$z][0]\\\", \\\"$Dates[$z][1]\\\", $sub_accts[0][$sub_count2][0], \\\"$sub_accts[0][$sub_count2][1]\\\", \\\"$SubEntity[0]\\\", \\\"$SubEntity[1]\\\"); return false;'>";
                          if ($SubEntity[1] eq "<i>None</i>")
                          {
                            $SubEntity[1] = "";
                            $SubEntity[0] = "";
                          }
                        }
                        $string .= "<code>";
                        $sub_acct_total /= $data_precision;
                        if ($data_precision == 1)
                        {
                          $sub_acct_total = sprintf "%.2f", $sub_acct_total;
                        }
                        else
                        {
                          $sub_acct_total = sprintf "%.0f", $sub_acct_total;
                        }
                        if ($sub_acct_total < 0)
                        {
                          $sub_acct_total *= -1;
                          if ($data_precision == 1)
                          {
                            $sub_acct_total = sprintf "%.2f", $sub_acct_total;
                          }
                          else
                          {
                            $sub_acct_total = sprintf "%.0f", $sub_acct_total;
                          }
                          $string .= "<font face='$font_str' color=red>(";
                        }
                        else
                        {
                          $string .= "<font face='$font_str' color=black>";
                        }
                        $string .= commify($sub_acct_total);
                        if ($SubEntity[0] == -2)
                        {
                          if ($sub_acct_activity[$z][0][1][$sub_count2][0] < 0)
                          {
                            $string .= ")</font>";
                          }
                          else
                          {
                            $string .= "</font>&nbsp;";
                          }
                        }
                        else # SubEntity
                        {
                          if ($sub_acct_activity[$z][0][1][0][1][$sub_count2][0] < 0)
                          {
                            $string .= ")</font>";
                          }
                          else
                          {
                            $string .= "</font>&nbsp;";
                          }
                        }
                        my $space_str = getSpaceString('', 8);
                        if ((not $printable) && $really_display)
                        {
                          $string .= "</code></a>$space_str";
                        }
                        else
                        {
                          $string .= $space_str;
                        }
                        if ($AccountTypes[$i] == 10 || $AccountTypes[$i] == 14)
                        {
                          $space_str .= "&nbsp;&nbsp;&nbsp;";
                        }
                        $string .= "</code></font>";
                        $sub_acct_temp_str .= "<td width=$width% align=right>&nbsp;$string</td>";
                      }
                      else  # this is an empty column
                      {
                        $sub_acct_temp_str .= "<td width=$width% align=right><br></td>";
                      }
                    }
                    $sub_acct_temp_str .= "</tr></table>";
                    if ($printable)
                    {
                      $sub_acct_temp_str .= "</td></tr>\n";
                      if (exists $lists_opened{$count2})
                      {
                        push @SubAcctPrintStack, $sub_acct_temp_str;
                      }
                    }
                    else
                    {
                      if (not $sub_acct_created)
                      {
                        $sub_acct_created = 1;
                        unshift @SubAcctPrintStack, "    sublist$count2 = new List(false, width, height, bgColor);\n";
                      }
                      push @SubAcctPrintStack, "      sublist$count2.addItem(\"$sub_acct_temp_str\", -1);\n";
                      $num_list_entries++;
                    }
                  }  # we have a sub-acct we can display
                  # see if we are at the end of the sub-acct list and insert an underline for all columns that have data.
                  if ($sub_count2 == scalar @{$sub_accts[0]} - 1)
                  {
                    # generate another line or list entry to display the underlines that are 13 long and extend 12 spaces from the right of each column.
                    $sub_acct_temp_str = "";
                    if ($printable)
                    {
                      $sub_acct_temp_str = "<tr><td>";
                    }
                    $sub_acct_temp_str .= $table_str . "<tr><td width=$text_width% align=left><br></td>";
                    for ($k=0; $k < $max_columns; $k++)
                    {
                      my $width = ($data_width / $max_columns);
                      if ($printable)
                      {
                        $width -= 3;
                      }
                      $sub_acct_temp_str .= "<td width=$width% align=right>";
                      if ($k < $num_dates)
                      {
                        if (not $printable)
                        {
                          my $space_str = getSpaceString('', 12);
                          $sub_acct_temp_str .= "<font face='$font_str'";
                          $sub_acct_temp_str .= "><code><u>$space_str</u></code>"; # underline the 12 spaces
                          $space_str = getSpaceString('',8);
                          $sub_acct_temp_str .= $space_str . "</font>";
                        }
                        else # printable
                        {
                          $sub_acct_temp_str .= "<hr noshade align=right width=$uline_length>";
                        }
                      }
                      else
                      {
                        $sub_acct_temp_str .= "<br>";
                      }
                      $sub_acct_temp_str .= "</td>";
                      if ($printable)
                      {
                        $width = 3;
                        $sub_acct_temp_str .= "<td width=$width align=right>&nbsp;</td>";
                      }
                    }
                    $sub_acct_temp_str .= "</tr></table>";
                    if ($printable)
                    {
                      $sub_acct_temp_str .= "</td></tr>\n";
                    }
                    # display the underline!
                    if ($printable)
                    {
                      push @SubAcctPrintStack, "$sub_acct_temp_str";
                    }
                    else
                    {
                      push @SubAcctPrintStack, "    sublist$count2.addItem(\"$sub_acct_temp_str\", 0);\n";
                      $num_list_entries++;
                    }
                  }
                } # end of loop to walk through all sub-accounts returned for the current account.
              } # end of display subaccounts
              # now display the list if not a printable report
              if (not $printable)
              {
                if (not $sub_acct_created)
                {
                  $sub_acct_created = 1;
                  push @PrintStack, "    sublist$count = new List(false, width, height, bgColor);\n";
                }
                my ($zz, $temp);
                for ($zz=0; $zz < scalar @SubAcctPrintStack; $zz++)
                {
                  $temp = $SubAcctPrintStack[$zz];
                  push @PrintStack, $temp;
                }
                @SubAcctPrintStack = ();

                push @PrintStack, "    sublist$count.addList(sublist$count2, \"$acct_temp_str\", $count2);\n";
                $num_list_entries++;

                push @PrintStack, "    sublist$count.addItem(\"$acct_total_str\", -1);\n";
                $num_list_entries++;
              }
              else
              {
                if (exists $lists_opened{$count2})
                {
                  push @PrintStack, "$acct_temp_str";

                  my ($zz, $temp);
                  for ($zz=0; $zz < scalar @SubAcctPrintStack; $zz++)
                  {
                    $temp = $SubAcctPrintStack[$zz];
                    push @PrintStack, $temp;
                  }
                  @SubAcctPrintStack = ();

                  push @PrintStack, "$acct_total_str";
                }
                else
                {
                  $acct_total_str =~ s/Total//;
                  push @PrintStack, "$acct_total_str";
                }
                $AccountPrinted = 1;
              }
            }
            else # no entries for this account
            { # just display the Total line for this account without the word Total.
              # only display this line if show_zero_balances is true
              if ($show_zero_balances)
              {
                $acct_total_str =~ s/Total//;
                if ($printable)
                {
                  if (exists $lists_opened{$count})
                  {
                    push @PrintStack, $acct_total_str;
                    $AccountPrinted = 1;
                  }
                }
                else
                {
                  push @PrintStack, "    sublist$count.addItem(\"$acct_total_str\", $sub_count);\n";
                  $num_list_entries++;
                }
              }
            } # end of Account has entries
          } # end of Display Account because it fits the initial criteria.
          # see if we need to underline this Accounts totals
          if ($sub_count == scalar @{$localAccounts[$i]} - 1  && scalar @PrintStack > 0)
          {
            # generate another line or list entry to display the underlines that are 12 long and extend 4 spaces from the right of each column.
            $acct_temp_str = "";
            if ($printable)
            {
              $acct_temp_str = "<tr><td>";
            }
            $acct_temp_str .= $table_str . "<tr><td width=$text_width% align=left><br></td>";
            for ($k=0; $k < $max_columns; $k++)
            {
              my $width = ($data_width / $max_columns);
              if ($printable)
              {
                $width -= 1;
              }
              $acct_temp_str .= "<td width=$width% align=right>";
              if ($k < $num_dates)
              {
                if (not $printable)
                {
                  my $space_str = getSpaceString('', 12);
                  $acct_temp_str .= "<font face='$font_str'";
                  if ($printable)
                  {
                    $acct_temp_str .= " size=$font_size_text";
                  }
                  $acct_temp_str .= "><code><u>$space_str</u></code>"; # underline the 12 spaces
                  $space_str = getSpaceString('',4);
                  $acct_temp_str .= $space_str . "</font>";
                }
                else # printable version
                {
                  $acct_temp_str .= "<hr noshade align=right width=$uline_length>";
                }
              }
              else
              {
                $acct_temp_str .= "<br>";
              }
              $acct_temp_str .= "</td>";
              if ($printable)
              {
                $width = 1;
                $acct_temp_str .= "<td width=$width% align=right>&nbsp;</td>";
              }
            }
            $acct_temp_str .= "</tr></table>";
            if ($printable)
            {
              $acct_temp_str .= "</td></tr>\n";
            }
            # display the underline!
            if ($printable)
            {
              push @PrintStack, "$acct_temp_str";
            }
            else
            {
              push @PrintStack, "    sublist$count.addItem(\"$acct_temp_str\", 0);\n";
              $num_list_entries++;
            }
          } # end of underline if last entry for this account (even if we didn't display this account!)
        } # end of for loop to walk through all accounts for this Account Type.

        # display the Account Type header
        # ************************** Do pop off of stack now! *******************************************
        if ($printable)
        {
          if (scalar @PrintStack > 0 || $show_zero_balances)
          {
            if (exists $lists_opened{$count})
            {
              print "$temp_str";

              my ($temp, $ii);
              #print "There are ". int (scalar @PrintStack) . " items on the PrintStack<br>\n";
              for ($ii=0; $ii < scalar @PrintStack; $ii++)
              {
                $temp = $PrintStack[$ii];
                print $temp;
              }
              @PrintStack = ();
              print "$total_str\n";
            }
            else
            {
              $total_str =~ s/Total//;
              print "$total_str\n";
            }
          }
        }
        else
        {
          if (scalar @PrintStack > 0 || $show_zero_balances)
          {
            if (scalar @PrintStack > 0)
            {
              print "    sublist$count = new List(false, width, height, bgColor);\n";
              $num_list_entries++;

              my ($temp, $ii);
              #print "There are ". int (scalar @PrintStack) . " items on the PrintStack<br>\n";
              for ($ii=0; $ii < scalar @PrintStack; $ii++)
              {
                $temp = $PrintStack[$ii];
                print $temp;
              }
              @PrintStack = ();

              print "    mylist.addList(sublist$count, \"$temp_str\", $count);\n";
              $num_list_entries++;

              print "    mylist.addItem(\"$total_str\", 0);\n";
              $num_list_entries++;
            }
            else # just display the Total line without Total
            {
              $total_str =~ s/Total//;
              print "    mylist.addItem(\"$total_str\", 0);\n";
              $num_list_entries++;
            }
            $AccountPrinted = 1;
          }
        } # endif printing Account Type list entries.
      }
      else # no accounts for this Account Type
      {
        $total_str =~ s/Total//;
        if ($printable)
        {
          print "$total_str\n";
        }
        else
        {
          print "    mylist.addItem(\"$total_str\", 0);\n";
          $num_list_entries++;
        }
        $AccountPrinted = 1;
      } # endif no accounts for Account Type
      # see if we need to underline this total as it is a Revenue, Expense, Depreciation/Depletion, Income Tax Total, or COGS Expense and printable.
      if (($report_type eq "services" && ($AccountTypes[$i] == 13 || $AccountTypes[$i] == 18)) || ($AccountTypes[$i] == 14 || $AccountTypes[$i] == 15 || $AccountTypes[$i] == 16) || ($report_type eq "investment" && !$taxable && $AccountTypes[$i] == 9))
      {
        if ($printable)# && $AccountPrinted)
        {
          my $acct_temp_str = "";
          $acct_temp_str = "<tr><td>" . $table_str . "<tr><td width=$text_width% align=left><br></td>";
          for ($k=0; $k < $max_columns; $k++)
          {
            my $width = ($data_width / $max_columns);
            $acct_temp_str .= "<td width=$width% align=right>";
            if ($k < $num_dates)
            {
              $acct_temp_str .= "<hr noshade align=right width=$uline_length>"; # underline the 10 spaces, 6 pixels per space
            }
            else
            {
              $acct_temp_str .= "<br>";
            }
            $acct_temp_str .= "</td>";
          }
          $acct_temp_str .= "</tr></table>";
          $acct_temp_str .= "</td></tr>\n";

          print $acct_temp_str;
        }
      }
    }
  } # End loop through Account Type local Accounts and their Activities

  # Display the Net Income value and verify that everything checks out.
  # Net Income = Net Income Before Taxes + Income Tax
  if ($printable)
  {
    my $temp;
    if (not $taxable)
    {
      $temp = "Tax Free Net Income";
    }
    else
    {
      $temp = "Net Income";
    }
    $total_str = "<tr><td>$table_str<tr><td width=$text_width% align=left><font face='$font_str' size=$font_size_text><b>$temp</b></font></td>";
  }
  else
  {
    my $temp;
    if (not $taxable)
    {
      $temp = "Tax Free Net Income";
    }
    else
    {
      $temp = "Net Income";
    }
    $total_str = $table_str . "<tr><td width=$text_width% align=left><b>$temp</b></td>";
  }
  for ($k=0; $k < $max_columns; $k++)
  {
    my $width = ($data_width / $max_columns);
    $total_str .= "<td width=$width% align=right><b>";
    if ($k < $num_dates)
    {
      my $income_tax = $income_tax[$k] / $data_precision;
      if ($data_precision == 1)
      {
        $income_tax = sprintf "%.2f", $income_tax;
      }
      else
      {
        $income_tax = sprintf "%.0f", $income_tax;
      }
      my $net_income = $net_income_before_taxes[$k] + $income_tax;
      #$net_income /= $data_precision;  # massage the data into the correct precision
      if ($data_precision == 1)
      {
        $net_income = sprintf "%.2f", $net_income;
      }
      else
      {
        $net_income = sprintf "%.0f", $net_income;
      }
      $NetIncome[$k] = $net_income;
      my $balance = $net_income;
      if ($balance < 0)
      {
        $balance *= -1;
        if ($data_precision > 1)
        {
          $balance = sprintf "%.0f", $balance;
        }
        else
        {
          $balance = sprintf "%.2f", $balance;
        }
      }
      my ($intro_str, $end_str);
      $total_str .= "<font face='$font_str'><code><font face='$font_str'";
      if ($printable)
      {
        $total_str .= " size=$font_size_data";
      }
      if ($net_income < 0)
      {
        $total_str .= " color=red";
      }
      $total_str .= ">$intro_str";
      if ($net_income < 0)
      {
        $total_str .= "(";
      }
      $total_str .= commify($balance);
      if ($net_income < 0)
      {
        $total_str .= ")";
      }
      $total_str .= "$end_str</font></code>";
      if ($net_income >= 0)
      {
        $total_str .= "&nbsp;";
      }
      $total_str .= "</font>";
    }
    else
    {  # we just display a <br> to fill in this columns entry.
      $total_str .= "<br>";
    }
    $total_str .= "</b></td>";
  }
  $total_str .= "</tr></table>";
  if ($printable)
  {
    $total_str .= "</td></tr>\n";
    print $total_str;
  }
  else
  {
    print "    mylist.addItem(\"$total_str\", -1);\n";
    $num_list_entries++;
  }

  # return the NetIncome calculated
  return @NetIncome;
}

# doBalanceSheetStatement
#   Takes  : SubEntity Array
#   Takes  : Array of Dates to work with
#   Takes  : The number of columns we are actually displaying data into.
#   Takes  : If this is a detailed view (Javascript) or Print view
sub doBalanceSheetStatement
{
  my @SubEntity;
  my @Dates;
  my $num_dates;
  my $printable;
  my $lists_opened;
  my %lists_opened = ();
  my @AccountTypes = ( 0, 1, 2, 4, 3, 5, 6, 7, 17, 8, 9, 10, 11, 12, 13, 14, 15, 16, 18 );  # This is in the order to display.
  my @HeaderTypes = ( 5, 7 );  # The Account Types that trigger the end of Assets and Liabilities respectively.
  my @AccountTypeNames = ();  # This will hold the Names of all Account Types we are working with.
  my @PrintStack = ();  # The Array to hold the list of items to be displayed.

  if (defined $_[0])
  {
    @SubEntity = @{$_[0]};
    shift;
  }
  else
  {
    print "You must specify the Sub Entity to work with!<br>$sys_admin";
    CleanUp();
  }

  if (defined $_[0])
  {
    @Dates = @{$_[0]};
    shift;
  }
  else
  {
    print "You must specify the Dates to work with!<br>$sys_admin";
    CleanUp();
  }

  if (defined $_[0])
  {
    $num_dates = shift;
  }
  else
  {
    print "You must specify how many Dates to work with!<br>$sys_admin";
    CleanUp();
  }

  if (defined $_[0])
  {
    $lists_opened = shift;
    foreach my $temp (split /,/, $lists_opened)
    {
      $lists_opened{$temp} = $temp;
    }
  }
  else
  {
    print "You must specify what Lists are to be displayed!<br>$sys_admin";
    CleanUp();
  }

  if (defined $_[0])
  {
    $printable = shift;
  }
  else
  {
    print "You must specify the Printable Flag!<br>$sys_admin";
    CleanUp();
  }

  # define the table header string that each list item will need.
  my $table_str = "<table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor='$body_bgcolor'>";
  my $temp_str;  # this string is used to store most of what gets displayed.
  my $total_str;  # this string is used to store the Account Type entry that displays the Total value for the Account Type.
  my @localAccounts;  # array of all accounts to work with.
  my (@total_assets, @total_liabilities, @total_equity, @asset_book_value, @NetIncome);

  # Get the Names of the Account Types we are working with.
  @AccountTypeNames = $report_obj->GetAccountTypeNames(\@AccountTypes);
  if ($report_obj->didErrorOccur)
  {
    if (not $printable)
    {
      print "</script></head><body bgcolor=#ffffff>\n";
    }
    print $report_obj->getErrorMessage;
    CleanUp();
  }

  # Get the local Accounts for the Account Types specified.
  @localAccounts = $report_obj->GetLocalAccounts(\@AccountTypes);
  if ($report_obj->didErrorOccur)
  {
    if (not $printable)
    {
      print "</script></head><body bgcolor=#ffffff>\n";
    }
    print $report_obj->getErrorMessage;
    CleanUp();
  }

  my ($i, @subEntity, @AccountActivity, @AccountTypeTotal, @AccountTypeEntries, $start_date, $end_date, $k, $j);
  # AccountActivity should be called AccountBalance

  # initialize all the arrays needed to store the different calculations throughout the report.
  for ($k=0; $k < $num_dates; $k++)
  {
    $total_assets[$k] = "0.00";
    $total_liabilities[$k] = "0.00";
    $total_equity[$k] = "0.00";
    $asset_book_value[$k] = "0.00";
    $NetIncome[$k] = "0.00";
  }

  # now we get the Account Balances for each Account Type and display the results.
  $subEntity[0] = [ @SubEntity ];  # massage the Sub Entity array to fit the needs for GetSubEntityAccountActivity function.
  LOOP: for ($i=0; $i < scalar @localAccounts; $i++)
  {
    @PrintStack = ();

    # see if this is the first time thru.  If so, display the Assets header entry.
    if ($i == 0)
    {
      if ($printable)
      {
        $total_str = "<tr><td>$table_str<tr><td width=$text_width% align=left><font face='$font_str' size=$font_size_text><b>Assets</b></font></td>";
      }
      else
      {
        $total_str = $table_str . "<tr><td width=$text_width% align=Left><b>Assets</b></td>";
      }
      for ($k=0; $k < $max_columns; $k++)
      {
        my $width = ($data_width / $max_columns);
        $total_str .= "<td width=$width% align=right>&nbsp;</td>";
      }
      $total_str .= "</tr></table>";
      if ($printable)
      {
        $total_str .= "</td></tr>\n";
        print $total_str;
      }
      else
      {
        print "    mylist.addItem(\"$total_str\", -1);\n";
        $num_list_entries++;
      }
    }

    # reset the AccountTypeTotal and Entries arrays to 0
    for ($k=0; $k < $max_columns; $k++)
    {
      $AccountTypeTotal[$k] = "0.00";
      $AccountTypeEntries[$k] = 0;
    }

    for ($k=0; $k < $num_dates; $k++)
    {
      # get the dates to work with.
      $start_date = $Dates[$k][0];
      $end_date   = $Dates[$k][1];

      #print "<br>Start Date = '$start_date', End Date = '$end_date'<br>\n";

      # See if we need to do a SubEntity Account Balance search or a normal search (The SubEntity Balance routine will need to be created if this is desired!)
      if ($SubEntity[0] == -2)
      { # Normal search
        my @temp = $report_obj->GetAccountBalances(\@{$localAccounts[$i]}, $end_date);
        @AccountActivity[$k] = [ @temp ];
      }
      else
      { # Sub Entity search
        my @temp = $report_obj->GetSubEntityAccountBalances(\@subEntity, \@{$localAccounts[$i]}, $end_date);
        @AccountActivity[$k] = [ @temp ];
      }
      if ($report_obj->didErrorOccur)
      {
        if (not $printable)
        {
          print "</script></head><body bgcolor=#ffffff>\n";
        }
        print $report_obj->getErrorMessage;
        CleanUp();
      }
      $AccountTypeTotal[$k] = 0;
      $AccountTypeEntries[$k] = 0;
      if ($SubEntity[0] == -2)  # normal search results
      {
        for ($j=0; $j < scalar @{$AccountActivity[$k]}; $j++)
        {
          $AccountTypeTotal[$k] += $AccountActivity[$k][$j][0];
          if ($AccountTypes[$i] < 4)
          {
            $total_assets[$k] += $AccountActivity[$k][$j][0];  # keep track of total assets
          }
          elsif ($AccountTypes[$i] == 4)  # Contra Assets get subtracted
          {
            $total_assets[$k] -= $AccountActivity[$k][$j][0];  # keep track of total assets
            $asset_book_value[$k] -= $AccountActivity[$k][$j][0];
          }
          elsif ($AccountTypes[$i] >= 5 && $AccountTypes[$i] <= 6)
          {
            $total_liabilities[$k] += $AccountActivity[$k][$j][0];  # keep track of total liabilities
          }
          if (($AccountTypes[$i] >= 7 && $AccountTypes[$i] <= 12) && $AccountTypes[$i] != 16)
          {
            $total_equity[$k] += $AccountActivity[$k][$j][0];  # keep track of total equity
            if ($AccountTypes[$i] != 7)
            {
              $NetIncome[$k] += $AccountActivity[$k][$j][0];
            }
          }
          if (($AccountTypes[$i] >= 13 && $AccountTypes[$i] <= 18) || $AccountTypes[$i] == 16)
          {
            $total_equity[$k] -= $AccountActivity[$k][$j][0];  # keep track of total equity
            $NetIncome[$k] -= $AccountActivity[$k][$j][0];
          }
          if ($AccountTypes[$i] == 2)
          {
            $asset_book_value[$k] += $AccountActivity[$k][$j][0];
          }
          $AccountTypeEntries[$k] += $AccountActivity[$k][$j][1];
        }
      }
      else # Sub Entity ---- Change this block when the time comes if ever.
      {
        #for ($j=0; $j < scalar @{$AccountActivity[$k][0][1]}; $j++)
        #{
          $AccountTypeTotal[$k] += $AccountActivity[$k][0][0];
          if ($AccountTypes[$i] < 13 && $AccountTypes[$i] != 10)
          {
            #$total_revenue[$k] += $AccountActivity[$k][0][0];  # keep track of total revenue
          }
          elsif ($AccountTypes[$i] == 13)
          {
            #$total_expenses[$k] += $AccountActivity[$k][0][0];  # keep track of total expenses
          }
          if ($AccountTypes[$i] == 10)
          {
            #$sales_revenue[$k] += $AccountActivity[$k][0][0];  # keep track of sales revenue total
          }
          if ($AccountTypes[$i] == 14)
          {
            #$COGS[$k] += $AccountActivity[$k][0][0];  # keep track of COGS total
          }
          if ($AccountTypes[$i] == 15)  # Income Tax
          {
            #$income_tax[$k] += $AccountActivity[$k][0][0];  # keep track of Income Tax total
          }
          if ($AccountTypes[$i] == 16) # Depreciation/Depletion
          {
            #$depreciation[$k] += $AccountActivity[$k][0][0];  # keep track of Depreciation/Depletion total
          }
          $AccountTypeEntries[$k] += $AccountActivity[$k][0][2];
        #}
      }
      $AccountTypeTotal[$k] /= $data_precision;  # massage the data into the correct precision
      $AccountTypeTotal[$k] = sprintf "%.2f", $AccountTypeTotal[$k];
      $total_assets[$k] = sprintf "%.2f", $total_assets[$k];
      $total_liabilities[$k] = sprintf "%.2f", $total_liabilities[$k];
      $total_equity[$k] = sprintf "%.2f", $total_equity[$k];
      $asset_book_value[$k] = sprintf "%.2f", $asset_book_value[$k];
      $NetIncome[$k] = sprintf "%.2f", $NetIncome[$k];
    } # end of dates for loop.

    # Now we check to see if we need to display this item's header.
    # If Activity for all date ranges = "0.00" and number of entries == 0 and show_zero_balances then display entry
    # Else if Activity = "0.00" and number of entries == 0 and not show_zero_balances then don't display entry
    # Else display entry.
    my ($display) = 0;
    if ($AccountTypeTotal[0] eq "0.00" && $AccountTypeTotal[1] eq "0.00" && $AccountTypeTotal[2] eq "0.00" && $AccountTypeTotal[3] eq "0.00")
    {
      if ($AccountTypeEntries[0] == 0 && $AccountTypeEntries[1] == 0 && $AccountTypeEntries[2] == 0 && $AccountTypeEntries[3] == 0)
      {
        if ($show_zero_balances)
        {
          $display = 1;
        }
      }
      else
      {
        $display = 1;
      }
    }
    else
    {
      $display = 1;  # it is okay to display this Account Type's info.
    }

    # see if we need to display the Total Assets entry and the Liabilities Header entry.
    if ($AccountTypes[$i] == $HeaderTypes[0])
    {
      if ($printable)
      {
        $total_str = "<tr><td>$table_str<tr><td width=$text_width% align=right><font face='$font_str' size=$font_size_text><b>Assets Total</b></font></td>";
      }
      else
      {
        $total_str = $table_str . "<tr><td width=$text_width% align=right><b>Assets Total</b></td>";
      }
      for ($k=0; $k < $max_columns; $k++)
      {
        my $width = ($data_width / $max_columns);
        $total_str .= "<td width=$width% align=right><b>";
        if ($k < $num_dates && $num_dates > 1)
        {
          $total_assets[$k] /= $data_precision;  # massage the data into the correct precision
          if ($data_precision == 1)
          {
            $total_assets[$k] = sprintf "%.2f", $total_assets[$k];
          }
          else
          {
            $total_assets[$k] = sprintf "%.0f", $total_assets[$k];
          }
          my $balance = $total_assets[$k];
          if ($balance < 0)
          {
            $balance *= -1;
            if ($data_precision > 1)
            {
              $balance = sprintf "%.0f", $balance;
            }
            else
            {
              $balance = sprintf "%.2f", $balance;
            }
          }
          my ($intro_str, $end_str);
          $total_str .= "<font face='$font_str'";
          if ($printable)
          {
            $total_str .= " size=$font_size_data";
          }
          $total_str .= "><code><font face='$font_str'";
          if ($total_assets[$k] < 0)
          {
            $total_str .= " color=red";
          }
          $total_str .= ">$intro_str";
          if ($total_assets[$k] < 0)
          {
            $total_str .= "(";
          }
          $total_str .= commify($balance);
          if ($total_assets[$k] < 0)
          {
            $total_str .= ")";
          }
          $total_str .= "$end_str</font></code>";
          if ($total_assets[$k] >= 0)
          {
            $total_str .= "&nbsp;";
          }
          $total_str .= "</font>";
        }
        elsif ($num_dates == 1 && $k == $max_columns-2)
        {
          my $k=0; # this will go away when we leave this block.
          $total_assets[$k] /= $data_precision;  # massage the data into the correct precision
          if ($data_precision == 1)
          {
            $total_assets[$k] = sprintf "%.2f", $total_assets[$k];
          }
          else
          {
            $total_assets[$k] = sprintf "%.0f", $total_assets[$k];
          }
          my $balance = $total_assets[$k];
          if ($balance < 0)
          {
            $balance *= -1;
            if ($data_precision > 1)
            {
              $balance = sprintf "%.0f", $balance;
            }
            else
            {
              $balance = sprintf "%.2f", $balance;
            }
          }
          my ($intro_str, $end_str);
          $total_str .= "<font face='$font_str'";
          if ($printable)
          {
            $total_str .= " size=$font_size_data";
          }
          $total_str .= "><code><font face='$font_str'";
          if ($total_assets[$k] < 0)
          {
            $total_str .= " color=red";
          }
          $total_str .= ">$intro_str";
          if ($total_assets[$k] < 0)
          {
            $total_str .= "(";
          }
          $total_str .= commify($balance);
          if ($total_assets[$k] < 0)
          {
            $total_str .= ")";
          }
          $total_str .= "$end_str</font></code>";
          if ($total_assets[$k] >= 0)
          {
            $total_str .= "&nbsp;";
          }
          $total_str .= "</font>";
        }
        else
        {  # we just display a &nbsp; to fill in this columns entry.
          $total_str .= "&nbsp;";
        }
        $total_str .= "</b></td>";
      }
      $total_str .= "</tr></table>";
      if ($printable)
      {
        $total_str .= "</td></tr>\n";
        print $total_str;
      }
      else
      {
        print "    mylist.addItem(\"$total_str\", -1);\n";
        $num_list_entries++;
      }

      # now print the Liabilities Header
      if ($printable)
      {
        $total_str = "<tr><td>$table_str<tr><td width=$text_width% align=left><font face='$font_str' size=$font_size_text><b>Liabilities</b></font></td>";
      }
      else
      {
        $total_str = $table_str . "<tr><td width=$text_width% align=Left><b>Liabilities</b></td>";
      }
      for ($k=0; $k < $max_columns; $k++)
      {
        my $width = ($data_width / $max_columns);
        $total_str .= "<td width=$width% align=right>&nbsp;</td>";
      }
      $total_str .= "</tr></table>";
      if ($printable)
      {
        $total_str .= "</td></tr>\n";
        print $total_str;
      }
      else
      {
        print "    mylist.addItem(\"$total_str\", -1);\n";
        $num_list_entries++;
      }
    }

    # see if we need to display the Liabilities Total entry and the Stockholder's Equity entry
    if ($AccountTypes[$i] == $HeaderTypes[1])
    {
      if ($printable)
      {
        $total_str = "<tr><td>$table_str<tr><td width=$text_width% align=right><font face='$font_str' size=$font_size_text><b>Liabilities Total</b></font></td>";
      }
      else
      {
        $total_str = $table_str . "<tr><td width=$text_width% align=right><b>Liabilities Total</b></td>";
      }
      for ($k=0; $k < $max_columns; $k++)
      {
        my $width = ($data_width / $max_columns);
        $total_str .= "<td width=$width% align=right><b>";
        if ($k < $num_dates && $num_dates > 1)
        {
          $total_liabilities[$k] /= $data_precision;  # massage the data into the correct precision
          if ($data_precision == 1)
          {
            $total_liabilities[$k] = sprintf "%.2f", $total_liabilities[$k];
          }
          else
          {
            $total_liabilities[$k] = sprintf "%.0f", $total_liabilities[$k];
          }
          my $balance = $total_liabilities[$k];
          if ($balance < 0)
          {
            $balance *= -1;
            if ($data_precision > 1)
            {
              $balance = sprintf "%.0f", $balance;
            }
            else
            {
              $balance = sprintf "%.2f", $balance;
            }
          }
          my ($intro_str, $end_str);
          $total_str .= "<font face='$font_str'";
          if ($printable)
          {
            $total_str .= " size=$font_size_data";
          }
          $total_str .= "><code><font face='$font_str'";
          if ($total_liabilities[$k] < 0)
          {
            $total_str .= " color=red";
          }
          $total_str .= ">$intro_str";
          if ($total_liabilities[$k] < 0)
          {
            $total_str .= "(";
          }
          $total_str .= commify($balance);
          if ($total_liabilities[$k] < 0)
          {
            $total_str .= ")";
          }
          $total_str .= "$end_str</font></code>";
          if ($total_liabilities[$k] >= 0)
          {
            $total_str .= "&nbsp;";
          }
          $total_str .= "</font>";
        }
        elsif ($num_dates == 1 && $k == $max_columns-2)
        {
          my $k=0;
          $total_liabilities[$k] /= $data_precision;  # massage the data into the correct precision
          if ($data_precision == 1)
          {
            $total_liabilities[$k] = sprintf "%.2f", $total_liabilities[$k];
          }
          else
          {
            $total_liabilities[$k] = sprintf "%.0f", $total_liabilities[$k];
          }
          my $balance = $total_liabilities[$k];
          if ($balance < 0)
          {
            $balance *= -1;
            if ($data_precision > 1)
            {
              $balance = sprintf "%.0f", $balance;
            }
            else
            {
              $balance = sprintf "%.2f", $balance;
            }
          }
          my ($intro_str, $end_str);
          $total_str .= "<font face='$font_str'";
          if ($printable)
          {
            $total_str .= " size=$font_size_data";
          }
          $total_str .= "><code><font face='$font_str'";
          if ($total_liabilities[$k] < 0)
          {
            $total_str .= " color=red";
          }
          $total_str .= ">$intro_str";
          if ($total_liabilities[$k] < 0)
          {
            $total_str .= "(";
          }
          $total_str .= commify($balance);
          if ($total_liabilities[$k] < 0)
          {
            $total_str .= ")";
          }
          $total_str .= "$end_str</font></code>";
          if ($total_liabilities[$k] >= 0)
          {
            $total_str .= "&nbsp;";
          }
          $total_str .= "</font>";
        }
        else
        {  # we just display a &nbsp; to fill in this columns entry.
          $total_str .= "&nbsp;";
        }
        $total_str .= "</b></td>";
      }
      $total_str .= "</tr></table>";
      if ($printable)
      {
        $total_str .= "</td></tr>\n";
        print $total_str;
      }
      else
      {
        print "    mylist.addItem(\"$total_str\", -1);\n";
        $num_list_entries++;
      }

      # now print the Stockholder's Equity Header
      if ($printable)
      {
        $total_str = "<tr><td>$table_str<tr><td width=$text_width% align=left><font face='$font_str' size=$font_size_text><b>Stockholder's Equity</b></font></td>";
      }
      else
      {
        $total_str = $table_str . "<tr><td width=$text_width% align=Left><b>Stockholder's Equity</b></td>";
      }
      for ($k=0; $k < $max_columns; $k++)
      {
        my $width = ($data_width / $max_columns);
        $total_str .= "<td width=$width% align=right><br></td>";
      }
      $total_str .= "</tr></table>";
      if ($printable)
      {
        $total_str .= "</td></tr>\n";
        print $total_str;
      }
      else
      {
        print "    mylist.addItem(\"$total_str\", -1);\n";
        $num_list_entries++;
      }
    }

    # see if we need to display the Book Value of Assets header
    if ($AccountTypes[$i] == 3)
    {
      if ($printable)
      {
        $total_str = "<tr><td>$table_str<tr><td width=$text_width% align=left><font face='$font_str' size=$font_size_text><b>Book Value of Assets</b></font></td>";
      }
      else
      {
        $total_str = $table_str . "<tr><td width=$text_width% align=left><b>Book Value of Assets</b></td>";
      }
      for ($k=0; $k < $max_columns; $k++)
      {
        my $width = ($data_width / $max_columns);
        $total_str .= "<td width=$width% align=right><b>";
        if ($k < $num_dates && $num_dates > 1)
        {
          $asset_book_value[$k] /= $data_precision;  # massage the data into the correct precision
          if ($data_precision == 1)
          {
            $asset_book_value[$k] = sprintf "%.2f", $asset_book_value[$k];
          }
          else
          {
            $asset_book_value[$k] = sprintf "%.0f", $asset_book_value[$k];
          }
          my $balance = $asset_book_value[$k];
          if ($balance < 0)
          {
            $balance *= -1;
            if ($data_precision > 1)
            {
              $balance = sprintf "%.0f", $balance;
            }
            else
            {
              $balance = sprintf "%.2f", $balance;
            }
          }
          my ($intro_str, $end_str);
          $total_str .= "<font face='$font_str'";
          if ($printable)
          {
            $total_str .= " size=$font_size_data";
          }
          $total_str .= "><code><font face='$font_str'";
          if ($asset_book_value[$k] < 0)
          {
            $total_str .= " color=red";
          }
          $total_str .= ">$intro_str";
          if ($asset_book_value[$k] < 0)
          {
            $total_str .= "(";
          }
          $total_str .= commify($balance);
          if ($asset_book_value[$k] < 0)
          {
            $total_str .= ")";
          }
          $total_str .= "$end_str</font></code>";
          if ($asset_book_value[$k] >= 0)
          {
            $total_str .= "&nbsp;";
          }
          $total_str .= "</font>";
        }
        elsif ($num_dates == 1 && $k == $max_columns-2)
        {
          my $k=0;
          $asset_book_value[$k] /= $data_precision;  # massage the data into the correct precision
          if ($data_precision == 1)
          {
            $asset_book_value[$k] = sprintf "%.2f", $asset_book_value[$k];
          }
          else
          {
            $asset_book_value[$k] = sprintf "%.0f", $asset_book_value[$k];
          }
          my $balance = $asset_book_value[$k];
          if ($balance < 0)
          {
            $balance *= -1;
            if ($data_precision > 1)
            {
              $balance = sprintf "%.0f", $balance;
            }
            else
            {
              $balance = sprintf "%.2f", $balance;
            }
          }
          my ($intro_str, $end_str);
          $total_str .= "<font face='$font_str'";
          if ($printable)
          {
            $total_str .= " size=$font_size_data";
          }
          $total_str .= "><code><font face='$font_str'";
          if ($asset_book_value[$k] < 0)
          {
            $total_str .= " color=red";
          }
          $total_str .= ">$intro_str";
          if ($asset_book_value[$k] < 0)
          {
            $total_str .= "(";
          }
          $total_str .= commify($balance);
          if ($asset_book_value[$k] < 0)
          {
            $total_str .= ")";
          }
          $total_str .= "$end_str</font></code>";
          if ($asset_book_value[$k] >= 0)
          {
            $total_str .= "&nbsp;";
          }
          $total_str .= "</font>";
        }
        else
        {  # we just display a &nbsp; to fill in this columns entry.
          $total_str .= "&nbsp;";
        }
        $total_str .= "</b></td>";
      }
      $total_str .= "</tr></table>";
      if ($printable)
      {
        $total_str .= "</td></tr>\n";
        print $total_str;
      }
      else
      {
        print "    mylist.addItem(\"$total_str\", -1);\n";
        $num_list_entries++;
      }
    }

    my $DisplayAccount = 0;
    if ($display && $AccountTypes[$i] <= 7)
    { # Display the Account Type Entry and related info.
      # start the header for the Account Type name
      if ($printable)
      {
        $temp_str = "<tr><td>$table_str<tr><td width=$text_width% align=left>";
      }
      else
      {
        $temp_str = $table_str . "<tr><td width=$text_width% align=left>";
      }

      # finish the header for the Account Type name
      $temp_str .= "<font face='$font_str'";
      if ($printable)
      {
        $temp_str .= " size=$font_size_text";
      }
      $temp_str .= ">";
      if ($AccountTypes[$i] == 2 || $AccountTypes[$i] == 4)
      {
        $temp_str .= "&nbsp;&nbsp;";
      }
      $temp_str .= $AccountTypeNames[$i];
      $total_str = $temp_str . "&nbsp;Total</font></td>";
      $temp_str .= "</td>";

      # just handle normally now.

      # create the Total string with the totals for this Account Type.
      for ($k=0; $k < $max_columns; $k++)
      {
        my $width = ($data_width / $max_columns);
        $total_str .= "<td width=$width% align=right>";
        if ($k < $num_dates && $num_dates > 1)
        {
          my $balance = $AccountTypeTotal[$k];
          if ($data_precision == 1)
          {
            $balance = sprintf "%.2f", $balance;
          }
          else
          {
            $balance = sprintf "%.0f", $balance;
          }
          if ($balance < 0)
          {
            $balance *= -1;
            if ($data_precision > 1)
            {
              $balance = sprintf "%.0f", $balance;
            }
            else
            {
              $balance = sprintf "%.2f", $balance;
            }
          }
          my ($intro_str, $end_str);
          # see if we need to underline this total and it is not printable.
          if ($AccountTypes[$i] == 3 || $AccountTypes[$i] == 4 || $AccountTypes[$i] == 6)
          {
            $intro_str = "<u>" . getSpaceString($AccountTypeTotal[$k], $line_length);
            $end_str = "</u>";
          }
          $total_str .= "<font face='$font_str'";
          if ($printable)
          {
            $total_str .= " size=$font_size_data";
          }
          if ($AccountTypeTotal[$k] < 0)
          {
            $total_str .= " color=red";
          }
          $total_str .= "><code>";
          if (not $printable)
          {
            $total_str .= "$intro_str";
          }
          if ($AccountTypeTotal[$k] < 0)
          {
            $total_str .= "(";
          }
          $total_str .= commify($balance);
          if ($AccountTypeTotal[$k] < 0)
          {
            $total_str .= ")";
          }
          if (not $printable)
          {
            $total_str .= "$end_str";
          }
          $total_str .= "</code>";
          if ($AccountTypeTotal[$k] >= 0)
          {
            $total_str .= "&nbsp;";
          }
          if (($AccountTypes[$i] == 2 || $AccountTypes[$i] == 4) && ($num_dates > 1))
          {
            $total_str .= "&nbsp;&nbsp;";  # bump it 2 in from the right.
          }
          $total_str .= "</font>";
        }
        elsif ($num_dates == 1 && $k == $max_columns-3)
        {
          my $k=0;
          my $balance = $AccountTypeTotal[$k];
          if ($data_precision == 1)
          {
            $balance = sprintf "%.2f", $balance;
          }
          else
          {
            $balance = sprintf "%.0f", $balance;
          }
          if ($balance < 0)
          {
            $balance *= -1;
            if ($data_precision > 1)
            {
              $balance = sprintf "%.0f", $balance;
            }
            else
            {
              $balance = sprintf "%.2f", $balance;
            }
          }
          my ($intro_str, $end_str);
          # see if we need to underline this total and it is not printable.
          if ($AccountTypes[$i] == 3 || $AccountTypes[$i] == 4 || $AccountTypes[$i] == 6)
          {
            $intro_str = "<u>" . getSpaceString($AccountTypeTotal[$k], $line_length);
            $end_str = "</u>";
          }
          $total_str .= "<font face='$font_str'";
          if ($printable)
          {
            $total_str .= " size=$font_size_data";
          }
          if ($AccountTypeTotal[$k] < 0)
          {
            $total_str .= " color=red";
          }
          $total_str .= "><code>";
          if (not $printable)
          {
            $total_str .= "$intro_str";
          }
          if ($AccountTypeTotal[$k] < 0)
          {
            $total_str .= "(";
          }
          $total_str .= commify($balance);
          if ($AccountTypeTotal[$k] < 0)
          {
            $total_str .= ")";
          }
          if (not $printable)
          {
            $total_str .= "$end_str";
          }
          $total_str .= "</code>";
          if ($AccountTypeTotal[$k] >= 0)
          {
            $total_str .= "&nbsp;";
          }
          if (($AccountTypes[$i] == 2 || $AccountTypes[$i] == 4) && ($num_dates > 1))
          {
            $total_str .= "&nbsp;&nbsp;";  # bump it 2 in from the right.
          }
          $total_str .= "</font>";
        }
        else
        {  # we just display a &nbsp; to fill in this columns entry.
          $total_str .= "&nbsp;";
        }
        $total_str .= "</td>";
        $temp_str .= "<td width=$width% align=right><br></td>";  # make the Header string equal the Total string minus the totals.
      }
      $total_str .= "</tr></table>";
      $temp_str .= "</tr></table>";
      if ($printable)
      {
        $total_str .= "</td></tr>";
        $temp_str .= "</td></tr>";
      }

      # now we display any Accounts that exist for this Account Type
      #print "<tr><td>Before display Accounts</td></tr>\n";
      if (scalar @{$localAccounts[$i]}> 0)
      {
        my $count = $num_sub_lists++;
        my $print_AccountList = 0;
        #print "<tr><td>We are in the Display Accounts loop.</td></tr>\n";

        # now we go through all accounts for this Account Type and create their lists or entries
        my ($sub_count, $acct_name, $acct_num, $acct_temp_str, $acct_total_str, $debit_increases);
        for ($sub_count=0; $sub_count < scalar @{$localAccounts[$i]}; $sub_count++)
        {
          $acct_name = $localAccounts[$i][$sub_count][2];
          $acct_num  = $localAccounts[$i][$sub_count][0];
          $debit_increases = $localAccounts[$i][$sub_count][1];
          #print "<tr><td>Working with Account ($acct_name) = $acct_num</td></tr>\n";
          # make sure this Account's activity != 0 and if so, see what the user wants to do.
          my ($display_account) = 0;
          for ($k=0; $k < $num_dates; $k++)
          {
            if (not $AccountActivity[$k][$sub_count][0] eq "0.00")
            {
              $display_account = 1;
            }
          }
          if (not $display_account)
          {
            #print "//Checking to see if there is activity since we have all \"0.00\"'s.\n";
            my ($account_num) = 0;
            for ($k=0; $k < $num_dates; $k++)
            {
              if ($SubEntity[0] == -2)
              {
                #print "// Normal - $acct_name has '".$AccountActivity[$k][$sub_count][1]."' entries.\n";
                if ($AccountActivity[$k][$sub_count][1] > 0)
                {
                  $account_num = 1;
                }
              }
              else
              {
                #print "//$acct_name has '$AccountActivity[$k][$sub_count][2]' entries.\n";
                if ($AccountActivity[$k][$sub_count][2] > 0)
                {
                  $account_num = 1;
                }
              }
            }
            if (not $account_num && $show_zero_balances)
            {
              $display_account = 1;
            }
            if ($account_num)
            {
              $display_account = 1;
            }
          }
          if ($display_account)
          {
            my @SubAcctPrintStack = ();
            #print "<tr><td>We are displaying Account ($acct_name).</td></tr>\n";
            # Generate the acct_temp_str and acct_total_str values
            $acct_temp_str = $acct_total_str = "";
            if ($printable)
            {
              $acct_temp_str = "<tr><td>";
              $acct_total_str = "<tr><td>";
            }
            my $acct_string = "";
            if ($show_accounts_as)
            { # name - number
              $acct_string = $acct_name . " - " . $acct_num;
            }
            else
            { # number - name
              $acct_string = $acct_num . " - " . $acct_name;
            }
            my $my_temp_str = "";
            if ($AccountTypes[$i] == 2 || $AccountTypes[$i] == 4)
            {
              $my_temp_str .= "&nbsp;&nbsp;&nbsp;";
            }
            $my_temp_str .= "<font face='$font_str'";
            if ($printable)
            {
              $my_temp_str .= "size=$font_size_text";
            }
            $my_temp_str .= ">";
            $acct_temp_str .= "$table_str<tr><td width=$text_width% align=left>&nbsp;&nbsp;$my_temp_str$acct_string</font>";
            $acct_total_str .= "$table_str<tr><td width=$text_width% align=left>&nbsp;&nbsp;$my_temp_str$acct_string</font>";
            $acct_temp_str .= "</td>";
            $acct_total_str .= "</td>";

            # see if this Account has any entries to display, and if so, how many sub-accounts to work with
            my ($has_accts) = 0;
            for ($k=0; $k < $num_dates; $k++)
            {
              if ($SubEntity[0] == -2)
              {
                #print "//$acct_name has '$AccountActivity[$k][$sub_count][1]' entries.\n";
                if ($AccountActivity[$k][$sub_count][1] > 0)
                { # This account has some activity
                  $has_accts = 1;
                }
              }
              else
              {
                #print "//$acct_name has '$AccountActivity[$k][$sub_count][2]' entries.\n";
                if ($AccountActivity[$k][$sub_count][2] > 0)
                { # This account has some activity
                  $has_accts = 1;
                }
              }
            }
            for ($k=0; $k < $max_columns; $k++)
            {
              my $width = ($data_width / $max_columns);
              $acct_total_str .= "<td width=$width% align=right>";
              if ($k < $num_dates)
              {
                my $acct_total = $AccountActivity[$k][$sub_count][0];
                $acct_total /= $data_precision;
                if ($data_precision == 1)
                {
                  $acct_total = sprintf "%.2f", $acct_total;
                }
                else
                {
                  $acct_total = sprintf "%.0f", $acct_total;
                }
                if ($acct_total < 0)
                {
                  $acct_total *= -1;
                  if ($data_precision == 1)
                  {
                    $acct_total = sprintf "%.2f", $acct_total;
                  }
                  else
                  {
                    $acct_total = sprintf "%.0f", $acct_total;
                  }
                }
                if (not $printable)
                {
                  if (($acct_total ne "0.00" && $data_precision == 1) || ($acct_total ne "0" && $data_precision > 1))
                  {  # changed the sub_acct = -1 to -2.
                    $acct_total_str .= "<a href='javascript:display_entries' onClick='javascript:display_entries($AccountTypes[$i], $acct_num, \\\"$acct_name\\\", \\\"$debit_increases\\\", \\\"$Dates[$k][0]\\\", \\\"$Dates[$k][1]\\\", -2, \\\" \\\", \\\"$SubEntity[0]\\\", \\\"$SubEntity[1]\\\"); return false;'>";
                  }
                }
                $acct_total_str .= "<font face='$font_str'";
                if ($printable)
                {
                  $acct_total_str .= " size=$font_size_data";
                }
                if ($AccountActivity[$k][$sub_count][0] < 0)
                {
                  $acct_total_str .= " color=red";
                }
                else
                {
                  $acct_total_str .= " color=black";
                }
                $acct_total_str .= "><code>";
                if ($AccountActivity[$k][$sub_count][0] < 0)
                {
                  $acct_total_str .= "(";
                }
                $acct_total_str .= commify($acct_total);
                if ($AccountActivity[$k][$sub_count][0] < 0)
                {
                  $acct_total_str .= ")";
                }
                $acct_total_str .= "</code>";
                if ($AccountActivity[$k][$sub_count][0] >= 0)
                {
                  $acct_total_str .= "&nbsp;";
                }
                if ($num_dates > 1)
                {
                  $acct_total_str .= getSpaceString('', 4);
                }
                $acct_total_str .= "</font>";
                if (not $printable)
                {
                  if (($acct_total ne "0.00" && $data_precision == 1) || ($acct_total ne "0" && $data_precision > 1))
                  {
                    $acct_total_str .= "</a>";
                  }
                }
              }
              else
              {
                $acct_total_str .= "<br>";
              }
              $acct_total_str .= "</td>";
            }

            # finish the Account Name and Total strings
            $acct_total_str .= "</tr></table>";
            $acct_temp_str .= "</tr></table>";
            if ($printable)
            {
              $acct_total_str .= "</td></tr>\n";
              $acct_temp_str .= "</td></tr>\n";
            }

            if ($has_accts)
            {
              # now display the list if not a printable report
              if (not $printable)
              {
                push @PrintStack, "    sublist$count.addItem(\"$acct_total_str\", -1);\n";
                $num_list_entries++;
              }
              else
              {
                push @PrintStack, "$acct_total_str";
              }
            }
            else # no entries for this account
            { # just display the Total line for this account without the word Total.
              # only display this line if show_zero_balances is true
              if ($show_zero_balances)
              {
                $acct_total_str =~ s/Total//;
                if ($printable)
                {
                  push @PrintStack, $acct_total_str;
                }
                else
                {
                  push @PrintStack, "    sublist$count.addItem(\"$acct_total_str\", $sub_count);\n";
                  $num_list_entries++;
                }
              }
            } # end of Account has entries
          } # end of Display Account because it fits the initial criteria.
          # see if we need to underline this Accounts totals
          if ($sub_count == scalar @{$localAccounts[$i]} - 1  && scalar @PrintStack > 0)
          {
            # generate another line or list entry to display the underlines that are 12 long and extend 4 spaces from the right of each column.
            $acct_temp_str = "";
            if ($printable)
            {
              $acct_temp_str = "<tr><td>";
            }
            $acct_temp_str .= $table_str . "<tr><td width=$text_width% align=left><br></td>";
            for ($k=0; $k < $max_columns; $k++)
            {
              my $width = ($data_width / $max_columns);
              if ($printable)
              {
                $width -= 1;
              }
              $acct_temp_str .= "<td width=$width% align=right>";
              if ($k < $num_dates)
              {
                if (not $printable)
                {
                  my $space_str = getSpaceString('', 12);
                  $acct_temp_str .= "<font face='$font_str'";
                  if ($printable)
                  {
                    $acct_temp_str .= " size=$font_size_text";
                  }
                  $acct_temp_str .= "><code><u>$space_str</u></code>"; # underline the 12 spaces
                  if ($num_dates > 1)
                  {
                    $space_str = getSpaceString('',4);
                  }
                  else
                  {
                    $space_str = "";
                  }
                  $acct_temp_str .= $space_str . "</font>";
                }
                else # printable version
                {
                  $acct_temp_str .= "<hr noshade align=right width=$uline_length>";
                }
              }
              else
              {
                $acct_temp_str .= "<br>";
              }
              $acct_temp_str .= "</td>";
              if ($printable && $num_dates > 1)
              {
                $width = 1;
                $acct_temp_str .= "<td width=$width% align=right>&nbsp;</td>";
              }
            }
            $acct_temp_str .= "</tr></table>";
            if ($printable)
            {
              $acct_temp_str .= "</td></tr>\n";
            }
            # display the underline!
            if ($printable)
            {
              push @PrintStack, "$acct_temp_str";
            }
            else
            {
              push @PrintStack, "    sublist$count.addItem(\"$acct_temp_str\", 0);\n";
              $num_list_entries++;
            }
          } # end of underline if last entry for this account (even if we didn't display this account!)
        } # end of for loop to walk through all accounts for this Account Type.

        # display the Account Type header
        # ************************** Do pop off of stack now! *******************************************
        if ($printable)
        {
          if (scalar @PrintStack > 0 || $show_zero_balances)
          {
            if (exists $lists_opened{$count})
            {
              print "$temp_str";

              my ($temp, $ii);
              #print "There are ". int (scalar @PrintStack) . " items on the PrintStack<br>\n";
              for ($ii=0; $ii < scalar @PrintStack; $ii++)
              {
                $temp = $PrintStack[$ii];
                print $temp;
              }
              @PrintStack = ();

              print "$total_str\n";
            }
            else
            {
              # just print the total string minus Total.
              $total_str =~ s/Total//;
              print "$total_str\n";
            }
            $AccountPrinted = 1;
          }
        }
        else
        {
          if (scalar @PrintStack > 0 || $show_zero_balances)
          {
            if (scalar @PrintStack > 0)
            {
              print "    sublist$count = new List(false, width, height, bgColor);\n";
              $num_list_entries++;

              my ($temp, $ii);
              #print "There are ". int (scalar @PrintStack) . " items on the PrintStack<br>\n";
              for ($ii=0; $ii < scalar @PrintStack; $ii++)
              {
                $temp = $PrintStack[$ii];
                print $temp;
              }
              @PrintStack = ();

              print "    mylist.addList(sublist$count, \"$temp_str\", $count);\n";
              $num_list_entries++;

              print "    mylist.addItem(\"$total_str\", 0);\n";
              $num_list_entries++;
            }
            else # just display the Total line without Total
            {
              $total_str =~ s/Total//;
              print "    mylist.addItem(\"$total_str\", 0);\n";
              $num_list_entries++;
            }
          }
        } # endif printing Account Type list entries.
      }
      else # no accounts for this Account Type
      {
        $total_str =~ s/Total//;
        if ($printable)
        {
          print "$total_str\n";
        }
        else
        {
          print "    mylist.addItem(\"$total_str\", 0);\n";
          $num_list_entries++;
        }
      } # endif no accounts for Account Type
      # see if we need to underline this total
      if ($AccountTypes[$i] == 3 || $AccountTypes[$i] == 6 || $AccountTypes[$i] == 4)
      {
        if ($printable && $AccountPrinted)
        {
          my $acct_temp_str = "";
          $acct_temp_str = "<tr><td>" . $table_str . "<tr><td width=$text_width% align=left><br></td>";
          for ($k=0; $k < $max_columns; $k++)
          {
            my $width = ($data_width / $max_columns);
            $acct_temp_str .= "<td width=$width% align=right>";
            if ($k < $num_dates && $num_dates > 1)
            {
              $acct_temp_str .= "<hr noshade align=right width=$uline_length>"; # underline the 10 spaces, 6 pixels per space
            }
            elsif ($num_dates == 1 && $k == $max_columns-3)
            {
              $acct_temp_str .= "<hr noshade align=right width=$uline_length>"; # underline the 10 spaces, 6 pixels per space
            }
            else
            {
              $acct_temp_str .= "&nbsp;";
            }
            $acct_temp_str .= "</td>";
          }
          $acct_temp_str .= "</tr></table>";
          $acct_temp_str .= "</td></tr>\n";

          print $acct_temp_str;
        }
      }
    }
  } # End loop through Account Type local Accounts and their Activities

  # Display the Net Income line
  if ($printable)
  {
    $total_str = "<tr><td>$table_str<tr><td width=$text_width% align=left><font face='$font_str' size=$font_size_text><b>Net Income</b></font></td>";
  }
  else
  {
    $total_str = $table_str . "<tr><td width=$text_width% align=left><b>Net Income</b></td>";
  }
  for ($k=0; $k < $max_columns; $k++)
  {
    my $width = ($data_width / $max_columns);
    $total_str .= "<td width=$width% align=right><b>";
    if ($k < $num_dates && $num_dates > 1)
    {
      $NetIncome[$k] /= $data_precision;  # massage the data into the correct precision
      if ($data_precision == 1)
      {
        $NetIncome[$k] = sprintf "%.2f", $NetIncome[$k];
      }
      else
      {
        $NetIncome[$k] = sprintf "%.0f", $NetIncome[$k];
      }
      my $balance = $NetIncome[$k];
      if ($balance < 0)
      {
        $balance *= -1;
        if ($data_precision > 1)
        {
          $balance = sprintf "%.0f", $balance;
        }
        else
        {
          $balance = sprintf "%.2f", $balance;
        }
      }
      my ($intro_str, $end_str);
      $intro_str = "<u>" . getSpaceString($AccountTypeTotal[$k], $line_length);
      $end_str = "</u>";

      $total_str .= "<font face='$font_str'><code><font face='$font_str'";
      if ($printable)
      {
        $total_str .= " size=$font_size_data";
      }
      if ($NetIncome[$k] < 0)
      {
        $total_str .= " color=red";
      }
      $total_str .= ">";
      if (not $printable)
      {
        $total_str .= "$intro_str";
      }
      if ($NetIncome[$k] < 0)
      {
        $total_str .= "(";
      }
      $total_str .= commify($balance);
      if ($NetIncome[$k] < 0)
      {
        $total_str .= ")";
      }
      if (not $printable)
      {
        $total_str .= "$end_str";
      }
      $total_str .= "</font></code>";
      if ($NetIncome[$k] >= 0)
      {
        $total_str .= "&nbsp;";
      }
      $total_str .= "</font>";
    }
    elsif ($num_dates == 1 && $k == $max_columns-3)
    {
      my $k=0;
      $NetIncome[$k] /= $data_precision;  # massage the data into the correct precision
      if ($data_precision == 1)
      {
        $NetIncome[$k] = sprintf "%.2f", $NetIncome[$k];
      }
      else
      {
        $NetIncome[$k] = sprintf "%.0f", $NetIncome[$k];
      }
      my $balance = $NetIncome[$k];
      if ($balance < 0)
      {
        $balance *= -1;
        if ($data_precision > 1)
        {
          $balance = sprintf "%.0f", $balance;
        }
        else
        {
          $balance = sprintf "%.2f", $balance;
        }
      }
      my ($intro_str, $end_str);
      $intro_str = "<u>" . getSpaceString($AccountTypeTotal[$k], $line_length);
      $end_str = "</u>";

      $total_str .= "<font face='$font_str'><code><font face='$font_str'";
      if ($printable)
      {
        $total_str .= " size=$font_size_data";
      }
      if ($NetIncome[$k] < 0)
      {
        $total_str .= " color=red";
      }
      $total_str .= ">";
      if (not $printable)
      {
        $total_str .= "$intro_str";
      }
      if ($NetIncome[$k] < 0)
      {
        $total_str .= "(";
      }
      $total_str .= commify($balance);
      if ($NetIncome[$k] < 0)
      {
        $total_str .= ")";
      }
      if (not $printable)
      {
        $total_str .= "$end_str";
      }
      $total_str .= "</font></code>";
      if ($NetIncome[$k] >= 0)
      {
        $total_str .= "&nbsp;";
      }
      $total_str .= "</font>";
    }
    else
    {  # we just display a &nbsp; to fill in this columns entry.
      $total_str .= "&nbsp;";
    }

    $total_str .= "</b></td>";
  }
  $total_str .= "</tr></table>";
  if ($printable)
  {
    $total_str .= "</td></tr>\n";
    print $total_str;
  }
  else
  {
    print "    mylist.addItem(\"$total_str\", -1);\n";
    $num_list_entries++;
  }

  if ($printable)  # print the underline if this is a Printable report.
  {
    my $acct_temp_str = "";
    $acct_temp_str = "<tr><td>" . $table_str . "<tr><td width=$text_width% align=left><br></td>";
    for ($k=0; $k < $max_columns; $k++)
    {
      my $width = ($data_width / $max_columns);
      $acct_temp_str .= "<td width=$width% align=right>";
      if ($k < $num_dates && $num_dates > 1)
      {
        $acct_temp_str .= "<hr noshade align=right width=$uline_length>"; # underline the 10 spaces, 6 pixels per space
      }
      elsif ($num_dates == 1 && $k == $max_columns-3)
      {
        $acct_temp_str .= "<hr noshade align=right width=$uline_length>"; # underline the 10 spaces, 6 pixels per space
      }
      else
      {
        $acct_temp_str .= "&nbsp;";
      }
      $acct_temp_str .= "</td>";
    }
    $acct_temp_str .= "</tr></table>";
    $acct_temp_str .= "</td></tr>\n";

    print $acct_temp_str;
  }

  # Display the Stockholder's Equity and verify that everything checks out.
  # Stockholders Equity = Assets - Liabilities
  if ($printable)
  {
    $total_str = "<tr><td>$table_str<tr><td width=$text_width% align=right><font face='$font_str' size=$font_size_text><b>Stockholder's Equity Total</b></font></td>";
  }
  else
  {
    $total_str = $table_str . "<tr><td width=$text_width% align=right><b>Stockholder's Equity Total</b></td>";
  }
  for ($k=0; $k < $max_columns; $k++)
  {
    my $width = ($data_width / $max_columns);
    $total_str .= "<td width=$width% align=right><b>";
    if ($k < $num_dates && $num_dates > 1)
    {
      $total_equity[$k] /= $data_precision;  # massage the data into the correct precision
      if ($data_precision == 1)
      {
        $total_equity[$k] = sprintf "%.2f", $total_equity[$k];
      }
      else
      {
        $total_equity[$k] = sprintf "%.0f", $total_equity[$k];
      }
      my $balance = $total_equity[$k];
      if ($balance < 0)
      {
        $balance *= -1;
        if ($data_precision > 1)
        {
          $balance = sprintf "%.0f", $balance;
        }
        else
        {
          $balance = sprintf "%.2f", $balance;
        }
      }
      my ($intro_str, $end_str);
      $total_str .= "<font face='$font_str'><code><font face='$font_str'";
      if ($printable)
      {
        $total_str .= " size=$font_size_data";
      }
      if ($total_equity[$k] < 0)
      {
        $total_str .= " color=red";
      }
      $total_str .= ">$intro_str";
      if ($total_equity[$k] < 0)
      {
        $total_str .= "(";
      }
      $total_str .= commify($balance);
      if ($total_equity[$k] < 0)
      {
        $total_str .= ")";
      }
      $total_str .= "$end_str</font></code>";
      if ($total_equity[$k] >= 0)
      {
        $total_str .= "&nbsp;";
      }
      $total_str .= "</font>";
    }
    elsif ($num_columns == 1 && $k == $max_columns-2)
    {
      my $k=0;
      $total_equity[$k] /= $data_precision;  # massage the data into the correct precision
      if ($data_precision == 1)
      {
        $total_equity[$k] = sprintf "%.2f", $total_equity[$k];
      }
      else
      {
        $total_equity[$k] = sprintf "%.0f", $total_equity[$k];
      }
      my $balance = $total_equity[$k];
      if ($balance < 0)
      {
        $balance *= -1;
        if ($data_precision > 1)
        {
          $balance = sprintf "%.0f", $balance;
        }
        else
        {
          $balance = sprintf "%.2f", $balance;
        }
      }
      my ($intro_str, $end_str);
      $total_str .= "<font face='$font_str'><code><font face='$font_str'";
      if ($printable)
      {
        $total_str .= " size=$font_size_data";
      }
      if ($total_equity[$k] < 0)
      {
        $total_str .= " color=red";
      }
      $total_str .= ">$intro_str";
      if ($total_equity[$k] < 0)
      {
        $total_str .= "(";
      }
      $total_str .= commify($balance);
      if ($total_equity[$k] < 0)
      {
        $total_str .= ")";
      }
      $total_str .= "$end_str</font></code>";
      if ($total_equity[$k] >= 0)
      {
        $total_str .= "&nbsp;";
      }
      $total_str .= "</font>";
    }
    else
    {  # we just display a &nbsp; to fill in this columns entry.
      $total_str .= "&nbsp;";
    }
    if ($k < $num_dates && $num_dates > 1)
    {
      # verify that everything balances for this column.
      my $total = $total_assets[$k] - $total_liabilities[$k];
      if ($data_precision == 1)
      {
        $total = sprintf "%.2f", $total;
      }
      else
      {
        $total = sprintf "%.0f", $total;
      }
      if ($total_equity[$k] ne $total)
      {
        $total_str .= "<br><font color=red";
        if ($printable)
        {
          $total_str .= " size=$font_size_data";
        }
        $total_str .= ">Does not Balance!</font>";
      }
    }
    elsif ($num_dates == 1 && $k == $max_columns-2)
    {
      my $k=0;
      # verify that everything balances for this column.
      my $total = $total_assets[$k] - $total_liabilities[$k];
      if ($data_precision == 1)
      {
        $total = sprintf "%.2f", $total;
      }
      else
      {
        $total = sprintf "%.0f", $total;
      }
      if ($total_equity[$k] ne $total)
      {
        $total_str .= "<br><font color=red";
        if ($printable)
        {
          $total_str .= " size=$font_size_data";
        }
        $total_str .= ">Does not Balance!</font>";
      }
    }

    $total_str .= "</b></td>";
  }
  $total_str .= "</tr></table>";
  if ($printable)
  {
    $total_str .= "</td></tr>\n";
    print $total_str;
  }
  else
  {
    print "    mylist.addItem(\"$total_str\", -1);\n";
    $num_list_entries++;
  }
}

# getSpaceString
#   Takes  : String to work with
#   Takes  : Max length of underscore
#   Returns: String of &nbsp;'s to insert into the code
sub getSpaceString
{
  my $string = shift;
  my $line_length = shift;

  my $length = length commify($string);
  if ($string < 0)
  {
    $length++;  # take into account the () and no - sign.
  }
  my ($y, $space_str);
  for ($y=0; $y < $line_length - $length; $y++)
  {
    $space_str .= "&nbsp;";
  }

  return $space_str;
}

return 1;