#$Id: reports_state_941.pm,v 1.1 2001/09/06 10:21:20 moreejt Exp $
#This package is released under the GNU General Public License.
#You should have recieved a copy of the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.
sub reports3State941JavaScriptValidation
{
  print <<"END_OF_SCRIPT";
  function reports3State941JavaScriptValidation(doc)
  {
    var msg = "";
    var tmp = "";

    // verify that they have specified at least one complete date range
    var date1_start, date1_end;
    date1_start = doc.state_from_date.value;
    date1_end   = doc.state_to_date.value;

    if (date1_start.length == 0 && date1_end.length == 0)
    {
      msg += "You must specify some dates to work with!\\n";
    }
    else  // something is filled in, now verify that it is a complete range
    {
      if ((date1_start.length > 0 && date1_end.length == 0) || (date1_start.length == 0 && date1_end.length > 0))
      {
        msg += "You must specify a complete range of dates for From and To!\\n";
      }
      else
      {
        if (date1_start.length > 0 && date1_end.length > 0) // check and make sure the dates are valid.
        {
          tmp = IsValidDateSyntax(date1_start);
          if (tmp.length > 0)
          {
            msg += "From date: " + tmp + "\\n";
          }
          tmp = IsValidDateSyntax(date1_end);
          if (tmp.length > 0)
          {
            msg += "To date: " + tmp + "\\n";
          }
        }
      }
    }
    // verify that any values they have entered are valid values
    var pattern = /^(-?(([0-9]+)|(([0-9]+\.[0-9]+)|(\.[0-9]+))))\$/;
    if (doc.cdp_auto.value.length != 0)
    {
      if (!pattern.test(doc.cdp_auto.value))
      {
        msg += "Compensation Deduction Percentage (auto) contains an invalid numeric value! (" + doc.cdp_auto.value + ")\\n";
      }
    }
    if (doc.cdp_manual.value.length != 0)
    {
      if (!pattern.test(doc.cdp_manual.value))
      {
        msg += "Compensation Deduction Percentage (manual) contains an invalid numeric value! (" + doc.cdp_manual.value + ")\\n";
      }
    }
    if (doc.pop_amount.value.length != 0)
    {
      if (!pattern.test(doc.pop_amount.value))
      {
        msg += "Previous Overpay/Payments contains an invalid numeric value! (" + doc.pop_amount.value + ")\\n";
      }
      if (!doc.pop_radio[0].checked && !doc.pop_radio[1].checked)
      {
        msg += "You must select 'Over' or 'Under' for the Previous Overpay/Payments value!\\n";
      }
    }
    if (doc.att_amount.value.length != 0)
    {
      if (!pattern.test(doc.att_amount.value))
      {
        msg += "Additions to Tax contains an invalid numeric value! (" + doc.att_amount.value + ")\\n";
      }
    }
    if (doc.interest_amount.value.length != 0)
    {
      if (!pattern.test(doc.interest_amount.value))
      {
        msg += "Interest Amount contains an invalid numeric value! (" + doc.interest_amount.value + ")\\n";
      }
    }

    return msg;
  }
END_OF_SCRIPT
}

sub reports3State941CustomizedFormItems
{
  print <<"END_OF_FORM";
  <tr><td align=center><font color=\"$menu_fgcolor\">State Income Tax Withholding Account:&nbsp;</font>
END_OF_FORM
  my $state_account_num;
  my $state_account_name;
  my $counter;
  # get the account from the database and display to the user
  # SWH Liability account type = 25
  $result = $conn->exec("select name, number from account_tb where number in (select acct_num from local_accounts_tb where ledger_code = '$ledger_code') and type = 25 order by name");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error: Accessing the database failed!</h1>\n";
    print $conn->errorMessage . "<br>1040: Tried to get the SITW accounts from the global database for the 941 state report.<br>$sys_admin";
    print "</td></tr></table>\n";
    CleanUp();
  }
  if ($result->ntuples <= 0)
  {
    print "<h1>Error: No records returned!</h1>\n";
    print "1041: No SITW accounts were found assigned to the ledger.<br>It does not look like this report has been setup.<br>$sys_admin";
    print "</td></tr></table>\n";
    CleanUp();
  }
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $state_account_name = $result->getvalue($counter, 0);
    $state_account_num = $result->getvalue($counter, 1);
    $state_account_name =~ s/\ /&nbsp;/g;
    print "$state_account_name&nbsp;-&nbsp;$state_account_num\n";
    if ($counter < $result->ntuples - 1)
    {
      print "<br>";
    }
  }
  print "<input type=hidden name=\"state_account_num\" value=\"";
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $state_account_num = $result->getvalue($counter, 1);
    print "$state_account_num";
    if ($counter < $result->ntuples - 1)
    {
      print ",";
    }
  }
  print "\">\n";
  print <<"END_OF_FORM";
  </td></tr>
  <tr><td>
  <table border=0 cellspacing=0 cellpadding=2 bgcolor=\"$menu_bgcolor\">
  <tr><td align=center><font color=\"$menu_fgcolor\">From date:&nbsp;</font><input type=text size=12 name=\"state_from_date\" value=\"\"></td><td align=center><font color=\"$menu_fgcolor\">To date:&nbsp;</font><input type=text size=12 name=\"state_to_date\" value=\"\"></td></tr>
  <tr><td colspan=2><hr width=90%></td></tr>
  <tr><td align=center colspan=2><font color=\"$menu_fgcolor\">Compensation Deduction Percentage<sup>*</sup> ( >= 0%)</font></td></tr>
  <tr><td align=center><input type=radio name=\"cdp_radio\" value=\"auto\" checked>Auto&nbsp;<input type=text size=5 name=\"cdp_auto\" value=\"\">%</td>
  <td align=center><input type=radio name=\"cdp_radio\" value=\"manual\">Manual&nbsp;<input type=text size=10 name=\"cdp_manual\" value=\"\">&nbsp;Amount</td></tr>
  <tr><td colspan=2>* If compensation deduction is complex, calculate manually.</td></tr>
  <tr><td colspan=2><hr width=90%></td></tr>
  <tr><td colspan=2 align=center><font color=\"$menu_fgcolor\">Previous&nbsp;Overpay/Payments:&nbsp;</font><input type=text size=10 name=\"pop_amount\" value=\"\">&nbsp;Amount</td></tr>
  <tr><td colspan=2 align=center><input type=radio name=\"pop_radio\" value=\"over\">Over&nbsp;<input type=radio name=\"pop_radio\" value=\"under\">&nbsp;Under</td></tr>
  <tr><td colspan=2><hr width=90%></td></tr>
  <tr><td colspan=2 align=center><font color=\"$menu_fgcolor\">Additions to Tax:&nbsp;</font><input type=text size=10 name=\"att_amount\" value=\"\">&nbsp;Amount</td></tr>
  <tr><td colspan=2><hr width=90%></td></tr>
  <tr><td colspan=2 align=center><font color=\"$menu_fgcolor\">Interest:&nbsp;</font><input type=text size=10 name=\"interest_amount\" value=\"\">&nbsp;Amount</td></tr>
  </table>
  </td></tr>
END_OF_FORM
}

sub reports4State941Work
{
  my $temp_sub_account_name;
  my $temp_sub_account_number;
  my $temp_balance = 0.0;
  my $count;

  # assign default values for the quarter sub-accounts
  $q1_sub_account_num = 1;
  $q2_sub_account_num = 2;
  $q3_sub_account_num = 3;
  $q4_sub_account_num = 4;

  # retrieve all the sub-account numbers for the SITW account (i.e., of Employee sub-account type = 20)
  $result = $conn->exec("select sub_acc_name, sub_acc_number from sub_acc_tb where type = 20 order by sub_acc_name");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>1044: Tried to retrieve all Employee sub-account numbers for account number: $state_account_num.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples <= 0)
  {
    PrintErrorHeader();
    print "<h1>Error: No records returned!</h1>\n";
    print "1045: Tried to retrieve all Employee sub-account numbers for account number: $state_account_num.<br>$sys_admin";
    CleanUp();
  }
  # store name - number or number - name based on the radio button from the previous form
  for ($count = 0; $count < $result->ntuples; $count++)
  {
    $temp_sub_account_name = $result->getvalue($count, 0);
    $temp_sub_account_number = $result->getvalue($count, 1);
    if ($temp_sub_account_number != $q1_sub_account_num && $temp_sub_account_number != $q2_sub_account_num && $temp_sub_account_number != $q3_sub_account_num && $temp_sub_account_number != $q4_sub_account_num)
    {
      $state_sub_account_balances{$temp_sub_account_number} = [];
      $state_sub_account_balances{$temp_sub_account_number}[0] = $temp_sub_account_name;
      $state_sub_account_balances{$temp_sub_account_number}[1] = $temp_sub_account_number;
    }
  }
  # create an entry for the "-1" sub-account number
  $state_sub_account_balances{'-1'} = [];
  $state_sub_account_balances{'-1'}[0] = "<i>None</i>";
  $state_sub_account_balances{'-1'}[1] = "-1";

  # set withholding and total balances to zero
  $state_total_balances_amount = 0.0;
  $state_withholding = 0.0;
  # retrieve all data from SITW customized account according to sub-account
  foreach $temp_sub_account_number (keys %state_sub_account_balances)
  {
    # get a sum of credits from the SITW account for the temp_sub_account_number
    $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = false and ledger_code = '$ledger_code' and account_num in ($state_account_num) and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '$state_from_date' and '$state_to_date' and ledger_code = '$ledger_code')");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to get the sum of credits for the sub-account: $temp_sub_account_number.<br>$sys_admin";
      CleanUp();
    }
    if ($result->getvalue(0, 0) eq "")
    {
      $temp_balance = 0.0;
    }
    else
    {
      $temp_balance = $result->getvalue(0, 0);
    }
    $state_sub_account_balances{$temp_sub_account_number}[2] = $temp_balance;

    # get a sum of debits from the SITW account for the temp_sub_account_number
    $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = true and ledger_code = '$ledger_code' and account_num in ($state_account_num) and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '$state_from_date' and '$state_to_date' and ledger_code = '$ledger_code')");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing database failed!<h1>\n";
      print $conn->errorMessage . "<br>Tried to get the sum of debits for the sub-account: $temp_sub_account_number.<br>$sys_admin";
      CleanUp();
    }
    if ($result->getvalue(0, 0) eq "")
    {
      $temp_balance = 0.0;
    }
    else
    {
      $temp_balance = $result->getvalue(0, 0);
    }

    # subtract debits from credits for final balance for the sub-account
    $state_sub_account_balances{$temp_sub_account_number}[2] -= $temp_balance;

    # cumulatively calculate withholdings and total balances
    $state_total_balances_amount += $state_sub_account_balances{$temp_sub_account_number}[2];
    if ($temp_sub_account_number ne "-1")
    {
      $state_withholding += $state_sub_account_balances{$temp_sub_account_number}[2];
    }
  }

  # calculate compensation deduction
  $state_compensation_deduction = ($state_cdp_percent eq "") ? $state_cdp_amount : ($state_cdp_percent/100.0) * $state_withholding;

  # calculate balance due
  $state_balance_due = $state_withholding - $state_compensation_deduction + $state_pop_amount;

  # calculate total amount due
  $state_total_due = $state_balance_due + $state_att_amount + $state_interest_amount;
}

sub reports4State941DisplayForm
{
  my $temp_sub_account_number;

  # display the dates for the report
  print "<center><font size=$font_size_text>From: <font color=blue>$state_from_date</font>&nbsp;&nbsp;To: <font color=blue>$state_to_date</font></font></center>\n";
  print "<br><br>\n";

  print "<table border=0 cellspacing=0 cellpadding=2 width=75%>\n";
  print "<tr>\n";
  print "<th align=left><font size=$font_size_text>Sub-Accounts <sub>(<i>Employees</i>)</sub></font></th>\n";
  print "<th align=right><font size=$font_size_text>Amount</font></th>\n";
  print "</tr>\n";
  # display summaries of sub-accounts and totals from SITW account
  if ($state_display_order eq "0")
  {
    foreach $temp_sub_account_number (keys %state_sub_account_balances)
    {
      if ($temp_sub_account_number ne "-1")
      {
        print "<tr>\n";
        print "<td><font size=$font_size_data>" . $state_sub_account_balances{$temp_sub_account_number}[0] . " - " . $state_sub_account_balances{$temp_sub_account_number}[1] . "</font></td>\n";
        print "<td align=right><font size=$font_size_data>";
        if ($state_sub_account_balances{$temp_sub_account_number}[2] < 0)
        {
          printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($state_sub_account_balances{$temp_sub_account_number}[2])));
        }
        else
        {
          printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($state_sub_account_balances{$temp_sub_account_number}[2])));
        }
        print "</font></td>\n";
        print "</tr>\n";
      }
    }
    if (exists $state_sub_account_balances{'-1'})
    {
      print "<tr>\n";
      print "<td><font size=$font_size_data>" . $state_sub_account_balances{'-1'}[0] . "</font></td>\n";
      print "<td align=right><font size=$font_size_data>";
      if ($state_sub_account_balances{'-1'}[2] < 0)
      {
        printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($state_sub_account_balances{'-1'}[2])));
      }
      else
      {
        printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($state_sub_account_balances{'-1'}[2])));
      }
      print "</font></td>\n";
      print "</tr>\n";
    }
  }
  else
  {
    foreach $temp_sub_account_number (sort {$a <=> $b} keys %state_sub_account_balances)
    {
      if ($temp_sub_account_number ne "-1")
      {
        print "<tr>\n";
        print "<td><font size=$font_size_data>" . $state_sub_account_balances{$temp_sub_account_number}[1] . " - " . $state_sub_account_balances{$temp_sub_account_number}[0] . "</font></td>\n";
        print "<td align=right><font size=$font_size_data>";
        if ($state_sub_account_balances{$temp_sub_account_number}[2] < 0)
        {
          printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($state_sub_account_balances{$temp_sub_account_number}[2])));
        }
        else
        {
          printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($state_sub_account_balances{$temp_sub_account_number}[2])));
        }
        print "</font></td>\n";
        print "</tr>\n";
      }
    }
    if (exists $state_sub_account_balances{'-1'})
    {
      print "<tr>\n";
      print "<td><font size=$font_size_data>" . $state_sub_account_balances{'-1'}[0] . "</font></td>\n";
      print "<td align=right><font size=$font_size_data>";
      if ($state_sub_account_balances{'-1'}[2] < 0)
      {
        printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($state_sub_account_balances{'-1'}[2])));
      }
      else
      {
        printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($state_sub_account_balances{'-1'}[2])));
      }
      print "</font></td>\n";
      print "</tr>\n";
    }
  }
  print "<tr><td colspan=2><hr></td></tr>\n";
  print "<tr>\n";
  print "<td align=left><font size=$font_size_data><b>Total</b></font></td>\n";
  print "<td align=right><font size=$font_size_data>";
  if ($state_total_balances_amount < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($state_total_balances_amount)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($state_total_balances_amount)));
  }
  print "</font></td>\n";
  print "</tr>\n";

  # display a space between the table entries
  print "<tr><td colspan=2><br></td></tr>\n";

  # 1. display withholdings line  (total from sub-accounts summary)
  print "<tr>\n";
  print "<td align=left><font size=$font_size_text>1.&nbsp;<b>Withholdings this Period</b></font></td>\n";
  print "<td align=right><font size=$font_size_text><b>";
  if ($state_withholding < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($state_withholding)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($state_withholding)));
  }
  print "</b></font></td>\n";
  print "</tr>\n";

  # 2. display compensation deductions line  (if Auto, CD = Auto% x total)
  #					      if Manual, CD = Manual amount)
  print "<tr>\n";
  print "<td align=left><font size=$font_size_text>2.&nbsp;Compensation Deduction</font></td>\n";
  print "<td align=right><font size=$font_size_text>";
  if ($state_compensation_deduction < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($state_compensation_deduction)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($state_compensation_deduction)));
  }
  print "</font></td>\n";
  print "</tr>\n";

  # 3. display previous overpay/payments line  (pop_amount)
  print "<tr>\n";
  print "<td align=left><font size=$font_size_text>3.&nbsp;Previous Overpay/Payments</font></td>\n";
  print "<td align=right><font size=$font_size_text>";
  if ($state_pop_amount < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($state_pop_amount)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($state_pop_amount)));
  }
  print "</font></td>\n";
  print "</tr>\n";

  # 4. display balance due line  (total - CD + ( (+)pop if under or (-)pop if over)
  print "<tr>\n";
  print "<td align=left><font size=$font_size_text>4.&nbsp;<b>Balance Due</b></font></td>\n";
  print "<td align=right><font size=$font_size_text><b>";
  if ($state_balance_due < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($state_balance_due)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($state_balance_due)));
  }
  print "</b></font></td>\n";
  print "</tr>\n";

  # 5. display additions to tax line  (att_amount)
  print "<tr>\n";
  print "<td align=left><font size=$font_size_text>5.&nbsp;Additions to Tax</font></td>\n";
  print "<td align=right><font size=$font_size_text>";
  if ($state_att_amount < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($state_att_amount)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($state_att_amount)));
  }
  print "</font></td>\n";
  print "</tr>\n";

  # 6. display interest line  (interest_amount)
  print "<tr>\n";
  print "<td align=left><font size=$font_size_text>6.&nbsp;Interest</font></td>\n";
  print "<td align=right><font size=$font_size_text>";
  if ($state_interest_amount < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($state_interest_amount)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($state_interest_amount)));
  }
  print "</font></td>\n";
  print "</tr>\n";

  # 7. display total amount due line  (4 + 5 + 6)
  print "<tr>\n";
  print "<td align=left><font size=$font_size_text>7.&nbsp;<b>Total Amount Due</b> <sub>(rounded to the nearest dollar)</sub></font></td>\n";
  print "<td align=right><font size=$font_size_text><b>";
  if ($state_total_due < 0)
  {
    printf "<font color=red>(%s.00)</font>", commify(sprintf("%.0f", abs($state_total_due)));
  }
  else
  {
    printf "%s.00&nbsp;&nbsp;", commify(sprintf("%.0f", abs($state_total_due)));
  }
  print "</b></font></td>\n";
  print "</tr>\n";

  print "</table>\n";
}

sub reports4State941Validate
{
  if (not exists $input{'custom_report_name'} || $input{'custom_report_name'} eq "")
  {
    $report_name = "State 941 Quarterly Payroll";
  }
  else
  {
    $report_name = $input{'custom_report_name'};
  }

  # check and see if they want to display by Sub-Entities or not.
  if (not exists $input{'show_by_sub_entities'})
  {
    PrintErrorHeader();
    print "<h1>Error:  Show by Sub-Entities must be set!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
  $show_by_sub_entities = $input{'show_by_sub_entities'};
  if (not ($show_by_sub_entities eq "YES" || $show_by_sub_entities eq "NO"))
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid value set for Show by Sub-Entities!</h1>\n";
    print "Value set was '$show_by_sub_entities'.<br>$sys_admin";
    CleanUp();
  }
  $show_by_sub_entities = ($show_by_sub_entities eq "YES" ? 1:0);

  # check to make sure the account has been selected and is available
  if (not exists $input{'state_account_num'})
  {
    PrintErrorHeader();
    print "<h1>Error: Missing necessary form value (account)!</h1>\n";
    print "Invalid access! $sys_admin";
    CleanUp();
  }
  # assign the account to the state account variable
  $state_account_num = $input{'state_account_num'};

  # check to make sure the dates entered on the form are valid
  if (not exists $input{'state_from_date'})
  {
    PrintErrorHeader();
    print "<h1>Error: A necessary form value (from date) is missing!</h1>\n";
    print "Invalid access! $sys_admin";
    CleanUp();
  }
  if (not exists $input{'state_to_date'})
  {
    PrintErrorHeader();
    print "<h1>Error: A necessary form value (to date) is missing!</h1>\n";
    print "Invalid access! $sys_admin";
    CleanUp();
  }

  if ($input{'state_from_date'} eq "")
  {
    PrintErrorHeader();
    print "<h1>Error: A FROM date for the State 941 report must be entered!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  if ($input{'state_to_date'} eq "")
  {
    PrintErrorHeader();
    print "<h1>Error: A TO date for the State 941 report must be entered!</h1>\n";
    print "$back_button";
    CleanUp();
  }

  if (!IsValidDateSyntax($input{'state_from_date'}))
  {
    PrintErrorHeader();
    print "<h1>Error: The FROM date syntax is invalid!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  if (!IsValidDateSyntax($input{'state_to_date'}))
  {
    PrintErrorHeader();
    print "<h1>Error: The TO date syntax is invalid!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  # make sure that the from date is less than the to date
  if (ReverseDateString($input{'state_from_date'}) >= ReverseDateString($input{'state_to_date'}))
  {
    PrintErrorHeader();
    print "<h1>Error: The State FROM date must be less than and different from the TO date!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  # dates should be valid now; assign to date variables
  $state_from_date = $input{'state_from_date'};
  $state_to_date = $input{'state_to_date'};

  # validate the compensation deduction percentage input
  if (exists $input{'cdp_radio'} && $input{'cdp_radio'} eq "auto")
  {
    $state_cdp_percent = $input{'cdp_auto'};
    $state_cdp_percent =~ s/" "//g;
    if ($state_cdp_percent eq "")
    {
      $state_cdp_percent = 0.0;
    }
    if (IsValidFloating($state_cdp_percent) eq "")
    {
      PrintErrorHeader();
      print "<h1>Error: Invalid floating point number!</h1>\n";
      print "Compensation Deduction Percentage contains an invalid floating point value.<br>$back_button";
      CleanUp();
    }
    $state_cdp_amount = "";
  }
  elsif (exists $input{'cdp_radio'} && $input{'cdp_radio'} eq "manual")
  {
    $state_cdp_amount = $input{'cdp_manual'};
    $state_cdp_amount =~ s/" "//g;
    if ($state_cdp_amount eq "")
    {
      $state_cdp_amount = 0.0;
    }
    if (IsValidFloating($state_cdp_amount) eq "")
    {
      PrintErrorHeader();
      print "<h1>Error: Invalid floating point number!</h1>\n";
      print "Compensation Deduction Amount contains an invalid floating point value.<br>$back_button";
      CleanUp();
    }
    $state_cdp_percent = "";
  }
  elsif (not exists $input{'cdp_radio'} || exists $input{'cdp_radio'})
  {
    PrintErrorHeader();
    print "<h1>Error: Missing form value (compensation deduction percentage) or invalid form value data!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }

  # validate the previous overpay/payments input
  if (exists $input{'pop_amount'} && $input{'pop_amount'} ne "" && not exists $input{'pop_radio'})
  {
    PrintErrorHeader();
    print "<h1>Error: Previous Overpay/Payment field non-empty but no Over/Under button selected!</h1>\n";
    print "Over or Under payment button must be selected if POP amount is not empty.<br>$back_button";
    CleanUp();
  }
  $state_pop_amount = $input{'pop_amount'};
  $state_pop_amount =~ s/" "//g;
  if ($state_pop_amount eq "")
  {
    $state_pop_amount = 0.0;
  }
  if (IsValidFloating($state_pop_amount) eq "")
  {
    PrintErrorHeader();
    print "<h1>Error: Invalid floating point number!</h1>\n";
    print "Previous Overpay/Payment contains an invalid floating point value.<br>$back_button";
    CleanUp();
  }
  if ($input{'pop_radio'} eq "over")
  {
    $state_pop_amount = (-1.0)*(abs($state_pop_amount));
  }
  else
  {
    $state_pop_amount = abs($state_pop_amount);
  }

  # validate the additions to tax input
  if (not exists $input{'att_amount'})
  {
    $state_att_amount = 0.0;
  }
  else
  {
    $state_att_amount = $input{'att_amount'};
  }
  $state_att_amount =~ s/" "//g;
  if ($state_att_amount eq "")
  {
    $state_att_amount = 0.0;
  }
  if (IsValidFloating($state_att_amount) eq "")
  {
    PrintErrorHeader();
    print "<h1>Error: Invalid floating point number!</h1>\n";
    print "Additions to Tax contains an invalid floating point value.<br>$back_button";
    CleanUp();
  }

  # validate the interest input
  if (not exists $input{'interest_amount'})
  {
    $state_interest_amount = 0.0;
  }
  else
  {
    $state_interest_amount = $input{'interest_amount'};
  }
  $state_interest_amount =~ s/" "//g;
  if ($state_interest_amount eq "")
  {
    $state_interest_amount = 0.0;
  }
  if (IsValidFloating($state_interest_amount) eq "")
  {
    PrintErrorHeader();
    print "<h1>Error: Invalid floating point number!</h1>\n";
    print "Interest contains an invalid floating point value.<br>$back_button";
    CleanUp();
  }

  # set the order the name and numbers display in
  if (exists $input{'show_accounts_as'})
  {
    if ($input{'show_accounts_as'} eq "name-number")
    {
      $state_display_order = "0";
    }
    elsif ($input{'show_accounts_as'} eq "number-name")
    {
      $state_display_order = "1";
    }
    else
    {
      $state_display_order = "0";
    }
  }
  else
  {
    $state_display_order = "0";
  }
}
return 1;