#$Id: reports_trial_balance.pm,v 1.1 2001/09/06 10:21:20 moreejt Exp $
#This package is released under the GNU General Public License.
#You should have recieved a copy of the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.
sub reports3TrialBalanceCustomizedFormItems
{
  my $today;
  $today = `date +%m-%d-%Y`;
  chomp $today;

  print "<tr>\n";
  print "<td align=center>\n";
  print "<hr width=\"95%\">\n";
  print "<table border=0 cellspacing=0 cellpadding=2 bgcolor=\"$menu_bgcolor\" width=\"50%\">\n";
  print "<td align=right nowrap>Date:&nbsp;</td><td align=left nowrap><input type=text name=\"trial_balance_date\" value=\"$today\" size=10>&nbsp;<input type=button value=\"Clear\" onClick=\"document.customize_form.trial_balance_date.value = ''; document.customize_form.trial_balance_date.focus();\"></td>\n";
  print "</table>\n";
  print "</td>\n";
  print "</tr>\n";
}

sub reports3TrialBalanceJavaScriptValidation
{
  print <<"END_OF_SCRIPT";
  function reports3TrialBalanceJavaScriptValidation(doc)
  {
    var msg = "";
    var tmp = "";

    // verify that the date entered has a valid date syntax
    var tb_date = doc.trial_balance_date.value;
    if (tb_date.length == 0)
    {
      msg += "You must specify the date to retrieve account balances up to!\\n";
    }
    else
    {
      tmp = IsValidDateSyntax(tb_date);
      if (tmp.length > 0)
      {
        msg += "Trial Balance Date: " + tmp + "\\n";
      }
    }

    return msg;
  }
END_OF_SCRIPT
}

sub reports4TrialBalanceValidate
{
  if (not exists $input{'custom_report_name'} || $input{'custom_report_name'} eq "")
  {
    $report_name = "Trial Balance";
  }
  else
  {
    $report_name = $input{'custom_report_name'};
  }

  if (not exists $input{'trial_balance_date'})
  {
    PrintErrorHeader();
    print "<h1>Error: Report form item (date) missing!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $trial_balance_date = $input{'trial_balance_date'};
  if (length $trial_balance_date == 0)
  {
    PrintErrorHeader();
    print "<h1>Error: A Trial Balance date must be entered!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  if (!IsValidDateSyntax($trial_balance_date))
  {
    PrintErrorHeader();
    print "<h1>Error: The Trial Balance date syntax is invalid!</h1>\n";
    print "$back_button";
    CleanUp();
  }

  # set the order the name and numbers display in
  if (exists $input{'show_accounts_as'})
  {
    if ($input{'show_accounts_as'} eq "name-number")
    {
      $tb_display_order = "0";
    }
    elsif ($input{'show_accounts_as'} eq "number-name")
    {
      $tb_display_order = "1";
    }
    else
    {
      $tb_display_order = "0";
    }
  }
  else
  {
    $tb_display_order = "0";
  }
}

sub reports4TrialBalanceWork
{
  my $sql_string;

  $tb_debit_sum = 0.0;
  $tb_credit_sum = 0.0;

  # get the accounts assigned to the ledger in the order the user wants to see them (number-name, name-number)
  $sql_string = "select name, number, type from account_tb where number in (select acct_num from local_accounts_tb where ledger_code = '$ledger_code') order by ";
  if ($tb_display_order eq "0")
  {
    # display name-number
    $sql_string .= "name";
  }
  else
  {
    # display number-name
    $sql_string .= "number";
  }
  $result = $conn->exec($sql_string);
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing the database failed!</h1>\n";
    print "Tried to get the local list of accounts for the trial balance report.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples > 0)
  {
    # load the accounts into the account array
    for ($count=0; $count < $result->ntuples; $count++)
    {
      $tb_accounts_array[$count] = [];
      $tb_accounts_array[$count][0] = $result->getvalue($count, 1);
      # get the debit_increases flag for the account type
      $result2 = $conn->exec("select debit_increases from acct_type_tb where num = " . $result->getvalue($count, 2));
      if ($result2->resultStatus != PGRES_TUPLES_OK)
      {
        PrintErrorHeader();
        print "<h1>Error: Accessing the database failed!</h1>\n";
        print "Tried to get the debit_increases flag for account " . $result->getvalue($count, 1) . " with account type " . $result->getvalue($count, 2) . ".<br>$sys_admin";
        CleanUp();
      }
      if ($result2->ntuples <= 0)
      {
        PrintErrorHeader();
        print "<h1>Error: No records returned!</h1>\n";
        print "Tried to get the debit_increases flag for account " . $result->getvalue($count, 1) . " with account type " . $result->getvalue($count, 2) . ".<br>$sys_admin";
        CleanUp();
      }
      if ($result2->ntuples > 1)
      {
        PrintErrorHeader();
        print "<h1>Error: Too many records returned!</h1>\n";
        print "Tried to get the debit_increases flag for account " . $result->getvalue($count, 1) . " with account type " . $result->getvalue($count, 2) . ".<br>$sys_admin";
        CleanUp();
      }
      $tb_accounts_array[$count][1] = $result2->getvalue(0, 0);
      $tb_accounts_array[$count][2] = $result->getvalue($count, 0);
    }
  }
  else
  {
    PrintErrorHeader();
    print "<h1>Error: No records returned!</h1>\n";
    print "It does not look like any accounts have been assigned to this ledger.<br>Assign some accounts or<br>$sys_admin";
    CleanUp();
  }
  # get the account balances for the accounts array
  @tb_accounts_balances = $report_obj->GetAccountBalances(\@tb_accounts_array, $trial_balance_date);
  if ($report_obj->didErrorOccur)
  {
    PrintErrorHeader();
    print "<h1>Error: Getting Trial Balance account balances failed!</h1>\n";
    print $report_obj->errorMessage;
    CleanUp();
  }
  # use tb_accounts_array[][3] for debits
  # use tb_accounts_array[][4] for credits
  for ($count=0; $count < @tb_accounts_balances; $count++)
  {
    if ($tb_accounts_balances[$count][0] < 0.0)
    {
      if ($tb_accounts_array[$count][1] eq "t")
      {
        $tb_accounts_array[$count][3] = "&nbsp;";
        $tb_accounts_array[$count][4] = commify(sprintf("%.2f", abs($tb_accounts_balances[$count][0])));
        $tb_credit_sum += abs($tb_accounts_balances[$count][0]);
      }
      else
      {
        $tb_accounts_array[$count][3] = commify(sprintf("%.2f", abs($tb_accounts_balances[$count][0])));
        $tb_accounts_array[$count][4] = "&nbsp;";
        $tb_debit_sum += abs($tb_accounts_balances[$count][0]);
      }
    }
    else
    {
      if ($tb_accounts_array[$count][1] eq "t")
      {
        $tb_accounts_array[$count][3] = commify(sprintf("%.2f", abs($tb_accounts_balances[$count][0])));
        $tb_accounts_array[$count][4] = "&nbsp;";
        $tb_debit_sum += abs($tb_accounts_balances[$count][0]);
      }
      else
      {
        $tb_accounts_array[$count][3] = "&nbsp;";
        $tb_accounts_array[$count][4] = commify(sprintf("%.2f", abs($tb_accounts_balances[$count][0])));
        $tb_credit_sum += abs($tb_accounts_balances[$count][0]);
      }
    }
  }
}

sub reports4TrialBalanceDisplayForm
{
  # output the date at the top of the form
  print "<br><center><font color=\"blue\" size=\"$font_size_text\">$trial_balance_date</font></center><br><br>\n";

  # output the table in which to display the results
  print "<table cellspacing=0 cellpadding=2 width=\"75%\">\n";
  print "<tr>\n";
  print "<td>&nbsp;</td><th colspan=\"2\"><font size=\"$font_size_text\">Balance</font><br><hr></td>\n";
  print "</tr>\n";
  print "<tr>\n";
  print "<th nowrap align=left><font size=\"$font_size_text\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Account Title</font></th><th align=right><font size=\"$font_size_text\">Debit&nbsp;&nbsp;</font></th><th align=right><font size=\"$font_size_text\">Credit&nbsp;&nbsp;</font></th>\n";
  print "</tr>\n";
  print "<tr>\n";
  print "<td colspan=\"3\"><hr></td>\n";
  print "</tr>\n";
  for ($count=0; $count < @tb_accounts_array; $count++)
  {
    print "<tr>\n";
    print "<td align=left nowrap><font size=\"$font_size_data\">" . (($tb_display_order eq "1") ? "$tb_accounts_array[$count][0] - $tb_accounts_array[$count][2]" : "$tb_accounts_array[$count][2] - $tb_accounts_array[$count][0]") . "</font></td>\n";
    print "<td align=right><font size=\"$font_size_data\">" . $tb_accounts_array[$count][3] . "</font></td>\n";
    print "<td align=right><font size=\"$font_size_data\">" . $tb_accounts_array[$count][4] . "</font></td>\n";
    print "</tr>\n";
  }
  print "<tr>\n";
  print "<td colspan=\"3\"><hr></td>\n";
  print "</tr>\n";
  print "<tr>\n";
  print "<th align=left><font size=\"$font_size_data\">Total</font></th>\n";
  print "<td align=right><font size=\"$font_size_data\"><b>" . commify(sprintf("%.2f", abs($tb_debit_sum))) . "</b></font></td>\n";
  print "<td align=right><font size=\"$font_size_data\"><b>" . commify(sprintf("%.2f", abs($tb_credit_sum))) . "</b></font></td>\n";
  print "</tr>\n";
  print "</table>\n";

  my $system_start_date;
  # get the date the system started to be used
  $result = $conn->exec("select start_date from known_years_tb where year = (select min(year) from known_years_tb where ledger_code = '$ledger_code') and ledger_code = '$ledger_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error: Failed to get the system start date!</h1>\n";
    print "Tried to get the minimum year to determine the system start date.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples == 0)
  {
    print "<h1>Error: Not enough records returned!</h1>\n";
    print "Tried to get the minimum year to determine the system start date.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples > 1)
  {
    print "<h1>Error: Too many records returned!</h1>\n";
    print $result->ntuples . " records were returned.  There should be only one.<br>Tried to get the minimum year to determine the system start date.<br>$sys_admin";
    CleanUp();
  }
  $system_start_date = $result->getvalue(0, 0);

  # see if the Debits don't Equal the Credits
  my @is_balanced = $report_obj->DoesSystemBalance($system_start_date, $trial_balance_date);
  if ($report_obj->didErrorOccur)
  {
    print "<h1>Error: Checking to see if Debits = Credits failed!</h1>\n";
    print "'" . $report_obj->errorMessage . "'";
    CleanUp();
  }
  if ($is_balanced[2] != 1)
  {
    print "<hr>\nDebits do not <b>Equal</b> Credits!<br><br>\n";
    print "Debits &nbsp;= <b>\$" . (commify($is_balanced[0])) . "</b><br>\n";
    print "Credits = <b>\$" . (commify($is_balanced[1])) . "</b><br><br>\n";

    my @entries = $report_obj->FindInvalidEntries($system_start_date, $trial_balance_date);
    if ($report_obj->didErrorOccur)
    {
      print "<h1>Error: Getting List of Invalid Transactions failed!</h1>\n";
      print $report_obj->errorMessage;
      CleanUp();
    }

    print "Reference Numbers are:<br>\n";
    print "<form method=post action=\"$site_dir/cgi-bin/journal_mod1.cgi\" target=\"edit_ref_num\" name=\"fix_form\">\n";
    print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
    print "<input type=hidden name=\"journal_view_command\" value=\"search2\">\n";
    print "<input type=hidden name=\"ref_num2\" value=\"\">\n";
    print "<input type=hidden name=\"num_entries_to_display\" value=\"10\">\n";
    print "<input type=hidden name=\"start_index\" value=\"1\">\n";
    my $i;
    for ($i=0; $i < scalar @entries; $i++)
    {
      print "<a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"javascript:document.fix_form.ref_num2.value=$entries[$i]; document.fix_form.submit(); return false;\">$entries[$i]</a><br>\n";
    }
    print "</form>\n";
  }
}

return 1;