#!/usr/bin/perl
#$Id: sub_accounts_config2.cgi,v 1.2 2001/10/25 23:03:52 pcxuser Exp $
#This package is released under the GPL.  You should have recieved the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.
# sub_accounts_config2.cgi  -  Created by James Pattie, 06/22/1999
# This script displays all sub accounts with parent = -1, with
# edit radio buttons down the left and delete check boxes down the right
# and the sub account information in the middle.  The layout will look
# similar to the Journal view screen.

use strict;

use Pg;  # PostgreSQL Database Module
use cgi_lib;  # CGI Library routines
use custom;  # our customizable features

use vars '$date';
my $ledger_db;
my $count;
my $result2;

use PortalWrapper; # The Portal Wrapper library.

my $portalObj;
$portalObj = PortalWrapper->new;
if ($portalObj->didErrorOccur)
{
  # begin the HTML Output
  print cgi_lib::PrintHeader();
  print "<html>\n";

  PrintErrorHeader();
  print $portalObj->errorMessage;
  CleanUp();
}
my $dbObj;
$dbObj = $portalObj->getDBInfo;
if (!defined $dbObj)
{
  if ($portalObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";

    PrintErrorHeader();
    print $portalObj->errorMessage;
    CleanUp();
  }
}
else
{
  if ($dbObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $dbObj->errorMessage;
    CleanUp();
  }
}
$db_host = $dbObj->dbHost;
$db_name = $dbObj->dbName;
$db_user = $dbObj->dbUser;
$db_passwd = $dbObj->dbPasswd;

my $database_connected;
$database_connected = 0;

# get the values being passed in from the client
%input = ();  # make sure it is empty!
cgi_lib::ReadParse(*input);

# begin the HTML Output
print cgi_lib::PrintHeader();
print "<html>\n";

$ledger_db = $input{'ledger'};

# check to see if we are running under mod_perl
if (exists $ENV{MOD_PERL})
{
  # check to see if the database is still connected
  if (defined $conn)
  {
    # check the status of the connection
    if ($conn->status != PGRES_CONNECTION_OK)
    {
      $database_connected = 0;
    }
    else
    {
      # connection still good!
      $database_connected = 1;
    }
  }
  else
  {
    $database_connected = 0;
  }
}

if (not $database_connected)
{
  # connect to the database.
  $conn = Pg::connectdb("host = $db_host dbname = $db_name user = $db_user password = $db_passwd");
  if ($conn->status == PGRES_CONNECTION_BAD)
  {
    PrintErrorHeader();
    print "<h1>Error:  Couldn't connect to the database!</h1><br>\n";
    print $conn->errorMessage . "<br>$sys_admin";
    CleanUp();
  }
}

# set the DateStyle for the Database.
$result = setDBDateStyle($conn);
if ($result->resultStatus != PGRES_COMMAND_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Setting Date Style failed!</h1>\n";
  print $conn->errorMessage . "<br>$sys_admin";
  CleanUp();
}

print "<head><title>$prog_name $prog_version Sub Accounts Configuration</title>\n";

print <<"END_OF_SCRIPT";
  <script language="Javascript1.2">
    function doLoad()
    {
    }
  </script>
END_OF_SCRIPT

print "</head>\n";
print "<body bgcolor=$body_bgcolor onLoad=\"doLoad();\">\n";
print <<"END_OF_STYLE";
<style type="text/css"><!--
  a:hover   { color: red }
  a:link    { text-decoration: none; color: blue }
  a:visited { text-decoration: none; color: blue }
  a:active  { text-decoration: none; color: blue }-->
</style>
<script language="Javascript1.2" src="../js/common.js"></script>
END_OF_STYLE
# get the date
$date = `/bin/date +%m-%d-%Y`;
chomp $date;

print "<center>\n";
print "<table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
print "<tr>\n";
print "<td width=47%>Working with Global Sub Accounts</td>\n";
print "<td align=left><a href=\"$site_dir/help.html#sub_account_config\" target=\"docs\"><img border=0 src=\"$site_dir/images/help.jpg\" alt=\"Help\"></a></td>\n";
print "<td align=right>$date</td></tr></table>\n<hr><br>\n";
print PrintStandardMainMenu($ledger_db);

# create the form that lets them update, delete or create new sub accounts from.
print "<form method=post action=\"$site_dir/cgi-bin/sub_accounts_config3.cgi\" name=\"sub_acct_form\">\n";
if (length $ledger_db > 0)
{
  print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
}
print <<"END_OF_FORM";
<input type=hidden name=\"submitted_by\" value=\"\">
<input type=hidden name=\"sub_acct\" value=\"\">
<table border=1 cellspacing=1 cellpadding=2 bgcolor=\"$body_bgcolor\" width=80%>
END_OF_FORM

my $temp;
$temp = 0;
# lookup all sub-account types in the database
$result = $conn->exec("select name, num from sub_acct_type_tb order by name");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "<tr><td colspan=2>";
  print "<h1>Error:  Accessing database failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get all the sub-account types' names and numbers.<br>$sys_admin";
  print "</td></tr></table></form>\n";
  CleanUp();
}
if ($result->ntuples <= 0)
{
  print "<tr><td colspan=2>";
  print "<h1>Error: No records returned!</h1>\n";
  print "Tried to get all the sub-account types' names and numbers.<br>$sys_admin";
  print "</td></tr></table></form>\n";
  CleanUp();
}
for ($count=0; $count < $result->ntuples; $count++)
{
  my $sub_acct_type_name = $result->getvalue($count, 0);
  my $sub_acct_type_num = $result->getvalue($count, 1);
  # now do a database lookup and find all sub accounts assigned to this sub-account type
  $result2 = $conn->exec("select sub_acc_name, sub_acc_number from sub_acc_tb where type = " . ($result->getvalue($count, 1)) . " order by sub_acc_name");
  if ($result2->resultStatus != PGRES_TUPLES_OK)
  {
    print "<tr><td colspan=2>";
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get all sub-accounts for sub-account type: " . ($result->getvalue($count, 0)) . ".<br>$sys_admin";
    print "</td></tr></table></form>\n";
    CleanUp();
  }

  if ($result2->ntuples == 0)
  {
    print "<tr>";
    print "<td align=left><b><font size=\"+1\">$sub_acct_type_name</font></b></td>";
    print "<td align=left>";
    print "<b>No sub-accounts defined!</b>\n";
    print "</td><td>&nbsp;</td></tr>\n";
  }
  else
  {
    my $i;
    print "<tr><td align=left><b><font size=\"+1\">$sub_acct_type_name</font></b></td><td align=left><select name=\"$sub_acct_type_name\">\n";
    for ($i=0; $i < $result2->ntuples; $i++)
    {
      my $name = $result2->getvalue($i, 0);
      my $num  = $result2->getvalue($i, 1);
      print "  <option value=\"$num|$name\">$name - $num\n";
    }
    print "</select></td>\n<td align=\"left\">";
    if ($sub_acct_type_num eq "1" || $sub_acct_type_num eq "15" || $sub_acct_type_num eq "90") # Other, Date, and System sub-account types should not be allowed to be edited or deleted
    {
      print "<br>";  # no edit/delete buttons
    }
    else
    { # print edit and delete buttons
      print "<input type=button name=\"$sub_acct_type_name" . "_edit\" onClick=\"document.sub_acct_form.submitted_by.value='edit'; document.sub_acct_form.sub_acct.value=document.sub_acct_form.$sub_acct_type_name.options[document.sub_acct_form.$sub_acct_type_name.selectedIndex].value; document.sub_acct_form.submit();\" value=\"Edit\">&nbsp;";
      print "<input type=button name=\"$sub_acct_type_name" . "_delete\" onClick=\"if (!confirm('Do you really want to delete this Sub Account?\\n\\nClick OK to Delete.\\n')) return false; document.sub_acct_form.submitted_by.value='delete'; document.sub_acct_form.sub_acct.value=document.sub_acct_form.$sub_acct_type_name.options[document.sub_acct_form.$sub_acct_type_name.selectedIndex].value; document.sub_acct_form.submit();\" value=\"Delete\">\n";
    }
    print "</td></tr>\n";
  }
}

print <<"END_OF_FORM";
</table>
<table border=0 cellspacing=0 cellpadding=2 width=60%>
<tr>
END_OF_FORM
print "<td align=center><input type=submit name=\"create\" value=\"Create New Sub Account\" onClick=\"document.sub_acct_form.submitted_by.value='create'; document.sub_acct_form.submit();\">&nbsp;<input type=submit name=\"createStock\" value=\"Create Stock\" onClick=\"document.sub_acct_form.submitted_by.value='createStock'; document.sub_acct_form.submit();\"></td>\n";
print <<"END_OF_FORM";
</tr>
</table>
</form>
END_OF_FORM

# print a horizontal rule to break the menu from the behind the scenes links
print "<br><hr>\n";

if (length $ledger_db == 0)
{
  print "<br><div align=left><a href=\"$site_dir/cgi-bin/account_config.cgi\">Account Configuration</a></div>\n";
  print "<br><div align=left><a href=\"$site_dir/cgi-bin/prg_config.cgi\">Program Configuration</a></div>\n";
}
else
{
  print "<form name=\"form1\" method=post action=\"\">\n";
  print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
  print "<br><div align=left><a href=\"$site_dir/cgi-bin/account_config.cgi\" onClick=\"go_here(document.form1, '$site_dir/cgi-bin/account_config.cgi'); return false;\">Account Configuration</a></div>\n";
  print "<br><div align=left><a href=\"$site_dir/cgi-bin/prg_config.cgi\" onClick=\"go_here(document.form1, '$site_dir/cgi-bin/prg_config.cgi'); return false;\">Program Configuration</a></div>\n";
  print "<input type=hidden name=\"open\" value=\"Open\">\n";
  print "<br><div align=left><a href=\"$site_dir/cgi-bin/ledger.cgi\" onClick=\"go_here(document.form1, '$site_dir/cgi-bin/ledger.cgi'); return false;\">Return to Ledger Summary</a></div>\n";
  print "</form>\n";
}

print "</body>\n";
print "</html>\n";
exit 0;