#!/usr/bin/perl
#$Id: sub_entities.cgi,v 1.1 2001/09/06 10:21:20 moreejt Exp $
#This package is released under the GPL.  You should have recieved the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.
# sub_entities.cgi  -  Created by James Pattie, 07/20/1999
# This script allows the user to create, edit or delete sub entities.

use strict;

use Pg;  # PostgreSQL Database Module
use cgi_lib;  # CGI Library routines
use custom;  # our customizable features
use reports;

use vars '$date';
use vars '$ledger_db';
use vars '$ledger_name';
my $report_obj;
my $ledger_code;

use PortalWrapper; # The Portal Wrapper library.

my $portalObj;
$portalObj = PortalWrapper->new;
if ($portalObj->didErrorOccur)
{
  # begin the HTML Output
  print cgi_lib::PrintHeader();
  print "<html>\n";

  PrintErrorHeader();
  print $portalObj->errorMessage;
  CleanUp();
}
my $dbObj;
$dbObj = $portalObj->getDBInfo;
if (!defined $dbObj)
{
  if ($portalObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $portalObj->errorMessage;
    CleanUp();
  }
}
else
{
  if ($dbObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $dbObj->errorMessage;
    CleanUp();
  }
}
$db_host = $dbObj->dbHost;
$db_name = $dbObj->dbName;
$db_user = $dbObj->dbUser;
$db_passwd = $dbObj->dbPasswd;

my $database_connected;
$database_connected = 0;

# get the values being passed in from the client
%input = ();  # make sure it is empty!
cgi_lib::ReadParse(*input);

# begin the HTML Output
print cgi_lib::PrintHeader();
print "<html>\n";

$ledger_db = $input{'ledger'};
if (length $ledger_db == 0)
{
  PrintErrorHeader();
  print "<h1>Error: You must specify a ledger to work with!</h1>\n";
  print "$back_button";
  CleanUp();
}

# check to see if we are running under mod_perl
if (exists $ENV{MOD_PERL})
{
  # check to see if the database is still connected
  if (defined $conn)
  {
    # check the status of the connection
    if ($conn->status != PGRES_CONNECTION_OK)
    {
      $database_connected = 0;
    }
    else
    {
      # connection still good!
      $database_connected = 1;
    }
  }
  else
  {
    $database_connected = 0;
  }
}

if (not $database_connected)
{
  # connect to the database.
  $conn = Pg::connectdb("host = $db_host dbname = $db_name user = $db_user password = $db_passwd");
  if ($conn->status == PGRES_CONNECTION_BAD)
  {
    PrintErrorHeader();
    print "<h1>Error:  Couldn't connect to the database!</h1><br>\n";
    print $conn->errorMessage . "<br>$sys_admin";
    CleanUp();
  }
}

# set the DateStyle for the Database.
$result = setDBDateStyle($conn);
if ($result->resultStatus != PGRES_COMMAND_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Setting Date Style failed!</h1>\n";
  print $conn->errorMessage . "<br>$sys_admin";
  CleanUp();
}

$result = $conn->exec("select name from entity_tb where database_name = '$ledger_db'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error: Accessing database failed!</h1>\n";
  print "Trying to check entity table.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples == 0)
{
  PrintErrorHeader();
  print "<h1>Error: Ledger <font color=\"blue\">$ledger_db</font> does not exist!</h1>\n";
  print "$sys_admin";
  CleanUp();
}
else
{
  $ledger_name = $result->getvalue(0, 0);
}

# create the reports object
$report_obj = reports->new($conn, $ledger_db);
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}
$ledger_code = $report_obj->getLedgerCode();
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}

# select all sub entites from the database
$result = $conn->exec("select name, code from sub_entity_tb WHERE ledger_code = '$ledger_code' order by name");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Accessing database failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get list of Sub Entities to work with.<br>$sys_admin";
  CleanUp();
}

print "<head><title>$prog_name $prog_version Sub Entity Administration</title></head>\n";
print "<body bgcolor=$body_bgcolor>\n";
print <<"END_OF_STYLE";
<style type="text/css"><!--
  a:hover   { color: red }
  a:link    { text-decoration: none; color: blue }
  a:visited { text-decoration: none; color: blue }
  a:active  { text-decoration: none; color: blue }-->
</style>
<script language="Javascript1.2" src="../js/common.js"></script>
END_OF_STYLE
# get the date
$date = `/bin/date +%m-%d-%Y`;
chomp $date;

print "<center>\n";
print "<table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
print "<tr>\n";
print "<td width=47%>Working with Ledger <font color=\"blue\">$ledger_name</font></td>\n";
print "<td align=left><a href=\"$site_dir/help.html#sub_entities\" target=\"docs\"><img border=0 src=\"$site_dir/images/help.jpg\" alt=\"Help\"></a></td>\n";
print "<td align=right>$date</td></tr></table>\n<hr><br>\n";
print PrintStandardLedgerMainMenu($ledger_db);
print "<h2><font color=$prog_fgcolor>$prog_name $prog_version</font> Sub Entity Administration</h2>\n";

# create the form that lets them select from the sub entities to work with.
my $temp;
$temp = $result->ntuples;
print <<"END_OF_FORM";
<form method=post action=\"$site_dir/cgi-bin/sub_entities2.cgi\" name=\"sube_form\">
<input type=hidden name=\"ledger\" value=\"$ledger_db\">
<input type=hidden name=\"sub_entity_command\" value=\"\">
<input type=hidden name=\"sub_entity\" value=\"\">
<table border=1 cellspacing=1 cellpadding=2 bgcolor=\"$menu_bgcolor\" width=50%>
<tr><th>Edit</th><th>Name</th><th>Code</th><th>Delete</th></tr>
END_OF_FORM
if ($result->ntuples == 0)
{ # we currently have no Sub Entities in the database.
  print <<"END_OF_FORM";
  <tr>
  <td><br></td>
  <td colspan=2><font color=\"$menu_fgcolor\">There are no Sub Entities currently available!</font></td>
  <td><br></td>
  </tr>
  </table>
  <input type=submit name=\"create\" value=\"Create Sub Entity\" onClick=\"document.sube_form.sub_entity_command.value='create'\">
  </form>
END_OF_FORM
}
else
{
  my $i;
  for ($i=0; $i < $result->ntuples; $i++)
  {
    my $name = $result->getvalue($i, 0);
    my $code  = $result->getvalue($i, 1);
    print "<tr><td align=center><input type=radio name=\"edit_entity\" value=\"$i\" onClick=\"document.sube_form.sub_entity_command.value='edit';document.sube_form.sub_entity.value='$code|$name';document.sube_form.submit();\"></td>";
    print "<td><font color=\"$menu_fgcolor\">$name</font></td>\n";
    print "<td><font color=\"$menu_fgcolor\">$code</font></td>\n";
    print "<td align=center><input type=checkbox name=\"delete_entity_$i\" value=\"ON\" onClick=\"if (!confirm('Are you sure you want to Delete Sub Entity $name?\\n\\nClick OK to Delete.\\n')) return false;document.sube_form.sub_entity_command.value='delete';document.sube_form.sub_entity.value='$code|$name';document.sube_form.submit();\"></td></tr>\n";
  }

  print <<"END_OF_FORM";
  </table>
  <table border=0 cellspacing=0 cellpadding=2 width=50%>
    <tr>
      <td align=center><input type=submit name=\"create\" value=\"Create Sub Entity\" onClick=\"document.sube_form.sub_entity_command.value='create'\">&nbsp;<input type=reset value=\"Reset\"></td>
    </tr>
  </table>
  </form>
END_OF_FORM
}

# print a horizontal rule to break the menu from the behind the scenes links
#print "<br><hr>\n";

print "</body>\n";
print "</html>\n";
exit 0;
