#!/usr/bin/perl
#$Id: time_tracker_config.cgi,v 1.1 2001/09/06 10:21:20 moreejt Exp $
#This package is released under the GPL.  You should have recieved the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.
# This script presents the user with a list of ledgers to select from.

use strict;

use Pg;  # PostgreSQL Database Module
use cgi_lib;  # CGI Library routines
use custom;  # our customizable features

use vars '$date';

use PortalWrapper; # The Portal Wrapper library.

my $portalObj;
$portalObj = PortalWrapper->new;
if ($portalObj->didErrorOccur)
{
  # begin the HTML Output
  print cgi_lib::PrintHeader();
  print "<html>\n";

  PrintErrorHeader();
  print $portalObj->errorMessage;
  CleanUp();
}
my $dbObj;
$dbObj = $portalObj->getDBInfo;
if (!defined $dbObj)
{
  if ($portalObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $portalObj->errorMessage;
    CleanUp();
  }
}
else
{
  if ($dbObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $dbObj->errorMessage;
    CleanUp();
  }
}
$db_host = $dbObj->dbHost;
$db_name = $dbObj->dbName;
$db_user = $dbObj->dbUser;
$db_passwd = $dbObj->dbPasswd;

my $database_connected;
$database_connected = 0;

# get the values being passed in from the client
%input = ();  # make sure it is empty!
cgi_lib::ReadParse(*input);

# begin the HTML Output
print cgi_lib::PrintHeader();
print "<html>\n";

# check to see if we are running under mod_perl
if (exists $ENV{MOD_PERL})
{
  # check to see if the database is still connected
  if (defined $conn)
  {
    # check the status of the connection
    if ($conn->status != PGRES_CONNECTION_OK)
    {
      $database_connected = 0;
    }
    else
    {
      # connection still good!
      $database_connected = 1;
    }
  }
  else
  {
    $database_connected = 0;
  }
}

if (not $database_connected)
{
  # connect to the database.
  $conn = Pg::connectdb("host = $db_host dbname = $db_name user = $db_user password = $db_passwd");
  if ($conn->status == PGRES_CONNECTION_BAD)
  {
    PrintErrorHeader();
    print "<h1>Error:  Couldn't connect to the database!</h1><br>\n";
    print $conn->errorMessage . "<br>$sys_admin";
    CleanUp();
  }
}

# set the DateStyle for the Database.
$result = setDBDateStyle($conn);
if ($result->resultStatus != PGRES_COMMAND_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Setting Date Style failed!</h1>\n";
  print $conn->errorMessage . "<br>$sys_admin";
  CleanUp();
}

$result = $conn->exec("SELECT name, database_name FROM entity_tb ORDER BY name");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Getting list of Ledger's failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get list of Ledger's to work with.<br>$sys_admin";
  CleanUp();
}

# present them with the main menu 

print "<head><title>$prog_name $prog_version Time Tracker Configuration</title>\n";

print <<"END_OF_SCRIPT";
  <script language="Javascript1.2">
    function doLoad()
    {
      document.time_form.ledger.selectedIndex = -1;
    }
  </script>
END_OF_SCRIPT

print "</head>\n";
print "<body bgcolor=$body_bgcolor onLoad=\"doLoad();\">\n";
print <<"END_OF_STYLE";
<style type="text/css"><!--
  a:hover   { color: blue }
  a:link    { text-decoration: none; color: blue }
  a:visited { text-decoration: none; color: blue }
  a:active  { text-decoration: none; color: blue }-->
</style>
<script language="Javascript1.2" src="../js/common.js"></script>
END_OF_STYLE
# get the date
$date = `/bin/date +%m-%d-%Y`;
chomp $date;

print "<center>\n";
print "<table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
print "<tr>\n";
print "<td width=47%><br></td>\n";
print "<td align=left><a href=\"$site_dir/help.html#tk_configuration\" target=\"docs\"><img border=0 src=\"$site_dir/images/help.jpg\" alt=\"Help\"></a></td>\n";
print "<td align=right>$date</td></tr></table>\n<hr><br>\n";
print PrintStandardMainMenu();  # This script should never be called so we don't need to give it the ledger.
print "<h2><font color=$prog_fgcolor>$prog_name $prog_version</font> Time Tracker Configuration</h2>\n";

# create the form to allow the user to select a ledger to work with.
print "<form method=post action=\"$site_dir/cgi-bin/time_tracker_config1.cgi\" name=\"time_form\">\n";
print "<input type=hidden name=\"select_ledger\" value=\"\">\n";
print "<table border=0 cellspacing=0 cellpadding=2 bgcolor=\"$menu_bgcolor\">\n";
print "<tr><td align=right><font color=\"$menu_fgcolor\">Ledger:</font></td><td align=left><select name=\"ledger\" onChange=\"document.time_form.submit();\">\n";
my ($i, $ledger_name, $ledger_db);
for ($i=0; $i < $result->ntuples; $i++)
{
  $ledger_name = $result->getvalue($i, 0);
  $ledger_db   = $result->getvalue($i, 1);

  print "<option value=\"$ledger_db\">$ledger_name\n";
}
print "</select></td></tr>\n";
print "</table>\n";
print "</form>\n";

# print a horizontal rule to break the menu from the behind the scenes links
print "<br><hr>\n";

print "<br><div align=left><a href=\"$site_dir/cgi-bin/prg_config.cgi\">Program Configuration</a></div>\n";

print "</body>\n";
print "</html>\n";
exit 0;
